/* Config.c generated by valac 0.9.8, the Vala compiler
 * generated from Config.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gconf/gconf-client.h>
#include <float.h>
#include <math.h>
#include <gconf/gconf.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
typedef struct _ConfigPrivate ConfigPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))
#define _gconf_value_free0(var) ((var == NULL) ? NULL : (var = (gconf_value_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_RATING_FILTER (rating_filter_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define COLLECTION_PAGE_TYPE_SORT_BY (collection_page_sort_by_get_type ())

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
typedef struct _ParamSpecConfig ParamSpecConfig;

struct _Config {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigPrivate * priv;
};

struct _ConfigClass {
	GTypeClass parent_class;
	void (*finalize) (Config *self);
};

struct _ConfigPrivate {
	char* bg_color;
	char* selected_color;
	char* unselected_color;
	char* unfocused_selected_color;
	char* border_color;
	GConfClient* client;
};

typedef enum  {
	RATING_FILTER_NO_FILTER = 0,
	RATING_FILTER_REJECTED_OR_HIGHER = 1,
	RATING_FILTER_UNRATED_OR_HIGHER = 2,
	RATING_FILTER_ONE_OR_HIGHER = 3,
	RATING_FILTER_TWO_OR_HIGHER = 4,
	RATING_FILTER_THREE_OR_HIGHER = 5,
	RATING_FILTER_FOUR_OR_HIGHER = 6,
	RATING_FILTER_FIVE_OR_HIGHER = 7,
	RATING_FILTER_REJECTED_ONLY = 8,
	RATING_FILTER_UNRATED_ONLY = 9,
	RATING_FILTER_ONE_ONLY = 10,
	RATING_FILTER_TWO_ONLY = 11,
	RATING_FILTER_THREE_ONLY = 12,
	RATING_FILTER_FOUR_ONLY = 13,
	RATING_FILTER_FIVE_ONLY = 14
} RatingFilter;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	COLLECTION_PAGE_SORT_BY_TITLE = 1,
	COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE = 2,
	COLLECTION_PAGE_SORT_BY_RATING = 3
} CollectionPageSortBy;

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ParamSpecConfig {
	GParamSpec parent_instance;
};


static Config* config_instance;
static Config* config_instance = NULL;
static gpointer config_parent_class = NULL;

gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
#define CONFIG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONFIG, ConfigPrivate))
enum  {
	CONFIG_DUMMY_PROPERTY
};
#define CONFIG_SLIDESHOW_DELAY_MAX 30.0
#define CONFIG_SLIDESHOW_DELAY_MIN 1.0
#define CONFIG_SLIDESHOW_DELAY_DEFAULT 3.0
#define CONFIG_WIDTH_DEFAULT 1024
#define CONFIG_HEIGHT_DEFAULT 768
#define CONFIG_SIDEBAR_MIN_POSITION 180
#define CONFIG_SIDEBAR_MAX_POSITION 1000
#define CONFIG_DEFAULT_BG_COLOR "#444"
#define CONFIG_BLACK_THRESHOLD ((guint) 40000)
#define CONFIG_DARK_SELECTED_COLOR "#0AD"
#define CONFIG_LIGHT_SELECTED_COLOR "#2DF"
#define CONFIG_DARK_UNSELECTED_COLOR "#000"
#define CONFIG_LIGHT_UNSELECTED_COLOR "#FFF"
#define CONFIG_DARK_BORDER_COLOR "#666"
#define CONFIG_LIGHT_BORDER_COLOR "#AAA"
#define CONFIG_DARK_UNFOCUSED_SELECTED_COLOR "#6fc4dd"
#define CONFIG_LIGHT_UNFOCUSED_SELECTED_COLOR "#99efff"
static Config* config_new (void);
static Config* config_construct (GType object_type);
Config* config_get_instance (void);
static void config_report_get_error (Config* self, const char* path, GError* err);
static void config_report_set_error (Config* self, const char* path, GError* err);
static gboolean config_get_bool (Config* self, const char* path, gboolean def);
static gboolean config_set_bool (Config* self, const char* path, gboolean value);
static gint config_get_int (Config* self, const char* path, gint def);
static gboolean config_set_int (Config* self, const char* path, gint value);
static double config_get_double (Config* self, const char* path, double def);
static gboolean config_set_double (Config* self, const char* path, double value);
static char* config_get_string (Config* self, const char* path, const char* def);
gboolean is_string_empty (const char* s);
static gboolean config_set_string (Config* self, const char* path, const char* value);
gboolean config_clear_flickr_auth_token (Config* self);
gboolean config_set_flickr_auth_token (Config* self, const char* token);
char* config_get_flickr_auth_token (Config* self);
gboolean config_clear_flickr_username (Config* self);
gboolean config_set_flickr_username (Config* self, const char* username);
char* config_get_flickr_username (Config* self);
gboolean config_set_flickr_default_size (Config* self, gint sizecode);
gint config_get_flickr_default_size (Config* self);
gboolean config_set_flickr_visibility (Config* self, gint viscode);
gint config_get_flickr_visibility (Config* self);
gboolean config_set_default_service (Config* self, gint service_code);
gint config_get_default_service (Config* self);
gboolean config_clear_facebook_session_key (Config* self);
gboolean config_set_facebook_session_key (Config* self, const char* key);
char* config_get_facebook_session_key (Config* self);
gboolean config_clear_facebook_session_secret (Config* self);
gboolean config_set_facebook_session_secret (Config* self, const char* secret);
char* config_get_facebook_session_secret (Config* self);
gboolean config_clear_facebook_uid (Config* self);
gboolean config_set_facebook_uid (Config* self, const char* uid);
char* config_get_facebook_uid (Config* self);
gboolean config_clear_facebook_user_name (Config* self);
gboolean config_set_facebook_user_name (Config* self, const char* user_name);
char* config_get_facebook_user_name (Config* self);
gboolean config_set_picasa_user_name (Config* self, const char* user_name);
char* config_get_picasa_user_name (Config* self);
gboolean config_set_picasa_auth_token (Config* self, const char* auth_token);
gboolean config_set_picasa_default_size (Config* self, gint default_size);
gint config_get_picasa_default_size (Config* self);
char* config_get_picasa_auth_token (Config* self);
gboolean config_set_printing_content_layout (Config* self, gint layout_code);
gint config_get_printing_content_layout (Config* self);
gboolean config_set_printing_content_ppi (Config* self, gint content_ppi);
gint config_get_printing_content_ppi (Config* self);
gboolean config_set_printing_content_width (Config* self, double content_width);
double config_get_printing_content_width (Config* self);
gboolean config_set_printing_content_height (Config* self, double content_height);
double config_get_printing_content_height (Config* self);
gboolean config_set_printing_content_units (Config* self, gint units_code);
gint config_get_printing_content_units (Config* self);
gboolean config_set_printing_size_selection (Config* self, gint size_code);
gint config_get_printing_size_selection (Config* self);
gboolean config_set_printing_match_aspect_ratio (Config* self, gboolean match_aspect_ratio);
gboolean config_get_printing_match_aspect_ratio (Config* self);
gboolean config_set_display_basic_properties (Config* self, gboolean display);
gboolean config_get_display_basic_properties (Config* self);
gboolean config_set_display_extended_properties (Config* self, gboolean display);
gboolean config_get_display_extended_properties (Config* self);
gboolean config_set_display_photo_titles (Config* self, gboolean display);
gboolean config_get_display_photo_titles (Config* self);
gboolean config_get_display_photo_tags (Config* self);
gboolean config_set_display_photo_tags (Config* self, gboolean display);
gboolean config_get_display_photo_ratings (Config* self);
gboolean config_set_display_photo_ratings (Config* self, gboolean display);
gboolean config_set_slideshow_delay (Config* self, double delay);
double config_get_slideshow_delay (Config* self);
GType rating_filter_get_type (void) G_GNUC_CONST;
RatingFilter config_get_photo_rating_filter (Config* self);
gboolean config_set_photo_rating_filter (Config* self, RatingFilter filter);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
void dimensions_init (Dimensions *self, gint width, gint height);
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
gint config_get_sidebar_position (Config* self);
gboolean config_set_sidebar_position (Config* self, gint position);
gboolean config_get_events_sort_ascending (Config* self);
gboolean config_set_events_sort_ascending (Config* self, gboolean sort);
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
GType collection_page_sort_by_get_type (void) G_GNUC_CONST;
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by);
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by);
gboolean config_get_24_hr_time (Config* self);
gboolean is_twentyfour_hr_time_system (void);
gboolean config_set_24_hr_time (Config* self, gboolean twentyfour_hr_time);
gboolean config_get_keep_relativity (Config* self);
gboolean config_set_keep_relativity (Config* self, gboolean keep_relativity);
gboolean config_get_modify_originals (Config* self);
gboolean config_set_modify_originals (Config* self, gboolean modify_originals);
char* config_get_background (Config* self);
gboolean config_set_background (Config* self, const char* filename);
gboolean config_get_show_welcome_dialog (Config* self);
gboolean config_set_show_welcome_dialog (Config* self, gboolean show);
gboolean config_set_photo_thumbnail_scale (Config* self, gint scale);
gint config_get_photo_thumbnail_scale (Config* self);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
gint thumbnail_cache_size_get_scale (ThumbnailCacheSize self);
#define THUMBNAIL_DEFAULT_SCALE thumbnail_cache_size_get_scale (THUMBNAIL_CACHE_SIZE_MEDIUM)
#define THUMBNAIL_MIN_SCALE 72
#define THUMBNAIL_MAX_SCALE thumbnail_cache_size_get_scale (THUMBNAIL_CACHE_SIZE_LARGEST)
static void config_get_colors (Config* self);
gboolean is_color_parsable (const char* spec);
static void config_set_text_colors (Config* self, GdkColor* bg_color);
void parse_color (const char* spec, GdkColor* result);
void config_get_bg_color (Config* self, GdkColor* result);
void config_get_selected_color (Config* self, gboolean in_focus, GdkColor* result);
void config_get_unselected_color (Config* self, GdkColor* result);
void config_get_border_color (Config* self, GdkColor* result);
void config_set_bg_color (Config* self, GdkColor* color);
gboolean config_commit_bg_color (Config* self);
char* config_get_import_dir (Config* self);
void config_set_import_dir (Config* self, const char* import_dir);
char* config_get_external_photo_app (Config* self);
GAppInfo* get_default_app_for_mime_types (char** mime_types, int mime_types_length1, GeeArrayList* preferred_apps);
char** photo_file_format_get_editable_mime_types (int* result_length1);
char* get_app_open_command (GAppInfo* app_info);
void config_set_external_photo_app (Config* self, const char* external_photo_app);
char* config_get_external_raw_app (Config* self);
GType photo_file_format_get_type (void) G_GNUC_CONST;
char** photo_file_format_get_mime_types (PhotoFileFormat self, int* result_length1);
void config_set_external_raw_app (Config* self, const char* external_raw_app);
static void config_finalize (Config* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 39 "Config.vala"
static Config* config_construct (GType object_type) {
#line 296 "Config.c"
	Config* self;
	GConfClient* _tmp0_;
	self = (Config*) g_type_create_instance (object_type);
#line 41 "Config.vala"
	g_assert (config_instance == NULL);
#line 43 "Config.vala"
	self->priv->client = (_tmp0_ = _g_object_ref0 (gconf_client_get_default ()), _g_object_unref0 (self->priv->client), _tmp0_);
#line 44 "Config.vala"
	g_assert (self->priv->client != NULL);
#line 306 "Config.c"
	return self;
}


#line 39 "Config.vala"
static Config* config_new (void) {
#line 39 "Config.vala"
	return config_construct (TYPE_CONFIG);
#line 315 "Config.c"
}


static gpointer _config_ref0 (gpointer self) {
	return self ? config_ref (self) : NULL;
}


#line 47 "Config.vala"
Config* config_get_instance (void) {
#line 326 "Config.c"
	Config* result = NULL;
#line 48 "Config.vala"
	if (config_instance == NULL) {
#line 330 "Config.c"
		Config* _tmp0_;
#line 49 "Config.vala"
		config_instance = (_tmp0_ = config_new (), _config_unref0 (config_instance), _tmp0_);
#line 334 "Config.c"
	}
	result = _config_ref0 (config_instance);
#line 51 "Config.vala"
	return result;
#line 339 "Config.c"
}


#line 54 "Config.vala"
static void config_report_get_error (Config* self, const char* path, GError* err) {
#line 54 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 54 "Config.vala"
	g_return_if_fail (path != NULL);
#line 55 "Config.vala"
	g_warning ("Config.vala:55: Unable to get GConf value at %s: %s", path, err->message);
#line 351 "Config.c"
}


#line 58 "Config.vala"
static void config_report_set_error (Config* self, const char* path, GError* err) {
#line 58 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 58 "Config.vala"
	g_return_if_fail (path != NULL);
#line 59 "Config.vala"
	g_warning ("Config.vala:59: Unable to set GConf value at %s: %s", path, err->message);
#line 363 "Config.c"
}


#line 62 "Config.vala"
static gboolean config_get_bool (Config* self, const char* path, gboolean def) {
#line 369 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 62 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 62 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 376 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 64 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 384 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch194_g_error;
		}
#line 64 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 390 "Config.c"
			result = def;
#line 65 "Config.vala"
			return result;
#line 394 "Config.c"
		}
#line 67 "Config.vala"
		_tmp3_ = gconf_client_get_bool (self->priv->client, path, &_inner_error_);
#line 398 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch194_g_error;
		}
		result = _tmp3_;
#line 67 "Config.vala"
		return result;
#line 405 "Config.c"
	}
	goto __finally194;
	__catch194_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 69 "Config.vala"
			config_report_get_error (self, path, err);
#line 416 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 71 "Config.vala"
			return result;
#line 421 "Config.c"
		}
	}
	__finally194:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 75 "Config.vala"
static gboolean config_set_bool (Config* self, const char* path, gboolean value) {
#line 435 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 75 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 75 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 442 "Config.c"
	{
#line 77 "Config.vala"
		gconf_client_set_bool (self->priv->client, path, value, &_inner_error_);
#line 446 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch195_g_error;
		}
		result = TRUE;
#line 79 "Config.vala"
		return result;
#line 453 "Config.c"
	}
	goto __finally195;
	__catch195_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 81 "Config.vala"
			config_report_set_error (self, path, err);
#line 464 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 83 "Config.vala"
			return result;
#line 469 "Config.c"
		}
	}
	__finally195:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 87 "Config.vala"
static gint config_get_int (Config* self, const char* path, gint def) {
#line 483 "Config.c"
	gint result = 0;
	GError * _inner_error_ = NULL;
#line 87 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 87 "Config.vala"
	g_return_val_if_fail (path != NULL, 0);
#line 490 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		gint value;
		gint _tmp3_ = 0;
#line 89 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 499 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch196_g_error;
		}
#line 89 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 505 "Config.c"
			result = def;
#line 90 "Config.vala"
			return result;
#line 509 "Config.c"
		}
#line 92 "Config.vala"
		value = gconf_client_get_int (self->priv->client, path, &_inner_error_);
#line 513 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch196_g_error;
		}
#line 94 "Config.vala"
		if (value != 0.0) {
#line 94 "Config.vala"
			_tmp3_ = value;
#line 521 "Config.c"
		} else {
#line 94 "Config.vala"
			_tmp3_ = def;
#line 525 "Config.c"
		}
		result = _tmp3_;
#line 94 "Config.vala"
		return result;
#line 530 "Config.c"
	}
	goto __finally196;
	__catch196_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 96 "Config.vala"
			config_report_get_error (self, path, err);
#line 541 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 98 "Config.vala"
			return result;
#line 546 "Config.c"
		}
	}
	__finally196:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


#line 102 "Config.vala"
static gboolean config_set_int (Config* self, const char* path, gint value) {
#line 560 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 102 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 102 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 567 "Config.c"
	{
#line 104 "Config.vala"
		gconf_client_set_int (self->priv->client, path, value, &_inner_error_);
#line 571 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch197_g_error;
		}
		result = TRUE;
#line 106 "Config.vala"
		return result;
#line 578 "Config.c"
	}
	goto __finally197;
	__catch197_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 108 "Config.vala"
			config_report_set_error (self, path, err);
#line 589 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 110 "Config.vala"
			return result;
#line 594 "Config.c"
		}
	}
	__finally197:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 114 "Config.vala"
static double config_get_double (Config* self, const char* path, double def) {
#line 608 "Config.c"
	double result = 0.0;
	GError * _inner_error_ = NULL;
#line 114 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 114 "Config.vala"
	g_return_val_if_fail (path != NULL, 0.0);
#line 615 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		double value;
		double _tmp3_ = 0.0;
#line 116 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 624 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch198_g_error;
		}
#line 116 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 630 "Config.c"
			result = def;
#line 117 "Config.vala"
			return result;
#line 634 "Config.c"
		}
#line 119 "Config.vala"
		value = gconf_client_get_float (self->priv->client, path, &_inner_error_);
#line 638 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch198_g_error;
		}
#line 121 "Config.vala"
		if (value != 0.0) {
#line 121 "Config.vala"
			_tmp3_ = value;
#line 646 "Config.c"
		} else {
#line 121 "Config.vala"
			_tmp3_ = def;
#line 650 "Config.c"
		}
		result = _tmp3_;
#line 121 "Config.vala"
		return result;
#line 655 "Config.c"
	}
	goto __finally198;
	__catch198_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 123 "Config.vala"
			config_report_get_error (self, path, err);
#line 666 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 125 "Config.vala"
			return result;
#line 671 "Config.c"
		}
	}
	__finally198:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
}


#line 129 "Config.vala"
static gboolean config_set_double (Config* self, const char* path, double value) {
#line 685 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 129 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 129 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 692 "Config.c"
	{
#line 131 "Config.vala"
		gconf_client_set_float (self->priv->client, path, value, &_inner_error_);
#line 696 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch199_g_error;
		}
		result = TRUE;
#line 133 "Config.vala"
		return result;
#line 703 "Config.c"
	}
	goto __finally199;
	__catch199_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 135 "Config.vala"
			config_report_set_error (self, path, err);
#line 714 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 137 "Config.vala"
			return result;
#line 719 "Config.c"
		}
	}
	__finally199:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 141 "Config.vala"
static char* config_get_string (Config* self, const char* path, const char* def) {
#line 733 "Config.c"
	char* result = NULL;
	GError * _inner_error_ = NULL;
#line 141 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 141 "Config.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 740 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		char* stored;
		const char* _tmp3_;
#line 143 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 749 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch200_g_error;
		}
#line 143 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 755 "Config.c"
			result = g_strdup (def);
#line 144 "Config.vala"
			return result;
#line 759 "Config.c"
		}
#line 146 "Config.vala"
		stored = gconf_client_get_string (self->priv->client, path, &_inner_error_);
#line 763 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch200_g_error;
		}
		_tmp3_ = NULL;
#line 148 "Config.vala"
		if (is_string_empty (stored)) {
#line 148 "Config.vala"
			_tmp3_ = NULL;
#line 772 "Config.c"
		} else {
#line 148 "Config.vala"
			_tmp3_ = stored;
#line 776 "Config.c"
		}
		result = g_strdup (_tmp3_);
		_g_free0 (stored);
#line 148 "Config.vala"
		return result;
#line 782 "Config.c"
	}
	goto __finally200;
	__catch200_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 150 "Config.vala"
			config_report_get_error (self, path, err);
#line 793 "Config.c"
			result = g_strdup (def);
			_g_error_free0 (err);
#line 152 "Config.vala"
			return result;
#line 798 "Config.c"
		}
	}
	__finally200:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 156 "Config.vala"
static gboolean config_set_string (Config* self, const char* path, const char* value) {
#line 812 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 156 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 156 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 156 "Config.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 821 "Config.c"
	{
#line 158 "Config.vala"
		gconf_client_set_string (self->priv->client, path, value, &_inner_error_);
#line 825 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch201_g_error;
		}
		result = TRUE;
#line 160 "Config.vala"
		return result;
#line 832 "Config.c"
	}
	goto __finally201;
	__catch201_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 162 "Config.vala"
			config_report_set_error (self, path, err);
#line 843 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 164 "Config.vala"
			return result;
#line 848 "Config.c"
		}
	}
	__finally201:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 168 "Config.vala"
gboolean config_clear_flickr_auth_token (Config* self) {
#line 862 "Config.c"
	gboolean result = FALSE;
#line 168 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 866 "Config.c"
	result = config_set_flickr_auth_token (self, "");
#line 169 "Config.vala"
	return result;
#line 870 "Config.c"
}


#line 172 "Config.vala"
gboolean config_set_flickr_auth_token (Config* self, const char* token) {
#line 876 "Config.c"
	gboolean result = FALSE;
#line 172 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 172 "Config.vala"
	g_return_val_if_fail (token != NULL, FALSE);
#line 882 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/auth_token", token);
#line 173 "Config.vala"
	return result;
#line 886 "Config.c"
}


#line 176 "Config.vala"
char* config_get_flickr_auth_token (Config* self) {
#line 892 "Config.c"
	char* result = NULL;
	char* stored_value;
	const char* _tmp0_;
#line 176 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 177 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/auth_token", NULL);
#line 900 "Config.c"
	_tmp0_ = NULL;
#line 178 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 178 "Config.vala"
		_tmp0_ = stored_value;
#line 906 "Config.c"
	} else {
#line 178 "Config.vala"
		_tmp0_ = NULL;
#line 910 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 178 "Config.vala"
	return result;
#line 916 "Config.c"
}


#line 181 "Config.vala"
gboolean config_clear_flickr_username (Config* self) {
#line 922 "Config.c"
	gboolean result = FALSE;
#line 181 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 926 "Config.c"
	result = config_set_flickr_username (self, "");
#line 182 "Config.vala"
	return result;
#line 930 "Config.c"
}


#line 185 "Config.vala"
gboolean config_set_flickr_username (Config* self, const char* username) {
#line 936 "Config.c"
	gboolean result = FALSE;
#line 185 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 185 "Config.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 942 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/username", username);
#line 186 "Config.vala"
	return result;
#line 946 "Config.c"
}


#line 189 "Config.vala"
char* config_get_flickr_username (Config* self) {
#line 952 "Config.c"
	char* result = NULL;
	char* stored_value;
	const char* _tmp0_;
#line 189 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 190 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/username", NULL);
#line 960 "Config.c"
	_tmp0_ = NULL;
#line 191 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 191 "Config.vala"
		_tmp0_ = stored_value;
#line 966 "Config.c"
	} else {
#line 191 "Config.vala"
		_tmp0_ = NULL;
#line 970 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 191 "Config.vala"
	return result;
#line 976 "Config.c"
}


#line 194 "Config.vala"
gboolean config_set_flickr_default_size (Config* self, gint sizecode) {
#line 982 "Config.c"
	gboolean result = FALSE;
#line 194 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 986 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/default_size", sizecode + 1);
#line 195 "Config.vala"
	return result;
#line 990 "Config.c"
}


#line 198 "Config.vala"
gint config_get_flickr_default_size (Config* self) {
#line 996 "Config.c"
	gint result = 0;
#line 198 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1000 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/default_size", 2) - 1;
#line 199 "Config.vala"
	return result;
#line 1004 "Config.c"
}


#line 202 "Config.vala"
gboolean config_set_flickr_visibility (Config* self, gint viscode) {
#line 1010 "Config.c"
	gboolean result = FALSE;
#line 202 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1014 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/visibility", viscode + 1);
#line 203 "Config.vala"
	return result;
#line 1018 "Config.c"
}


#line 206 "Config.vala"
gint config_get_flickr_visibility (Config* self) {
#line 1024 "Config.c"
	gint result = 0;
#line 206 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1028 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/visibility", 1) - 1;
#line 207 "Config.vala"
	return result;
#line 1032 "Config.c"
}


#line 210 "Config.vala"
gboolean config_set_default_service (Config* self, gint service_code) {
#line 1038 "Config.c"
	gboolean result = FALSE;
#line 210 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1042 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/default_service", service_code + 1);
#line 211 "Config.vala"
	return result;
#line 1046 "Config.c"
}


#line 214 "Config.vala"
gint config_get_default_service (Config* self) {
#line 1052 "Config.c"
	gint result = 0;
#line 214 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1056 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/default_service", 1) - 1;
#line 215 "Config.vala"
	return result;
#line 1060 "Config.c"
}


#line 218 "Config.vala"
gboolean config_clear_facebook_session_key (Config* self) {
#line 1066 "Config.c"
	gboolean result = FALSE;
#line 218 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1070 "Config.c"
	result = config_set_facebook_session_key (self, "");
#line 219 "Config.vala"
	return result;
#line 1074 "Config.c"
}


#line 222 "Config.vala"
gboolean config_set_facebook_session_key (Config* self, const char* key) {
#line 1080 "Config.c"
	gboolean result = FALSE;
#line 222 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 222 "Config.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 1086 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_key", key);
#line 223 "Config.vala"
	return result;
#line 1090 "Config.c"
}


#line 226 "Config.vala"
char* config_get_facebook_session_key (Config* self) {
#line 1096 "Config.c"
	char* result = NULL;
#line 226 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1100 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_key", NULL);
#line 227 "Config.vala"
	return result;
#line 1104 "Config.c"
}


#line 230 "Config.vala"
gboolean config_clear_facebook_session_secret (Config* self) {
#line 1110 "Config.c"
	gboolean result = FALSE;
#line 230 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1114 "Config.c"
	result = config_set_facebook_session_secret (self, "");
#line 231 "Config.vala"
	return result;
#line 1118 "Config.c"
}


#line 234 "Config.vala"
gboolean config_set_facebook_session_secret (Config* self, const char* secret) {
#line 1124 "Config.c"
	gboolean result = FALSE;
#line 234 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 234 "Config.vala"
	g_return_val_if_fail (secret != NULL, FALSE);
#line 1130 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_secret", secret);
#line 235 "Config.vala"
	return result;
#line 1134 "Config.c"
}


#line 238 "Config.vala"
char* config_get_facebook_session_secret (Config* self) {
#line 1140 "Config.c"
	char* result = NULL;
#line 238 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1144 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_secret", NULL);
#line 239 "Config.vala"
	return result;
#line 1148 "Config.c"
}


#line 242 "Config.vala"
gboolean config_clear_facebook_uid (Config* self) {
#line 1154 "Config.c"
	gboolean result = FALSE;
#line 242 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1158 "Config.c"
	result = config_set_facebook_uid (self, "");
#line 243 "Config.vala"
	return result;
#line 1162 "Config.c"
}


#line 246 "Config.vala"
gboolean config_set_facebook_uid (Config* self, const char* uid) {
#line 1168 "Config.c"
	gboolean result = FALSE;
#line 246 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 246 "Config.vala"
	g_return_val_if_fail (uid != NULL, FALSE);
#line 1174 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/uid", uid);
#line 247 "Config.vala"
	return result;
#line 1178 "Config.c"
}


#line 250 "Config.vala"
char* config_get_facebook_uid (Config* self) {
#line 1184 "Config.c"
	char* result = NULL;
#line 250 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1188 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/uid", NULL);
#line 251 "Config.vala"
	return result;
#line 1192 "Config.c"
}


#line 254 "Config.vala"
gboolean config_clear_facebook_user_name (Config* self) {
#line 1198 "Config.c"
	gboolean result = FALSE;
#line 254 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1202 "Config.c"
	result = config_set_facebook_user_name (self, "");
#line 255 "Config.vala"
	return result;
#line 1206 "Config.c"
}


#line 258 "Config.vala"
gboolean config_set_facebook_user_name (Config* self, const char* user_name) {
#line 1212 "Config.c"
	gboolean result = FALSE;
#line 258 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 258 "Config.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 1218 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/user_name", user_name);
#line 259 "Config.vala"
	return result;
#line 1222 "Config.c"
}


#line 262 "Config.vala"
char* config_get_facebook_user_name (Config* self) {
#line 1228 "Config.c"
	char* result = NULL;
#line 262 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1232 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/user_name", NULL);
#line 263 "Config.vala"
	return result;
#line 1236 "Config.c"
}


#line 266 "Config.vala"
gboolean config_set_picasa_user_name (Config* self, const char* user_name) {
#line 1242 "Config.c"
	gboolean result = FALSE;
#line 266 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 266 "Config.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 1248 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/picasa/user_name", user_name);
#line 267 "Config.vala"
	return result;
#line 1252 "Config.c"
}


#line 270 "Config.vala"
char* config_get_picasa_user_name (Config* self) {
#line 1258 "Config.c"
	char* result = NULL;
#line 270 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1262 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/picasa/user_name", NULL);
#line 271 "Config.vala"
	return result;
#line 1266 "Config.c"
}


#line 274 "Config.vala"
gboolean config_set_picasa_auth_token (Config* self, const char* auth_token) {
#line 1272 "Config.c"
	gboolean result = FALSE;
#line 274 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 274 "Config.vala"
	g_return_val_if_fail (auth_token != NULL, FALSE);
#line 1278 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/picasa/auth_token", auth_token);
#line 275 "Config.vala"
	return result;
#line 1282 "Config.c"
}


#line 278 "Config.vala"
gboolean config_set_picasa_default_size (Config* self, gint default_size) {
#line 1288 "Config.c"
	gboolean result = FALSE;
#line 278 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1292 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/picasa/default_size", default_size + 1);
#line 279 "Config.vala"
	return result;
#line 1296 "Config.c"
}


#line 282 "Config.vala"
gint config_get_picasa_default_size (Config* self) {
#line 1302 "Config.c"
	gint result = 0;
#line 282 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1306 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/picasa/default_size", 3) - 1;
#line 283 "Config.vala"
	return result;
#line 1310 "Config.c"
}


#line 286 "Config.vala"
char* config_get_picasa_auth_token (Config* self) {
#line 1316 "Config.c"
	char* result = NULL;
#line 286 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1320 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/picasa/auth_token", NULL);
#line 287 "Config.vala"
	return result;
#line 1324 "Config.c"
}


#line 290 "Config.vala"
gboolean config_set_printing_content_layout (Config* self, gint layout_code) {
#line 1330 "Config.c"
	gboolean result = FALSE;
#line 290 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1334 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_layout", layout_code + 1);
#line 291 "Config.vala"
	return result;
#line 1338 "Config.c"
}


#line 294 "Config.vala"
gint config_get_printing_content_layout (Config* self) {
#line 1344 "Config.c"
	gint result = 0;
#line 294 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1348 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_layout", 1) - 1;
#line 295 "Config.vala"
	return result;
#line 1352 "Config.c"
}


#line 298 "Config.vala"
gboolean config_set_printing_content_ppi (Config* self, gint content_ppi) {
#line 1358 "Config.c"
	gboolean result = FALSE;
#line 298 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1362 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_ppi", content_ppi);
#line 299 "Config.vala"
	return result;
#line 1366 "Config.c"
}


#line 302 "Config.vala"
gint config_get_printing_content_ppi (Config* self) {
#line 1372 "Config.c"
	gint result = 0;
#line 302 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1376 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_ppi", 600);
#line 303 "Config.vala"
	return result;
#line 1380 "Config.c"
}


#line 306 "Config.vala"
gboolean config_set_printing_content_width (Config* self, double content_width) {
#line 1386 "Config.c"
	gboolean result = FALSE;
#line 306 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1390 "Config.c"
	result = config_set_double (self, "/apps/shotwell/printing/content_width", content_width);
#line 307 "Config.vala"
	return result;
#line 1394 "Config.c"
}


#line 310 "Config.vala"
double config_get_printing_content_width (Config* self) {
#line 1400 "Config.c"
	double result = 0.0;
#line 310 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1404 "Config.c"
	result = config_get_double (self, "/apps/shotwell/printing/content_width", 7.0);
#line 311 "Config.vala"
	return result;
#line 1408 "Config.c"
}


#line 314 "Config.vala"
gboolean config_set_printing_content_height (Config* self, double content_height) {
#line 1414 "Config.c"
	gboolean result = FALSE;
#line 314 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1418 "Config.c"
	result = config_set_double (self, "/apps/shotwell/printing/content_height", content_height);
#line 315 "Config.vala"
	return result;
#line 1422 "Config.c"
}


#line 318 "Config.vala"
double config_get_printing_content_height (Config* self) {
#line 1428 "Config.c"
	double result = 0.0;
#line 318 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1432 "Config.c"
	result = config_get_double (self, "/apps/shotwell/printing/content_height", 5.0);
#line 319 "Config.vala"
	return result;
#line 1436 "Config.c"
}


#line 322 "Config.vala"
gboolean config_set_printing_content_units (Config* self, gint units_code) {
#line 1442 "Config.c"
	gboolean result = FALSE;
#line 322 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1446 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_units", units_code + 1);
#line 323 "Config.vala"
	return result;
#line 1450 "Config.c"
}


#line 326 "Config.vala"
gint config_get_printing_content_units (Config* self) {
#line 1456 "Config.c"
	gint result = 0;
#line 326 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1460 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_units", 1) - 1;
#line 327 "Config.vala"
	return result;
#line 1464 "Config.c"
}


#line 330 "Config.vala"
gboolean config_set_printing_size_selection (Config* self, gint size_code) {
#line 1470 "Config.c"
	gboolean result = FALSE;
#line 330 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1474 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/size_selection", size_code + 1);
#line 331 "Config.vala"
	return result;
#line 1478 "Config.c"
}


#line 334 "Config.vala"
gint config_get_printing_size_selection (Config* self) {
#line 1484 "Config.c"
	gint result = 0;
#line 334 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1488 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/size_selection", 1) - 1;
#line 335 "Config.vala"
	return result;
#line 1492 "Config.c"
}


#line 338 "Config.vala"
gboolean config_set_printing_match_aspect_ratio (Config* self, gboolean match_aspect_ratio) {
#line 1498 "Config.c"
	gboolean result = FALSE;
#line 338 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1502 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/printing/match_aspect_ratio", match_aspect_ratio);
#line 339 "Config.vala"
	return result;
#line 1506 "Config.c"
}


#line 342 "Config.vala"
gboolean config_get_printing_match_aspect_ratio (Config* self) {
#line 1512 "Config.c"
	gboolean result = FALSE;
#line 342 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1516 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/printing/match_aspect_ratio", TRUE);
#line 343 "Config.vala"
	return result;
#line 1520 "Config.c"
}


#line 346 "Config.vala"
gboolean config_set_display_basic_properties (Config* self, gboolean display) {
#line 1526 "Config.c"
	gboolean result = FALSE;
#line 346 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1530 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", display);
#line 347 "Config.vala"
	return result;
#line 1534 "Config.c"
}


#line 350 "Config.vala"
gboolean config_get_display_basic_properties (Config* self) {
#line 1540 "Config.c"
	gboolean result = FALSE;
#line 350 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1544 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", TRUE);
#line 351 "Config.vala"
	return result;
#line 1548 "Config.c"
}


#line 354 "Config.vala"
gboolean config_set_display_extended_properties (Config* self, gboolean display) {
#line 1554 "Config.c"
	gboolean result = FALSE;
#line 354 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1558 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", display);
#line 355 "Config.vala"
	return result;
#line 1562 "Config.c"
}


#line 358 "Config.vala"
gboolean config_get_display_extended_properties (Config* self) {
#line 1568 "Config.c"
	gboolean result = FALSE;
#line 358 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1572 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", FALSE);
#line 359 "Config.vala"
	return result;
#line 1576 "Config.c"
}


#line 362 "Config.vala"
gboolean config_set_display_photo_titles (Config* self, gboolean display) {
#line 1582 "Config.c"
	gboolean result = FALSE;
#line 362 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1586 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", display);
#line 363 "Config.vala"
	return result;
#line 1590 "Config.c"
}


#line 366 "Config.vala"
gboolean config_get_display_photo_titles (Config* self) {
#line 1596 "Config.c"
	gboolean result = FALSE;
#line 366 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1600 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", FALSE);
#line 367 "Config.vala"
	return result;
#line 1604 "Config.c"
}


#line 370 "Config.vala"
gboolean config_get_display_photo_tags (Config* self) {
#line 1610 "Config.c"
	gboolean result = FALSE;
#line 370 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1614 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_tags", TRUE);
#line 371 "Config.vala"
	return result;
#line 1618 "Config.c"
}


#line 374 "Config.vala"
gboolean config_set_display_photo_tags (Config* self, gboolean display) {
#line 1624 "Config.c"
	gboolean result = FALSE;
#line 374 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1628 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_tags", display);
#line 375 "Config.vala"
	return result;
#line 1632 "Config.c"
}


#line 378 "Config.vala"
gboolean config_get_display_photo_ratings (Config* self) {
#line 1638 "Config.c"
	gboolean result = FALSE;
#line 378 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1642 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_ratings", TRUE);
#line 379 "Config.vala"
	return result;
#line 1646 "Config.c"
}


#line 382 "Config.vala"
gboolean config_set_display_photo_ratings (Config* self, gboolean display) {
#line 1652 "Config.c"
	gboolean result = FALSE;
#line 382 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1656 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_ratings", display);
#line 383 "Config.vala"
	return result;
#line 1660 "Config.c"
}


#line 386 "Config.vala"
gboolean config_set_slideshow_delay (Config* self, double delay) {
#line 1666 "Config.c"
	gboolean result = FALSE;
#line 386 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1670 "Config.c"
	result = config_set_double (self, "/apps/shotwell/preferences/slideshow/delay", delay);
#line 387 "Config.vala"
	return result;
#line 1674 "Config.c"
}


#line 390 "Config.vala"
double config_get_slideshow_delay (Config* self) {
#line 1680 "Config.c"
	double result = 0.0;
#line 390 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1684 "Config.c"
	result = CLAMP (config_get_double (self, "/apps/shotwell/preferences/slideshow/delay", CONFIG_SLIDESHOW_DELAY_DEFAULT), CONFIG_SLIDESHOW_DELAY_MIN, CONFIG_SLIDESHOW_DELAY_MAX);
#line 391 "Config.vala"
	return result;
#line 1688 "Config.c"
}


#line 395 "Config.vala"
RatingFilter config_get_photo_rating_filter (Config* self) {
#line 1694 "Config.c"
	RatingFilter result = 0;
#line 395 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1698 "Config.c"
	result = (RatingFilter) config_get_int (self, "/apps/shotwell/preferences/ui/photo_rating_filter", (gint) RATING_FILTER_UNRATED_OR_HIGHER);
#line 396 "Config.vala"
	return result;
#line 1702 "Config.c"
}


#line 400 "Config.vala"
gboolean config_set_photo_rating_filter (Config* self, RatingFilter filter) {
#line 1708 "Config.c"
	gboolean result = FALSE;
#line 400 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1712 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/ui/photo_rating_filter", (gint) filter);
#line 401 "Config.vala"
	return result;
#line 1716 "Config.c"
}


#line 404 "Config.vala"
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1722 "Config.c"
	Dimensions _tmp0_ = {0};
#line 404 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 405 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/library_maximize", FALSE);
#line 406 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/library_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/library_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1730 "Config.c"
}


#line 411 "Config.vala"
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1736 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 411 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 412 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/library_maximize", maximize)) {
#line 413 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/library_width", (*dimensions).width);
#line 1746 "Config.c"
	} else {
#line 412 "Config.vala"
		_tmp1_ = FALSE;
#line 1750 "Config.c"
	}
#line 412 "Config.vala"
	if (_tmp1_) {
#line 414 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/library_height", (*dimensions).height);
#line 1756 "Config.c"
	} else {
#line 412 "Config.vala"
		_tmp0_ = FALSE;
#line 1760 "Config.c"
	}
	result = _tmp0_;
#line 412 "Config.vala"
	return result;
#line 1765 "Config.c"
}


#line 417 "Config.vala"
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1771 "Config.c"
	Dimensions _tmp0_ = {0};
#line 417 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 418 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/direct_maximize", FALSE);
#line 419 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/direct_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/direct_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1779 "Config.c"
}


#line 424 "Config.vala"
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1785 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 424 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 425 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/direct_maximize", maximize)) {
#line 426 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_width", (*dimensions).width);
#line 1795 "Config.c"
	} else {
#line 425 "Config.vala"
		_tmp1_ = FALSE;
#line 1799 "Config.c"
	}
#line 425 "Config.vala"
	if (_tmp1_) {
#line 427 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_height", (*dimensions).height);
#line 1805 "Config.c"
	} else {
#line 425 "Config.vala"
		_tmp0_ = FALSE;
#line 1809 "Config.c"
	}
	result = _tmp0_;
#line 425 "Config.vala"
	return result;
#line 1814 "Config.c"
}


#line 430 "Config.vala"
gint config_get_sidebar_position (Config* self) {
#line 1820 "Config.c"
	gint result = 0;
#line 430 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1824 "Config.c"
	result = CLAMP (config_get_int (self, "/apps/shotwell/preferences/window/pane_position", CONFIG_SIDEBAR_MIN_POSITION), CONFIG_SIDEBAR_MIN_POSITION, CONFIG_SIDEBAR_MAX_POSITION);
#line 431 "Config.vala"
	return result;
#line 1828 "Config.c"
}


#line 434 "Config.vala"
gboolean config_set_sidebar_position (Config* self, gint position) {
#line 1834 "Config.c"
	gboolean result = FALSE;
#line 434 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1838 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/window/pane_position", position);
#line 435 "Config.vala"
	return result;
#line 1842 "Config.c"
}


#line 438 "Config.vala"
gboolean config_get_events_sort_ascending (Config* self) {
#line 1848 "Config.c"
	gboolean result = FALSE;
#line 438 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1852 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", FALSE);
#line 439 "Config.vala"
	return result;
#line 1856 "Config.c"
}


#line 442 "Config.vala"
gboolean config_set_events_sort_ascending (Config* self, gboolean sort) {
#line 1862 "Config.c"
	gboolean result = FALSE;
#line 442 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1866 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", sort);
#line 443 "Config.vala"
	return result;
#line 1870 "Config.c"
}


#line 446 "Config.vala"
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 446 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 447 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", FALSE);
#line 448 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", (gint) COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE);
#line 1882 "Config.c"
}


#line 451 "Config.vala"
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1888 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 451 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 452 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", sort_order)) {
#line 453 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", sort_by);
#line 1897 "Config.c"
	} else {
#line 452 "Config.vala"
		_tmp0_ = FALSE;
#line 1901 "Config.c"
	}
	result = _tmp0_;
#line 452 "Config.vala"
	return result;
#line 1906 "Config.c"
}


#line 456 "Config.vala"
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 456 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 457 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", TRUE);
#line 458 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", (gint) COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE);
#line 1918 "Config.c"
}


#line 461 "Config.vala"
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1924 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 461 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 462 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", sort_order)) {
#line 463 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", sort_by);
#line 1933 "Config.c"
	} else {
#line 462 "Config.vala"
		_tmp0_ = FALSE;
#line 1937 "Config.c"
	}
	result = _tmp0_;
#line 462 "Config.vala"
	return result;
#line 1942 "Config.c"
}


#line 466 "Config.vala"
gboolean config_get_24_hr_time (Config* self) {
#line 1948 "Config.c"
	gboolean result = FALSE;
#line 466 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1952 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/twentyfour_hr_time", is_twentyfour_hr_time_system ());
#line 467 "Config.vala"
	return result;
#line 1956 "Config.c"
}


#line 471 "Config.vala"
gboolean config_set_24_hr_time (Config* self, gboolean twentyfour_hr_time) {
#line 1962 "Config.c"
	gboolean result = FALSE;
#line 471 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1966 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/twentyfour_hr_time", twentyfour_hr_time);
#line 472 "Config.vala"
	return result;
#line 1970 "Config.c"
}


#line 475 "Config.vala"
gboolean config_get_keep_relativity (Config* self) {
#line 1976 "Config.c"
	gboolean result = FALSE;
#line 475 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1980 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/keep_relativity", TRUE);
#line 476 "Config.vala"
	return result;
#line 1984 "Config.c"
}


#line 479 "Config.vala"
gboolean config_set_keep_relativity (Config* self, gboolean keep_relativity) {
#line 1990 "Config.c"
	gboolean result = FALSE;
#line 479 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1994 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/keep_relativity", keep_relativity);
#line 480 "Config.vala"
	return result;
#line 1998 "Config.c"
}


#line 483 "Config.vala"
gboolean config_get_modify_originals (Config* self) {
#line 2004 "Config.c"
	gboolean result = FALSE;
#line 483 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2008 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/modify_originals", FALSE);
#line 484 "Config.vala"
	return result;
#line 2012 "Config.c"
}


#line 487 "Config.vala"
gboolean config_set_modify_originals (Config* self, gboolean modify_originals) {
#line 2018 "Config.c"
	gboolean result = FALSE;
#line 487 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2022 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/modify_originals", modify_originals);
#line 488 "Config.vala"
	return result;
#line 2026 "Config.c"
}


#line 492 "Config.vala"
char* config_get_background (Config* self) {
#line 2032 "Config.c"
	char* result = NULL;
#line 492 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 2036 "Config.c"
	result = config_get_string (self, "/desktop/gnome/background/picture_filename", NULL);
#line 493 "Config.vala"
	return result;
#line 2040 "Config.c"
}


#line 496 "Config.vala"
gboolean config_set_background (Config* self, const char* filename) {
#line 2046 "Config.c"
	gboolean result = FALSE;
#line 496 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 496 "Config.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 497 "Config.vala"
	if (!config_set_string (self, "/desktop/gnome/background/picture_options", "zoom")) {
#line 2054 "Config.c"
		result = FALSE;
#line 498 "Config.vala"
		return result;
#line 2058 "Config.c"
	}
	result = config_set_string (self, "/desktop/gnome/background/picture_filename", filename);
#line 499 "Config.vala"
	return result;
#line 2063 "Config.c"
}


#line 503 "Config.vala"
gboolean config_get_show_welcome_dialog (Config* self) {
#line 2069 "Config.c"
	gboolean result = FALSE;
#line 503 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2073 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/show_welcome_dialog", TRUE);
#line 504 "Config.vala"
	return result;
#line 2077 "Config.c"
}


#line 507 "Config.vala"
gboolean config_set_show_welcome_dialog (Config* self, gboolean show) {
#line 2083 "Config.c"
	gboolean result = FALSE;
#line 507 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2087 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/show_welcome_dialog", show);
#line 508 "Config.vala"
	return result;
#line 2091 "Config.c"
}


#line 511 "Config.vala"
gboolean config_set_photo_thumbnail_scale (Config* self, gint scale) {
#line 2097 "Config.c"
	gboolean result = FALSE;
#line 511 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2101 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/ui/photo_thumbnail_scale", scale);
#line 512 "Config.vala"
	return result;
#line 2105 "Config.c"
}


#line 515 "Config.vala"
gint config_get_photo_thumbnail_scale (Config* self) {
#line 2111 "Config.c"
	gint result = 0;
#line 515 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 2115 "Config.c"
	result = CLAMP (config_get_int (self, "/apps/shotwell/preferences/ui/photo_thumbnail_scale", THUMBNAIL_DEFAULT_SCALE), THUMBNAIL_MIN_SCALE, THUMBNAIL_MAX_SCALE);
#line 516 "Config.vala"
	return result;
#line 2119 "Config.c"
}


#line 521 "Config.vala"
static void config_get_colors (Config* self) {
#line 2125 "Config.c"
	char* _tmp0_;
	GdkColor _tmp2_ = {0};
	GdkColor _tmp3_;
#line 521 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 522 "Config.vala"
	self->priv->bg_color = (_tmp0_ = config_get_string (self, "/apps/shotwell/preferences/ui/background_color", CONFIG_DEFAULT_BG_COLOR), _g_free0 (self->priv->bg_color), _tmp0_);
#line 524 "Config.vala"
	if (!is_color_parsable (self->priv->bg_color)) {
#line 2135 "Config.c"
		char* _tmp1_;
#line 525 "Config.vala"
		self->priv->bg_color = (_tmp1_ = g_strdup (CONFIG_DEFAULT_BG_COLOR), _g_free0 (self->priv->bg_color), _tmp1_);
#line 2139 "Config.c"
	}
#line 527 "Config.vala"
	config_set_text_colors (self, (_tmp3_ = (parse_color (self->priv->bg_color, &_tmp2_), _tmp2_), &_tmp3_));
#line 2143 "Config.c"
}


#line 530 "Config.vala"
void config_get_bg_color (Config* self, GdkColor* result) {
#line 2149 "Config.c"
	GdkColor _tmp0_ = {0};
#line 530 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 531 "Config.vala"
	if (is_string_empty (self->priv->bg_color)) {
#line 532 "Config.vala"
		config_get_colors (self);
#line 2157 "Config.c"
	}
	*result = (parse_color (self->priv->bg_color, &_tmp0_), _tmp0_);
#line 534 "Config.vala"
	return;
#line 2162 "Config.c"
}


#line 537 "Config.vala"
void config_get_selected_color (Config* self, gboolean in_focus, GdkColor* result) {
#line 537 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 538 "Config.vala"
	if (in_focus) {
#line 2172 "Config.c"
		GdkColor _tmp0_ = {0};
#line 539 "Config.vala"
		if (is_string_empty (self->priv->selected_color)) {
#line 540 "Config.vala"
			config_get_colors (self);
#line 2178 "Config.c"
		}
		*result = (parse_color (self->priv->selected_color, &_tmp0_), _tmp0_);
#line 542 "Config.vala"
		return;
#line 2183 "Config.c"
	} else {
		GdkColor _tmp1_ = {0};
#line 544 "Config.vala"
		if (is_string_empty (self->priv->unfocused_selected_color)) {
#line 545 "Config.vala"
			config_get_colors (self);
#line 2190 "Config.c"
		}
		*result = (parse_color (self->priv->unfocused_selected_color, &_tmp1_), _tmp1_);
#line 547 "Config.vala"
		return;
#line 2195 "Config.c"
	}
}


#line 551 "Config.vala"
void config_get_unselected_color (Config* self, GdkColor* result) {
#line 2202 "Config.c"
	GdkColor _tmp0_ = {0};
#line 551 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 552 "Config.vala"
	if (is_string_empty (self->priv->unselected_color)) {
#line 553 "Config.vala"
		config_get_colors (self);
#line 2210 "Config.c"
	}
	*result = (parse_color (self->priv->unselected_color, &_tmp0_), _tmp0_);
#line 555 "Config.vala"
	return;
#line 2215 "Config.c"
}


#line 558 "Config.vala"
void config_get_border_color (Config* self, GdkColor* result) {
#line 2221 "Config.c"
	GdkColor _tmp0_ = {0};
#line 558 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 559 "Config.vala"
	if (is_string_empty (self->priv->border_color)) {
#line 560 "Config.vala"
		config_get_colors (self);
#line 2229 "Config.c"
	}
	*result = (parse_color (self->priv->border_color, &_tmp0_), _tmp0_);
#line 562 "Config.vala"
	return;
#line 2234 "Config.c"
}


#line 565 "Config.vala"
static void config_set_text_colors (Config* self, GdkColor* bg_color) {
#line 565 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 569 "Config.vala"
	if ((*bg_color).red > CONFIG_BLACK_THRESHOLD) {
#line 2244 "Config.c"
		char* _tmp0_;
		char* _tmp1_;
		char* _tmp2_;
		char* _tmp3_;
#line 570 "Config.vala"
		self->priv->selected_color = (_tmp0_ = g_strdup (CONFIG_DARK_SELECTED_COLOR), _g_free0 (self->priv->selected_color), _tmp0_);
#line 571 "Config.vala"
		self->priv->unselected_color = (_tmp1_ = g_strdup (CONFIG_DARK_UNSELECTED_COLOR), _g_free0 (self->priv->unselected_color), _tmp1_);
#line 572 "Config.vala"
		self->priv->unfocused_selected_color = (_tmp2_ = g_strdup (CONFIG_DARK_UNFOCUSED_SELECTED_COLOR), _g_free0 (self->priv->unfocused_selected_color), _tmp2_);
#line 573 "Config.vala"
		self->priv->border_color = (_tmp3_ = g_strdup (CONFIG_DARK_BORDER_COLOR), _g_free0 (self->priv->border_color), _tmp3_);
#line 2257 "Config.c"
	} else {
		char* _tmp4_;
		char* _tmp5_;
		char* _tmp6_;
		char* _tmp7_;
#line 575 "Config.vala"
		self->priv->selected_color = (_tmp4_ = g_strdup (CONFIG_LIGHT_SELECTED_COLOR), _g_free0 (self->priv->selected_color), _tmp4_);
#line 576 "Config.vala"
		self->priv->unselected_color = (_tmp5_ = g_strdup (CONFIG_LIGHT_UNSELECTED_COLOR), _g_free0 (self->priv->unselected_color), _tmp5_);
#line 577 "Config.vala"
		self->priv->unfocused_selected_color = (_tmp6_ = g_strdup (CONFIG_LIGHT_UNFOCUSED_SELECTED_COLOR), _g_free0 (self->priv->unfocused_selected_color), _tmp6_);
#line 578 "Config.vala"
		self->priv->border_color = (_tmp7_ = g_strdup (CONFIG_LIGHT_BORDER_COLOR), _g_free0 (self->priv->border_color), _tmp7_);
#line 2271 "Config.c"
	}
}


#line 582 "Config.vala"
void config_set_bg_color (Config* self, GdkColor* color) {
#line 2278 "Config.c"
	char* _tmp0_;
#line 582 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 583 "Config.vala"
	self->priv->bg_color = (_tmp0_ = gdk_color_to_string (color), _g_free0 (self->priv->bg_color), _tmp0_);
#line 585 "Config.vala"
	config_set_text_colors (self, color);
#line 587 "Config.vala"
	g_signal_emit_by_name (self, "colors-changed");
#line 2288 "Config.c"
}


#line 590 "Config.vala"
gboolean config_commit_bg_color (Config* self) {
#line 2294 "Config.c"
	gboolean result = FALSE;
#line 590 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2298 "Config.c"
	result = config_set_string (self, "/apps/shotwell/preferences/ui/background_color", self->priv->bg_color);
#line 591 "Config.vala"
	return result;
#line 2302 "Config.c"
}


#line 594 "Config.vala"
char* config_get_import_dir (Config* self) {
#line 2308 "Config.c"
	char* result = NULL;
#line 594 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 2312 "Config.c"
	result = config_get_string (self, "/apps/shotwell/preferences/files/import_dir", NULL);
#line 595 "Config.vala"
	return result;
#line 2316 "Config.c"
}


#line 598 "Config.vala"
void config_set_import_dir (Config* self, const char* import_dir) {
#line 598 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 598 "Config.vala"
	g_return_if_fail (import_dir != NULL);
#line 599 "Config.vala"
	config_set_string (self, "/apps/shotwell/preferences/files/import_dir", import_dir);
#line 2328 "Config.c"
}


#line 602 "Config.vala"
char* config_get_external_photo_app (Config* self) {
#line 2334 "Config.c"
	char* result = NULL;
	char* external_app;
	GeeArrayList* preferred_apps;
	gint _tmp0_;
	char** _tmp1_;
	gint _tmp1__length1;
	char** _tmp2_;
	GAppInfo* _tmp3_;
	GAppInfo* app;
	char* _tmp4_;
#line 602 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 603 "Config.vala"
	external_app = config_get_string (self, "/apps/shotwell/preferences/editing/external_photo_editor", "");
#line 605 "Config.vala"
	if (!is_string_empty (external_app)) {
#line 2351 "Config.c"
		result = external_app;
#line 606 "Config.vala"
		return result;
#line 2355 "Config.c"
	}
#line 608 "Config.vala"
	preferred_apps = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 609 "Config.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (preferred_apps), "GIMP");
#line 611 "Config.vala"
	app = (_tmp3_ = (_tmp2_ = (_tmp1_ = photo_file_format_get_editable_mime_types (&_tmp0_), _tmp1__length1 = _tmp0_, _tmp1_), get_default_app_for_mime_types (_tmp2_, _tmp0_, preferred_apps)), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL), _tmp3_);
#line 2363 "Config.c"
	_tmp4_ = NULL;
#line 612 "Config.vala"
	if (app != NULL) {
#line 2367 "Config.c"
		char* _tmp5_;
#line 612 "Config.vala"
		_tmp4_ = (_tmp5_ = get_app_open_command (app), _g_free0 (_tmp4_), _tmp5_);
#line 2371 "Config.c"
	} else {
		char* _tmp6_;
#line 612 "Config.vala"
		_tmp4_ = (_tmp6_ = g_strdup (""), _g_free0 (_tmp4_), _tmp6_);
#line 2376 "Config.c"
	}
	result = _tmp4_;
	_g_object_unref0 (app);
	_g_object_unref0 (preferred_apps);
	_g_free0 (external_app);
#line 612 "Config.vala"
	return result;
#line 2384 "Config.c"
}


#line 615 "Config.vala"
void config_set_external_photo_app (Config* self, const char* external_photo_app) {
#line 615 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 615 "Config.vala"
	g_return_if_fail (external_photo_app != NULL);
#line 616 "Config.vala"
	config_set_string (self, "/apps/shotwell/preferences/editing/external_photo_editor", external_photo_app);
#line 618 "Config.vala"
	g_signal_emit_by_name (self, "external-app-changed");
#line 2398 "Config.c"
}


#line 622 "Config.vala"
char* config_get_external_raw_app (Config* self) {
#line 2404 "Config.c"
	char* result = NULL;
	char* external_app;
	GeeArrayList* preferred_apps;
	gint _tmp0_;
	char** _tmp1_;
	gint _tmp1__length1;
	char** _tmp2_;
	GAppInfo* _tmp3_;
	GAppInfo* app;
	char* _tmp4_;
#line 622 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 623 "Config.vala"
	external_app = config_get_string (self, "/apps/shotwell/preferences/editing/external_raw_editor", "");
#line 625 "Config.vala"
	if (!is_string_empty (external_app)) {
#line 2421 "Config.c"
		result = external_app;
#line 626 "Config.vala"
		return result;
#line 2425 "Config.c"
	}
#line 628 "Config.vala"
	preferred_apps = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 629 "Config.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (preferred_apps), "UFRaw");
#line 631 "Config.vala"
	app = (_tmp3_ = (_tmp2_ = (_tmp1_ = photo_file_format_get_mime_types (PHOTO_FILE_FORMAT_RAW, &_tmp0_), _tmp1__length1 = _tmp0_, _tmp1_), get_default_app_for_mime_types (_tmp2_, _tmp0_, preferred_apps)), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL), _tmp3_);
#line 2433 "Config.c"
	_tmp4_ = NULL;
#line 632 "Config.vala"
	if (app != NULL) {
#line 2437 "Config.c"
		char* _tmp5_;
#line 632 "Config.vala"
		_tmp4_ = (_tmp5_ = get_app_open_command (app), _g_free0 (_tmp4_), _tmp5_);
#line 2441 "Config.c"
	} else {
		char* _tmp6_;
#line 632 "Config.vala"
		_tmp4_ = (_tmp6_ = g_strdup (""), _g_free0 (_tmp4_), _tmp6_);
#line 2446 "Config.c"
	}
	result = _tmp4_;
	_g_object_unref0 (app);
	_g_object_unref0 (preferred_apps);
	_g_free0 (external_app);
#line 632 "Config.vala"
	return result;
#line 2454 "Config.c"
}


#line 636 "Config.vala"
void config_set_external_raw_app (Config* self, const char* external_raw_app) {
#line 636 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 636 "Config.vala"
	g_return_if_fail (external_raw_app != NULL);
#line 637 "Config.vala"
	config_set_string (self, "/apps/shotwell/preferences/editing/external_raw_editor", external_raw_app);
#line 638 "Config.vala"
	g_signal_emit_by_name (self, "external-app-changed");
#line 2468 "Config.c"
}


static void value_config_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_config_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		config_unref (value->data[0].v_pointer);
	}
}


static void value_config_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = config_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_config_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_config_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Config* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = config_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_config_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Config** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = config_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecConfig* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIG), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_config (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG), NULL);
	return value->data[0].v_pointer;
}


void value_set_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		config_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


void value_take_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


static void config_class_init (ConfigClass * klass) {
	config_parent_class = g_type_class_peek_parent (klass);
	CONFIG_CLASS (klass)->finalize = config_finalize;
	g_type_class_add_private (klass, sizeof (ConfigPrivate));
	g_signal_new ("colors_changed", TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("external_app_changed", TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void config_instance_init (Config * self) {
	self->priv = CONFIG_GET_PRIVATE (self);
	self->priv->bg_color = NULL;
	self->priv->selected_color = NULL;
	self->priv->unselected_color = NULL;
	self->priv->unfocused_selected_color = NULL;
	self->priv->border_color = NULL;
	self->ref_count = 1;
}


static void config_finalize (Config* obj) {
	Config * self;
	self = CONFIG (obj);
	_g_free0 (self->priv->bg_color);
	_g_free0 (self->priv->selected_color);
	_g_free0 (self->priv->unselected_color);
	_g_free0 (self->priv->unfocused_selected_color);
	_g_free0 (self->priv->border_color);
	_g_object_unref0 (self->priv->client);
}


GType config_get_type (void) {
	static volatile gsize config_type_id__volatile = 0;
	if (g_once_init_enter (&config_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_config_init, value_config_free_value, value_config_copy_value, value_config_peek_pointer, "p", value_config_collect_value, "p", value_config_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Config), 0, (GInstanceInitFunc) config_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType config_type_id;
		config_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Config", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&config_type_id__volatile, config_type_id);
	}
	return config_type_id__volatile;
}


gpointer config_ref (gpointer instance) {
	Config* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void config_unref (gpointer instance) {
	Config* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CONFIG_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




