/* LibraryMonitor.c generated by valac 0.9.8, the Vala compiler
 * generated from LibraryMonitor.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* LibraryMonitor uses DirectoryMonitor to track assets in the user's library directory and make*/
/* sure they're reflected in the application.*/
/**/
/* NOTE: There appears to be a bug where prior versions of Shotwell (>= 0.6.x) were not*/
/* properly loading the file modification timestamp during import.  This was no issue*/
/* before but becomes imperative now with file monitoring.  A "proper" algorithm is*/
/* to reimport an entire photo if the modification time in the database is different*/
/* than the file's, but that's Real Bad when the user first turns on monitoring, as it*/
/* will cause a lot of reimports (think of a 10,000 photo database) and will blow away*/
/* ALL transformations, as they are now suspect.*/
/**/
/* So: If the modification time is zero and filesize is the same, simply update the*/
/* timestamp in the database and move on.*/
/**/
/* TODO: Although it seems highly unlikely that a file's timestamp could change but the file size*/
/* has not and the file really be "changed", it *is* possible, even in the case of complex little*/
/* animals like photo files.  We could be more liberal and treat this case as a metadata-changed*/
/* situation (since that's a likely case).*/
/**/
/* NOTE: Current implementation is only to check all photos at initialization, with no auto-import*/
/* and no realtime monitoring (http://trac.yorba.org/ticket/2302).  Auto-import and realtime*/
/* monitoring will be added later.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
typedef struct _LibraryMonitorPrivate LibraryMonitorPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_TRANSFORMABLE_PHOTO (transformable_photo_get_type ())
#define TRANSFORMABLE_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSFORMABLE_PHOTO, TransformablePhoto))
#define TRANSFORMABLE_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSFORMABLE_PHOTO, TransformablePhotoClass))
#define IS_TRANSFORMABLE_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSFORMABLE_PHOTO))
#define IS_TRANSFORMABLE_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSFORMABLE_PHOTO))
#define TRANSFORMABLE_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSFORMABLE_PHOTO, TransformablePhotoClass))

typedef struct _TransformablePhoto TransformablePhoto;
typedef struct _TransformablePhotoClass TransformablePhotoClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LibraryMonitorVerifyExternalPhotoData LibraryMonitorVerifyExternalPhotoData;

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _LibraryMonitor {
	DirectoryMonitor parent_instance;
	LibraryMonitorPrivate * priv;
};

struct _LibraryMonitorClass {
	DirectoryMonitorClass parent_class;
};

struct _LibraryMonitorPrivate {
	GCancellable* cancellable;
	GeeHashSet* discovered;
	GeeArrayList* external_mark_online;
	GeeArrayList* external_mark_offline;
	gint verify_external_outstanding;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE
} LibraryPhotoSourceCollectionState;

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _LibraryMonitorVerifyExternalPhotoData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	LibraryMonitor* self;
	LibraryPhoto* photo;
	GFile* master;
	GFileInfo* info;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError * err;
	GError * _inner_error_;
};


extern LibraryPhotoSourceCollection* library_photo_global;
static gpointer library_monitor_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_source_get_type (void) G_GNUC_CONST;
GType transformable_photo_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType library_photo_get_type (void) G_GNUC_CONST;
#define LIBRARY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_MONITOR, LibraryMonitorPrivate))
enum  {
	LIBRARY_MONITOR_DUMMY_PROPERTY
};
LibraryMonitor* library_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
LibraryMonitor* library_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
static void library_monitor_real_close (DirectoryMonitor* base);
void directory_monitor_close (DirectoryMonitor* self);
static void library_monitor_real_discovery_started (DirectoryMonitor* base);
static void library_monitor_real_file_discovered (DirectoryMonitor* base, GFile* file, GFileInfo* info);
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
static void library_monitor_real_discovery_completed (DirectoryMonitor* base);
GType marker_get_type (void) G_GNUC_CONST;
Marker* data_collection_start_marking (DataCollection* self);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
GFile* transformable_photo_get_master_file (TransformablePhoto* self);
gboolean library_photo_is_offline (LibraryPhoto* self);
void marker_mark (Marker* self, DataObject* object);
GeeCollection* data_collection_get_all (DataCollection* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file);
static void library_monitor_launch_verify_external_photo (LibraryMonitor* self, LibraryPhoto* photo);
void library_photo_source_collection_mark_online_offline (LibraryPhotoSourceCollection* self, Marker* online, Marker* offline);
GeeCollection* library_photo_source_collection_get_offline (LibraryPhotoSourceCollection* self);
void directory_monitor_mdbg (DirectoryMonitor* self, const char* msg);
static void library_monitor_verify_external_photo (LibraryMonitor* self, LibraryPhoto* photo, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void library_monitor_verify_external_photo_finish (LibraryMonitor* self, GAsyncResult* _res_);
static void library_monitor_verify_external_complete (LibraryMonitor* self);
static void _library_monitor_verify_external_complete_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void library_monitor_verify_external_photo_data_free (gpointer _data);
static void library_monitor_verify_external_photo_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean library_monitor_verify_external_photo_co (LibraryMonitorVerifyExternalPhotoData* data);
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
void data_collection_freeze_notifications (DataCollection* self);
void library_photo_mark_online (LibraryPhoto* self);
void data_collection_thaw_notifications (DataCollection* self);
gboolean spin_event_loop (void);
void library_photo_mark_offline (LibraryPhoto* self);
static void library_monitor_finalize (GObject* obj);



#line 39 "LibraryMonitor.vala"
LibraryMonitor* library_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
#line 359 "LibraryMonitor.c"
	LibraryMonitor * self;
#line 39 "LibraryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), NULL);
#line 40 "LibraryMonitor.vala"
	self = (LibraryMonitor*) directory_monitor_construct (object_type, root, recurse, monitoring);
#line 365 "LibraryMonitor.c"
	return self;
}


#line 39 "LibraryMonitor.vala"
LibraryMonitor* library_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
#line 39 "LibraryMonitor.vala"
	return library_monitor_construct (TYPE_LIBRARY_MONITOR, root, recurse, monitoring);
#line 374 "LibraryMonitor.c"
}


#line 43 "LibraryMonitor.vala"
static void library_monitor_real_close (DirectoryMonitor* base) {
#line 380 "LibraryMonitor.c"
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (base);
#line 44 "LibraryMonitor.vala"
	g_cancellable_cancel (self->priv->cancellable);
#line 46 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->close (DIRECTORY_MONITOR (self));
#line 387 "LibraryMonitor.c"
}


#line 49 "LibraryMonitor.vala"
static void library_monitor_real_discovery_started (DirectoryMonitor* base) {
#line 393 "LibraryMonitor.c"
	LibraryMonitor * self;
	GeeHashSet* _tmp0_;
	self = LIBRARY_MONITOR (base);
#line 50 "LibraryMonitor.vala"
	self->priv->discovered = (_tmp0_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->discovered), _tmp0_);
#line 52 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_started (DIRECTORY_MONITOR (self));
#line 401 "LibraryMonitor.c"
}


#line 55 "LibraryMonitor.vala"
static void library_monitor_real_file_discovered (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
#line 407 "LibraryMonitor.c"
	LibraryMonitor * self;
	LibraryPhotoSourceCollectionState state = 0;
	LibraryPhoto* photo;
	self = LIBRARY_MONITOR (base);
#line 55 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 55 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 58 "LibraryMonitor.vala"
	photo = library_photo_source_collection_get_state_by_file (library_photo_global, file, &state);
#line 59 "LibraryMonitor.vala"
	if (photo != NULL) {
#line 60 "LibraryMonitor.vala"
		switch (state) {
#line 422 "LibraryMonitor.c"
			case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE:
			case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE:
			{
#line 63 "LibraryMonitor.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->discovered), photo);
#line 64 "LibraryMonitor.vala"
				break;
#line 430 "LibraryMonitor.c"
			}
			default:
			{
#line 71 "LibraryMonitor.vala"
				break;
#line 436 "LibraryMonitor.c"
			}
		}
	}
#line 75 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->file_discovered (DIRECTORY_MONITOR (self), file, info);
#line 442 "LibraryMonitor.c"
	_g_object_unref0 (photo);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 78 "LibraryMonitor.vala"
static void library_monitor_real_discovery_completed (DirectoryMonitor* base) {
#line 454 "LibraryMonitor.c"
	LibraryMonitor * self;
	Marker* to_offline;
	Marker* to_online;
	GeeHashSet* _tmp10_;
	self = LIBRARY_MONITOR (base);
#line 79 "LibraryMonitor.vala"
	to_offline = data_collection_start_marking (DATA_COLLECTION (library_photo_global));
#line 80 "LibraryMonitor.vala"
	to_online = data_collection_start_marking (DATA_COLLECTION (library_photo_global));
#line 464 "LibraryMonitor.c"
	{
		GeeIterator* _photo_it;
#line 83 "LibraryMonitor.vala"
		_photo_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->discovered));
#line 83 "LibraryMonitor.vala"
		while (TRUE) {
#line 471 "LibraryMonitor.c"
			LibraryPhoto* photo;
			GFile* _tmp0_;
			GFileInfo* _tmp1_;
			GFileInfo* master_info;
			gboolean _tmp2_ = FALSE;
#line 83 "LibraryMonitor.vala"
			if (!gee_iterator_next (_photo_it)) {
#line 83 "LibraryMonitor.vala"
				break;
#line 481 "LibraryMonitor.c"
			}
#line 83 "LibraryMonitor.vala"
			photo = (LibraryPhoto*) gee_iterator_get (_photo_it);
#line 87 "LibraryMonitor.vala"
			master_info = (_tmp1_ = directory_monitor_get_file_info (DIRECTORY_MONITOR (self), _tmp0_ = transformable_photo_get_master_file (TRANSFORMABLE_PHOTO (photo))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 88 "LibraryMonitor.vala"
			if (master_info != NULL) {
#line 88 "LibraryMonitor.vala"
				_tmp2_ = library_photo_is_offline (photo);
#line 491 "LibraryMonitor.c"
			} else {
#line 88 "LibraryMonitor.vala"
				_tmp2_ = FALSE;
#line 495 "LibraryMonitor.c"
			}
#line 88 "LibraryMonitor.vala"
			if (_tmp2_) {
#line 89 "LibraryMonitor.vala"
				marker_mark (to_online, DATA_OBJECT (photo));
#line 501 "LibraryMonitor.c"
			} else {
				gboolean _tmp3_ = FALSE;
#line 90 "LibraryMonitor.vala"
				if (master_info == NULL) {
#line 90 "LibraryMonitor.vala"
					_tmp3_ = !library_photo_is_offline (photo);
#line 508 "LibraryMonitor.c"
				} else {
#line 90 "LibraryMonitor.vala"
					_tmp3_ = FALSE;
#line 512 "LibraryMonitor.c"
				}
#line 90 "LibraryMonitor.vala"
				if (_tmp3_) {
#line 93 "LibraryMonitor.vala"
					marker_mark (to_offline, DATA_OBJECT (photo));
#line 518 "LibraryMonitor.c"
				}
			}
			_g_object_unref0 (master_info);
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
	{
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 98 "LibraryMonitor.vala"
		_object_it = (_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_ = data_collection_get_all (DATA_COLLECTION (library_photo_global)))), _g_object_unref0 (_tmp4_), _tmp5_);
#line 98 "LibraryMonitor.vala"
		while (TRUE) {
#line 534 "LibraryMonitor.c"
			DataObject* object;
			LibraryPhoto* photo;
			GFile* _tmp6_;
			gboolean _tmp7_;
#line 98 "LibraryMonitor.vala"
			if (!gee_iterator_next (_object_it)) {
#line 98 "LibraryMonitor.vala"
				break;
#line 543 "LibraryMonitor.c"
			}
#line 98 "LibraryMonitor.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 99 "LibraryMonitor.vala"
			photo = _g_object_ref0 (LIBRARY_PHOTO (object));
#line 102 "LibraryMonitor.vala"
			if ((_tmp7_ = !directory_monitor_is_in_root (DIRECTORY_MONITOR (self), _tmp6_ = transformable_photo_get_master_file (TRANSFORMABLE_PHOTO (photo))), _g_object_unref0 (_tmp6_), _tmp7_)) {
#line 103 "LibraryMonitor.vala"
				library_monitor_launch_verify_external_photo (self, photo);
#line 553 "LibraryMonitor.c"
				_g_object_unref0 (photo);
				_g_object_unref0 (object);
#line 105 "LibraryMonitor.vala"
				continue;
#line 558 "LibraryMonitor.c"
			}
#line 109 "LibraryMonitor.vala"
			if (!gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->discovered), photo)) {
#line 110 "LibraryMonitor.vala"
				marker_mark (to_offline, DATA_OBJECT (photo));
#line 564 "LibraryMonitor.c"
			}
			_g_object_unref0 (photo);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 113 "LibraryMonitor.vala"
	library_photo_source_collection_mark_online_offline (library_photo_global, to_online, to_offline);
#line 573 "LibraryMonitor.c"
	{
		GeeCollection* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _photo_it;
#line 116 "LibraryMonitor.vala"
		_photo_it = (_tmp9_ = gee_iterable_iterator (GEE_ITERABLE (_tmp8_ = library_photo_source_collection_get_offline (library_photo_global))), _g_object_unref0 (_tmp8_), _tmp9_);
#line 116 "LibraryMonitor.vala"
		while (TRUE) {
#line 582 "LibraryMonitor.c"
			LibraryPhoto* photo;
#line 116 "LibraryMonitor.vala"
			if (!gee_iterator_next (_photo_it)) {
#line 116 "LibraryMonitor.vala"
				break;
#line 588 "LibraryMonitor.c"
			}
#line 116 "LibraryMonitor.vala"
			photo = (LibraryPhoto*) gee_iterator_get (_photo_it);
#line 117 "LibraryMonitor.vala"
			library_monitor_launch_verify_external_photo (self, photo);
#line 594 "LibraryMonitor.c"
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
#line 119 "LibraryMonitor.vala"
	self->priv->discovered = (_tmp10_ = NULL, _g_object_unref0 (self->priv->discovered), _tmp10_);
#line 121 "LibraryMonitor.vala"
	directory_monitor_mdbg (DIRECTORY_MONITOR (self), "all checksums completed");
#line 125 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_completed (DIRECTORY_MONITOR (self));
#line 605 "LibraryMonitor.c"
	_g_object_unref0 (to_online);
	_g_object_unref0 (to_offline);
}


#line 155 "LibraryMonitor.vala"
static void _library_monitor_verify_external_complete_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 613 "LibraryMonitor.c"
	library_monitor_verify_external_complete (self);
	g_object_unref (self);
}


#line 128 "LibraryMonitor.vala"
static void library_monitor_launch_verify_external_photo (LibraryMonitor* self, LibraryPhoto* photo) {
#line 128 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 128 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 129 "LibraryMonitor.vala"
	if (self->priv->external_mark_online == NULL) {
#line 627 "LibraryMonitor.c"
		GeeArrayList* _tmp0_;
#line 130 "LibraryMonitor.vala"
		self->priv->external_mark_online = (_tmp0_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (self->priv->external_mark_online), _tmp0_);
#line 631 "LibraryMonitor.c"
	}
#line 132 "LibraryMonitor.vala"
	if (self->priv->external_mark_offline == NULL) {
#line 635 "LibraryMonitor.c"
		GeeArrayList* _tmp1_;
#line 133 "LibraryMonitor.vala"
		self->priv->external_mark_offline = (_tmp1_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (self->priv->external_mark_offline), _tmp1_);
#line 639 "LibraryMonitor.c"
	}
#line 135 "LibraryMonitor.vala"
	self->priv->verify_external_outstanding++;
#line 136 "LibraryMonitor.vala"
	library_monitor_verify_external_photo (self, photo, _library_monitor_verify_external_complete_gasync_ready_callback, g_object_ref (self));
#line 645 "LibraryMonitor.c"
}


static void library_monitor_verify_external_photo_data_free (gpointer _data) {
	LibraryMonitorVerifyExternalPhotoData* data;
	data = _data;
	_g_object_unref0 (data->photo);
	g_object_unref (data->self);
	g_slice_free (LibraryMonitorVerifyExternalPhotoData, data);
}


static void library_monitor_verify_external_photo (LibraryMonitor* self, LibraryPhoto* photo, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	LibraryMonitorVerifyExternalPhotoData* _data_;
	_data_ = g_slice_new0 (LibraryMonitorVerifyExternalPhotoData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, library_monitor_verify_external_photo);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, library_monitor_verify_external_photo_data_free);
	_data_->self = g_object_ref (self);
	_data_->photo = _g_object_ref0 (photo);
	library_monitor_verify_external_photo_co (_data_);
}


static void library_monitor_verify_external_photo_finish (LibraryMonitor* self, GAsyncResult* _res_) {
	LibraryMonitorVerifyExternalPhotoData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void library_monitor_verify_external_photo_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	LibraryMonitorVerifyExternalPhotoData* data;
	data = _user_data_;
	data->_res_ = _res_;
	library_monitor_verify_external_photo_co (data);
}


static gboolean library_monitor_verify_external_photo_co (LibraryMonitorVerifyExternalPhotoData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 4:
		goto _state_4;
	}
	_state_0:
	data->master = transformable_photo_get_master_file (TRANSFORMABLE_PHOTO (data->photo));
	{
		data->_state_ = 4;
		g_file_query_info_async (data->master, G_FILE_ATTRIBUTE_ACCESS_CAN_READ, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, library_monitor_verify_external_photo_ready, data);
		return FALSE;
		_state_4:
		data->info = g_file_query_info_finish (data->master, data->_res_, &data->_inner_error_);
		if (data->_inner_error_ != NULL) {
			goto __catch280_g_error;
		}
#line 145 "LibraryMonitor.vala"
		if (data->info != NULL) {
#line 145 "LibraryMonitor.vala"
			data->_tmp0_ = library_photo_is_offline (data->photo);
#line 707 "LibraryMonitor.c"
		} else {
#line 145 "LibraryMonitor.vala"
			data->_tmp0_ = FALSE;
#line 711 "LibraryMonitor.c"
		}
#line 145 "LibraryMonitor.vala"
		if (data->_tmp0_) {
#line 146 "LibraryMonitor.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (data->self->priv->external_mark_online), data->photo);
#line 717 "LibraryMonitor.c"
		} else {
#line 147 "LibraryMonitor.vala"
			if (data->info == NULL) {
#line 147 "LibraryMonitor.vala"
				data->_tmp1_ = !library_photo_is_offline (data->photo);
#line 723 "LibraryMonitor.c"
			} else {
#line 147 "LibraryMonitor.vala"
				data->_tmp1_ = FALSE;
#line 727 "LibraryMonitor.c"
			}
#line 147 "LibraryMonitor.vala"
			if (data->_tmp1_) {
#line 148 "LibraryMonitor.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (data->self->priv->external_mark_offline), data->photo);
#line 733 "LibraryMonitor.c"
			}
		}
		_g_object_unref0 (data->info);
	}
	goto __finally280;
	__catch280_g_error:
	{
		data->err = data->_inner_error_;
		data->_inner_error_ = NULL;
		{
#line 150 "LibraryMonitor.vala"
			if (!library_photo_is_offline (data->photo)) {
#line 151 "LibraryMonitor.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (data->self->priv->external_mark_offline), data->photo);
#line 748 "LibraryMonitor.c"
			}
			_g_error_free0 (data->err);
		}
	}
	__finally280:
	if (data->_inner_error_ != NULL) {
		_g_object_unref0 (data->master);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	_g_object_unref0 (data->master);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 155 "LibraryMonitor.vala"
static void library_monitor_verify_external_complete (LibraryMonitor* self) {
#line 775 "LibraryMonitor.c"
	gint total;
	gint count;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
#line 155 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 156 "LibraryMonitor.vala"
	g_assert (self->priv->verify_external_outstanding > 0);
#line 157 "LibraryMonitor.vala"
	if ((self->priv->verify_external_outstanding = self->priv->verify_external_outstanding - 1) > 0) {
#line 158 "LibraryMonitor.vala"
		return;
#line 788 "LibraryMonitor.c"
	}
#line 160 "LibraryMonitor.vala"
	total = 0;
#line 162 "LibraryMonitor.vala"
	data_collection_freeze_notifications (DATA_COLLECTION (library_photo_global));
#line 164 "LibraryMonitor.vala"
	count = gee_collection_get_size (GEE_COLLECTION (self->priv->external_mark_online));
#line 796 "LibraryMonitor.c"
	{
		gint ctr;
#line 165 "LibraryMonitor.vala"
		ctr = 0;
#line 801 "LibraryMonitor.c"
		{
			gboolean _tmp0_;
#line 165 "LibraryMonitor.vala"
			_tmp0_ = TRUE;
#line 165 "LibraryMonitor.vala"
			while (TRUE) {
#line 808 "LibraryMonitor.c"
				LibraryPhoto* _tmp1_;
#line 165 "LibraryMonitor.vala"
				if (!_tmp0_) {
#line 165 "LibraryMonitor.vala"
					ctr++;
#line 814 "LibraryMonitor.c"
				}
#line 165 "LibraryMonitor.vala"
				_tmp0_ = FALSE;
#line 165 "LibraryMonitor.vala"
				if (!(ctr < count)) {
#line 165 "LibraryMonitor.vala"
					break;
#line 822 "LibraryMonitor.c"
				}
#line 166 "LibraryMonitor.vala"
				library_photo_mark_online (_tmp1_ = (LibraryPhoto*) gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->external_mark_online), ctr));
#line 826 "LibraryMonitor.c"
				_g_object_unref0 (_tmp1_);
#line 168 "LibraryMonitor.vala"
				if (((total = total + 1) % 50) == 0) {
#line 169 "LibraryMonitor.vala"
					data_collection_thaw_notifications (DATA_COLLECTION (library_photo_global));
#line 170 "LibraryMonitor.vala"
					spin_event_loop ();
#line 171 "LibraryMonitor.vala"
					data_collection_freeze_notifications (DATA_COLLECTION (library_photo_global));
#line 836 "LibraryMonitor.c"
				}
			}
		}
	}
#line 175 "LibraryMonitor.vala"
	count = gee_collection_get_size (GEE_COLLECTION (self->priv->external_mark_offline));
#line 843 "LibraryMonitor.c"
	{
		gint ctr;
#line 176 "LibraryMonitor.vala"
		ctr = 0;
#line 848 "LibraryMonitor.c"
		{
			gboolean _tmp2_;
#line 176 "LibraryMonitor.vala"
			_tmp2_ = TRUE;
#line 176 "LibraryMonitor.vala"
			while (TRUE) {
#line 855 "LibraryMonitor.c"
				LibraryPhoto* _tmp3_;
#line 176 "LibraryMonitor.vala"
				if (!_tmp2_) {
#line 176 "LibraryMonitor.vala"
					ctr++;
#line 861 "LibraryMonitor.c"
				}
#line 176 "LibraryMonitor.vala"
				_tmp2_ = FALSE;
#line 176 "LibraryMonitor.vala"
				if (!(ctr < count)) {
#line 176 "LibraryMonitor.vala"
					break;
#line 869 "LibraryMonitor.c"
				}
#line 177 "LibraryMonitor.vala"
				library_photo_mark_offline (_tmp3_ = (LibraryPhoto*) gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->external_mark_offline), ctr));
#line 873 "LibraryMonitor.c"
				_g_object_unref0 (_tmp3_);
#line 179 "LibraryMonitor.vala"
				if (((total = total + 1) % 50) == 0) {
#line 180 "LibraryMonitor.vala"
					data_collection_thaw_notifications (DATA_COLLECTION (library_photo_global));
#line 181 "LibraryMonitor.vala"
					spin_event_loop ();
#line 182 "LibraryMonitor.vala"
					data_collection_freeze_notifications (DATA_COLLECTION (library_photo_global));
#line 883 "LibraryMonitor.c"
				}
			}
		}
	}
#line 186 "LibraryMonitor.vala"
	data_collection_thaw_notifications (DATA_COLLECTION (library_photo_global));
#line 188 "LibraryMonitor.vala"
	self->priv->external_mark_online = (_tmp4_ = NULL, _g_object_unref0 (self->priv->external_mark_online), _tmp4_);
#line 189 "LibraryMonitor.vala"
	self->priv->external_mark_offline = (_tmp5_ = NULL, _g_object_unref0 (self->priv->external_mark_offline), _tmp5_);
#line 894 "LibraryMonitor.c"
}


static void library_monitor_class_init (LibraryMonitorClass * klass) {
	library_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LibraryMonitorPrivate));
	DIRECTORY_MONITOR_CLASS (klass)->close = library_monitor_real_close;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = library_monitor_real_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = library_monitor_real_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = library_monitor_real_discovery_completed;
	G_OBJECT_CLASS (klass)->finalize = library_monitor_finalize;
}


static void library_monitor_instance_init (LibraryMonitor * self) {
	self->priv = LIBRARY_MONITOR_GET_PRIVATE (self);
	self->priv->cancellable = g_cancellable_new ();
	self->priv->discovered = NULL;
	self->priv->external_mark_online = NULL;
	self->priv->external_mark_offline = NULL;
	self->priv->verify_external_outstanding = 0;
}


static void library_monitor_finalize (GObject* obj) {
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (obj);
	_g_object_unref0 (self->priv->cancellable);
	_g_object_unref0 (self->priv->discovered);
	_g_object_unref0 (self->priv->external_mark_online);
	_g_object_unref0 (self->priv->external_mark_offline);
	G_OBJECT_CLASS (library_monitor_parent_class)->finalize (obj);
}


GType library_monitor_get_type (void) {
	static volatile gsize library_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitor), 0, (GInstanceInitFunc) library_monitor_instance_init, NULL };
		GType library_monitor_type_id;
		library_monitor_type_id = g_type_register_static (TYPE_DIRECTORY_MONITOR, "LibraryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_type_id__volatile, library_monitor_type_id);
	}
	return library_monitor_type_id__volatile;
}




