/* PhotoMetadata.c generated by valac 0.9.8, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2010 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
typedef struct _MetadataDateTimePrivate MetadataDateTimePrivate;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _ParamSpecMetadataDateTime ParamSpecMetadataDateTime;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;
#define _gexiv2_metadata_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_metadata_free (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _photo_metadata_unref0(var) ((var == NULL) ? NULL : (var = (photo_metadata_unref (var), NULL)))
#define _gexiv2_preview_image_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_preview_image_free (var), NULL)))
typedef struct _ParamSpecPhotoMetadata ParamSpecPhotoMetadata;

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _MetadataDateTime {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MetadataDateTimePrivate * priv;
};

struct _MetadataDateTimeClass {
	GTypeClass parent_class;
	void (*finalize) (MetadataDateTime *self);
};

struct _MetadataDateTimePrivate {
	time_t timestamp;
};

struct _ParamSpecMetadataDateTime {
	GParamSpec parent_instance;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, int* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	char* name;
	Dimensions dimensions;
	guint32 size;
	char* mime_type;
	char* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _PhotoMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoMetadata *self);
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	char* source_name;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};

struct _ParamSpecPhotoMetadata {
	GParamSpec parent_instance;
};


static gpointer metadata_date_time_parent_class = NULL;
static gpointer photo_preview_parent_class = NULL;
static char** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static char** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static char** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static char** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static char** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static char** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static char** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static char** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern char** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
char** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static char** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static char** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static char** photo_metadata_STANDARD_DESCRIPTION_TAGS;
static gint photo_metadata_STANDARD_DESCRIPTION_TAGS_length1;
static char** photo_metadata_STANDARD_DESCRIPTION_TAGS = NULL;
static gint photo_metadata_STANDARD_DESCRIPTION_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_DESCRIPTION_TAGS_size_ = 0;
static char** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static char** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static char** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static char** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static char** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static char** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;
static gpointer photo_metadata_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator);
static gboolean metadata_rational_is_component_valid (MetadataRational *self, gint component);
gboolean metadata_rational_is_valid (MetadataRational *self);
char* metadata_rational_to_string (MetadataRational *self);
GQuark metadata_date_time_error_quark (void);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
#define METADATA_DATE_TIME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_DATE_TIME, MetadataDateTimePrivate))
enum  {
	METADATA_DATE_TIME_DUMMY_PROPERTY
};
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
MetadataDateTime* metadata_date_time_new_from_exif (const char* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const char* label, GError** error);
gboolean metadata_date_time_from_exif_date_time (const char* date_time, time_t* timestamp);
MetadataDateTime* metadata_date_time_new_from_iptc (const char* date, const char* time, GError** error);
MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type, const char* date, const char* time, GError** error);
MetadataDateTime* metadata_date_time_new_from_xmp (const char* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const char* label, GError** error);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
char* metadata_date_time_get_exif_label (MetadataDateTime* self);
char* metadata_date_time_to_exif_date_time (time_t timestamp);
char* metadata_date_time_get_xmp_label (MetadataDateTime* self);
static void metadata_date_time_finalize (MetadataDateTime* obj);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define PHOTO_PREVIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_PREVIEW, PhotoPreviewPrivate))
enum  {
	PHOTO_PREVIEW_DUMMY_PROPERTY
};
PhotoPreview* photo_preview_construct (GType object_type, const char* name, Dimensions* dimensions, guint32 size, const char* mime_type, const char* extension);
char* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
char* photo_preview_get_mime_type (PhotoPreview* self);
char* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error);
static void photo_preview_finalize (PhotoPreview* obj);
gpointer photo_metadata_ref (gpointer instance);
void photo_metadata_unref (gpointer instance);
GParamSpec* param_spec_photo_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_metadata (GValue* value, gpointer v_object);
void value_take_photo_metadata (GValue* value, gpointer v_object);
gpointer value_get_photo_metadata (const GValue* value);
GType photo_metadata_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_METADATA, PhotoMetadataPrivate))
enum  {
	PHOTO_METADATA_DUMMY_PROPERTY
};
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
#define PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG "Iptc.Application2.Caption"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
void photo_metadata_read_from_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
MetadataDomain photo_metadata_get_tag_domain (const char* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self, const char* tag);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func);
char* photo_metadata_get_tag_label (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_tag_description (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_string (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_string_interpreted (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_first_string (PhotoMetadata* self, char** tags, int tags_length1);
char* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, char** tags, int tags_length1);
GeeCollection* photo_metadata_get_string_multiple (PhotoMetadata* self, const char* tag, GCompareFunc compare_func);
void photo_metadata_set_string (PhotoMetadata* self, const char* tag, const char* value);
void photo_metadata_set_all_string (PhotoMetadata* self, char** tags, int tags_length1, const char* value, gboolean only_if_domain_present);
void photo_metadata_set_string_multiple (PhotoMetadata* self, const char* tag, GeeCollection* collection);
static void _vala_array_add246 (char*** array, int* length, int* size, char* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, char** tags, int tags_length1, GeeCollection* values, gboolean only_if_domain_present);
gboolean photo_metadata_get_long (PhotoMetadata* self, const char* tag, glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self, char** tags, int tags_length1, glong* value);
void photo_metadata_set_long (PhotoMetadata* self, const char* tag, glong value);
void photo_metadata_set_all_long (PhotoMetadata* self, char** tags, int tags_length1, glong value, gboolean only_if_domain_present);
gboolean photo_metadata_get_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational);
void photo_metadata_set_all_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational, gboolean only_if_domain_present);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const char* tag);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, char** tags, int tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self, const char* tag, MetadataDateTime* date_time);
void photo_metadata_set_all_date_time (PhotoMetadata* self, char** tags, int tags_length1, MetadataDateTime* date_time, gboolean only_if_domain_present);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1);
static guint8* _vala_array_dup16 (guint8* self, int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self, const char* tag);
void photo_metadata_remove_tags (PhotoMetadata* self, char** tags, int tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, gboolean only_if_domain_present);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, gboolean only_if_domain_present);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, gboolean only_if_domain_present);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, gboolean only_if_domain_present);
char* photo_metadata_get_title (PhotoMetadata* self);
gboolean is_string_empty (const char* s);
void photo_metadata_set_title (PhotoMetadata* self, const char* title, gboolean only_if_domain_present);
char* photo_metadata_get_description (PhotoMetadata* self);
void photo_metadata_set_description (PhotoMetadata* self, const char* description, gboolean only_if_domain_present);
GeeCollection* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, gboolean only_if_domain_present);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self, double* longitude, char** long_ref, double* latitude, char** lat_ref, double* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure);
char* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso);
char* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture);
char* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted);
char* photo_metadata_get_camera_make (PhotoMetadata* self);
char* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash);
char* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length);
char* photo_metadata_get_focal_length_string (PhotoMetadata* self);
char* photo_metadata_get_artist (PhotoMetadata* self);
char* photo_metadata_get_copyright (PhotoMetadata* self);
char* photo_metadata_get_software (PhotoMetadata* self);
char* photo_metadata_get_exposure_bias (PhotoMetadata* self);
GType rating_get_type (void) G_GNUC_CONST;
Rating photo_metadata_get_rating (PhotoMetadata* self);
Rating rating_unserialize (gint value);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
gint rating_serialize (Rating self);
enum  {
	PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_DUMMY_PROPERTY
};
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error);
static guint8* _vala_array_dup17 (guint8* self, int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj);
static void photo_metadata_finalize (PhotoMetadata* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



GType metadata_domain_get_type (void) {
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}


#line 35 "PhotoMetadata.vala"
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator) {
#line 484 "PhotoMetadata.c"
	memset (self, 0, sizeof (MetadataRational));
#line 36 "PhotoMetadata.vala"
	(*self).numerator = numerator;
#line 37 "PhotoMetadata.vala"
	(*self).denominator = denominator;
#line 490 "PhotoMetadata.c"
}


#line 40 "PhotoMetadata.vala"
static gboolean metadata_rational_is_component_valid (MetadataRational *self, gint component) {
#line 496 "PhotoMetadata.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 41 "PhotoMetadata.vala"
	if (component < 0) {
#line 41 "PhotoMetadata.vala"
		_tmp0_ = TRUE;
#line 503 "PhotoMetadata.c"
	} else {
#line 41 "PhotoMetadata.vala"
		_tmp0_ = component > 1000000;
#line 507 "PhotoMetadata.c"
	}
	result = !_tmp0_;
#line 41 "PhotoMetadata.vala"
	return result;
#line 512 "PhotoMetadata.c"
}


#line 45 "PhotoMetadata.vala"
gboolean metadata_rational_is_valid (MetadataRational *self) {
#line 518 "PhotoMetadata.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 46 "PhotoMetadata.vala"
	if (metadata_rational_is_component_valid (&(*self), (*self).numerator)) {
#line 46 "PhotoMetadata.vala"
		_tmp0_ = metadata_rational_is_component_valid (&(*self), (*self).denominator);
#line 525 "PhotoMetadata.c"
	} else {
#line 46 "PhotoMetadata.vala"
		_tmp0_ = FALSE;
#line 529 "PhotoMetadata.c"
	}
	result = _tmp0_;
#line 46 "PhotoMetadata.vala"
	return result;
#line 534 "PhotoMetadata.c"
}


#line 49 "PhotoMetadata.vala"
char* metadata_rational_to_string (MetadataRational *self) {
#line 540 "PhotoMetadata.c"
	char* result = NULL;
	char* _tmp0_;
	_tmp0_ = NULL;
#line 50 "PhotoMetadata.vala"
	if (metadata_rational_is_valid (&(*self))) {
#line 546 "PhotoMetadata.c"
		char* _tmp1_;
#line 50 "PhotoMetadata.vala"
		_tmp0_ = (_tmp1_ = g_strdup_printf ("%d/%d", (*self).numerator, (*self).denominator), _g_free0 (_tmp0_), _tmp1_);
#line 550 "PhotoMetadata.c"
	} else {
		char* _tmp2_;
#line 50 "PhotoMetadata.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 555 "PhotoMetadata.c"
	}
	result = _tmp0_;
#line 50 "PhotoMetadata.vala"
	return result;
#line 560 "PhotoMetadata.c"
}


MetadataRational* metadata_rational_dup (const MetadataRational* self) {
	MetadataRational* dup;
	dup = g_new0 (MetadataRational, 1);
	memcpy (dup, self, sizeof (MetadataRational));
	return dup;
}


void metadata_rational_free (MetadataRational* self) {
	g_free (self);
}


GType metadata_rational_get_type (void) {
	static volatile gsize metadata_rational_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_rational_type_id__volatile)) {
		GType metadata_rational_type_id;
		metadata_rational_type_id = g_boxed_type_register_static ("MetadataRational", (GBoxedCopyFunc) metadata_rational_dup, (GBoxedFreeFunc) metadata_rational_free);
		g_once_init_leave (&metadata_rational_type_id__volatile, metadata_rational_type_id);
	}
	return metadata_rational_type_id__volatile;
}


GQuark metadata_date_time_error_quark (void) {
	return g_quark_from_static_string ("metadata_date_time_error-quark");
}


#line 62 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp) {
#line 595 "PhotoMetadata.c"
	MetadataDateTime* self;
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 63 "PhotoMetadata.vala"
	self->priv->timestamp = timestamp;
#line 600 "PhotoMetadata.c"
	return self;
}


#line 62 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_new (time_t timestamp) {
#line 62 "PhotoMetadata.vala"
	return metadata_date_time_construct (TYPE_METADATA_DATE_TIME, timestamp);
#line 609 "PhotoMetadata.c"
}


#line 66 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const char* label, GError** error) {
#line 615 "PhotoMetadata.c"
	MetadataDateTime* self;
	GError * _inner_error_ = NULL;
#line 66 "PhotoMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 620 "PhotoMetadata.c"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 67 "PhotoMetadata.vala"
	if (!metadata_date_time_from_exif_date_time (label, &self->priv->timestamp)) {
#line 624 "PhotoMetadata.c"
		_inner_error_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not EXIF format date/time", label);
		{
			if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
				g_propagate_error (error, _inner_error_);
				_metadata_date_time_unref0 (self);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
	return self;
}


#line 66 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_new_from_exif (const char* label, GError** error) {
#line 66 "PhotoMetadata.vala"
	return metadata_date_time_construct_from_exif (TYPE_METADATA_DATE_TIME, label, error);
#line 646 "PhotoMetadata.c"
}


#line 71 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type, const char* date, const char* time, GError** error) {
#line 652 "PhotoMetadata.c"
	MetadataDateTime* self;
	GError * _inner_error_ = NULL;
#line 71 "PhotoMetadata.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 71 "PhotoMetadata.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 659 "PhotoMetadata.c"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
	_inner_error_ = g_error_new_literal (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT, "IPTC date/time format not currently supported");
	{
		if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error_);
			_metadata_date_time_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


#line 71 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_new_from_iptc (const char* date, const char* time, GError** error) {
#line 71 "PhotoMetadata.vala"
	return metadata_date_time_construct_from_iptc (TYPE_METADATA_DATE_TIME, date, time, error);
#line 681 "PhotoMetadata.c"
}


#line 76 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const char* label, GError** error) {
#line 687 "PhotoMetadata.c"
	MetadataDateTime* self;
	GTimeVal time_val = {0};
	GError * _inner_error_ = NULL;
#line 76 "PhotoMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 693 "PhotoMetadata.c"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
	g_get_current_time (&time_val);
#line 78 "PhotoMetadata.vala"
	if (!g_time_val_from_iso8601 (label, &time_val)) {
#line 698 "PhotoMetadata.c"
		_inner_error_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not XMP format date/time", label);
		{
			if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
				g_propagate_error (error, _inner_error_);
				_metadata_date_time_unref0 (self);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 81 "PhotoMetadata.vala"
	self->priv->timestamp = (time_t) time_val.tv_sec;
#line 714 "PhotoMetadata.c"
	return self;
}


#line 76 "PhotoMetadata.vala"
MetadataDateTime* metadata_date_time_new_from_xmp (const char* label, GError** error) {
#line 76 "PhotoMetadata.vala"
	return metadata_date_time_construct_from_xmp (TYPE_METADATA_DATE_TIME, label, error);
#line 723 "PhotoMetadata.c"
}


#line 84 "PhotoMetadata.vala"
time_t metadata_date_time_get_timestamp (MetadataDateTime* self) {
#line 729 "PhotoMetadata.c"
	time_t result;
	result = self->priv->timestamp;
#line 85 "PhotoMetadata.vala"
	return result;
#line 734 "PhotoMetadata.c"
}


#line 88 "PhotoMetadata.vala"
char* metadata_date_time_get_exif_label (MetadataDateTime* self) {
#line 740 "PhotoMetadata.c"
	char* result = NULL;
#line 88 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
#line 744 "PhotoMetadata.c"
	result = metadata_date_time_to_exif_date_time (self->priv->timestamp);
#line 89 "PhotoMetadata.vala"
	return result;
#line 748 "PhotoMetadata.c"
}


#line 94 "PhotoMetadata.vala"
char* metadata_date_time_get_xmp_label (MetadataDateTime* self) {
#line 754 "PhotoMetadata.c"
	char* result = NULL;
	GTimeVal time_val = {0};
#line 94 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
#line 759 "PhotoMetadata.c"
	g_get_current_time (&time_val);
#line 96 "PhotoMetadata.vala"
	time_val.tv_sec = (glong) self->priv->timestamp;
#line 97 "PhotoMetadata.vala"
	time_val.tv_usec = (glong) 0;
#line 765 "PhotoMetadata.c"
	result = g_time_val_to_iso8601 (&time_val);
#line 99 "PhotoMetadata.vala"
	return result;
#line 769 "PhotoMetadata.c"
}


#line 102 "PhotoMetadata.vala"
gboolean metadata_date_time_from_exif_date_time (const char* date_time, time_t* timestamp) {
#line 775 "PhotoMetadata.c"
	gboolean result = FALSE;
	struct tm tm = {0};
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 102 "PhotoMetadata.vala"
	g_return_val_if_fail (date_time != NULL, FALSE);
#line 785 "PhotoMetadata.c"
	memset (&tm, 0, sizeof (struct tm));
#line 105 "PhotoMetadata.vala"
	if (sscanf (date_time, "%d:%d:%d %d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec) != 6) {
#line 108 "PhotoMetadata.vala"
		if (sscanf (date_time, "%d:%d:%d:%d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec) != 6) {
#line 791 "PhotoMetadata.c"
			result = FALSE;
#line 110 "PhotoMetadata.vala"
			return result;
#line 795 "PhotoMetadata.c"
		}
	}
#line 115 "PhotoMetadata.vala"
	if (tm.tm_year <= 1900) {
#line 115 "PhotoMetadata.vala"
		_tmp4_ = TRUE;
#line 802 "PhotoMetadata.c"
	} else {
#line 115 "PhotoMetadata.vala"
		_tmp4_ = tm.tm_mon <= 0;
#line 806 "PhotoMetadata.c"
	}
#line 115 "PhotoMetadata.vala"
	if (_tmp4_) {
#line 115 "PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 812 "PhotoMetadata.c"
	} else {
#line 115 "PhotoMetadata.vala"
		_tmp3_ = tm.tm_mday < 0;
#line 816 "PhotoMetadata.c"
	}
#line 115 "PhotoMetadata.vala"
	if (_tmp3_) {
#line 115 "PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 822 "PhotoMetadata.c"
	} else {
#line 115 "PhotoMetadata.vala"
		_tmp2_ = tm.tm_hour < 0;
#line 826 "PhotoMetadata.c"
	}
#line 115 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 115 "PhotoMetadata.vala"
		_tmp1_ = TRUE;
#line 832 "PhotoMetadata.c"
	} else {
#line 115 "PhotoMetadata.vala"
		_tmp1_ = tm.tm_min < 0;
#line 836 "PhotoMetadata.c"
	}
#line 115 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 115 "PhotoMetadata.vala"
		_tmp0_ = TRUE;
#line 842 "PhotoMetadata.c"
	} else {
#line 115 "PhotoMetadata.vala"
		_tmp0_ = tm.tm_sec < 0;
#line 846 "PhotoMetadata.c"
	}
#line 115 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 850 "PhotoMetadata.c"
		result = FALSE;
#line 116 "PhotoMetadata.vala"
		return result;
#line 854 "PhotoMetadata.c"
	}
#line 118 "PhotoMetadata.vala"
	tm.tm_year = tm.tm_year - 1900;
#line 119 "PhotoMetadata.vala"
	tm.tm_mon--;
#line 120 "PhotoMetadata.vala"
	tm.tm_isdst = -1;
#line 122 "PhotoMetadata.vala"
	*timestamp = mktime (&tm);
#line 864 "PhotoMetadata.c"
	result = TRUE;
#line 124 "PhotoMetadata.vala"
	return result;
#line 868 "PhotoMetadata.c"
}


#line 2194 "glib-2.0.vapi"
static void g_time_local (time_t time, struct tm* result) {
#line 874 "PhotoMetadata.c"
	struct tm _result_ = {0};
#line 2196 "glib-2.0.vapi"
	localtime_r (&time, &_result_);
#line 878 "PhotoMetadata.c"
	*result = _result_;
#line 2197 "glib-2.0.vapi"
	return;
#line 882 "PhotoMetadata.c"
}


#line 2204 "glib-2.0.vapi"
static char* g_time_format (struct tm *self, const char* format) {
#line 888 "PhotoMetadata.c"
	char* result = NULL;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp0_;
	gchar* buffer;
#line 2204 "glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 896 "PhotoMetadata.c"
	buffer = (_tmp0_ = g_new0 (gchar, 64), buffer_length1 = 64, _buffer_size_ = buffer_length1, _tmp0_);
#line 2206 "glib-2.0.vapi"
	strftime (buffer, buffer_length1, format, &(*self));
#line 900 "PhotoMetadata.c"
	result = g_strdup ((const char*) buffer);
	buffer = (g_free (buffer), NULL);
#line 2207 "glib-2.0.vapi"
	return result;
#line 905 "PhotoMetadata.c"
}


#line 127 "PhotoMetadata.vala"
char* metadata_date_time_to_exif_date_time (time_t timestamp) {
#line 911 "PhotoMetadata.c"
	char* result = NULL;
	struct tm _tmp0_ = {0};
	struct tm _tmp1_;
	result = g_time_format ((_tmp1_ = (g_time_local (timestamp, &_tmp0_), _tmp0_), &_tmp1_), "%Y:%m:%d %H:%M:%S");
#line 128 "PhotoMetadata.vala"
	return result;
#line 918 "PhotoMetadata.c"
}


static void value_metadata_date_time_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_metadata_date_time_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		metadata_date_time_unref (value->data[0].v_pointer);
	}
}


static void value_metadata_date_time_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = metadata_date_time_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_metadata_date_time_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_metadata_date_time_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		MetadataDateTime* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = metadata_date_time_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_metadata_date_time_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	MetadataDateTime** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = metadata_date_time_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecMetadataDateTime* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_METADATA_DATE_TIME), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_metadata_date_time (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME), NULL);
	return value->data[0].v_pointer;
}


void value_set_metadata_date_time (GValue* value, gpointer v_object) {
	MetadataDateTime* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		metadata_date_time_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		metadata_date_time_unref (old);
	}
}


void value_take_metadata_date_time (GValue* value, gpointer v_object) {
	MetadataDateTime* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		metadata_date_time_unref (old);
	}
}


static void metadata_date_time_class_init (MetadataDateTimeClass * klass) {
	metadata_date_time_parent_class = g_type_class_peek_parent (klass);
	METADATA_DATE_TIME_CLASS (klass)->finalize = metadata_date_time_finalize;
	g_type_class_add_private (klass, sizeof (MetadataDateTimePrivate));
}


static void metadata_date_time_instance_init (MetadataDateTime * self) {
	self->priv = METADATA_DATE_TIME_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void metadata_date_time_finalize (MetadataDateTime* obj) {
	MetadataDateTime * self;
	self = METADATA_DATE_TIME (obj);
}


GType metadata_date_time_get_type (void) {
	static volatile gsize metadata_date_time_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_date_time_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_metadata_date_time_init, value_metadata_date_time_free_value, value_metadata_date_time_copy_value, value_metadata_date_time_peek_pointer, "p", value_metadata_date_time_collect_value, "p", value_metadata_date_time_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (MetadataDateTimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_date_time_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataDateTime), 0, (GInstanceInitFunc) metadata_date_time_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType metadata_date_time_type_id;
		metadata_date_time_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MetadataDateTime", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&metadata_date_time_type_id__volatile, metadata_date_time_type_id);
	}
	return metadata_date_time_type_id__volatile;
}


gpointer metadata_date_time_ref (gpointer instance) {
	MetadataDateTime* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void metadata_date_time_unref (gpointer instance) {
	MetadataDateTime* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		METADATA_DATE_TIME_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 139 "PhotoMetadata.vala"
PhotoPreview* photo_preview_construct (GType object_type, const char* name, Dimensions* dimensions, guint32 size, const char* mime_type, const char* extension) {
#line 1085 "PhotoMetadata.c"
	PhotoPreview* self;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 139 "PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 139 "PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 139 "PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 1096 "PhotoMetadata.c"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 140 "PhotoMetadata.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 141 "PhotoMetadata.vala"
	self->priv->dimensions = *dimensions;
#line 142 "PhotoMetadata.vala"
	self->priv->size = size;
#line 143 "PhotoMetadata.vala"
	self->priv->mime_type = (_tmp1_ = g_strdup (mime_type), _g_free0 (self->priv->mime_type), _tmp1_);
#line 144 "PhotoMetadata.vala"
	self->priv->extension = (_tmp2_ = g_strdup (extension), _g_free0 (self->priv->extension), _tmp2_);
#line 1108 "PhotoMetadata.c"
	return self;
}


#line 147 "PhotoMetadata.vala"
char* photo_preview_get_name (PhotoPreview* self) {
#line 1115 "PhotoMetadata.c"
	char* result = NULL;
#line 147 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 1119 "PhotoMetadata.c"
	result = g_strdup (self->priv->name);
#line 148 "PhotoMetadata.vala"
	return result;
#line 1123 "PhotoMetadata.c"
}


#line 151 "PhotoMetadata.vala"
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result) {
#line 151 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
#line 1131 "PhotoMetadata.c"
	*result = self->priv->dimensions;
#line 152 "PhotoMetadata.vala"
	return;
#line 1135 "PhotoMetadata.c"
}


#line 155 "PhotoMetadata.vala"
guint32 photo_preview_get_size (PhotoPreview* self) {
#line 1141 "PhotoMetadata.c"
	guint32 result = 0U;
#line 155 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
#line 1145 "PhotoMetadata.c"
	result = self->priv->size;
#line 156 "PhotoMetadata.vala"
	return result;
#line 1149 "PhotoMetadata.c"
}


#line 159 "PhotoMetadata.vala"
char* photo_preview_get_mime_type (PhotoPreview* self) {
#line 1155 "PhotoMetadata.c"
	char* result = NULL;
#line 159 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 1159 "PhotoMetadata.c"
	result = g_strdup (self->priv->mime_type);
#line 160 "PhotoMetadata.vala"
	return result;
#line 1163 "PhotoMetadata.c"
}


#line 163 "PhotoMetadata.vala"
char* photo_preview_get_extension (PhotoPreview* self) {
#line 1169 "PhotoMetadata.c"
	char* result = NULL;
#line 163 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 1173 "PhotoMetadata.c"
	result = g_strdup (self->priv->extension);
#line 164 "PhotoMetadata.vala"
	return result;
#line 1177 "PhotoMetadata.c"
}


#line 167 "PhotoMetadata.vala"
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 1183 "PhotoMetadata.c"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 139 "PhotoMetadata.vala"
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 139 "PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
#line 1194 "PhotoMetadata.c"
}


#line 169 "PhotoMetadata.vala"
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error) {
#line 1200 "PhotoMetadata.c"
	GdkPixbuf* result = NULL;
	gint flattened_length1;
	gint _flattened_size_;
	guint8* _tmp1_;
	gint _tmp0_;
	guint8* flattened;
	GError * _inner_error_ = NULL;
#line 169 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 1210 "PhotoMetadata.c"
	flattened = (_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error_), flattened_length1 = _tmp0_, _flattened_size_ = flattened_length1, _tmp1_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	{
		GMemoryInputStream* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 175 "PhotoMetadata.vala"
		_tmp4_ = (_tmp3_ = gdk_pixbuf_new_from_stream (G_INPUT_STREAM (_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (flattened, (gssize) flattened_length1, NULL)), NULL, &_inner_error_), _g_object_unref0 (_tmp2_), _tmp3_);
#line 1222 "PhotoMetadata.c"
		if (_inner_error_ != NULL) {
			goto __catch258_g_error;
		}
		result = _tmp4_;
		flattened = (g_free (flattened), NULL);
#line 175 "PhotoMetadata.vala"
		return result;
#line 1230 "PhotoMetadata.c"
	}
	goto __finally258;
	__catch258_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 178 "PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:178: Unable to decode thumbnail for %s: %s", self->priv->name, err->message);
#line 1241 "PhotoMetadata.c"
			result = NULL;
			_g_error_free0 (err);
			flattened = (g_free (flattened), NULL);
#line 180 "PhotoMetadata.vala"
			return result;
#line 1247 "PhotoMetadata.c"
		}
	}
	__finally258:
	{
		g_propagate_error (error, _inner_error_);
		flattened = (g_free (flattened), NULL);
		return NULL;
	}
	flattened = (g_free (flattened), NULL);
}


#line 139 "PhotoMetadata.vala"
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error) {
#line 139 "PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
#line 1264 "PhotoMetadata.c"
}


static void value_photo_preview_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_preview_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_preview_unref (value->data[0].v_pointer);
	}
}


static void value_photo_preview_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_preview_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_preview_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoPreview* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_preview_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_preview_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoPreview** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_preview_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoPreview* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_preview (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_preview_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_preview_unref (old);
	}
}


void value_take_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_preview_unref (old);
	}
}


static void photo_preview_class_init (PhotoPreviewClass * klass) {
	photo_preview_parent_class = g_type_class_peek_parent (klass);
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_preview_finalize;
	g_type_class_add_private (klass, sizeof (PhotoPreviewPrivate));
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_preview_real_flatten;
	PHOTO_PREVIEW_CLASS (klass)->get_pixbuf = photo_preview_real_get_pixbuf;
}


static void photo_preview_instance_init (PhotoPreview * self) {
	self->priv = PHOTO_PREVIEW_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void photo_preview_finalize (PhotoPreview* obj) {
	PhotoPreview * self;
	self = PHOTO_PREVIEW (obj);
	_g_free0 (self->priv->name);
	_g_free0 (self->priv->mime_type);
	_g_free0 (self->priv->extension);
}


GType photo_preview_get_type (void) {
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}


gpointer photo_preview_ref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_preview_unref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 211 "PhotoMetadata.vala"
PhotoMetadata* photo_metadata_construct (GType object_type) {
#line 1436 "PhotoMetadata.c"
	PhotoMetadata* self;
	self = (PhotoMetadata*) g_type_create_instance (object_type);
	return self;
}


#line 211 "PhotoMetadata.vala"
PhotoMetadata* photo_metadata_new (void) {
#line 211 "PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 1447 "PhotoMetadata.c"
}


#line 214 "PhotoMetadata.vala"
void photo_metadata_read_from_file (PhotoMetadata* self, GFile* file, GError** error) {
#line 1453 "PhotoMetadata.c"
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	ExifData* _tmp4_;
	char* _tmp5_;
	GError * _inner_error_ = NULL;
#line 214 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 214 "PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 215 "PhotoMetadata.vala"
	self->priv->exiv2 = (_tmp0_ = gexiv2_metadata_new (), _gexiv2_metadata_free0 (self->priv->exiv2), _tmp0_);
#line 216 "PhotoMetadata.vala"
	self->priv->exif = (_tmp1_ = NULL, _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 218 "PhotoMetadata.vala"
	gexiv2_metadata_open_path (self->priv->exiv2, _tmp2_ = g_file_get_path (file), &_inner_error_);
#line 1471 "PhotoMetadata.c"
	_g_free0 (_tmp2_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 219 "PhotoMetadata.vala"
	self->priv->exif = (_tmp4_ = exif_data_new_from_file (_tmp3_ = g_file_get_path (file)), _exif_data_unref0 (self->priv->exif), _tmp4_);
#line 1479 "PhotoMetadata.c"
	_g_free0 (_tmp3_);
#line 220 "PhotoMetadata.vala"
	self->priv->source_name = (_tmp5_ = g_file_get_basename (file), _g_free0 (self->priv->source_name), _tmp5_);
#line 1483 "PhotoMetadata.c"
}


#line 223 "PhotoMetadata.vala"
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error) {
#line 1489 "PhotoMetadata.c"
	char* _tmp0_;
	GError * _inner_error_ = NULL;
#line 223 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 223 "PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 224 "PhotoMetadata.vala"
	gexiv2_metadata_save_file (self->priv->exiv2, _tmp0_ = g_file_get_path (file), &_inner_error_);
#line 1498 "PhotoMetadata.c"
	_g_free0 (_tmp0_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


#line 227 "PhotoMetadata.vala"
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
#line 1509 "PhotoMetadata.c"
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
	ExifData* _tmp2_;
	char* _tmp3_;
	GError * _inner_error_ = NULL;
#line 227 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 228 "PhotoMetadata.vala"
	if (length <= 0) {
#line 229 "PhotoMetadata.vala"
		length = buffer_length1;
#line 1521 "PhotoMetadata.c"
	}
#line 231 "PhotoMetadata.vala"
	g_assert (buffer_length1 >= length);
#line 233 "PhotoMetadata.vala"
	self->priv->exiv2 = (_tmp0_ = gexiv2_metadata_new (), _gexiv2_metadata_free0 (self->priv->exiv2), _tmp0_);
#line 234 "PhotoMetadata.vala"
	self->priv->exif = (_tmp1_ = NULL, _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 236 "PhotoMetadata.vala"
	gexiv2_metadata_open_buf (self->priv->exiv2, buffer, (glong) length, &_inner_error_);
#line 1531 "PhotoMetadata.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 237 "PhotoMetadata.vala"
	self->priv->exif = (_tmp2_ = exif_data_new_from_data (buffer, (gsize) length), _exif_data_unref0 (self->priv->exif), _tmp2_);
#line 238 "PhotoMetadata.vala"
	self->priv->source_name = (_tmp3_ = g_strdup_printf ("<memory buffer %d bytes>", length), _g_free0 (self->priv->source_name), _tmp3_);
#line 1540 "PhotoMetadata.c"
}


#line 241 "PhotoMetadata.vala"
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
#line 1546 "PhotoMetadata.c"
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
	ExifData* _tmp2_;
	char* _tmp3_;
	GError * _inner_error_ = NULL;
#line 241 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 242 "PhotoMetadata.vala"
	if (length <= 0) {
#line 243 "PhotoMetadata.vala"
		length = buffer_length1;
#line 1558 "PhotoMetadata.c"
	}
#line 245 "PhotoMetadata.vala"
	g_assert (buffer_length1 >= length);
#line 247 "PhotoMetadata.vala"
	self->priv->exiv2 = (_tmp0_ = gexiv2_metadata_new (), _gexiv2_metadata_free0 (self->priv->exiv2), _tmp0_);
#line 248 "PhotoMetadata.vala"
	self->priv->exif = (_tmp1_ = NULL, _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 250 "PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (self->priv->exiv2, buffer, (glong) length, &_inner_error_);
#line 1568 "PhotoMetadata.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 251 "PhotoMetadata.vala"
	self->priv->exif = (_tmp2_ = exif_data_new_from_data (buffer, (gsize) length), _exif_data_unref0 (self->priv->exif), _tmp2_);
#line 252 "PhotoMetadata.vala"
	self->priv->source_name = (_tmp3_ = g_strdup_printf ("<app1 segment %d bytes>", length), _g_free0 (self->priv->source_name), _tmp3_);
#line 1577 "PhotoMetadata.c"
}


#line 255 "PhotoMetadata.vala"
MetadataDomain photo_metadata_get_tag_domain (const char* tag) {
#line 1583 "PhotoMetadata.c"
	MetadataDomain result = 0;
#line 255 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 256 "PhotoMetadata.vala"
	if (gexiv2_metadata_is_exif_tag (tag)) {
#line 1589 "PhotoMetadata.c"
		result = METADATA_DOMAIN_EXIF;
#line 257 "PhotoMetadata.vala"
		return result;
#line 1593 "PhotoMetadata.c"
	}
#line 259 "PhotoMetadata.vala"
	if (gexiv2_metadata_is_xmp_tag (tag)) {
#line 1597 "PhotoMetadata.c"
		result = METADATA_DOMAIN_XMP;
#line 260 "PhotoMetadata.vala"
		return result;
#line 1601 "PhotoMetadata.c"
	}
#line 262 "PhotoMetadata.vala"
	if (gexiv2_metadata_is_iptc_tag (tag)) {
#line 1605 "PhotoMetadata.c"
		result = METADATA_DOMAIN_IPTC;
#line 263 "PhotoMetadata.vala"
		return result;
#line 1609 "PhotoMetadata.c"
	}
	result = METADATA_DOMAIN_UNKNOWN;
#line 265 "PhotoMetadata.vala"
	return result;
#line 1614 "PhotoMetadata.c"
}


#line 268 "PhotoMetadata.vala"
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain) {
#line 1620 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 268 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 269 "PhotoMetadata.vala"
	switch (domain) {
#line 1626 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			result = gexiv2_metadata_has_exif (self->priv->exiv2);
#line 271 "PhotoMetadata.vala"
			return result;
#line 1632 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			result = gexiv2_metadata_has_xmp (self->priv->exiv2);
#line 274 "PhotoMetadata.vala"
			return result;
#line 1639 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
			result = gexiv2_metadata_has_iptc (self->priv->exiv2);
#line 277 "PhotoMetadata.vala"
			return result;
#line 1646 "PhotoMetadata.c"
		}
		default:
		{
			result = FALSE;
#line 281 "PhotoMetadata.vala"
			return result;
#line 1653 "PhotoMetadata.c"
		}
	}
}


#line 285 "PhotoMetadata.vala"
gboolean photo_metadata_has_exif (PhotoMetadata* self) {
#line 1661 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 285 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1665 "PhotoMetadata.c"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 286 "PhotoMetadata.vala"
	return result;
#line 1669 "PhotoMetadata.c"
}


#line 289 "PhotoMetadata.vala"
gboolean photo_metadata_has_xmp (PhotoMetadata* self) {
#line 1675 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 289 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1679 "PhotoMetadata.c"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 290 "PhotoMetadata.vala"
	return result;
#line 1683 "PhotoMetadata.c"
}


#line 293 "PhotoMetadata.vala"
gboolean photo_metadata_has_iptc (PhotoMetadata* self) {
#line 1689 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 293 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1693 "PhotoMetadata.c"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 294 "PhotoMetadata.vala"
	return result;
#line 1697 "PhotoMetadata.c"
}


#line 297 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain) {
#line 1703 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 297 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 298 "PhotoMetadata.vala"
	switch (domain) {
#line 1709 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			result = gexiv2_metadata_get_supports_exif (self->priv->exiv2);
#line 300 "PhotoMetadata.vala"
			return result;
#line 1715 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			result = gexiv2_metadata_get_supports_xmp (self->priv->exiv2);
#line 303 "PhotoMetadata.vala"
			return result;
#line 1722 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
			result = gexiv2_metadata_get_supports_iptc (self->priv->exiv2);
#line 306 "PhotoMetadata.vala"
			return result;
#line 1729 "PhotoMetadata.c"
		}
		default:
		{
			result = FALSE;
#line 310 "PhotoMetadata.vala"
			return result;
#line 1736 "PhotoMetadata.c"
		}
	}
}


#line 314 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_exif (PhotoMetadata* self) {
#line 1744 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 314 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1748 "PhotoMetadata.c"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 315 "PhotoMetadata.vala"
	return result;
#line 1752 "PhotoMetadata.c"
}


#line 318 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self) {
#line 1758 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 318 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1762 "PhotoMetadata.c"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 319 "PhotoMetadata.vala"
	return result;
#line 1766 "PhotoMetadata.c"
}


#line 322 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self) {
#line 1772 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 322 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1776 "PhotoMetadata.c"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 323 "PhotoMetadata.vala"
	return result;
#line 1780 "PhotoMetadata.c"
}


#line 326 "PhotoMetadata.vala"
gboolean photo_metadata_has_tag (PhotoMetadata* self, const char* tag) {
#line 1786 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 326 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 326 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 1792 "PhotoMetadata.c"
	result = gexiv2_metadata_has_tag (self->priv->exiv2, tag);
#line 327 "PhotoMetadata.vala"
	return result;
#line 1796 "PhotoMetadata.c"
}


#line 330 "PhotoMetadata.vala"
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func) {
#line 1802 "PhotoMetadata.c"
	GeeCollection* result = NULL;
	gint tags_length1;
	gint _tags_size_;
	char** _tmp0_;
	char** tags;
	gboolean _tmp7_ = FALSE;
	GeeCollection* collection;
#line 330 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1812 "PhotoMetadata.c"
	tags = (_tmp0_ = NULL, tags_length1 = 0, _tags_size_ = tags_length1, _tmp0_);
#line 332 "PhotoMetadata.vala"
	switch (domain) {
#line 1816 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			char** _tmp1_;
			char** _tmp2_;
#line 334 "PhotoMetadata.vala"
			tags = (_tmp2_ = _tmp1_ = gexiv2_metadata_get_exif_tags (self->priv->exiv2), tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL), tags_length1 = _vala_array_length (_tmp1_), _tags_size_ = tags_length1, _tmp2_);
#line 335 "PhotoMetadata.vala"
			break;
#line 1825 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			char** _tmp3_;
			char** _tmp4_;
#line 338 "PhotoMetadata.vala"
			tags = (_tmp4_ = _tmp3_ = gexiv2_metadata_get_xmp_tags (self->priv->exiv2), tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL), tags_length1 = _vala_array_length (_tmp3_), _tags_size_ = tags_length1, _tmp4_);
#line 339 "PhotoMetadata.vala"
			break;
#line 1835 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
			char** _tmp5_;
			char** _tmp6_;
#line 342 "PhotoMetadata.vala"
			tags = (_tmp6_ = _tmp5_ = gexiv2_metadata_get_iptc_tags (self->priv->exiv2), tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL), tags_length1 = _vala_array_length (_tmp5_), _tags_size_ = tags_length1, _tmp6_);
#line 343 "PhotoMetadata.vala"
			break;
#line 1845 "PhotoMetadata.c"
		}
	}
#line 346 "PhotoMetadata.vala"
	if (tags == NULL) {
#line 346 "PhotoMetadata.vala"
		_tmp7_ = TRUE;
#line 1852 "PhotoMetadata.c"
	} else {
#line 346 "PhotoMetadata.vala"
		_tmp7_ = tags_length1 == 0;
#line 1856 "PhotoMetadata.c"
	}
#line 346 "PhotoMetadata.vala"
	if (_tmp7_) {
#line 1860 "PhotoMetadata.c"
		result = NULL;
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 347 "PhotoMetadata.vala"
		return result;
#line 1865 "PhotoMetadata.c"
	}
#line 349 "PhotoMetadata.vala"
	collection = GEE_COLLECTION (gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, compare_func));
#line 1869 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 350 "PhotoMetadata.vala"
		tag_collection = tags;
#line 1876 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 351 "PhotoMetadata.vala"
				gee_collection_add (collection, tag);
#line 1884 "PhotoMetadata.c"
				_g_free0 (tag);
			}
		}
	}
	result = collection;
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 353 "PhotoMetadata.vala"
	return result;
#line 1893 "PhotoMetadata.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 356 "PhotoMetadata.vala"
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func) {
#line 1904 "PhotoMetadata.c"
	GeeCollection* result = NULL;
	GeeCollection* all_tags;
	GeeCollection* exif_tags;
	gboolean _tmp0_ = FALSE;
	GeeCollection* xmp_tags;
	gboolean _tmp1_ = FALSE;
	GeeCollection* iptc_tags;
	gboolean _tmp2_ = FALSE;
	GeeCollection* _tmp3_;
#line 356 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 357 "PhotoMetadata.vala"
	all_tags = GEE_COLLECTION (gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, compare_func));
#line 359 "PhotoMetadata.vala"
	exif_tags = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL);
#line 360 "PhotoMetadata.vala"
	if (exif_tags != NULL) {
#line 360 "PhotoMetadata.vala"
		_tmp0_ = gee_collection_get_size (exif_tags) > 0;
#line 1924 "PhotoMetadata.c"
	} else {
#line 360 "PhotoMetadata.vala"
		_tmp0_ = FALSE;
#line 1928 "PhotoMetadata.c"
	}
#line 360 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 361 "PhotoMetadata.vala"
		gee_collection_add_all (all_tags, exif_tags);
#line 1934 "PhotoMetadata.c"
	}
#line 363 "PhotoMetadata.vala"
	xmp_tags = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL);
#line 364 "PhotoMetadata.vala"
	if (xmp_tags != NULL) {
#line 364 "PhotoMetadata.vala"
		_tmp1_ = gee_collection_get_size (xmp_tags) > 0;
#line 1942 "PhotoMetadata.c"
	} else {
#line 364 "PhotoMetadata.vala"
		_tmp1_ = FALSE;
#line 1946 "PhotoMetadata.c"
	}
#line 364 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 365 "PhotoMetadata.vala"
		gee_collection_add_all (all_tags, xmp_tags);
#line 1952 "PhotoMetadata.c"
	}
#line 367 "PhotoMetadata.vala"
	iptc_tags = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL);
#line 368 "PhotoMetadata.vala"
	if (iptc_tags != NULL) {
#line 368 "PhotoMetadata.vala"
		_tmp2_ = gee_collection_get_size (iptc_tags) > 0;
#line 1960 "PhotoMetadata.c"
	} else {
#line 368 "PhotoMetadata.vala"
		_tmp2_ = FALSE;
#line 1964 "PhotoMetadata.c"
	}
#line 368 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 369 "PhotoMetadata.vala"
		gee_collection_add_all (all_tags, iptc_tags);
#line 1970 "PhotoMetadata.c"
	}
	_tmp3_ = NULL;
#line 371 "PhotoMetadata.vala"
	if (gee_collection_get_size (all_tags) > 0) {
#line 371 "PhotoMetadata.vala"
		_tmp3_ = all_tags;
#line 1977 "PhotoMetadata.c"
	} else {
#line 371 "PhotoMetadata.vala"
		_tmp3_ = NULL;
#line 1981 "PhotoMetadata.c"
	}
	result = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (iptc_tags);
	_g_object_unref0 (xmp_tags);
	_g_object_unref0 (exif_tags);
	_g_object_unref0 (all_tags);
#line 371 "PhotoMetadata.vala"
	return result;
#line 1990 "PhotoMetadata.c"
}


#line 374 "PhotoMetadata.vala"
char* photo_metadata_get_tag_label (PhotoMetadata* self, const char* tag) {
#line 1996 "PhotoMetadata.c"
	char* result = NULL;
#line 374 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 374 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 2002 "PhotoMetadata.c"
	result = g_strdup (gexiv2_metadata_get_tag_label (tag));
#line 375 "PhotoMetadata.vala"
	return result;
#line 2006 "PhotoMetadata.c"
}


#line 378 "PhotoMetadata.vala"
char* photo_metadata_get_tag_description (PhotoMetadata* self, const char* tag) {
#line 2012 "PhotoMetadata.c"
	char* result = NULL;
#line 378 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 378 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 2018 "PhotoMetadata.c"
	result = g_strdup (gexiv2_metadata_get_tag_description (tag));
#line 379 "PhotoMetadata.vala"
	return result;
#line 2022 "PhotoMetadata.c"
}


#line 382 "PhotoMetadata.vala"
char* photo_metadata_get_string (PhotoMetadata* self, const char* tag) {
#line 2028 "PhotoMetadata.c"
	char* result = NULL;
	char* value;
	const char* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 382 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 382 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 383 "PhotoMetadata.vala"
	value = gexiv2_metadata_get_tag_string (self->priv->exiv2, tag);
#line 2039 "PhotoMetadata.c"
	_tmp0_ = NULL;
#line 385 "PhotoMetadata.vala"
	if (value != NULL) {
#line 385 "PhotoMetadata.vala"
		_tmp1_ = g_utf8_validate (value, -1, NULL);
#line 2045 "PhotoMetadata.c"
	} else {
#line 385 "PhotoMetadata.vala"
		_tmp1_ = FALSE;
#line 2049 "PhotoMetadata.c"
	}
#line 385 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 385 "PhotoMetadata.vala"
		_tmp0_ = value;
#line 2055 "PhotoMetadata.c"
	} else {
#line 385 "PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 2059 "PhotoMetadata.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (value);
#line 385 "PhotoMetadata.vala"
	return result;
#line 2065 "PhotoMetadata.c"
}


#line 388 "PhotoMetadata.vala"
char* photo_metadata_get_string_interpreted (PhotoMetadata* self, const char* tag) {
#line 2071 "PhotoMetadata.c"
	char* result = NULL;
	char* value;
	const char* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 388 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 388 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 389 "PhotoMetadata.vala"
	value = gexiv2_metadata_get_tag_interpreted_string (self->priv->exiv2, tag);
#line 2082 "PhotoMetadata.c"
	_tmp0_ = NULL;
#line 391 "PhotoMetadata.vala"
	if (value != NULL) {
#line 391 "PhotoMetadata.vala"
		_tmp1_ = g_utf8_validate (value, -1, NULL);
#line 2088 "PhotoMetadata.c"
	} else {
#line 391 "PhotoMetadata.vala"
		_tmp1_ = FALSE;
#line 2092 "PhotoMetadata.c"
	}
#line 391 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 391 "PhotoMetadata.vala"
		_tmp0_ = value;
#line 2098 "PhotoMetadata.c"
	} else {
#line 391 "PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 2102 "PhotoMetadata.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (value);
#line 391 "PhotoMetadata.vala"
	return result;
#line 2108 "PhotoMetadata.c"
}


#line 394 "PhotoMetadata.vala"
char* photo_metadata_get_first_string (PhotoMetadata* self, char** tags, int tags_length1) {
#line 2114 "PhotoMetadata.c"
	char* result = NULL;
#line 394 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2118 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 395 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2125 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				char* value;
#line 396 "PhotoMetadata.vala"
				value = photo_metadata_get_string (self, tag);
#line 397 "PhotoMetadata.vala"
				if (value != NULL) {
#line 2136 "PhotoMetadata.c"
					result = value;
					_g_free0 (tag);
#line 398 "PhotoMetadata.vala"
					return result;
#line 2141 "PhotoMetadata.c"
				}
				_g_free0 (value);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 401 "PhotoMetadata.vala"
	return result;
#line 2151 "PhotoMetadata.c"
}


#line 404 "PhotoMetadata.vala"
char* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, char** tags, int tags_length1) {
#line 2157 "PhotoMetadata.c"
	char* result = NULL;
#line 404 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2161 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 405 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2168 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				char* value;
#line 406 "PhotoMetadata.vala"
				value = photo_metadata_get_string_interpreted (self, tag);
#line 407 "PhotoMetadata.vala"
				if (value != NULL) {
#line 2179 "PhotoMetadata.c"
					result = value;
					_g_free0 (tag);
#line 408 "PhotoMetadata.vala"
					return result;
#line 2184 "PhotoMetadata.c"
				}
				_g_free0 (value);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 411 "PhotoMetadata.vala"
	return result;
#line 2194 "PhotoMetadata.c"
}


#line 414 "PhotoMetadata.vala"
GeeCollection* photo_metadata_get_string_multiple (PhotoMetadata* self, const char* tag, GCompareFunc compare_func) {
#line 2200 "PhotoMetadata.c"
	GeeCollection* result = NULL;
	gint values_length1;
	gint _values_size_;
	char** _tmp1_;
	char** _tmp0_;
	char** values;
	gboolean _tmp2_ = FALSE;
	GeeCollection* collection;
#line 414 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 414 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 2213 "PhotoMetadata.c"
	values = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_tag_multiple (self->priv->exiv2, tag), values_length1 = _vala_array_length (_tmp0_), _values_size_ = values_length1, _tmp1_);
#line 416 "PhotoMetadata.vala"
	if (values == NULL) {
#line 416 "PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 2219 "PhotoMetadata.c"
	} else {
#line 416 "PhotoMetadata.vala"
		_tmp2_ = values_length1 == 0;
#line 2223 "PhotoMetadata.c"
	}
#line 416 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 2227 "PhotoMetadata.c"
		result = NULL;
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 417 "PhotoMetadata.vala"
		return result;
#line 2232 "PhotoMetadata.c"
	}
#line 419 "PhotoMetadata.vala"
	collection = GEE_COLLECTION (gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, compare_func));
#line 2236 "PhotoMetadata.c"
	{
		char** value_collection;
		int value_collection_length1;
		int value_it;
#line 420 "PhotoMetadata.vala"
		value_collection = values;
#line 2243 "PhotoMetadata.c"
		value_collection_length1 = values_length1;
		for (value_it = 0; value_it < values_length1; value_it = value_it + 1) {
			char* value;
			value = g_strdup (value_collection[value_it]);
			{
#line 421 "PhotoMetadata.vala"
				if (g_utf8_validate (value, -1, NULL)) {
#line 422 "PhotoMetadata.vala"
					gee_collection_add (collection, value);
#line 2253 "PhotoMetadata.c"
				}
				_g_free0 (value);
			}
		}
	}
	result = collection;
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 425 "PhotoMetadata.vala"
	return result;
#line 2263 "PhotoMetadata.c"
}


#line 428 "PhotoMetadata.vala"
void photo_metadata_set_string (PhotoMetadata* self, const char* tag, const char* value) {
#line 428 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 428 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 428 "PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 429 "PhotoMetadata.vala"
	if (!g_utf8_validate (value, -1, NULL)) {
#line 430 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:430: Not setting tag %s to string %s: invalid UTF-8", tag, value);
#line 432 "PhotoMetadata.vala"
		return;
#line 2281 "PhotoMetadata.c"
	}
#line 435 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_string (self->priv->exiv2, tag, value)) {
#line 436 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:436: Unable to set tag %s to string %s from source " \
"%s", tag, value, self->priv->source_name);
#line 2287 "PhotoMetadata.c"
	}
}


#line 439 "PhotoMetadata.vala"
void photo_metadata_set_all_string (PhotoMetadata* self, char** tags, int tags_length1, const char* value, gboolean only_if_domain_present) {
#line 439 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 439 "PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 2298 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 440 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2305 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				gboolean _tmp0_ = FALSE;
#line 441 "PhotoMetadata.vala"
				if (!only_if_domain_present) {
#line 441 "PhotoMetadata.vala"
					_tmp0_ = TRUE;
#line 2316 "PhotoMetadata.c"
				} else {
#line 441 "PhotoMetadata.vala"
					_tmp0_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (tag));
#line 2320 "PhotoMetadata.c"
				}
#line 441 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 442 "PhotoMetadata.vala"
					photo_metadata_set_string (self, tag, value);
#line 2326 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
}


static void _vala_array_add246 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 446 "PhotoMetadata.vala"
void photo_metadata_set_string_multiple (PhotoMetadata* self, const char* tag, GeeCollection* collection) {
#line 2347 "PhotoMetadata.c"
	gint values_length1;
	gint _values_size_;
	char** _tmp0_;
	char** values;
#line 446 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 446 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 446 "PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (collection));
#line 2358 "PhotoMetadata.c"
	values = (_tmp0_ = g_new0 (char*, 0 + 1), values_length1 = 0, _values_size_ = values_length1, _tmp0_);
	{
		GeeIterator* _value_it;
#line 448 "PhotoMetadata.vala"
		_value_it = gee_iterable_iterator (GEE_ITERABLE (collection));
#line 448 "PhotoMetadata.vala"
		while (TRUE) {
#line 2366 "PhotoMetadata.c"
			char* value;
#line 448 "PhotoMetadata.vala"
			if (!gee_iterator_next (_value_it)) {
#line 448 "PhotoMetadata.vala"
				break;
#line 2372 "PhotoMetadata.c"
			}
#line 448 "PhotoMetadata.vala"
			value = (char*) gee_iterator_get (_value_it);
#line 449 "PhotoMetadata.vala"
			if (g_utf8_validate (value, -1, NULL)) {
#line 450 "PhotoMetadata.vala"
				_vala_array_add246 (&values, &values_length1, &_values_size_, g_strdup (value));
#line 2380 "PhotoMetadata.c"
			}
			_g_free0 (value);
		}
		_g_object_unref0 (_value_it);
	}
#line 453 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_multiple (self->priv->exiv2, tag, values)) {
#line 454 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:454: Unable to set %d strings to tag %s from source" \
" %s", values_length1, tag, self->priv->source_name);
#line 2390 "PhotoMetadata.c"
	}
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
}


#line 457 "PhotoMetadata.vala"
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, char** tags, int tags_length1, GeeCollection* values, gboolean only_if_domain_present) {
#line 457 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 457 "PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (values));
#line 2402 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 459 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2409 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				gboolean _tmp0_ = FALSE;
#line 460 "PhotoMetadata.vala"
				if (!only_if_domain_present) {
#line 460 "PhotoMetadata.vala"
					_tmp0_ = TRUE;
#line 2420 "PhotoMetadata.c"
				} else {
#line 460 "PhotoMetadata.vala"
					_tmp0_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (tag));
#line 2424 "PhotoMetadata.c"
				}
#line 460 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 461 "PhotoMetadata.vala"
					photo_metadata_set_string_multiple (self, tag, values);
#line 2430 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
}


#line 465 "PhotoMetadata.vala"
gboolean photo_metadata_get_long (PhotoMetadata* self, const char* tag, glong* value) {
#line 2441 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 465 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 465 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 466 "PhotoMetadata.vala"
	if (!photo_metadata_has_tag (self, tag)) {
#line 2449 "PhotoMetadata.c"
		result = FALSE;
#line 467 "PhotoMetadata.vala"
		return result;
#line 2453 "PhotoMetadata.c"
	}
#line 469 "PhotoMetadata.vala"
	*value = gexiv2_metadata_get_tag_long (self->priv->exiv2, tag);
#line 2457 "PhotoMetadata.c"
	result = TRUE;
#line 471 "PhotoMetadata.vala"
	return result;
#line 2461 "PhotoMetadata.c"
}


#line 474 "PhotoMetadata.vala"
gboolean photo_metadata_get_first_long (PhotoMetadata* self, char** tags, int tags_length1, glong* value) {
#line 2467 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 474 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 2471 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 475 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2478 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 476 "PhotoMetadata.vala"
				if (photo_metadata_get_long (self, tag, value)) {
#line 2486 "PhotoMetadata.c"
					result = TRUE;
					_g_free0 (tag);
#line 477 "PhotoMetadata.vala"
					return result;
#line 2491 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
	result = FALSE;
#line 480 "PhotoMetadata.vala"
	return result;
#line 2500 "PhotoMetadata.c"
}


#line 483 "PhotoMetadata.vala"
void photo_metadata_set_long (PhotoMetadata* self, const char* tag, glong value) {
#line 483 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 483 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 484 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_long (self->priv->exiv2, tag, value)) {
#line 485 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:485: Unable to set tag %s to long %ld from source %" \
"s", tag, value, self->priv->source_name);
#line 2514 "PhotoMetadata.c"
	}
}


#line 488 "PhotoMetadata.vala"
void photo_metadata_set_all_long (PhotoMetadata* self, char** tags, int tags_length1, glong value, gboolean only_if_domain_present) {
#line 488 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 2523 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 489 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2530 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				gboolean _tmp0_ = FALSE;
#line 490 "PhotoMetadata.vala"
				if (!only_if_domain_present) {
#line 490 "PhotoMetadata.vala"
					_tmp0_ = TRUE;
#line 2541 "PhotoMetadata.c"
				} else {
#line 490 "PhotoMetadata.vala"
					_tmp0_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (tag));
#line 2545 "PhotoMetadata.c"
				}
#line 490 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 491 "PhotoMetadata.vala"
					photo_metadata_set_long (self, tag, value);
#line 2551 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
}


#line 495 "PhotoMetadata.vala"
gboolean photo_metadata_get_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational) {
#line 2562 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 495 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 495 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 2568 "PhotoMetadata.c"
	result = gexiv2_metadata_get_exif_tag_rational (self->priv->exiv2, tag, &(*rational).numerator, &(*rational).denominator);
#line 496 "PhotoMetadata.vala"
	return result;
#line 2572 "PhotoMetadata.c"
}


#line 499 "PhotoMetadata.vala"
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational) {
#line 2578 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 499 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 2582 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 500 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2589 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 501 "PhotoMetadata.vala"
				if (photo_metadata_get_rational (self, tag, rational)) {
#line 2597 "PhotoMetadata.c"
					result = TRUE;
					_g_free0 (tag);
#line 502 "PhotoMetadata.vala"
					return result;
#line 2602 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
	result = FALSE;
#line 505 "PhotoMetadata.vala"
	return result;
#line 2611 "PhotoMetadata.c"
}


#line 508 "PhotoMetadata.vala"
void photo_metadata_set_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational) {
#line 508 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 508 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 509 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_exif_tag_rational (self->priv->exiv2, tag, (*rational).numerator, (*rational).denominator)) {
#line 2623 "PhotoMetadata.c"
		char* _tmp0_;
#line 510 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:510: Unable to set tag %s to rational %s from sourc" \
"e %s", tag, _tmp0_ = metadata_rational_to_string (rational), self->priv->source_name);
#line 2627 "PhotoMetadata.c"
		_g_free0 (_tmp0_);
	}
}


#line 515 "PhotoMetadata.vala"
void photo_metadata_set_all_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational, gboolean only_if_domain_present) {
#line 515 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 2637 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 516 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2644 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				gboolean _tmp0_ = FALSE;
#line 517 "PhotoMetadata.vala"
				if (!only_if_domain_present) {
#line 517 "PhotoMetadata.vala"
					_tmp0_ = TRUE;
#line 2655 "PhotoMetadata.c"
				} else {
#line 517 "PhotoMetadata.vala"
					_tmp0_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (tag));
#line 2659 "PhotoMetadata.c"
				}
#line 517 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 518 "PhotoMetadata.vala"
					photo_metadata_set_rational (self, tag, rational);
#line 2665 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
}


#line 522 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const char* tag) {
#line 2676 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
	char* value;
	GError * _inner_error_ = NULL;
#line 522 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 522 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 523 "PhotoMetadata.vala"
	value = photo_metadata_get_string (self, tag);
#line 524 "PhotoMetadata.vala"
	if (value == NULL) {
#line 2688 "PhotoMetadata.c"
		result = NULL;
		_g_free0 (value);
#line 525 "PhotoMetadata.vala"
		return result;
#line 2693 "PhotoMetadata.c"
	}
	{
#line 528 "PhotoMetadata.vala"
		switch (photo_metadata_get_tag_domain (tag)) {
#line 2698 "PhotoMetadata.c"
			case METADATA_DOMAIN_XMP:
			{
				MetadataDateTime* _tmp0_;
#line 530 "PhotoMetadata.vala"
				_tmp0_ = metadata_date_time_new_from_xmp (value, &_inner_error_);
#line 2704 "PhotoMetadata.c"
				if (_inner_error_ != NULL) {
					goto __catch259_g_error;
				}
				result = _tmp0_;
				_g_free0 (value);
#line 530 "PhotoMetadata.vala"
				return result;
#line 2712 "PhotoMetadata.c"
			}
			case METADATA_DOMAIN_IPTC:
			{
				result = NULL;
				_g_free0 (value);
#line 535 "PhotoMetadata.vala"
				return result;
#line 2720 "PhotoMetadata.c"
			}
			default:
			{
				MetadataDateTime* _tmp1_;
#line 539 "PhotoMetadata.vala"
				_tmp1_ = metadata_date_time_new_from_exif (value, &_inner_error_);
#line 2727 "PhotoMetadata.c"
				if (_inner_error_ != NULL) {
					goto __catch259_g_error;
				}
				result = _tmp1_;
				_g_free0 (value);
#line 539 "PhotoMetadata.vala"
				return result;
#line 2735 "PhotoMetadata.c"
			}
		}
	}
	goto __finally259;
	__catch259_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 542 "PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:542: Unable to read date/time %s from source %s: %s", tag, self->priv->source_name, err->message);
#line 2748 "PhotoMetadata.c"
			result = NULL;
			_g_error_free0 (err);
			_g_free0 (value);
#line 544 "PhotoMetadata.vala"
			return result;
#line 2754 "PhotoMetadata.c"
		}
	}
	__finally259:
	{
		_g_free0 (value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_free0 (value);
}


#line 548 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, char** tags, int tags_length1) {
#line 2770 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 548 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2774 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 549 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2781 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				MetadataDateTime* date_time;
#line 550 "PhotoMetadata.vala"
				date_time = photo_metadata_get_date_time (self, tag);
#line 551 "PhotoMetadata.vala"
				if (date_time != NULL) {
#line 2792 "PhotoMetadata.c"
					result = date_time;
					_g_free0 (tag);
#line 552 "PhotoMetadata.vala"
					return result;
#line 2797 "PhotoMetadata.c"
				}
				_metadata_date_time_unref0 (date_time);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 555 "PhotoMetadata.vala"
	return result;
#line 2807 "PhotoMetadata.c"
}


#line 558 "PhotoMetadata.vala"
void photo_metadata_set_date_time (PhotoMetadata* self, const char* tag, MetadataDateTime* date_time) {
#line 558 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 558 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 558 "PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 559 "PhotoMetadata.vala"
	switch (photo_metadata_get_tag_domain (tag)) {
#line 2821 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			char* _tmp0_;
#line 561 "PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp0_ = metadata_date_time_get_exif_label (date_time));
#line 2827 "PhotoMetadata.c"
			_g_free0 (_tmp0_);
#line 562 "PhotoMetadata.vala"
			break;
#line 2831 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			char* _tmp1_;
#line 565 "PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp1_ = metadata_date_time_get_xmp_label (date_time));
#line 2838 "PhotoMetadata.c"
			_g_free0 (_tmp1_);
#line 566 "PhotoMetadata.vala"
			break;
#line 2842 "PhotoMetadata.c"
		}
		default:
		{
			GEnumValue* _tmp2_;
#line 571 "PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:571: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, self->priv->source_name, (_tmp2_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), (int) photo_metadata_get_tag_domain (tag)), (_tmp2_ != NULL) ? _tmp2_->value_name : NULL));
#line 573 "PhotoMetadata.vala"
			break;
#line 2851 "PhotoMetadata.c"
		}
	}
}


#line 577 "PhotoMetadata.vala"
void photo_metadata_set_all_date_time (PhotoMetadata* self, char** tags, int tags_length1, MetadataDateTime* date_time, gboolean only_if_domain_present) {
#line 577 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 577 "PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 2863 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 578 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2870 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				gboolean _tmp0_ = FALSE;
#line 579 "PhotoMetadata.vala"
				if (!only_if_domain_present) {
#line 579 "PhotoMetadata.vala"
					_tmp0_ = TRUE;
#line 2881 "PhotoMetadata.c"
				} else {
#line 579 "PhotoMetadata.vala"
					_tmp0_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (tag));
#line 2885 "PhotoMetadata.c"
				}
#line 579 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 580 "PhotoMetadata.vala"
					photo_metadata_set_date_time (self, tag, date_time);
#line 2891 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
}


#line 585 "PhotoMetadata.vala"
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1) {
#line 2902 "PhotoMetadata.c"
	guint8* result = NULL;
	guchar* thumbnail;
	guint thumbnail_size;
	gint flattened_length1;
	gint _flattened_size_;
	guint8* _tmp1_;
	guint8* flattened;
	guchar* saved_data;
	guint saved_size;
	gboolean _tmp2_ = FALSE;
	guint8* _tmp5_;
#line 585 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 586 "PhotoMetadata.vala"
	if (self->priv->exif == NULL) {
#line 2918 "PhotoMetadata.c"
		gpointer _tmp0_;
		result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
#line 587 "PhotoMetadata.vala"
		return result;
#line 2923 "PhotoMetadata.c"
	}
#line 591 "PhotoMetadata.vala"
	thumbnail = self->priv->exif->data;
#line 592 "PhotoMetadata.vala"
	thumbnail_size = self->priv->exif->size;
#line 593 "PhotoMetadata.vala"
	if (!include_preview) {
#line 594 "PhotoMetadata.vala"
		self->priv->exif->data = NULL;
#line 595 "PhotoMetadata.vala"
		self->priv->exif->size = (guint) 0;
#line 2935 "PhotoMetadata.c"
	}
	flattened = (_tmp1_ = NULL, flattened_length1 = 0, _flattened_size_ = flattened_length1, _tmp1_);
#line 601 "PhotoMetadata.vala"
	saved_data = NULL;
#line 602 "PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 603 "PhotoMetadata.vala"
	exif_data_save_data (self->priv->exif, &saved_data, &saved_size);
#line 604 "PhotoMetadata.vala"
	if (saved_size > 0) {
#line 604 "PhotoMetadata.vala"
		_tmp2_ = saved_data != NULL;
#line 2948 "PhotoMetadata.c"
	} else {
#line 604 "PhotoMetadata.vala"
		_tmp2_ = FALSE;
#line 2952 "PhotoMetadata.c"
	}
#line 604 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 2956 "PhotoMetadata.c"
		guint8* _tmp3_;
		ExifMem* _tmp4_;
#line 605 "PhotoMetadata.vala"
		flattened = (_tmp3_ = g_new0 (guint8, saved_size), flattened = (g_free (flattened), NULL), flattened_length1 = saved_size, _flattened_size_ = flattened_length1, _tmp3_);
#line 606 "PhotoMetadata.vala"
		memcpy (flattened, saved_data, (gsize) saved_size);
#line 608 "PhotoMetadata.vala"
		exif_mem_free (_tmp4_ = exif_mem_new_default (), saved_data);
#line 2965 "PhotoMetadata.c"
		_exif_mem_unref0 (_tmp4_);
	}
#line 612 "PhotoMetadata.vala"
	self->priv->exif->data = thumbnail;
#line 613 "PhotoMetadata.vala"
	self->priv->exif->size = thumbnail_size;
#line 2972 "PhotoMetadata.c"
	result = (_tmp5_ = flattened, *result_length1 = flattened_length1, _tmp5_);
#line 615 "PhotoMetadata.vala"
	return result;
#line 2976 "PhotoMetadata.c"
	flattened = (g_free (flattened), NULL);
}


static guint8* _vala_array_dup16 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


#line 619 "PhotoMetadata.vala"
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1) {
#line 2988 "PhotoMetadata.c"
	guint8* result = NULL;
	gint buffer_length1;
	gint _buffer_size_;
	guchar* buffer;
	gint _tmp0__length1;
	gint __tmp0__size_;
	guchar* _tmp0_;
	guint8* _tmp3_;
	guchar* _tmp4_;
#line 619 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3000 "PhotoMetadata.c"
	buffer = (buffer_length1 = 0, NULL);
	_tmp0_ = (_tmp0__length1 = 0, NULL);
#line 621 "PhotoMetadata.vala"
	if (gexiv2_metadata_get_exif_thumbnail (self->priv->exiv2, &buffer, &buffer_length1)) {
#line 3005 "PhotoMetadata.c"
		guchar* _tmp1_;
#line 621 "PhotoMetadata.vala"
		_tmp0_ = (_tmp1_ = buffer, _tmp0__length1 = buffer_length1, __tmp0__size_ = _tmp0__length1, _tmp1_);
#line 3009 "PhotoMetadata.c"
	} else {
		guchar* _tmp2_;
#line 621 "PhotoMetadata.vala"
		_tmp0_ = (_tmp2_ = NULL, _tmp0__length1 = 0, __tmp0__size_ = _tmp0__length1, _tmp2_);
#line 3014 "PhotoMetadata.c"
	}
	result = (_tmp4_ = (_tmp3_ = _tmp0_, (_tmp3_ == NULL) ? ((gpointer) _tmp3_) : _vala_array_dup16 (_tmp3_, _tmp0__length1)), *result_length1 = _tmp0__length1, _tmp4_);
	buffer = (g_free (buffer), NULL);
#line 621 "PhotoMetadata.vala"
	return result;
#line 3020 "PhotoMetadata.c"
	buffer = (g_free (buffer), NULL);
}


#line 624 "PhotoMetadata.vala"
guint photo_metadata_get_preview_count (PhotoMetadata* self) {
#line 3027 "PhotoMetadata.c"
	guint result = 0U;
	gint props_length1;
	gint _props_size_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** props;
	gint _tmp2_ = 0;
#line 624 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
#line 3037 "PhotoMetadata.c"
	props = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->priv->exiv2), props_length1 = _vala_array_length (_tmp0_), _props_size_ = props_length1, _tmp1_);
#line 627 "PhotoMetadata.vala"
	if (props != NULL) {
#line 627 "PhotoMetadata.vala"
		_tmp2_ = props_length1;
#line 3043 "PhotoMetadata.c"
	} else {
#line 627 "PhotoMetadata.vala"
		_tmp2_ = 0;
#line 3047 "PhotoMetadata.c"
	}
	result = (guint) _tmp2_;
#line 627 "PhotoMetadata.vala"
	return result;
#line 3052 "PhotoMetadata.c"
}


#line 631 "PhotoMetadata.vala"
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number) {
#line 3058 "PhotoMetadata.c"
	PhotoPreview* result = NULL;
	gint props_length1;
	gint _props_size_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** props;
	gboolean _tmp2_ = FALSE;
#line 631 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3068 "PhotoMetadata.c"
	props = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->priv->exiv2), props_length1 = _vala_array_length (_tmp0_), _props_size_ = props_length1, _tmp1_);
#line 633 "PhotoMetadata.vala"
	if (props == NULL) {
#line 633 "PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 3074 "PhotoMetadata.c"
	} else {
#line 633 "PhotoMetadata.vala"
		_tmp2_ = props_length1 <= number;
#line 3078 "PhotoMetadata.c"
	}
#line 633 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 3082 "PhotoMetadata.c"
		result = NULL;
#line 634 "PhotoMetadata.vala"
		return result;
#line 3086 "PhotoMetadata.c"
	}
	result = PHOTO_PREVIEW (photo_metadata_internal_photo_preview_new (self, self->priv->source_name, number, props[number]));
#line 636 "PhotoMetadata.vala"
	return result;
#line 3091 "PhotoMetadata.c"
}


#line 639 "PhotoMetadata.vala"
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self) {
#line 639 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 640 "PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (self->priv->exiv2);
#line 641 "PhotoMetadata.vala"
	if (self->priv->exif != NULL) {
#line 3103 "PhotoMetadata.c"
		ExifMem* _tmp0_;
#line 642 "PhotoMetadata.vala"
		exif_mem_free (_tmp0_ = exif_mem_new_default (), self->priv->exif->data);
#line 3107 "PhotoMetadata.c"
		_exif_mem_unref0 (_tmp0_);
#line 643 "PhotoMetadata.vala"
		self->priv->exif->data = NULL;
#line 644 "PhotoMetadata.vala"
		self->priv->exif->size = (guint) 0;
#line 3113 "PhotoMetadata.c"
	}
}


#line 648 "PhotoMetadata.vala"
void photo_metadata_remove_tag (PhotoMetadata* self, const char* tag) {
#line 648 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 648 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 649 "PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (self->priv->exiv2, tag);
#line 3126 "PhotoMetadata.c"
}


#line 652 "PhotoMetadata.vala"
void photo_metadata_remove_tags (PhotoMetadata* self, char** tags, int tags_length1) {
#line 652 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 3134 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 653 "PhotoMetadata.vala"
		tag_collection = tags;
#line 3141 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 654 "PhotoMetadata.vala"
				photo_metadata_remove_tag (self, tag);
#line 3149 "PhotoMetadata.c"
				_g_free0 (tag);
			}
		}
	}
}


#line 657 "PhotoMetadata.vala"
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain) {
#line 657 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 658 "PhotoMetadata.vala"
	switch (domain) {
#line 3163 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
#line 660 "PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (self->priv->exiv2);
#line 661 "PhotoMetadata.vala"
			break;
#line 3170 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
#line 664 "PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (self->priv->exiv2);
#line 665 "PhotoMetadata.vala"
			break;
#line 3178 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
#line 668 "PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (self->priv->exiv2);
#line 669 "PhotoMetadata.vala"
			break;
#line 3186 "PhotoMetadata.c"
		}
	}
}


#line 673 "PhotoMetadata.vala"
void photo_metadata_clear (PhotoMetadata* self) {
#line 673 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 674 "PhotoMetadata.vala"
	gexiv2_metadata_clear (self->priv->exiv2);
#line 3198 "PhotoMetadata.c"
}


#line 683 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self) {
#line 3204 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 683 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3208 "PhotoMetadata.c"
	result = photo_metadata_get_first_date_time (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1);
#line 684 "PhotoMetadata.vala"
	return result;
#line 3212 "PhotoMetadata.c"
}


#line 687 "PhotoMetadata.vala"
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, gboolean only_if_domain_present) {
#line 687 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 687 "PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 688 "PhotoMetadata.vala"
	if (date_time != NULL) {
#line 689 "PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1, date_time, only_if_domain_present);
#line 3226 "PhotoMetadata.c"
	} else {
#line 691 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1);
#line 3230 "PhotoMetadata.c"
	}
}


#line 700 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self) {
#line 3237 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 700 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3241 "PhotoMetadata.c"
	result = photo_metadata_get_first_date_time (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1);
#line 701 "PhotoMetadata.vala"
	return result;
#line 3245 "PhotoMetadata.c"
}


#line 704 "PhotoMetadata.vala"
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, gboolean only_if_domain_present) {
#line 704 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 704 "PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 705 "PhotoMetadata.vala"
	if (date_time != NULL) {
#line 706 "PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1, date_time, only_if_domain_present);
#line 3259 "PhotoMetadata.c"
	} else {
#line 708 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1);
#line 3263 "PhotoMetadata.c"
	}
}


#line 716 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self) {
#line 3270 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 716 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3274 "PhotoMetadata.c"
	result = photo_metadata_get_first_date_time (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1);
#line 717 "PhotoMetadata.vala"
	return result;
#line 3278 "PhotoMetadata.c"
}


#line 720 "PhotoMetadata.vala"
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, gboolean only_if_domain_present) {
#line 720 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 720 "PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 721 "PhotoMetadata.vala"
	if (date_time != NULL) {
#line 722 "PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1, date_time, only_if_domain_present);
#line 3292 "PhotoMetadata.c"
	} else {
#line 724 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1);
#line 3296 "PhotoMetadata.c"
	}
}


static gpointer _dimensions_dup0 (gpointer self) {
	return self ? dimensions_dup (self) : NULL;
}


#line 741 "PhotoMetadata.vala"
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self) {
#line 3308 "PhotoMetadata.c"
	Dimensions* result = NULL;
#line 741 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 743 "PhotoMetadata.vala"
	g_assert (photo_metadata_WIDTH_TAGS_length1 == photo_metadata_HEIGHT_TAGS_length1);
#line 3314 "PhotoMetadata.c"
	{
		gint ctr;
#line 744 "PhotoMetadata.vala"
		ctr = 0;
#line 3319 "PhotoMetadata.c"
		{
			gboolean _tmp0_;
#line 744 "PhotoMetadata.vala"
			_tmp0_ = TRUE;
#line 744 "PhotoMetadata.vala"
			while (TRUE) {
#line 3326 "PhotoMetadata.c"
				glong width = 0L;
				glong height = 0L;
				Dimensions _tmp1_ = {0};
				Dimensions _tmp2_;
#line 744 "PhotoMetadata.vala"
				if (!_tmp0_) {
#line 744 "PhotoMetadata.vala"
					ctr++;
#line 3335 "PhotoMetadata.c"
				}
#line 744 "PhotoMetadata.vala"
				_tmp0_ = FALSE;
#line 744 "PhotoMetadata.vala"
				if (!(ctr < photo_metadata_WIDTH_TAGS_length1)) {
#line 744 "PhotoMetadata.vala"
					break;
#line 3343 "PhotoMetadata.c"
				}
#line 748 "PhotoMetadata.vala"
				if (!photo_metadata_get_long (self, photo_metadata_WIDTH_TAGS[ctr], &width)) {
#line 749 "PhotoMetadata.vala"
					continue;
#line 3349 "PhotoMetadata.c"
				}
#line 752 "PhotoMetadata.vala"
				if (!photo_metadata_get_long (self, photo_metadata_HEIGHT_TAGS[ctr], &height)) {
#line 753 "PhotoMetadata.vala"
					continue;
#line 3355 "PhotoMetadata.c"
				}
				result = _dimensions_dup0 ((_tmp2_ = (dimensions_init (&_tmp1_, (gint) width, (gint) height), _tmp1_), &_tmp2_));
#line 755 "PhotoMetadata.vala"
				return result;
#line 3360 "PhotoMetadata.c"
			}
		}
	}
	result = NULL;
#line 758 "PhotoMetadata.vala"
	return result;
#line 3367 "PhotoMetadata.c"
}


#line 761 "PhotoMetadata.vala"
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, gboolean only_if_domain_present) {
#line 761 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 762 "PhotoMetadata.vala"
	if (dim != NULL) {
#line 763 "PhotoMetadata.vala"
		photo_metadata_set_all_long (self, photo_metadata_WIDTH_TAGS, photo_metadata_WIDTH_TAGS_length1, (glong) (*dim).width, only_if_domain_present);
#line 764 "PhotoMetadata.vala"
		photo_metadata_set_all_long (self, photo_metadata_HEIGHT_TAGS, photo_metadata_HEIGHT_TAGS_length1, (glong) (*dim).height, only_if_domain_present);
#line 3381 "PhotoMetadata.c"
	} else {
#line 766 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_WIDTH_TAGS, photo_metadata_WIDTH_TAGS_length1);
#line 767 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_HEIGHT_TAGS, photo_metadata_HEIGHT_TAGS_length1);
#line 3387 "PhotoMetadata.c"
	}
}


#line 1027 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 3394 "PhotoMetadata.c"
	char* result = NULL;
	char* _result_;
#line 1027 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1028 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1029 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 3403 "PhotoMetadata.c"
	result = _result_;
#line 1030 "glib-2.0.vapi"
	return result;
#line 3407 "PhotoMetadata.c"
}


#line 1153 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 3413 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 1153 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1153 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 3419 "PhotoMetadata.c"
	result = strstr (self, needle) != NULL;
#line 1154 "glib-2.0.vapi"
	return result;
#line 3423 "PhotoMetadata.c"
}


#line 800 "PhotoMetadata.vala"
char* photo_metadata_get_title (PhotoMetadata* self) {
#line 3429 "PhotoMetadata.c"
	char* result = NULL;
	char* _tmp0_;
	char* title;
	const char* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 800 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3438 "PhotoMetadata.c"
	_tmp0_ = NULL;
#line 801 "PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 3442 "PhotoMetadata.c"
		char* _tmp1_;
#line 802 "PhotoMetadata.vala"
		_tmp0_ = (_tmp1_ = photo_metadata_get_string_interpreted (self, PHOTO_METADATA_IPHOTO_TITLE_TAG), _g_free0 (_tmp0_), _tmp1_);
#line 3446 "PhotoMetadata.c"
	} else {
		char* _tmp2_;
#line 803 "PhotoMetadata.vala"
		_tmp0_ = (_tmp2_ = photo_metadata_get_first_string_interpreted (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1), _g_free0 (_tmp0_), _tmp2_);
#line 3451 "PhotoMetadata.c"
	}
#line 801 "PhotoMetadata.vala"
	title = g_strdup (_tmp0_);
#line 806 "PhotoMetadata.vala"
	if (title != NULL) {
#line 3457 "PhotoMetadata.c"
		char* _tmp3_;
#line 807 "PhotoMetadata.vala"
		title = (_tmp3_ = string_strip (title), _g_free0 (title), _tmp3_);
#line 3461 "PhotoMetadata.c"
	}
	_tmp4_ = NULL;
#line 810 "PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 810 "PhotoMetadata.vala"
		_tmp6_ = !string_contains (title, "\n");
#line 3468 "PhotoMetadata.c"
	} else {
#line 810 "PhotoMetadata.vala"
		_tmp6_ = FALSE;
#line 3472 "PhotoMetadata.c"
	}
#line 810 "PhotoMetadata.vala"
	if (_tmp6_) {
#line 810 "PhotoMetadata.vala"
		_tmp5_ = !string_contains (title, "\r");
#line 3478 "PhotoMetadata.c"
	} else {
#line 810 "PhotoMetadata.vala"
		_tmp5_ = FALSE;
#line 3482 "PhotoMetadata.c"
	}
#line 810 "PhotoMetadata.vala"
	if (_tmp5_) {
#line 811 "PhotoMetadata.vala"
		_tmp4_ = title;
#line 3488 "PhotoMetadata.c"
	} else {
#line 811 "PhotoMetadata.vala"
		_tmp4_ = NULL;
#line 3492 "PhotoMetadata.c"
	}
	result = g_strdup (_tmp4_);
	_g_free0 (title);
	_g_free0 (_tmp0_);
#line 810 "PhotoMetadata.vala"
	return result;
#line 3499 "PhotoMetadata.c"
}


#line 814 "PhotoMetadata.vala"
void photo_metadata_set_title (PhotoMetadata* self, const char* title, gboolean only_if_domain_present) {
#line 814 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 815 "PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 816 "PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 817 "PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title);
#line 3513 "PhotoMetadata.c"
		} else {
#line 819 "PhotoMetadata.vala"
			photo_metadata_set_all_string (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1, title, only_if_domain_present);
#line 3517 "PhotoMetadata.c"
		}
	} else {
#line 821 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1);
#line 3522 "PhotoMetadata.c"
	}
}


#line 831 "PhotoMetadata.vala"
char* photo_metadata_get_description (PhotoMetadata* self) {
#line 3529 "PhotoMetadata.c"
	char* result = NULL;
#line 831 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 833 "PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 3535 "PhotoMetadata.c"
		result = photo_metadata_get_string_interpreted (self, PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG);
#line 834 "PhotoMetadata.vala"
		return result;
#line 3539 "PhotoMetadata.c"
	} else {
		result = photo_metadata_get_first_string_interpreted (self, photo_metadata_STANDARD_DESCRIPTION_TAGS, photo_metadata_STANDARD_DESCRIPTION_TAGS_length1);
#line 836 "PhotoMetadata.vala"
		return result;
#line 3544 "PhotoMetadata.c"
	}
}


#line 839 "PhotoMetadata.vala"
void photo_metadata_set_description (PhotoMetadata* self, const char* description, gboolean only_if_domain_present) {
#line 839 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 840 "PhotoMetadata.vala"
	if (!is_string_empty (description)) {
#line 3555 "PhotoMetadata.c"
		gboolean _tmp0_ = FALSE;
#line 841 "PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 3559 "PhotoMetadata.c"
			gboolean _tmp1_ = FALSE;
#line 842 "PhotoMetadata.vala"
			if (!only_if_domain_present) {
#line 842 "PhotoMetadata.vala"
				_tmp1_ = TRUE;
#line 3565 "PhotoMetadata.c"
			} else {
#line 842 "PhotoMetadata.vala"
				_tmp1_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG));
#line 3569 "PhotoMetadata.c"
			}
#line 842 "PhotoMetadata.vala"
			_tmp0_ = _tmp1_;
#line 3573 "PhotoMetadata.c"
		} else {
#line 841 "PhotoMetadata.vala"
			_tmp0_ = FALSE;
#line 3577 "PhotoMetadata.c"
		}
#line 841 "PhotoMetadata.vala"
		if (_tmp0_) {
#line 843 "PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG, description);
#line 3583 "PhotoMetadata.c"
		} else {
#line 845 "PhotoMetadata.vala"
			photo_metadata_set_all_string (self, photo_metadata_STANDARD_DESCRIPTION_TAGS, photo_metadata_STANDARD_DESCRIPTION_TAGS_length1, description, only_if_domain_present);
#line 3587 "PhotoMetadata.c"
		}
	} else {
#line 847 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_STANDARD_DESCRIPTION_TAGS, photo_metadata_STANDARD_DESCRIPTION_TAGS_length1);
#line 3592 "PhotoMetadata.c"
	}
}


#line 856 "PhotoMetadata.vala"
GeeCollection* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func) {
#line 3599 "PhotoMetadata.c"
	GeeCollection* result = NULL;
	GeeCollection* keywords;
	GeeCollection* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 856 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 857 "PhotoMetadata.vala"
	keywords = NULL;
#line 3608 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 858 "PhotoMetadata.vala"
		tag_collection = photo_metadata_KEYWORD_TAGS;
#line 3615 "PhotoMetadata.c"
		tag_collection_length1 = photo_metadata_KEYWORD_TAGS_length1;
		for (tag_it = 0; tag_it < photo_metadata_KEYWORD_TAGS_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				GeeCollection* values;
				gboolean _tmp0_ = FALSE;
#line 859 "PhotoMetadata.vala"
				values = photo_metadata_get_string_multiple (self, tag, NULL);
#line 860 "PhotoMetadata.vala"
				if (values != NULL) {
#line 860 "PhotoMetadata.vala"
					_tmp0_ = gee_collection_get_size (values) > 0;
#line 3629 "PhotoMetadata.c"
				} else {
#line 860 "PhotoMetadata.vala"
					_tmp0_ = FALSE;
#line 3633 "PhotoMetadata.c"
				}
#line 860 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 861 "PhotoMetadata.vala"
					if (keywords == NULL) {
#line 862 "PhotoMetadata.vala"
						if (compare_func == NULL) {
#line 3641 "PhotoMetadata.c"
							GeeCollection* _tmp1_;
#line 863 "PhotoMetadata.vala"
							keywords = (_tmp1_ = GEE_COLLECTION (gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL)), _g_object_unref0 (keywords), _tmp1_);
#line 3645 "PhotoMetadata.c"
						} else {
							GeeCollection* _tmp2_;
#line 865 "PhotoMetadata.vala"
							keywords = (_tmp2_ = GEE_COLLECTION (gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, compare_func)), _g_object_unref0 (keywords), _tmp2_);
#line 3650 "PhotoMetadata.c"
						}
					}
#line 868 "PhotoMetadata.vala"
					gee_collection_add_all (keywords, values);
#line 3655 "PhotoMetadata.c"
				}
				_g_object_unref0 (values);
				_g_free0 (tag);
			}
		}
	}
	_tmp3_ = NULL;
#line 872 "PhotoMetadata.vala"
	if (keywords != NULL) {
#line 872 "PhotoMetadata.vala"
		_tmp4_ = gee_collection_get_size (keywords) > 0;
#line 3667 "PhotoMetadata.c"
	} else {
#line 872 "PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 3671 "PhotoMetadata.c"
	}
#line 872 "PhotoMetadata.vala"
	if (_tmp4_) {
#line 872 "PhotoMetadata.vala"
		_tmp3_ = keywords;
#line 3677 "PhotoMetadata.c"
	} else {
#line 872 "PhotoMetadata.vala"
		_tmp3_ = NULL;
#line 3681 "PhotoMetadata.c"
	}
	result = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (keywords);
#line 872 "PhotoMetadata.vala"
	return result;
#line 3687 "PhotoMetadata.c"
}


#line 875 "PhotoMetadata.vala"
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, gboolean only_if_domain_present) {
#line 875 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 875 "PhotoMetadata.vala"
	g_return_if_fail ((keywords == NULL) || GEE_IS_COLLECTION (keywords));
#line 876 "PhotoMetadata.vala"
	if (keywords != NULL) {
#line 877 "PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, photo_metadata_KEYWORD_TAGS, photo_metadata_KEYWORD_TAGS_length1, keywords, only_if_domain_present);
#line 3701 "PhotoMetadata.c"
	} else {
#line 879 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_KEYWORD_TAGS, photo_metadata_KEYWORD_TAGS_length1);
#line 3705 "PhotoMetadata.c"
	}
}


#line 882 "PhotoMetadata.vala"
gboolean photo_metadata_has_orientation (PhotoMetadata* self) {
#line 3712 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 882 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3716 "PhotoMetadata.c"
	result = gexiv2_metadata_get_orientation (self->priv->exiv2) == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 883 "PhotoMetadata.vala"
	return result;
#line 3720 "PhotoMetadata.c"
}


#line 887 "PhotoMetadata.vala"
Orientation photo_metadata_get_orientation (PhotoMetadata* self) {
#line 3726 "PhotoMetadata.c"
	Orientation result = 0;
	GExiv2Orientation orientation;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 887 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 890 "PhotoMetadata.vala"
	orientation = gexiv2_metadata_get_orientation (self->priv->exiv2);
#line 891 "PhotoMetadata.vala"
	if (orientation == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 891 "PhotoMetadata.vala"
		_tmp1_ = TRUE;
#line 3739 "PhotoMetadata.c"
	} else {
#line 891 "PhotoMetadata.vala"
		_tmp1_ = orientation < ORIENTATION_MIN;
#line 3743 "PhotoMetadata.c"
	}
#line 891 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 891 "PhotoMetadata.vala"
		_tmp0_ = TRUE;
#line 3749 "PhotoMetadata.c"
	} else {
#line 892 "PhotoMetadata.vala"
		_tmp0_ = orientation > ORIENTATION_MAX;
#line 3753 "PhotoMetadata.c"
	}
#line 891 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 3757 "PhotoMetadata.c"
		result = ORIENTATION_TOP_LEFT;
#line 893 "PhotoMetadata.vala"
		return result;
#line 3761 "PhotoMetadata.c"
	} else {
		result = (Orientation) orientation;
#line 895 "PhotoMetadata.vala"
		return result;
#line 3766 "PhotoMetadata.c"
	}
}


#line 898 "PhotoMetadata.vala"
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation) {
#line 898 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 900 "PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (self->priv->exiv2, (GExiv2Orientation) orientation);
#line 3777 "PhotoMetadata.c"
}


#line 903 "PhotoMetadata.vala"
gboolean photo_metadata_get_gps (PhotoMetadata* self, double* longitude, char** long_ref, double* latitude, char** lat_ref, double* altitude) {
#line 3783 "PhotoMetadata.c"
	gboolean result = FALSE;
	char* _tmp0_;
	char* _tmp1_;
#line 903 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3789 "PhotoMetadata.c"
	if (long_ref != NULL) {
		*long_ref = NULL;
	}
	if (lat_ref != NULL) {
		*lat_ref = NULL;
	}
#line 905 "PhotoMetadata.vala"
	if (!gexiv2_metadata_get_gps_info (self->priv->exiv2, longitude, latitude, altitude)) {
#line 3798 "PhotoMetadata.c"
		result = FALSE;
#line 906 "PhotoMetadata.vala"
		return result;
#line 3802 "PhotoMetadata.c"
	}
#line 908 "PhotoMetadata.vala"
	*long_ref = (_tmp0_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef"), _g_free0 (*long_ref), _tmp0_);
#line 909 "PhotoMetadata.vala"
	*lat_ref = (_tmp1_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef"), _g_free0 (*lat_ref), _tmp1_);
#line 3808 "PhotoMetadata.c"
	result = TRUE;
#line 911 "PhotoMetadata.vala"
	return result;
#line 3812 "PhotoMetadata.c"
}


#line 914 "PhotoMetadata.vala"
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure) {
#line 3818 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 914 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3822 "PhotoMetadata.c"
	result = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", exposure);
#line 915 "PhotoMetadata.vala"
	return result;
#line 3826 "PhotoMetadata.c"
}


#line 918 "PhotoMetadata.vala"
char* photo_metadata_get_exposure_string (PhotoMetadata* self) {
#line 3832 "PhotoMetadata.c"
	char* result = NULL;
	MetadataRational exposure_time = {0};
#line 918 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 920 "PhotoMetadata.vala"
	if (!photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &exposure_time)) {
#line 3839 "PhotoMetadata.c"
		result = NULL;
#line 921 "PhotoMetadata.vala"
		return result;
#line 3843 "PhotoMetadata.c"
	}
#line 923 "PhotoMetadata.vala"
	if (!metadata_rational_is_valid (&exposure_time)) {
#line 3847 "PhotoMetadata.c"
		result = NULL;
#line 924 "PhotoMetadata.vala"
		return result;
#line 3851 "PhotoMetadata.c"
	}
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime");
#line 926 "PhotoMetadata.vala"
	return result;
#line 3856 "PhotoMetadata.c"
}


#line 929 "PhotoMetadata.vala"
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso) {
#line 3862 "PhotoMetadata.c"
	gboolean result = FALSE;
	gboolean fetched_ok;
	gboolean _tmp0_ = FALSE;
#line 929 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 930 "PhotoMetadata.vala"
	fetched_ok = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", iso);
#line 932 "PhotoMetadata.vala"
	if (fetched_ok == FALSE) {
#line 3872 "PhotoMetadata.c"
		result = FALSE;
#line 933 "PhotoMetadata.vala"
		return result;
#line 3876 "PhotoMetadata.c"
	}
#line 937 "PhotoMetadata.vala"
	if ((*iso) < 6) {
#line 937 "PhotoMetadata.vala"
		_tmp0_ = TRUE;
#line 3882 "PhotoMetadata.c"
	} else {
#line 937 "PhotoMetadata.vala"
		_tmp0_ = (*iso) > 409600;
#line 3886 "PhotoMetadata.c"
	}
#line 937 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 3890 "PhotoMetadata.c"
		result = FALSE;
#line 938 "PhotoMetadata.vala"
		return result;
#line 3894 "PhotoMetadata.c"
	}
	result = TRUE;
#line 940 "PhotoMetadata.vala"
	return result;
#line 3899 "PhotoMetadata.c"
}


#line 943 "PhotoMetadata.vala"
char* photo_metadata_get_iso_string (PhotoMetadata* self) {
#line 3905 "PhotoMetadata.c"
	char* result = NULL;
	glong iso = 0L;
#line 943 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 945 "PhotoMetadata.vala"
	if (!photo_metadata_get_iso (self, &iso)) {
#line 3912 "PhotoMetadata.c"
		result = NULL;
#line 946 "PhotoMetadata.vala"
		return result;
#line 3916 "PhotoMetadata.c"
	}
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings");
#line 948 "PhotoMetadata.vala"
	return result;
#line 3921 "PhotoMetadata.c"
}


#line 951 "PhotoMetadata.vala"
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture) {
#line 3927 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 951 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3931 "PhotoMetadata.c"
	result = photo_metadata_get_rational (self, "Exif.Photo.FNumber", aperture);
#line 952 "PhotoMetadata.vala"
	return result;
#line 3935 "PhotoMetadata.c"
}


#line 955 "PhotoMetadata.vala"
char* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted) {
#line 3941 "PhotoMetadata.c"
	char* result = NULL;
	MetadataRational aperture = {0};
	double aperture_value;
	const char* _tmp0_;
	const char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 955 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 957 "PhotoMetadata.vala"
	if (!photo_metadata_get_aperture (self, &aperture)) {
#line 3953 "PhotoMetadata.c"
		result = NULL;
#line 958 "PhotoMetadata.vala"
		return result;
#line 3957 "PhotoMetadata.c"
	}
#line 960 "PhotoMetadata.vala"
	aperture_value = ((double) aperture.numerator) / ((double) aperture.denominator);
#line 961 "PhotoMetadata.vala"
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
#line 3963 "PhotoMetadata.c"
	_tmp0_ = NULL;
#line 963 "PhotoMetadata.vala"
	if (pango_formatted) {
#line 963 "PhotoMetadata.vala"
		_tmp0_ = "<i>f</i>/";
#line 3969 "PhotoMetadata.c"
	} else {
#line 963 "PhotoMetadata.vala"
		_tmp0_ = "f/";
#line 3973 "PhotoMetadata.c"
	}
	_tmp1_ = NULL;
#line 964 "PhotoMetadata.vala"
	if (fmod (aperture_value, 1) == 0) {
#line 964 "PhotoMetadata.vala"
		_tmp1_ = "%.0f";
#line 3980 "PhotoMetadata.c"
	} else {
#line 964 "PhotoMetadata.vala"
		_tmp1_ = "%.1f";
#line 3984 "PhotoMetadata.c"
	}
	result = (_tmp3_ = g_strconcat (_tmp0_, _tmp2_ = g_strdup_printf (_tmp1_, aperture_value), NULL), _g_free0 (_tmp2_), _tmp3_);
#line 963 "PhotoMetadata.vala"
	return result;
#line 3989 "PhotoMetadata.c"
}


#line 967 "PhotoMetadata.vala"
char* photo_metadata_get_camera_make (PhotoMetadata* self) {
#line 3995 "PhotoMetadata.c"
	char* result = NULL;
#line 967 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3999 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Make");
#line 968 "PhotoMetadata.vala"
	return result;
#line 4003 "PhotoMetadata.c"
}


#line 971 "PhotoMetadata.vala"
char* photo_metadata_get_camera_model (PhotoMetadata* self) {
#line 4009 "PhotoMetadata.c"
	char* result = NULL;
#line 971 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4013 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Model");
#line 972 "PhotoMetadata.vala"
	return result;
#line 4017 "PhotoMetadata.c"
}


#line 975 "PhotoMetadata.vala"
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash) {
#line 4023 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 975 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 4027 "PhotoMetadata.c"
	result = photo_metadata_get_long (self, "Exif.Photo.Flash", flash);
#line 977 "PhotoMetadata.vala"
	return result;
#line 4031 "PhotoMetadata.c"
}


#line 980 "PhotoMetadata.vala"
char* photo_metadata_get_flash_string (PhotoMetadata* self) {
#line 4037 "PhotoMetadata.c"
	char* result = NULL;
#line 980 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4041 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash");
#line 982 "PhotoMetadata.vala"
	return result;
#line 4045 "PhotoMetadata.c"
}


#line 985 "PhotoMetadata.vala"
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length) {
#line 4051 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 985 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 4055 "PhotoMetadata.c"
	result = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", focal_length);
#line 986 "PhotoMetadata.vala"
	return result;
#line 4059 "PhotoMetadata.c"
}


#line 989 "PhotoMetadata.vala"
char* photo_metadata_get_focal_length_string (PhotoMetadata* self) {
#line 4065 "PhotoMetadata.c"
	char* result = NULL;
#line 989 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4069 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength");
#line 990 "PhotoMetadata.vala"
	return result;
#line 4073 "PhotoMetadata.c"
}


#line 998 "PhotoMetadata.vala"
char* photo_metadata_get_artist (PhotoMetadata* self) {
#line 4079 "PhotoMetadata.c"
	char* result = NULL;
#line 998 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4083 "PhotoMetadata.c"
	result = photo_metadata_get_first_string_interpreted (self, photo_metadata_ARTIST_TAGS, photo_metadata_ARTIST_TAGS_length1);
#line 999 "PhotoMetadata.vala"
	return result;
#line 4087 "PhotoMetadata.c"
}


#line 1002 "PhotoMetadata.vala"
char* photo_metadata_get_copyright (PhotoMetadata* self) {
#line 4093 "PhotoMetadata.c"
	char* result = NULL;
#line 1002 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4097 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright");
#line 1003 "PhotoMetadata.vala"
	return result;
#line 4101 "PhotoMetadata.c"
}


#line 1006 "PhotoMetadata.vala"
char* photo_metadata_get_software (PhotoMetadata* self) {
#line 4107 "PhotoMetadata.c"
	char* result = NULL;
#line 1006 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4111 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Software");
#line 1007 "PhotoMetadata.vala"
	return result;
#line 4115 "PhotoMetadata.c"
}


#line 1010 "PhotoMetadata.vala"
char* photo_metadata_get_exposure_bias (PhotoMetadata* self) {
#line 4121 "PhotoMetadata.c"
	char* result = NULL;
#line 1010 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4125 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue");
#line 1011 "PhotoMetadata.vala"
	return result;
#line 4129 "PhotoMetadata.c"
}


#line 1020 "PhotoMetadata.vala"
Rating photo_metadata_get_rating (PhotoMetadata* self) {
#line 4135 "PhotoMetadata.c"
	Rating result = 0;
	char* rating_string;
	Rating _tmp0_ = 0;
#line 1020 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1021 "PhotoMetadata.vala"
	rating_string = photo_metadata_get_first_string (self, photo_metadata_RATING_TAGS, photo_metadata_RATING_TAGS_length1);
#line 1022 "PhotoMetadata.vala"
	if (rating_string == NULL) {
#line 1022 "PhotoMetadata.vala"
		_tmp0_ = RATING_UNRATED;
#line 4147 "PhotoMetadata.c"
	} else {
#line 1022 "PhotoMetadata.vala"
		_tmp0_ = rating_unserialize (atoi (rating_string));
#line 4151 "PhotoMetadata.c"
	}
	result = _tmp0_;
	_g_free0 (rating_string);
#line 1022 "PhotoMetadata.vala"
	return result;
#line 4157 "PhotoMetadata.c"
}


#line 1030 "PhotoMetadata.vala"
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating) {
#line 4163 "PhotoMetadata.c"
	char* _tmp0_;
#line 1030 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1031 "PhotoMetadata.vala"
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp0_ = g_strdup_printf ("%i", rating_serialize (rating)));
#line 4169 "PhotoMetadata.c"
	_g_free0 (_tmp0_);
}


static gpointer _photo_metadata_ref0 (gpointer self) {
	return self ? photo_metadata_ref (self) : NULL;
}


#line 190 "PhotoMetadata.vala"
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props) {
#line 4181 "PhotoMetadata.c"
	PhotoMetadataInternalPhotoPreview* self;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	PhotoMetadata* _tmp2_;
#line 190 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
#line 190 "PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 190 "PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 192 "PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, (_tmp1_ = (dimensions_init (&_tmp0_, (gint) gexiv2_preview_properties_get_width (props), (gint) gexiv2_preview_properties_get_height (props)), _tmp0_), &_tmp1_), gexiv2_preview_properties_get_size (props), gexiv2_preview_properties_get_mime_type (props), gexiv2_preview_properties_get_extension (props));
#line 195 "PhotoMetadata.vala"
	self->owner = (_tmp2_ = _photo_metadata_ref0 (owner), _photo_metadata_unref0 (self->owner), _tmp2_);
#line 196 "PhotoMetadata.vala"
	self->number = number;
#line 4198 "PhotoMetadata.c"
	return self;
}


#line 190 "PhotoMetadata.vala"
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props) {
#line 190 "PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 4207 "PhotoMetadata.c"
}


static guint8* _vala_array_dup17 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


#line 199 "PhotoMetadata.vala"
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error) {
#line 4218 "PhotoMetadata.c"
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	gint props_length1;
	gint _props_size_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** props;
	GExiv2PreviewImage* _tmp2_;
	gint _tmp3_;
	guint8* _tmp4_;
	guint8* _tmp5_;
	guchar** _tmp6_;
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (base);
	props = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->owner->priv->exiv2), props_length1 = _vala_array_length (_tmp0_), _props_size_ = props_length1, _tmp1_);
#line 201 "PhotoMetadata.vala"
	g_assert ((props != NULL) && (props_length1 > self->number));
#line 4235 "PhotoMetadata.c"
	result = (_tmp6_ = (_tmp5_ = (_tmp4_ = gexiv2_preview_image_get_data (_tmp2_ = gexiv2_metadata_get_preview_image (self->owner->priv->exiv2, props[self->number]), &_tmp3_), (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup17 (_tmp4_, _tmp3_)), _gexiv2_preview_image_free0 (_tmp2_), _tmp5_), *result_length1 = _tmp3_, _tmp6_);
#line 203 "PhotoMetadata.vala"
	return result;
#line 4239 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass) {
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_metadata_internal_photo_preview_finalize;
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_metadata_internal_photo_preview_real_flatten;
}


static void photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self) {
}


static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj) {
	PhotoMetadataInternalPhotoPreview * self;
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (obj);
	_photo_metadata_unref0 (self->owner);
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
}


static GType photo_metadata_internal_photo_preview_get_type (void) {
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}


static void value_photo_metadata_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_metadata_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_metadata_unref (value->data[0].v_pointer);
	}
}


static void value_photo_metadata_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_metadata_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_metadata_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_metadata_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoMetadata* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_metadata_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_metadata_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoMetadata** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_metadata_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoMetadata* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_METADATA), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_metadata (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_METADATA), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_metadata (GValue* value, gpointer v_object) {
	PhotoMetadata* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_METADATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_METADATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_metadata_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_metadata_unref (old);
	}
}


void value_take_photo_metadata (GValue* value, gpointer v_object) {
	PhotoMetadata* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_METADATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_METADATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_metadata_unref (old);
	}
}


static void photo_metadata_class_init (PhotoMetadataClass * klass) {
	char** _tmp0_ = NULL;
	char** _tmp1_ = NULL;
	char** _tmp2_ = NULL;
	char** _tmp3_ = NULL;
	char** _tmp4_ = NULL;
	char** _tmp5_ = NULL;
	char** _tmp6_ = NULL;
	char** _tmp7_ = NULL;
	char** _tmp8_ = NULL;
	char** _tmp9_ = NULL;
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
	PHOTO_METADATA_CLASS (klass)->finalize = photo_metadata_finalize;
	g_type_class_add_private (klass, sizeof (PhotoMetadataPrivate));
	photo_metadata_DATE_TIME_TAGS = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup ("Exif.Image.DateTime"), _tmp0_[1] = g_strdup ("Xmp.tiff.DateTime"), _tmp0_[2] = g_strdup ("Xmp.xmp.ModifyDate"), _tmp0_);
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = (_tmp1_ = g_new0 (char*, 3 + 1), _tmp1_[0] = g_strdup ("Exif.Photo.DateTimeOriginal"), _tmp1_[1] = g_strdup ("Xmp.exif.DateTimeOriginal"), _tmp1_[2] = g_strdup ("Xmp.xmp.CreateDate"), _tmp1_);
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 3;
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = (_tmp2_ = g_new0 (char*, 2 + 1), _tmp2_[0] = g_strdup ("Exif.Photo.DateTimeDigitized"), _tmp2_[1] = g_strdup ("Xmp.exif.DateTimeDigitized"), _tmp2_);
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
	photo_metadata_WIDTH_TAGS = (_tmp3_ = g_new0 (char*, 4 + 1), _tmp3_[0] = g_strdup ("Exif.Photo.PixelXDimension"), _tmp3_[1] = g_strdup ("Xmp.exif.PixelXDimension"), _tmp3_[2] = g_strdup ("Xmp.tiff.ImageWidth"), _tmp3_[3] = g_strdup ("Xmp.exif.PixelXDimension"), _tmp3_);
	photo_metadata_WIDTH_TAGS_length1 = 4;
	photo_metadata_HEIGHT_TAGS = (_tmp4_ = g_new0 (char*, 4 + 1), _tmp4_[0] = g_strdup ("Exif.Photo.PixelYDimension"), _tmp4_[1] = g_strdup ("Xmp.exif.PixelYDimension"), _tmp4_[2] = g_strdup ("Xmp.tiff.ImageHeight"), _tmp4_[3] = g_strdup ("Xmp.exif.PixelYDimension"), _tmp4_);
	photo_metadata_HEIGHT_TAGS_length1 = 4;
	photo_metadata_STANDARD_TITLE_TAGS = (_tmp5_ = g_new0 (char*, 4 + 1), _tmp5_[0] = g_strdup ("Iptc.Application2.Caption"), _tmp5_[1] = g_strdup ("Xmp.dc.title"), _tmp5_[2] = g_strdup ("Iptc.Application2.Headline"), _tmp5_[3] = g_strdup ("Xmp.photoshop.Headline"), _tmp5_);
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
	photo_metadata_STANDARD_DESCRIPTION_TAGS = (_tmp6_ = g_new0 (char*, 1 + 1), _tmp6_[0] = g_strdup ("Xmp.dc.description"), _tmp6_);
	photo_metadata_STANDARD_DESCRIPTION_TAGS_length1 = 1;
	photo_metadata_KEYWORD_TAGS = (_tmp7_ = g_new0 (char*, 2 + 1), _tmp7_[0] = g_strdup ("Xmp.dc.subject"), _tmp7_[1] = g_strdup ("Iptc.Application2.Keywords"), _tmp7_);
	photo_metadata_KEYWORD_TAGS_length1 = 2;
	photo_metadata_ARTIST_TAGS = (_tmp8_ = g_new0 (char*, 2 + 1), _tmp8_[0] = g_strdup ("Exif.Image.Artist"), _tmp8_[1] = g_strdup ("Exif.Canon.OwnerName"), _tmp8_);
	photo_metadata_ARTIST_TAGS_length1 = 2;
	photo_metadata_RATING_TAGS = (_tmp9_ = g_new0 (char*, 3 + 1), _tmp9_[0] = g_strdup ("Xmp.xmp.Rating"), _tmp9_[1] = g_strdup ("Iptc.Application2.Urgency"), _tmp9_[2] = g_strdup ("Xmp.photoshop.Urgency"), _tmp9_);
	photo_metadata_RATING_TAGS_length1 = 3;
}


static void photo_metadata_instance_init (PhotoMetadata * self) {
	self->priv = PHOTO_METADATA_GET_PRIVATE (self);
	self->priv->exiv2 = gexiv2_metadata_new ();
	self->priv->exif = NULL;
	self->priv->source_name = g_strdup ("<uninitialized>");
	self->ref_count = 1;
}


static void photo_metadata_finalize (PhotoMetadata* obj) {
	PhotoMetadata * self;
	self = PHOTO_METADATA (obj);
	_gexiv2_metadata_free0 (self->priv->exiv2);
	_exif_data_unref0 (self->priv->exif);
	_g_free0 (self->priv->source_name);
}


GType photo_metadata_get_type (void) {
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_metadata_init, value_photo_metadata_free_value, value_photo_metadata_copy_value, value_photo_metadata_peek_pointer, "p", value_photo_metadata_collect_value, "p", value_photo_metadata_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoMetadata", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}


gpointer photo_metadata_ref (gpointer instance) {
	PhotoMetadata* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_metadata_unref (gpointer instance) {
	PhotoMetadata* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_METADATA_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




