/* DataCollection.c generated by valac 0.9.8, the Vala compiler
 * generated from DataCollection.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataSet*/
/**/
/* A DataSet is a collection class used for internal implementations of DataCollection*/
/* and its children.  It may be of use to other classes, however.*/
/**/
/* The general purpose of DataSet is to provide low-cost implementations of various collection*/
/* operations at a cost of internally maintaining its objects in more than one simple collection.*/
/* contains(), for example, can return a result with hash-table performance while notions of*/
/* ordering are maintained by a SortedList.  The cost is in adding and removing objects (in general,*/
/* there are others).*/
/**/
/* Because this class has no signalling mechanisms and does not manipulate DataObjects in ways*/
/* they expect to be manipulated (these features are performed by DataCollection), it's probably*/
/* best not to use this class.  Even in cases of building a list of DataObjects for some quick*/
/* operation is probably best done by a Gee.ArrayList.*/
/**/
/* ComparatorPredicate is used to determine if a re-sort operation is necessary; it has no*/
/* effect on adding a DataObject to a DataSet in sorted order.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
typedef struct _DataSetPrivate DataSetPrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
typedef struct _ParamSpecDataSet ParamSpecDataSet;

#define TYPE_SINGLETON_COLLECTION (singleton_collection_get_type ())
#define SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollection))
#define SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))
#define IS_SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLETON_COLLECTION))
#define IS_SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLETON_COLLECTION))
#define SINGLETON_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))

typedef struct _SingletonCollection SingletonCollection;
typedef struct _SingletonCollectionClass SingletonCollectionClass;
typedef struct _SingletonCollectionPrivate SingletonCollectionPrivate;
#define _g_destroy_func0(var) (((var == NULL) || (g_destroy_func == NULL)) ? NULL : (var = (g_destroy_func (var), NULL)))

#define SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR (singleton_collection_singleton_iterator_get_type ())
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIterator))
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorClass))
#define SINGLETON_COLLECTION_IS_SINGLETON_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR))
#define SINGLETON_COLLECTION_IS_SINGLETON_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR))
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorClass))

typedef struct _SingletonCollectionSingletonIterator SingletonCollectionSingletonIterator;
typedef struct _SingletonCollectionSingletonIteratorClass SingletonCollectionSingletonIteratorClass;
typedef struct _SingletonCollectionSingletonIteratorPrivate SingletonCollectionSingletonIteratorPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_UNKNOWN_TOTAL_MONITOR (unknown_total_monitor_get_type ())
#define UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitor))
#define UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))
#define IS_UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNKNOWN_TOTAL_MONITOR))
#define IS_UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNKNOWN_TOTAL_MONITOR))
#define UNKNOWN_TOTAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))

typedef struct _UnknownTotalMonitor UnknownTotalMonitor;
typedef struct _UnknownTotalMonitorClass UnknownTotalMonitorClass;
typedef struct _UnknownTotalMonitorPrivate UnknownTotalMonitorPrivate;
typedef struct _ParamSpecUnknownTotalMonitor ParamSpecUnknownTotalMonitor;

#define TYPE_AGGREGATE_PROGRESS_MONITOR (aggregate_progress_monitor_get_type ())
#define AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitor))
#define AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))
#define IS_AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define IS_AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define AGGREGATE_PROGRESS_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))

typedef struct _AggregateProgressMonitor AggregateProgressMonitor;
typedef struct _AggregateProgressMonitorClass AggregateProgressMonitorClass;
typedef struct _AggregateProgressMonitorPrivate AggregateProgressMonitorPrivate;
typedef struct _ParamSpecAggregateProgressMonitor ParamSpecAggregateProgressMonitor;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define DATA_COLLECTION_TYPE_MARKER_IMPL (data_collection_marker_impl_get_type ())
#define DATA_COLLECTION_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImpl))
#define DATA_COLLECTION_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))
#define DATA_COLLECTION_IS_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_IS_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_MARKER_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))

typedef struct _DataCollectionMarkerImpl DataCollectionMarkerImpl;
typedef struct _DataCollectionMarkerImplClass DataCollectionMarkerImplClass;
typedef struct _DataCollectionMarkerImplPrivate DataCollectionMarkerImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
typedef struct _ParamSpecDataCollection ParamSpecDataCollection;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define SOURCE_COLLECTION_TYPE_DESTROY_COUNTER (source_collection_destroy_counter_get_type ())
#define SOURCE_COLLECTION_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounter))
#define SOURCE_COLLECTION_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_DESTROY_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))

typedef struct _SourceCollectionDestroyCounter SourceCollectionDestroyCounter;
typedef struct _SourceCollectionDestroyCounterClass SourceCollectionDestroyCounterClass;
typedef struct _SourceCollectionDestroyCounterPrivate SourceCollectionDestroyCounterPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;
typedef struct _ContainerSourceCollectionPrivate ContainerSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _ParamSpecSourceHoldingTank ParamSpecSourceHoldingTank;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
typedef struct _ViewManagerPrivate ViewManagerPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
typedef struct _ParamSpecViewManager ParamSpecViewManager;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;

typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
struct _DataSet {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataSetPrivate * priv;
};

struct _DataSetClass {
	GTypeClass parent_class;
	void (*finalize) (DataSet *self);
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _DataSetPrivate {
	SortedList* list;
	GeeHashSet* hash_set;
	Comparator user_comparator;
	gpointer user_comparator_target;
	GDestroyNotify user_comparator_target_destroy_notify;
	ComparatorPredicate comparator_predicate;
	gpointer comparator_predicate_target;
	GDestroyNotify comparator_predicate_target_destroy_notify;
};

struct _ParamSpecDataSet {
	GParamSpec parent_instance;
};

struct _SingletonCollection {
	GeeAbstractCollection parent_instance;
	SingletonCollectionPrivate * priv;
};

struct _SingletonCollectionClass {
	GeeAbstractCollectionClass parent_class;
};

struct _SingletonCollectionPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	gpointer object;
};

struct _SingletonCollectionSingletonIterator {
	GObject parent_instance;
	SingletonCollectionSingletonIteratorPrivate * priv;
};

struct _SingletonCollectionSingletonIteratorClass {
	GObjectClass parent_class;
};

struct _SingletonCollectionSingletonIteratorPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	SingletonCollection* c;
	gboolean done;
	gpointer current;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _UnknownTotalMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UnknownTotalMonitorPrivate * priv;
};

struct _UnknownTotalMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UnknownTotalMonitor *self);
};

struct _UnknownTotalMonitorPrivate {
	guint64 total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
};

struct _ParamSpecUnknownTotalMonitor {
	GParamSpec parent_instance;
};

struct _AggregateProgressMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AggregateProgressMonitorPrivate * priv;
};

struct _AggregateProgressMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (AggregateProgressMonitor *self);
};

struct _AggregateProgressMonitorPrivate {
	guint64 grand_total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
	guint64 aggregate_count;
	guint64 last_count;
};

struct _ParamSpecAggregateProgressMonitor {
	GParamSpec parent_instance;
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	char* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_item_altered) (DataCollection* self, DataObject* item, Alteration* alteration);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const char* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*item_altered) (DataCollection* self, DataObject* item, Alteration* alteration);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const char* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _DataCollectionPrivate {
	char* name;
	DataSet* dataset;
	GeeHashMap* properties;
	gint64 object_ordinal_generator;
	gint notifies_frozen;
	GeeHashMap* frozen_items_altered;
	gboolean fire_ordering_changed;
};

struct _DataCollectionMarkerImpl {
	GObject parent_instance;
	DataCollectionMarkerImplPrivate * priv;
	DataCollection* owner;
	GeeHashSet* marked;
	gint freeze_count;
};

struct _DataCollectionMarkerImplClass {
	GObjectClass parent_class;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _ParamSpecDataCollection {
	GParamSpec parent_instance;
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
};

struct _SourceCollectionPrivate {
	GeeMultiMap* backlinks;
};

struct _SourceCollectionDestroyCounter {
	GObject parent_instance;
	SourceCollectionDestroyCounterPrivate * priv;
	Marker* remove_marker;
	GeeArrayList* notify_list;
	gint delete_failed;
};

struct _SourceCollectionDestroyCounterClass {
	GObjectClass parent_class;
};

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _DatabaseSourceCollectionPrivate {
	GetSourceDatabaseKey source_key_func;
	gpointer source_key_func_target;
	GDestroyNotify source_key_func_target_destroy_notify;
	GeeHashMap* map;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

struct _ContainerSourceCollection {
	DatabaseSourceCollection parent_instance;
	ContainerSourceCollectionPrivate * priv;
};

struct _ContainerSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	void (*notify_container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
	void (*notify_container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
	void (*notify_container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
	GeeCollection* (*get_containers_holding_source) (ContainerSourceCollection* self, DataSource* source);
	ContainerSource* (*convert_backlink_to_container) (ContainerSourceCollection* self, SourceBacklink* backlink);
	void (*container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
	void (*container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
	void (*container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
};

struct _ContainerSourceCollectionPrivate {
	SourceCollection* contained_sources;
	char* backlink_name;
	GeeHashSet* holding_tank;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _SourceHoldingTankPrivate {
	SourceCollection* sources;
	SourceHoldingTankCheckToKeep check_to_keep;
	gpointer check_to_keep_target;
	GDestroyNotify check_to_keep_target_destroy_notify;
	DataSet* tank;
	GeeHashSet* relinks;
	GeeHashSet* unlinking;
	gint64 ordinal;
};

struct _ParamSpecSourceHoldingTank {
	GParamSpec parent_instance;
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _DatabaseSourceHoldingTankPrivate {
	GetSourceDatabaseKey get_key;
	gpointer get_key_target;
	GDestroyNotify get_key_target_destroy_notify;
	GeeHashMap* map;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*ViewFilter) (DataView* view, void* user_data);
struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected) (ViewCollection* self, GeeIterable* views);
	void (*notify_items_unselected) (ViewCollection* self, GeeIterable* views);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
};

struct _ViewCollectionPrivate {
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* sources_alteration;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	GDestroyNotify mirroring_ctor_target_destroy_notify;
	ViewFilter filter;
	gpointer filter_target;
	GDestroyNotify filter_target_destroy_notify;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	gint view_lock_count;
	GeeHashMap* locked_filter_items;
	GeeHashSet* locked_unlinked_items;
	GeeHashMap* source_map;
};

struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};


static gpointer data_set_parent_class = NULL;
static gpointer singleton_collection_singleton_iterator_parent_class = NULL;
static GeeIteratorIface* singleton_collection_singleton_iterator_gee_iterator_parent_iface = NULL;
static gpointer singleton_collection_parent_class = NULL;
static gpointer unknown_total_monitor_parent_class = NULL;
static gpointer aggregate_progress_monitor_parent_class = NULL;
static gpointer data_collection_marker_impl_parent_class = NULL;
static MarkerIface* data_collection_marker_impl_marker_parent_iface = NULL;
static gpointer data_collection_parent_class = NULL;
static gpointer source_collection_destroy_counter_parent_class = NULL;
static gpointer source_collection_parent_class = NULL;
static gpointer database_source_collection_parent_class = NULL;
static gpointer container_source_collection_parent_class = NULL;
static gpointer source_holding_tank_parent_class = NULL;
static gpointer database_source_holding_tank_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_collection_parent_class = NULL;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
GType sorted_list_get_type (void) G_GNUC_CONST;
#define DATA_SET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SET, DataSetPrivate))
enum  {
	DATA_SET_DUMMY_PROPERTY
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
void data_set_reset_comparator (DataSet* self);
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b);
gint64 data_object_internal_get_ordinal (DataObject* self);
static gboolean data_set_order_added_predicate (DataSet* self, DataObject* object, Alteration* alteration);
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b);
gboolean data_set_contains (DataSet* self, DataObject* object);
gint data_set_get_count (DataSet* self);
gint sorted_list_get_count (SortedList* self);
static gboolean _data_set_order_added_predicate_comparator_predicate (DataObject* object, Alteration* alteration, gpointer self);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target);
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self);
GeeCollection* data_set_get_all (DataSet* self);
DataSet* data_set_copy (DataSet* self);
SortedList* sorted_list_copy (SortedList* self);
DataObject* data_set_get_at (DataSet* self, gint index);
gpointer sorted_list_get_at (SortedList* self, gint index);
gint data_set_index_of (DataSet* self, DataObject* object);
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gboolean data_set_add (DataSet* self, DataObject* object);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
gboolean data_set_remove (DataSet* self, DataObject* object);
gboolean data_set_remove_many (DataSet* self, GeeList* objects);
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
static void data_set_finalize (DataSet* obj);
GType singleton_collection_get_type (void) G_GNUC_CONST;
#define SINGLETON_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SINGLETON_COLLECTION, SingletonCollectionPrivate))
enum  {
	SINGLETON_COLLECTION_DUMMY_PROPERTY,
	SINGLETON_COLLECTION_SIZE,
	SINGLETON_COLLECTION_G_TYPE,
	SINGLETON_COLLECTION_G_DUP_FUNC,
	SINGLETON_COLLECTION_G_DESTROY_FUNC
};
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
static gboolean singleton_collection_real_add (GeeAbstractCollection* base, gconstpointer object);
static void singleton_collection_real_clear (GeeAbstractCollection* base);
static gboolean singleton_collection_real_contains (GeeAbstractCollection* base, gconstpointer object);
static GeeIterator* singleton_collection_real_iterator (GeeAbstractCollection* base);
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c);
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c);
static GType singleton_collection_singleton_iterator_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean singleton_collection_real_remove (GeeAbstractCollection* base, gconstpointer item);
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorPrivate))
enum  {
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_DUMMY_PROPERTY,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC
};
static gboolean singleton_collection_singleton_iterator_real_first (GeeIterator* base);
static gpointer singleton_collection_singleton_iterator_real_get (GeeIterator* base);
static gboolean singleton_collection_singleton_iterator_real_has_next (GeeIterator* base);
static gboolean singleton_collection_singleton_iterator_real_next (GeeIterator* base);
static void singleton_collection_singleton_iterator_real_remove (GeeIterator* base);
static void singleton_collection_singleton_iterator_finalize (GObject* obj);
static void singleton_collection_singleton_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void singleton_collection_singleton_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void singleton_collection_finalize (GObject* obj);
static void singleton_collection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void singleton_collection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
void marker_mark (Marker* self, DataObject* object);
void marker_unmark (Marker* self, DataObject* object);
gboolean marker_toggle (Marker* self, DataObject* object);
void marker_mark_many (Marker* self, GeeCollection* list);
void marker_unmark_many (Marker* self, GeeCollection* list);
void marker_mark_all (Marker* self);
gint marker_get_count (Marker* self);
GeeCollection* marker_get_all (Marker* self);
gpointer unknown_total_monitor_ref (gpointer instance);
void unknown_total_monitor_unref (gpointer instance);
GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_unknown_total_monitor (GValue* value, gpointer v_object);
void value_take_unknown_total_monitor (GValue* value, gpointer v_object);
gpointer value_get_unknown_total_monitor (const GValue* value);
GType unknown_total_monitor_get_type (void) G_GNUC_CONST;
#define UNKNOWN_TOTAL_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorPrivate))
enum  {
	UNKNOWN_TOTAL_MONITOR_DUMMY_PROPERTY
};
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total);
static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj);
gpointer aggregate_progress_monitor_ref (gpointer instance);
void aggregate_progress_monitor_unref (gpointer instance);
GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object);
void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object);
gpointer value_get_aggregate_progress_monitor (const GValue* value);
GType aggregate_progress_monitor_get_type (void) G_GNUC_CONST;
#define AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorPrivate))
enum  {
	AGGREGATE_PROGRESS_MONITOR_DUMMY_PROPERTY
};
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name);
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total);
static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj);
gboolean null_progress_monitor (guint64 count, guint64 total);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_COLLECTION, DataCollectionPrivate))
enum  {
	DATA_COLLECTION_DUMMY_PROPERTY
};
static GValue* _g_value_dup (GValue* self);
static void _vala_GValue_free (GValue* self);
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataCollection* data_collection_new (const char* name);
DataCollection* data_collection_construct (GType object_type, const char* name);
char* data_collection_to_string (DataCollection* self);
static char* data_collection_real_to_string (DataCollection* self);
gint data_collection_get_count (DataCollection* self);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_notify_item_altered (DataCollection* self, DataObject* item, Alteration* alteration);
static void data_collection_real_notify_item_altered (DataCollection* self, DataObject* item, Alteration* alteration);
void data_collection_notify_items_altered (DataCollection* self, GeeMap* items);
static void data_collection_real_notify_items_altered (DataCollection* self, GeeMap* items);
void data_collection_notify_ordering_changed (DataCollection* self);
static void data_collection_real_notify_ordering_changed (DataCollection* self);
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_notify_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name);
GeeCollection* data_collection_get_singleton (DataObject* object);
GeeMap* data_collection_get_alteration_singleton (DataObject* object, Alteration* alteration);
gboolean data_collection_valid_type (DataCollection* self, DataObject* object);
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
void data_collection_reset_comparator (DataCollection* self);
static void data_collection_real_reset_comparator (DataCollection* self);
GeeCollection* data_collection_get_all (DataCollection* self);
static GeeCollection* data_collection_real_get_all (DataCollection* self);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
static gint data_collection_real_get_count (DataCollection* self);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static DataObject* data_collection_real_get_at (DataCollection* self, gint index);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gint data_collection_real_index_of (DataCollection* self, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object);
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object);
DataCollection* data_object_get_membership (DataObject* self);
static void data_collection_internal_add (DataCollection* self, DataObject* object);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target);
static void data_collection_internal_remove (DataCollection* self, DataObject* object);
void data_object_internal_clear_membership (DataObject* self);
gboolean data_collection_add (DataCollection* self, DataObject* object);
static gboolean data_collection_real_add (DataCollection* self, DataObject* object);
char* data_object_to_string (DataObject* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static GeeCollection* data_collection_real_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
Marker* data_collection_start_marking (DataCollection* self);
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner);
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner);
static GType data_collection_marker_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
Marker* data_collection_mark (DataCollection* self, DataObject* object);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection);
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self);
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self);
void data_collection_remove_marked (DataCollection* self, Marker* m);
static void data_collection_real_remove_marked (DataCollection* self, Marker* m);
void data_collection_clear (DataCollection* self);
static void data_collection_real_clear (DataCollection* self);
void data_collection_close (DataCollection* self);
static void data_collection_real_close (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
Alteration* alteration_compress (Alteration* self, Alteration* other);
GValue* data_collection_get_property (DataCollection* self, const char* name);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
gboolean bool_value_equals (GValue* a, GValue* b);
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
gboolean int_value_equals (GValue* a, GValue* b);
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
void data_collection_freeze_notifications (DataCollection* self);
void data_collection_notify_frozen (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
void data_collection_notify_thawed (DataCollection* self);
static void data_collection_real_notify_frozen (DataCollection* self);
static void data_collection_real_notify_thawed (DataCollection* self);
void data_object_internal_collection_thawed (DataObject* self);
void data_collection_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added);
void data_collection_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_item_altered (DataCollection* self, DataObject* item, Alteration* alteration);
static void data_collection_real_item_altered (DataCollection* self, DataObject* item, Alteration* alteration);
void data_collection_items_altered (DataCollection* self, GeeMap* items);
static void data_collection_real_items_altered (DataCollection* self, GeeMap* items);
void data_collection_ordering_changed (DataCollection* self);
static void data_collection_real_ordering_changed (DataCollection* self);
void data_collection_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_property_cleared (DataCollection* self, const char* name);
void data_collection_frozen (DataCollection* self);
static void data_collection_real_frozen (DataCollection* self);
void data_collection_thawed (DataCollection* self);
static void data_collection_real_thawed (DataCollection* self);
enum  {
	DATA_COLLECTION_MARKER_IMPL_DUMMY_PROPERTY
};
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed);
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_unmark (Marker* base, DataObject* object);
static gboolean data_collection_marker_impl_real_toggle (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeCollection* list);
static void data_collection_marker_impl_real_unmark_many (Marker* base, GeeCollection* list);
static void data_collection_marker_impl_real_mark_all (Marker* base);
static gint data_collection_marker_impl_real_get_count (Marker* base);
static GeeCollection* data_collection_marker_impl_real_get_all (Marker* base);
static void data_collection_marker_impl_finalize (GObject* obj);
static void data_collection_finalize (DataCollection* obj);
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
#define SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_COLLECTION, SourceCollectionPrivate))
enum  {
	SOURCE_COLLECTION_DUMMY_PROPERTY
};
SourceCollection* source_collection_new (const char* name);
SourceCollection* source_collection_construct (GType object_type, const char* name);
void source_collection_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
static void source_collection_real_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
void source_collection_notify_items_relinked (SourceCollection* self, GeeCollection* relinked);
static void source_collection_real_notify_items_relinked (SourceCollection* self, GeeCollection* relinked);
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source);
void source_collection_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static void source_collection_real_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
static void source_collection_real_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object);
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker);
static GType source_collection_destroy_counter_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self);
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
void data_source_internal_mark_for_destroy (DataSource* self);
void data_source_destroy (DataSource* self);
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
guint source_backlink_hash_func (void* key);
static guint _source_backlink_hash_func_ghash_func (void* key);
gboolean source_backlink_equal_func (void* a, void* b);
static gboolean _source_backlink_equal_func_gequal_func (void* a, void* b);
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
static gboolean source_collection_real_has_backlink (SourceCollection* self, SourceBacklink* backlink);
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
static gboolean source_collection_prepare_for_unlink (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_prepare_for_unlink_marked_action (DataObject* object, GObject* user, gpointer self);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
void source_collection_relink (SourceCollection* self, DataSource* source);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
static void source_collection_real_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
static void source_collection_real_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
void source_collection_items_relinked (SourceCollection* self, GeeCollection* relinked);
static void source_collection_real_items_relinked (SourceCollection* self, GeeCollection* relinked);
void source_collection_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source);
void source_collection_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static void source_collection_real_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
void source_collection_unlinked_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_unlinked_destroyed (SourceCollection* self, DataSource* source);
enum  {
	SOURCE_COLLECTION_DESTROY_COUNTER_DUMMY_PROPERTY
};
static void source_collection_destroy_counter_finalize (GObject* obj);
static void source_collection_finalize (DataCollection* obj);
GType database_source_collection_get_type (void) G_GNUC_CONST;
#define DATABASE_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionPrivate))
enum  {
	DATABASE_SOURCE_COLLECTION_DUMMY_PROPERTY
};
guint int64_hash (void* p);
static guint _int64_hash_ghash_func (void* key);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (void* a, void* b);
static gint64* _int64_dup (gint64* self);
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
static void database_source_collection_finalize (DataCollection* obj);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
#define CONTAINER_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionPrivate))
enum  {
	CONTAINER_SOURCE_COLLECTION_DUMMY_PROPERTY
};
ContainerSourceCollection* container_source_collection_construct (GType object_type, SourceCollection* contained_sources, const char* backlink_name, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking);
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self);
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked);
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self);
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source);
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self);
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked);
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked);
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources);
GeeList* data_source_get_backlinks (DataSource* self, const char* name);
char* source_backlink_to_string (SourceBacklink* self);
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources);
gboolean container_source_has_links (ContainerSource* self);
void data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source);
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container);
void container_source_collection_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
void container_source_collection_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
void container_source_collection_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
static void container_source_collection_finalize (DataCollection* obj);
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
#define SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankPrivate))
enum  {
	SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source);
static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self);
static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_on_held_source_altered (SourceHoldingTank* self, DataObject* object, Alteration* alteration);
static void _source_holding_tank_on_held_source_altered_data_object_altered (DataObject* _sender, Alteration* alteration, gpointer self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source);
void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target);
void source_holding_tank_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_finalize (SourceHoldingTank* obj);
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
#define DATABASE_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankPrivate))
enum  {
	DATABASE_SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
DatabaseSourceHoldingTank* database_source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
DatabaseSourceHoldingTank* database_source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
DataSource* database_source_holding_tank_get_by_id (DatabaseSourceHoldingTank* self, gint64 id);
static void database_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed);
static void database_source_holding_tank_finalize (SourceHoldingTank* obj);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
GType view_collection_get_type (void) G_GNUC_CONST;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
ViewCollection* view_collection_new (const char* name);
ViewCollection* view_collection_construct (GType object_type, const char* name);
void view_collection_notify_items_selected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_items_selected (ViewCollection* self, GeeIterable* views);
void view_collection_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_items_unselected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_items_unselected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown);
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown);
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_clear (DataCollection* base);
static void view_collection_real_close (DataCollection* base);
void view_collection_halt_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
void view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* alteration, GeeIterable* initial, ProgressMonitor monitor, void* monitor_target);
static void view_collection_add_sources (ViewCollection* self, GeeIterable* added, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void view_collection_on_sources_altered (ViewCollection* self, GeeMap* items);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target);
void view_collection_reapply_view_filter (ViewCollection* self);
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views);
void view_collection_reset_view_filter (ViewCollection* self);
gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
static gboolean view_collection_real_add (DataCollection* base, DataObject* object);
void data_view_internal_set_visible (DataView* self, gboolean visible);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many);
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
DataSource* data_view_get_source (DataView* self);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
gboolean data_view_is_selected (DataView* self);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
static void view_collection_remove_selected (ViewCollection* self, DataView* view);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map);
gboolean view_collection_is_view_locked (ViewCollection* self);
void view_collection_lock_view (ViewCollection* self);
void view_collection_unlock_view (ViewCollection* self);
static void view_collection_real_remove_marked (DataCollection* base, Marker* marker);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
static void view_collection_add_selected (ViewCollection* self, DataView* view);
void view_collection_select_all (ViewCollection* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_all (ViewCollection* self);
GeeCollection* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
GeeCollection* view_collection_get_sources (ViewCollection* self);
GeeCollection* view_collection_get_selected_sources (ViewCollection* self);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_internal_notify_unlinking (ViewCollection* self, DataView* view, SourceCollection* sources);
void view_collection_internal_notify_relinked (ViewCollection* self, DataView* view, SourceCollection* sources);
static void view_collection_real_notify_thawed (DataCollection* base);
void view_collection_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
void view_collection_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
void view_collection_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_selection_group_altered (ViewCollection* self);
static void view_collection_real_selection_group_altered (ViewCollection* self);
void view_collection_items_shown (ViewCollection* self, GeeCollection* visible);
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible);
void view_collection_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
void view_collection_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_ALTERATION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 35 "DataCollection.vala"
DataSet* data_set_construct (GType object_type) {
#line 1347 "DataCollection.c"
	DataSet* self;
	self = (DataSet*) g_type_create_instance (object_type);
#line 36 "DataCollection.vala"
	data_set_reset_comparator (self);
#line 1352 "DataCollection.c"
	return self;
}


#line 35 "DataCollection.vala"
DataSet* data_set_new (void) {
#line 35 "DataCollection.vala"
	return data_set_construct (TYPE_DATA_SET);
#line 1361 "DataCollection.c"
}


#line 39 "DataCollection.vala"
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b) {
#line 1367 "DataCollection.c"
	gint64 result = 0LL;
#line 39 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 1371 "DataCollection.c"
	result = data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) a)) - data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) b));
#line 40 "DataCollection.vala"
	return result;
#line 1375 "DataCollection.c"
}


#line 43 "DataCollection.vala"
static gboolean data_set_order_added_predicate (DataSet* self, DataObject* object, Alteration* alteration) {
#line 1381 "DataCollection.c"
	gboolean result = FALSE;
#line 43 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 43 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 43 "DataCollection.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 1389 "DataCollection.c"
	result = FALSE;
#line 45 "DataCollection.vala"
	return result;
#line 1393 "DataCollection.c"
}


#line 48 "DataCollection.vala"
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b) {
#line 1399 "DataCollection.c"
	gint64 result = 0LL;
	gint64 _result_;
#line 48 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 49 "DataCollection.vala"
	if (a == b) {
#line 1406 "DataCollection.c"
		result = (gint64) 0;
#line 50 "DataCollection.vala"
		return result;
#line 1410 "DataCollection.c"
	}
#line 54 "DataCollection.vala"
	_result_ = self->priv->user_comparator (a, b, self->priv->user_comparator_target);
#line 55 "DataCollection.vala"
	if (_result_ == 0) {
#line 56 "DataCollection.vala"
		_result_ = data_set_order_added_comparator (self, a, b);
#line 1418 "DataCollection.c"
	}
#line 58 "DataCollection.vala"
	g_assert (_result_ != 0);
#line 1422 "DataCollection.c"
	result = _result_;
#line 60 "DataCollection.vala"
	return result;
#line 1426 "DataCollection.c"
}


#line 63 "DataCollection.vala"
gboolean data_set_contains (DataSet* self, DataObject* object) {
#line 1432 "DataCollection.c"
	gboolean result = FALSE;
#line 63 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 63 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1438 "DataCollection.c"
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object);
#line 64 "DataCollection.vala"
	return result;
#line 1442 "DataCollection.c"
}


#line 67 "DataCollection.vala"
inline gint data_set_get_count (DataSet* self) {
#line 1448 "DataCollection.c"
	gint result = 0;
#line 67 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 1452 "DataCollection.c"
	result = sorted_list_get_count (self->priv->list);
#line 68 "DataCollection.vala"
	return result;
#line 1456 "DataCollection.c"
}


#line 43 "DataCollection.vala"
static gboolean _data_set_order_added_predicate_comparator_predicate (DataObject* object, Alteration* alteration, gpointer self) {
#line 1462 "DataCollection.c"
	gboolean result;
	result = data_set_order_added_predicate (self, object, alteration);
	return result;
}


#line 39 "DataCollection.vala"
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self) {
#line 1471 "DataCollection.c"
	gint64 result;
	result = data_set_order_added_comparator (self, a, b);
	return result;
}


#line 71 "DataCollection.vala"
void data_set_reset_comparator (DataSet* self) {
#line 1480 "DataCollection.c"
	Comparator _tmp0_;
	ComparatorPredicate _tmp1_;
#line 71 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 72 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = NULL, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 73 "DataCollection.vala"
	self->priv->comparator_predicate = (_tmp1_ = _data_set_order_added_predicate_comparator_predicate, ((self->priv->comparator_predicate_target_destroy_notify == NULL) ? NULL : (self->priv->comparator_predicate_target_destroy_notify (self->priv->comparator_predicate_target), NULL), self->priv->comparator_predicate = NULL, self->priv->comparator_predicate_target = NULL, self->priv->comparator_predicate_target_destroy_notify = NULL), self->priv->comparator_predicate_target = data_set_ref (self), self->priv->comparator_predicate_target_destroy_notify = data_set_unref, _tmp1_);
#line 74 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_order_added_comparator_comparator, self);
#line 1491 "DataCollection.c"
}


#line 48 "DataCollection.vala"
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self) {
#line 1497 "DataCollection.c"
	gint64 result;
	result = data_set_comparator_wrapper (self, a, b);
	return result;
}


#line 77 "DataCollection.vala"
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target) {
#line 1506 "DataCollection.c"
	Comparator _tmp0_;
	ComparatorPredicate _tmp1_;
#line 77 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 78 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = user_comparator, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = user_comparator_target, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 79 "DataCollection.vala"
	self->priv->comparator_predicate = (_tmp1_ = comparator_predicate, ((self->priv->comparator_predicate_target_destroy_notify == NULL) ? NULL : (self->priv->comparator_predicate_target_destroy_notify (self->priv->comparator_predicate_target), NULL), self->priv->comparator_predicate = NULL, self->priv->comparator_predicate_target = NULL, self->priv->comparator_predicate_target_destroy_notify = NULL), self->priv->comparator_predicate_target = comparator_predicate_target, self->priv->comparator_predicate_target_destroy_notify = NULL, _tmp1_);
#line 80 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_comparator_wrapper_comparator, self);
#line 1517 "DataCollection.c"
}


#line 83 "DataCollection.vala"
GeeCollection* data_set_get_all (DataSet* self) {
#line 1523 "DataCollection.c"
	GeeCollection* result = NULL;
#line 83 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1527 "DataCollection.c"
	result = gee_collection_get_read_only_view (GEE_COLLECTION (self->priv->list));
#line 84 "DataCollection.vala"
	return result;
#line 1531 "DataCollection.c"
}


#line 87 "DataCollection.vala"
DataSet* data_set_copy (DataSet* self) {
#line 1537 "DataCollection.c"
	DataSet* result = NULL;
	DataSet* clone;
	SortedList* _tmp0_;
#line 87 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 88 "DataCollection.vala"
	clone = data_set_new ();
#line 89 "DataCollection.vala"
	clone->priv->list = (_tmp0_ = sorted_list_copy (self->priv->list), _g_object_unref0 (clone->priv->list), _tmp0_);
#line 90 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (clone->priv->hash_set), GEE_COLLECTION (self->priv->hash_set));
#line 1549 "DataCollection.c"
	result = clone;
#line 92 "DataCollection.vala"
	return result;
#line 1553 "DataCollection.c"
}


#line 95 "DataCollection.vala"
DataObject* data_set_get_at (DataSet* self, gint index) {
#line 1559 "DataCollection.c"
	DataObject* result = NULL;
#line 95 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1563 "DataCollection.c"
	result = (DataObject*) sorted_list_get_at (self->priv->list, index);
#line 96 "DataCollection.vala"
	return result;
#line 1567 "DataCollection.c"
}


#line 99 "DataCollection.vala"
gint data_set_index_of (DataSet* self, DataObject* object) {
#line 1573 "DataCollection.c"
	gint result = 0;
#line 99 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 99 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 1579 "DataCollection.c"
	result = sorted_list_locate (self->priv->list, object, g_direct_equal);
#line 100 "DataCollection.vala"
	return result;
#line 1583 "DataCollection.c"
}


#line 104 "DataCollection.vala"
gboolean data_set_add (DataSet* self, DataObject* object) {
#line 1589 "DataCollection.c"
	gboolean result = FALSE;
#line 104 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 104 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 105 "DataCollection.vala"
	if (!gee_collection_add (GEE_COLLECTION (self->priv->list), object)) {
#line 1597 "DataCollection.c"
		result = FALSE;
#line 106 "DataCollection.vala"
		return result;
#line 1601 "DataCollection.c"
	}
#line 108 "DataCollection.vala"
	if (!gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 110 "DataCollection.vala"
		gee_collection_remove (GEE_COLLECTION (self->priv->list), object);
#line 1607 "DataCollection.c"
		result = FALSE;
#line 112 "DataCollection.vala"
		return result;
#line 1611 "DataCollection.c"
	}
	result = TRUE;
#line 115 "DataCollection.vala"
	return result;
#line 1616 "DataCollection.c"
}


#line 119 "DataCollection.vala"
gboolean data_set_add_many (DataSet* self, GeeCollection* objects) {
#line 1622 "DataCollection.c"
	gboolean result = FALSE;
	gint count;
#line 119 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 119 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), FALSE);
#line 120 "DataCollection.vala"
	count = gee_collection_get_size (objects);
#line 121 "DataCollection.vala"
	if (count == 0) {
#line 1633 "DataCollection.c"
		result = TRUE;
#line 122 "DataCollection.vala"
		return result;
#line 1637 "DataCollection.c"
	}
#line 124 "DataCollection.vala"
	if (!gee_collection_add_all (GEE_COLLECTION (self->priv->list), objects)) {
#line 1641 "DataCollection.c"
		result = FALSE;
#line 125 "DataCollection.vala"
		return result;
#line 1645 "DataCollection.c"
	}
#line 127 "DataCollection.vala"
	if (!gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), objects)) {
#line 129 "DataCollection.vala"
		gee_collection_remove_all (GEE_COLLECTION (self->priv->list), objects);
#line 1651 "DataCollection.c"
		result = FALSE;
#line 131 "DataCollection.vala"
		return result;
#line 1655 "DataCollection.c"
	}
	result = TRUE;
#line 134 "DataCollection.vala"
	return result;
#line 1660 "DataCollection.c"
}


#line 137 "DataCollection.vala"
gboolean data_set_remove (DataSet* self, DataObject* object) {
#line 1666 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 137 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 137 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 138 "DataCollection.vala"
	success = TRUE;
#line 140 "DataCollection.vala"
	if (!gee_collection_remove (GEE_COLLECTION (self->priv->list), object)) {
#line 141 "DataCollection.vala"
		success = FALSE;
#line 1679 "DataCollection.c"
	}
#line 143 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 144 "DataCollection.vala"
		success = FALSE;
#line 1685 "DataCollection.c"
	}
	result = success;
#line 146 "DataCollection.vala"
	return result;
#line 1690 "DataCollection.c"
}


#line 149 "DataCollection.vala"
gboolean data_set_remove_many (DataSet* self, GeeList* objects) {
#line 1696 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 149 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 149 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (objects), FALSE);
#line 150 "DataCollection.vala"
	success = TRUE;
#line 152 "DataCollection.vala"
	if (!gee_collection_remove_all (GEE_COLLECTION (self->priv->list), GEE_COLLECTION (objects))) {
#line 153 "DataCollection.vala"
		success = FALSE;
#line 1709 "DataCollection.c"
	}
#line 155 "DataCollection.vala"
	if (!gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), GEE_COLLECTION (objects))) {
#line 156 "DataCollection.vala"
		success = FALSE;
#line 1715 "DataCollection.c"
	}
	result = success;
#line 158 "DataCollection.vala"
	return result;
#line 1720 "DataCollection.c"
}


#line 162 "DataCollection.vala"
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration) {
#line 1726 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 162 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 162 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 162 "DataCollection.vala"
	g_return_val_if_fail ((alteration == NULL) || IS_ALTERATION (alteration), FALSE);
#line 163 "DataCollection.vala"
	if (self->priv->comparator_predicate != NULL) {
#line 163 "DataCollection.vala"
		_tmp1_ = alteration != NULL;
#line 1740 "DataCollection.c"
	} else {
#line 163 "DataCollection.vala"
		_tmp1_ = FALSE;
#line 1744 "DataCollection.c"
	}
#line 163 "DataCollection.vala"
	if (_tmp1_) {
#line 164 "DataCollection.vala"
		_tmp0_ = !self->priv->comparator_predicate (object, alteration, self->priv->comparator_predicate_target);
#line 1750 "DataCollection.c"
	} else {
#line 163 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 1754 "DataCollection.c"
	}
#line 163 "DataCollection.vala"
	if (_tmp0_) {
#line 1758 "DataCollection.c"
		result = FALSE;
#line 165 "DataCollection.vala"
		return result;
#line 1762 "DataCollection.c"
	}
	result = sorted_list_resort_item (self->priv->list, object);
#line 168 "DataCollection.vala"
	return result;
#line 1767 "DataCollection.c"
}


static void value_data_set_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_set_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_set_unref (value->data[0].v_pointer);
	}
}


static void value_data_set_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_set_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_set_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_set_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataSet* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_set_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_set_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataSet** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_set_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataSet* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_SET), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_set (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_set_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


void value_take_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


static void data_set_class_init (DataSetClass * klass) {
	data_set_parent_class = g_type_class_peek_parent (klass);
	DATA_SET_CLASS (klass)->finalize = data_set_finalize;
	g_type_class_add_private (klass, sizeof (DataSetPrivate));
}


static void data_set_instance_init (DataSet * self) {
	self->priv = DATA_SET_GET_PRIVATE (self);
	self->priv->list = sorted_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->hash_set = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->user_comparator = NULL;
	self->priv->comparator_predicate = NULL;
	self->ref_count = 1;
}


static void data_set_finalize (DataSet* obj) {
	DataSet * self;
	self = DATA_SET (obj);
	_g_object_unref0 (self->priv->list);
	_g_object_unref0 (self->priv->hash_set);
	(self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL);
	self->priv->user_comparator = NULL;
	self->priv->user_comparator_target = NULL;
	self->priv->user_comparator_target_destroy_notify = NULL;
	(self->priv->comparator_predicate_target_destroy_notify == NULL) ? NULL : (self->priv->comparator_predicate_target_destroy_notify (self->priv->comparator_predicate_target), NULL);
	self->priv->comparator_predicate = NULL;
	self->priv->comparator_predicate_target = NULL;
	self->priv->comparator_predicate_target_destroy_notify = NULL;
}


GType data_set_get_type (void) {
	static volatile gsize data_set_type_id__volatile = 0;
	if (g_once_init_enter (&data_set_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_set_init, value_data_set_free_value, value_data_set_copy_value, value_data_set_peek_pointer, "p", value_data_set_collect_value, "p", value_data_set_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSet), 0, (GInstanceInitFunc) data_set_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_set_type_id;
		data_set_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataSet", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_set_type_id__volatile, data_set_type_id);
	}
	return data_set_type_id__volatile;
}


gpointer data_set_ref (gpointer instance) {
	DataSet* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_set_unref (gpointer instance) {
	DataSet* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_SET_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 225 "DataCollection.vala"
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object) {
#line 1948 "DataCollection.c"
	SingletonCollection * self;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
#line 225 "DataCollection.vala"
	self = (SingletonCollection*) gee_abstract_collection_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func);
#line 225 "DataCollection.vala"
	self->priv->g_type = g_type;
#line 225 "DataCollection.vala"
	self->priv->g_dup_func = g_dup_func;
#line 225 "DataCollection.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 226 "DataCollection.vala"
	self->priv->object = (_tmp1_ = (_tmp0_ = object, ((_tmp0_ == NULL) || (g_dup_func == NULL)) ? ((gpointer) _tmp0_) : g_dup_func ((gpointer) _tmp0_)), _g_destroy_func0 (self->priv->object), _tmp1_);
#line 1962 "DataCollection.c"
	return self;
}


#line 225 "DataCollection.vala"
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object) {
#line 225 "DataCollection.vala"
	return singleton_collection_construct (TYPE_SINGLETON_COLLECTION, g_type, g_dup_func, g_destroy_func, object);
#line 1971 "DataCollection.c"
}


#line 229 "DataCollection.vala"
static gboolean singleton_collection_real_add (GeeAbstractCollection* base, gconstpointer object) {
#line 1977 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
#line 230 "DataCollection.vala"
	g_warning ("DataCollection.vala:230: Cannot add to SingletonCollection");
#line 1983 "DataCollection.c"
	result = FALSE;
#line 232 "DataCollection.vala"
	return result;
#line 1987 "DataCollection.c"
}


#line 235 "DataCollection.vala"
static void singleton_collection_real_clear (GeeAbstractCollection* base) {
#line 1993 "DataCollection.c"
	SingletonCollection * self;
	gpointer _tmp0_;
	self = SINGLETON_COLLECTION (base);
#line 236 "DataCollection.vala"
	self->priv->object = (_tmp0_ = NULL, ((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL)), _tmp0_);
#line 1999 "DataCollection.c"
}


#line 239 "DataCollection.vala"
static gboolean singleton_collection_real_contains (GeeAbstractCollection* base, gconstpointer object) {
#line 2005 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
	result = self->priv->object == object;
#line 240 "DataCollection.vala"
	return result;
#line 2012 "DataCollection.c"
}


#line 243 "DataCollection.vala"
static GeeIterator* singleton_collection_real_iterator (GeeAbstractCollection* base) {
#line 2018 "DataCollection.c"
	SingletonCollection * self;
	GeeIterator* result = NULL;
	self = SINGLETON_COLLECTION (base);
	result = GEE_ITERATOR (singleton_collection_singleton_iterator_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self));
#line 244 "DataCollection.vala"
	return result;
#line 2025 "DataCollection.c"
}


#line 247 "DataCollection.vala"
static gboolean singleton_collection_real_remove (GeeAbstractCollection* base, gconstpointer item) {
#line 2031 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
#line 248 "DataCollection.vala"
	if (item == self->priv->object) {
#line 2037 "DataCollection.c"
		gpointer _tmp0_;
#line 249 "DataCollection.vala"
		self->priv->object = (_tmp0_ = NULL, ((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL)), _tmp0_);
#line 2041 "DataCollection.c"
		result = TRUE;
#line 251 "DataCollection.vala"
		return result;
#line 2045 "DataCollection.c"
	}
	result = FALSE;
#line 254 "DataCollection.vala"
	return result;
#line 2050 "DataCollection.c"
}


static gint singleton_collection_real_get_size (GeeAbstractCollection* base) {
	gint result;
	SingletonCollection* self;
	gint _tmp0_ = 0;
	self = SINGLETON_COLLECTION (base);
#line 259 "DataCollection.vala"
	if (self->priv->object != NULL) {
#line 259 "DataCollection.vala"
		_tmp0_ = 1;
#line 2063 "DataCollection.c"
	} else {
#line 259 "DataCollection.vala"
		_tmp0_ = 0;
#line 2067 "DataCollection.c"
	}
	result = _tmp0_;
#line 259 "DataCollection.vala"
	return result;
#line 2072 "DataCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 184 "DataCollection.vala"
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c) {
#line 2083 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	SingletonCollection* _tmp0_;
#line 184 "DataCollection.vala"
	g_return_val_if_fail (IS_SINGLETON_COLLECTION (c), NULL);
#line 184 "DataCollection.vala"
	self = (SingletonCollectionSingletonIterator*) g_object_new (object_type, NULL);
#line 184 "DataCollection.vala"
	self->priv->g_type = g_type;
#line 184 "DataCollection.vala"
	self->priv->g_dup_func = g_dup_func;
#line 184 "DataCollection.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 185 "DataCollection.vala"
	self->priv->c = (_tmp0_ = _g_object_ref0 (c), _g_object_unref0 (self->priv->c), _tmp0_);
#line 2098 "DataCollection.c"
	return self;
}


#line 184 "DataCollection.vala"
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c) {
#line 184 "DataCollection.vala"
	return singleton_collection_singleton_iterator_construct (SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, g_type, g_dup_func, g_destroy_func, c);
#line 2107 "DataCollection.c"
}


#line 188 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_first (GeeIterator* base) {
#line 2113 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 189 "DataCollection.vala"
	self->priv->done = FALSE;
#line 190 "DataCollection.vala"
	self->priv->current = (_tmp1_ = (_tmp0_ = self->priv->c->priv->object, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_)), ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 2123 "DataCollection.c"
	result = self->priv->current != NULL;
#line 192 "DataCollection.vala"
	return result;
#line 2127 "DataCollection.c"
}


#line 195 "DataCollection.vala"
static gpointer singleton_collection_singleton_iterator_real_get (GeeIterator* base) {
#line 2133 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gpointer result = NULL;
	gconstpointer _tmp0_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
	result = (_tmp0_ = self->priv->current, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_));
#line 196 "DataCollection.vala"
	return result;
#line 2141 "DataCollection.c"
}


#line 199 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_has_next (GeeIterator* base) {
#line 2147 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
	result = FALSE;
#line 200 "DataCollection.vala"
	return result;
#line 2154 "DataCollection.c"
}


#line 203 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_next (GeeIterator* base) {
#line 2160 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 204 "DataCollection.vala"
	if (self->priv->done) {
#line 2168 "DataCollection.c"
		result = FALSE;
#line 205 "DataCollection.vala"
		return result;
#line 2172 "DataCollection.c"
	}
#line 207 "DataCollection.vala"
	self->priv->done = TRUE;
#line 208 "DataCollection.vala"
	self->priv->current = (_tmp1_ = (_tmp0_ = self->priv->c->priv->object, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_)), ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 2178 "DataCollection.c"
	result = TRUE;
#line 210 "DataCollection.vala"
	return result;
#line 2182 "DataCollection.c"
}


#line 213 "DataCollection.vala"
static void singleton_collection_singleton_iterator_real_remove (GeeIterator* base) {
#line 2188 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 214 "DataCollection.vala"
	if (!self->priv->done) {
#line 2193 "DataCollection.c"
		gpointer _tmp0_;
		gpointer _tmp1_;
#line 215 "DataCollection.vala"
		self->priv->c->priv->object = (_tmp0_ = NULL, ((self->priv->c->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->c->priv->object = (self->priv->g_destroy_func (self->priv->c->priv->object), NULL)), _tmp0_);
#line 216 "DataCollection.vala"
		self->priv->current = (_tmp1_ = NULL, ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 2200 "DataCollection.c"
	}
#line 219 "DataCollection.vala"
	self->priv->done = TRUE;
#line 2204 "DataCollection.c"
}


static void singleton_collection_singleton_iterator_class_init (SingletonCollectionSingletonIteratorClass * klass) {
	singleton_collection_singleton_iterator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SingletonCollectionSingletonIteratorPrivate));
	G_OBJECT_CLASS (klass)->get_property = singleton_collection_singleton_iterator_get_property;
	G_OBJECT_CLASS (klass)->set_property = singleton_collection_singleton_iterator_set_property;
	G_OBJECT_CLASS (klass)->finalize = singleton_collection_singleton_iterator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void singleton_collection_singleton_iterator_gee_iterator_interface_init (GeeIteratorIface * iface) {
	singleton_collection_singleton_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
	iface->first = singleton_collection_singleton_iterator_real_first;
	iface->get = singleton_collection_singleton_iterator_real_get;
	iface->has_next = singleton_collection_singleton_iterator_real_has_next;
	iface->next = singleton_collection_singleton_iterator_real_next;
	iface->remove = singleton_collection_singleton_iterator_real_remove;
}


static void singleton_collection_singleton_iterator_instance_init (SingletonCollectionSingletonIterator * self) {
	self->priv = SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_PRIVATE (self);
	self->priv->done = FALSE;
	self->priv->current = NULL;
}


static void singleton_collection_singleton_iterator_finalize (GObject* obj) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (obj);
	_g_object_unref0 (self->priv->c);
	((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL));
	G_OBJECT_CLASS (singleton_collection_singleton_iterator_parent_class)->finalize (obj);
}


static GType singleton_collection_singleton_iterator_get_type (void) {
	static volatile gsize singleton_collection_singleton_iterator_type_id__volatile = 0;
	if (g_once_init_enter (&singleton_collection_singleton_iterator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SingletonCollectionSingletonIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) singleton_collection_singleton_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingletonCollectionSingletonIterator), 0, (GInstanceInitFunc) singleton_collection_singleton_iterator_instance_init, NULL };
		static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) singleton_collection_singleton_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType singleton_collection_singleton_iterator_type_id;
		singleton_collection_singleton_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "SingletonCollectionSingletonIterator", &g_define_type_info, 0);
		g_type_add_interface_static (singleton_collection_singleton_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
		g_once_init_leave (&singleton_collection_singleton_iterator_type_id__volatile, singleton_collection_singleton_iterator_type_id);
	}
	return singleton_collection_singleton_iterator_type_id__volatile;
}


static void singleton_collection_singleton_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void singleton_collection_singleton_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void singleton_collection_class_init (SingletonCollectionClass * klass) {
	singleton_collection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SingletonCollectionPrivate));
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->add = singleton_collection_real_add;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->clear = singleton_collection_real_clear;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->contains = singleton_collection_real_contains;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->iterator = singleton_collection_real_iterator;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->remove = singleton_collection_real_remove;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->get_size = singleton_collection_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = singleton_collection_get_property;
	G_OBJECT_CLASS (klass)->set_property = singleton_collection_set_property;
	G_OBJECT_CLASS (klass)->finalize = singleton_collection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SIZE, "size");
}


static void singleton_collection_instance_init (SingletonCollection * self) {
	self->priv = SINGLETON_COLLECTION_GET_PRIVATE (self);
}


static void singleton_collection_finalize (GObject* obj) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (obj);
	((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL));
	G_OBJECT_CLASS (singleton_collection_parent_class)->finalize (obj);
}


GType singleton_collection_get_type (void) {
	static volatile gsize singleton_collection_type_id__volatile = 0;
	if (g_once_init_enter (&singleton_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SingletonCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) singleton_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingletonCollection), 0, (GInstanceInitFunc) singleton_collection_instance_init, NULL };
		GType singleton_collection_type_id;
		singleton_collection_type_id = g_type_register_static (GEE_TYPE_ABSTRACT_COLLECTION, "SingletonCollection", &g_define_type_info, 0);
		g_once_init_leave (&singleton_collection_type_id__volatile, singleton_collection_type_id);
	}
	return singleton_collection_type_id__volatile;
}


static void singleton_collection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (object);
	switch (property_id) {
		case SINGLETON_COLLECTION_SIZE:
		g_value_set_int (value, gee_abstract_collection_get_size (GEE_ABSTRACT_COLLECTION (self)));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void singleton_collection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SINGLETON_COLLECTION_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SINGLETON_COLLECTION_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SINGLETON_COLLECTION_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


#line 184 "DataCollection.vala"
void marker_mark (Marker* self, DataObject* object) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark (self, object);
#line 2373 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_unmark (Marker* self, DataObject* object) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->unmark (self, object);
#line 2381 "DataCollection.c"
}


#line 184 "DataCollection.vala"
gboolean marker_toggle (Marker* self, DataObject* object) {
#line 184 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->toggle (self, object);
#line 2389 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_mark_many (Marker* self, GeeCollection* list) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_many (self, list);
#line 2397 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_unmark_many (Marker* self, GeeCollection* list) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->unmark_many (self, list);
#line 2405 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_mark_all (Marker* self) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_all (self);
#line 2413 "DataCollection.c"
}


#line 184 "DataCollection.vala"
gint marker_get_count (Marker* self) {
#line 184 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->get_count (self);
#line 2421 "DataCollection.c"
}


#line 184 "DataCollection.vala"
GeeCollection* marker_get_all (Marker* self) {
#line 184 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->get_all (self);
#line 2429 "DataCollection.c"
}


static void marker_base_init (MarkerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType marker_get_type (void) {
	static volatile gsize marker_type_id__volatile = 0;
	if (g_once_init_enter (&marker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MarkerIface), (GBaseInitFunc) marker_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType marker_type_id;
		marker_type_id = g_type_register_static (G_TYPE_INTERFACE, "Marker", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (marker_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&marker_type_id__volatile, marker_type_id);
	}
	return marker_type_id__volatile;
}


#line 307 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 2456 "DataCollection.c"
	UnknownTotalMonitor* self;
	ProgressMonitor _tmp0_;
	self = (UnknownTotalMonitor*) g_type_create_instance (object_type);
#line 308 "DataCollection.vala"
	self->priv->total = total;
#line 309 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 2464 "DataCollection.c"
	return self;
}


#line 307 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 307 "DataCollection.vala"
	return unknown_total_monitor_construct (TYPE_UNKNOWN_TOTAL_MONITOR, total, wrapped_monitor, wrapped_monitor_target);
#line 2473 "DataCollection.c"
}


#line 312 "DataCollection.vala"
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total) {
#line 2479 "DataCollection.c"
	gboolean result = FALSE;
#line 312 "DataCollection.vala"
	g_return_val_if_fail (IS_UNKNOWN_TOTAL_MONITOR (self), FALSE);
#line 2483 "DataCollection.c"
	result = self->priv->wrapped_monitor (count, self->priv->total, self->priv->wrapped_monitor_target);
#line 313 "DataCollection.vala"
	return result;
#line 2487 "DataCollection.c"
}


static void value_unknown_total_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_unknown_total_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		unknown_total_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_unknown_total_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = unknown_total_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_unknown_total_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_unknown_total_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		UnknownTotalMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = unknown_total_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_unknown_total_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	UnknownTotalMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = unknown_total_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUnknownTotalMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_unknown_total_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		unknown_total_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


void value_take_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


static void unknown_total_monitor_class_init (UnknownTotalMonitorClass * klass) {
	unknown_total_monitor_parent_class = g_type_class_peek_parent (klass);
	UNKNOWN_TOTAL_MONITOR_CLASS (klass)->finalize = unknown_total_monitor_finalize;
	g_type_class_add_private (klass, sizeof (UnknownTotalMonitorPrivate));
}


static void unknown_total_monitor_instance_init (UnknownTotalMonitor * self) {
	self->priv = UNKNOWN_TOTAL_MONITOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj) {
	UnknownTotalMonitor * self;
	self = UNKNOWN_TOTAL_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType unknown_total_monitor_get_type (void) {
	static volatile gsize unknown_total_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&unknown_total_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_unknown_total_monitor_init, value_unknown_total_monitor_free_value, value_unknown_total_monitor_copy_value, value_unknown_total_monitor_peek_pointer, "p", value_unknown_total_monitor_collect_value, "p", value_unknown_total_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UnknownTotalMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) unknown_total_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UnknownTotalMonitor), 0, (GInstanceInitFunc) unknown_total_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType unknown_total_monitor_type_id;
		unknown_total_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UnknownTotalMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&unknown_total_monitor_type_id__volatile, unknown_total_monitor_type_id);
	}
	return unknown_total_monitor_type_id__volatile;
}


gpointer unknown_total_monitor_ref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void unknown_total_monitor_unref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UNKNOWN_TOTAL_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 325 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 2658 "DataCollection.c"
	AggregateProgressMonitor* self;
	ProgressMonitor _tmp0_;
	self = (AggregateProgressMonitor*) g_type_create_instance (object_type);
#line 326 "DataCollection.vala"
	self->priv->grand_total = grand_total;
#line 327 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 2666 "DataCollection.c"
	return self;
}


#line 325 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 325 "DataCollection.vala"
	return aggregate_progress_monitor_construct (TYPE_AGGREGATE_PROGRESS_MONITOR, grand_total, wrapped_monitor, wrapped_monitor_target);
#line 2675 "DataCollection.c"
}


#line 330 "DataCollection.vala"
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name) {
#line 330 "DataCollection.vala"
	g_return_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self));
#line 330 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 331 "DataCollection.vala"
	g_debug ("DataCollection.vala:331: next step: %s (%lld/%lld)", name, self->priv->aggregate_count, self->priv->grand_total);
#line 332 "DataCollection.vala"
	self->priv->last_count = G_MAXUINT64;
#line 2689 "DataCollection.c"
}


#line 335 "DataCollection.vala"
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total) {
#line 2695 "DataCollection.c"
	gboolean result = FALSE;
	guint64 _tmp0_ = 0ULL;
#line 335 "DataCollection.vala"
	g_return_val_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self), FALSE);
#line 337 "DataCollection.vala"
	if (self->priv->last_count != G_MAXUINT64) {
#line 337 "DataCollection.vala"
		_tmp0_ = count - self->priv->last_count;
#line 2704 "DataCollection.c"
	} else {
#line 337 "DataCollection.vala"
		_tmp0_ = count;
#line 2708 "DataCollection.c"
	}
#line 337 "DataCollection.vala"
	self->priv->aggregate_count = self->priv->aggregate_count + _tmp0_;
#line 338 "DataCollection.vala"
	if (self->priv->aggregate_count > self->priv->grand_total) {
#line 339 "DataCollection.vala"
		self->priv->aggregate_count = self->priv->grand_total;
#line 2716 "DataCollection.c"
	}
#line 342 "DataCollection.vala"
	self->priv->last_count = count;
#line 2720 "DataCollection.c"
	result = self->priv->wrapped_monitor (self->priv->aggregate_count, self->priv->grand_total, self->priv->wrapped_monitor_target);
#line 344 "DataCollection.vala"
	return result;
#line 2724 "DataCollection.c"
}


static void value_aggregate_progress_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_aggregate_progress_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		aggregate_progress_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_aggregate_progress_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = aggregate_progress_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_aggregate_progress_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_aggregate_progress_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		AggregateProgressMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = aggregate_progress_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_aggregate_progress_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	AggregateProgressMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = aggregate_progress_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAggregateProgressMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_aggregate_progress_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		aggregate_progress_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


static void aggregate_progress_monitor_class_init (AggregateProgressMonitorClass * klass) {
	aggregate_progress_monitor_parent_class = g_type_class_peek_parent (klass);
	AGGREGATE_PROGRESS_MONITOR_CLASS (klass)->finalize = aggregate_progress_monitor_finalize;
	g_type_class_add_private (klass, sizeof (AggregateProgressMonitorPrivate));
}


static void aggregate_progress_monitor_instance_init (AggregateProgressMonitor * self) {
	self->priv = AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE (self);
	self->priv->aggregate_count = (guint64) 0;
	self->priv->last_count = G_MAXUINT64;
	self->ref_count = 1;
}


static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj) {
	AggregateProgressMonitor * self;
	self = AGGREGATE_PROGRESS_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType aggregate_progress_monitor_get_type (void) {
	static volatile gsize aggregate_progress_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&aggregate_progress_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_aggregate_progress_monitor_init, value_aggregate_progress_monitor_free_value, value_aggregate_progress_monitor_copy_value, value_aggregate_progress_monitor_peek_pointer, "p", value_aggregate_progress_monitor_collect_value, "p", value_aggregate_progress_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AggregateProgressMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aggregate_progress_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AggregateProgressMonitor), 0, (GInstanceInitFunc) aggregate_progress_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType aggregate_progress_monitor_type_id;
		aggregate_progress_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AggregateProgressMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&aggregate_progress_monitor_type_id__volatile, aggregate_progress_monitor_type_id);
	}
	return aggregate_progress_monitor_type_id__volatile;
}


gpointer aggregate_progress_monitor_ref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void aggregate_progress_monitor_unref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		AGGREGATE_PROGRESS_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 349 "DataCollection.vala"
gboolean null_progress_monitor (guint64 count, guint64 total) {
#line 2897 "DataCollection.c"
	gboolean result = FALSE;
	result = TRUE;
#line 350 "DataCollection.vala"
	return result;
#line 2902 "DataCollection.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


#line 509 "DataCollection.vala"
DataCollection* data_collection_construct (GType object_type, const char* name) {
#line 2919 "DataCollection.c"
	DataCollection* self;
	char* _tmp0_;
#line 509 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2924 "DataCollection.c"
	self = (DataCollection*) g_type_create_instance (object_type);
#line 510 "DataCollection.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 2928 "DataCollection.c"
	return self;
}


#line 509 "DataCollection.vala"
DataCollection* data_collection_new (const char* name) {
#line 509 "DataCollection.vala"
	return data_collection_construct (TYPE_DATA_COLLECTION, name);
#line 2937 "DataCollection.c"
}


#line 519 "DataCollection.vala"
static char* data_collection_real_to_string (DataCollection* self) {
#line 2943 "DataCollection.c"
	char* result = NULL;
#line 519 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2947 "DataCollection.c"
	result = g_strdup_printf ("%s (%d)", self->priv->name, data_collection_get_count (self));
#line 520 "DataCollection.vala"
	return result;
#line 2951 "DataCollection.c"
}


#line 509 "DataCollection.vala"
char* data_collection_to_string (DataCollection* self) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->to_string (self);
#line 2959 "DataCollection.c"
}


#line 524 "DataCollection.vala"
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 524 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 524 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 525 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-added", added);
#line 2971 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_added (self, added);
#line 2979 "DataCollection.c"
}


#line 528 "DataCollection.vala"
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 528 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 528 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 529 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-removed", removed);
#line 2991 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_removed (self, removed);
#line 2999 "DataCollection.c"
}


#line 532 "DataCollection.vala"
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 532 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 532 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 532 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 534 "DataCollection.vala"
	g_signal_emit_by_name (self, "contents-altered", added, removed);
#line 3013 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 3021 "DataCollection.c"
}


#line 537 "DataCollection.vala"
static void data_collection_real_notify_item_altered (DataCollection* self, DataObject* item, Alteration* alteration) {
#line 537 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 537 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 537 "DataCollection.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 538 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-altered", item, alteration);
#line 3035 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_item_altered (DataCollection* self, DataObject* item, Alteration* alteration) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_item_altered (self, item, alteration);
#line 3043 "DataCollection.c"
}


#line 541 "DataCollection.vala"
static void data_collection_real_notify_items_altered (DataCollection* self, GeeMap* items) {
#line 541 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 541 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 542 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-altered", items);
#line 3055 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_items_altered (DataCollection* self, GeeMap* items) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_altered (self, items);
#line 3063 "DataCollection.c"
}


#line 545 "DataCollection.vala"
static void data_collection_real_notify_ordering_changed (DataCollection* self) {
#line 545 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 546 "DataCollection.vala"
	g_signal_emit_by_name (self, "ordering-changed");
#line 3073 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_ordering_changed (DataCollection* self) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_ordering_changed (self);
#line 3081 "DataCollection.c"
}


#line 549 "DataCollection.vala"
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 549 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 549 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 550 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-set", name, old, val);
#line 3093 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_set (self, name, old, val);
#line 3101 "DataCollection.c"
}


#line 553 "DataCollection.vala"
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name) {
#line 553 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 553 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 554 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-cleared", name);
#line 3113 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_property_cleared (DataCollection* self, const char* name) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_cleared (self, name);
#line 3121 "DataCollection.c"
}


#line 562 "DataCollection.vala"
GeeCollection* data_collection_get_singleton (DataObject* object) {
#line 3127 "DataCollection.c"
	GeeCollection* result = NULL;
#line 562 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 3131 "DataCollection.c"
	result = GEE_COLLECTION (singleton_collection_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, object));
#line 563 "DataCollection.vala"
	return result;
#line 3135 "DataCollection.c"
}


#line 566 "DataCollection.vala"
GeeMap* data_collection_get_alteration_singleton (DataObject* object, Alteration* alteration) {
#line 3141 "DataCollection.c"
	GeeMap* result = NULL;
	GeeMap* map;
#line 566 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 566 "DataCollection.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), NULL);
#line 568 "DataCollection.vala"
	map = GEE_MAP (gee_hash_map_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_ALTERATION, (GBoxedCopyFunc) alteration_ref, alteration_unref, NULL, NULL, NULL));
#line 569 "DataCollection.vala"
	gee_map_set (map, object, alteration);
#line 3152 "DataCollection.c"
	result = map;
#line 571 "DataCollection.vala"
	return result;
#line 3156 "DataCollection.c"
}


#line 574 "DataCollection.vala"
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object) {
#line 3162 "DataCollection.c"
	gboolean result = FALSE;
#line 574 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 574 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 3168 "DataCollection.c"
	result = TRUE;
#line 575 "DataCollection.vala"
	return result;
#line 3172 "DataCollection.c"
}


#line 509 "DataCollection.vala"
gboolean data_collection_valid_type (DataCollection* self, DataObject* object) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->valid_type (self, object);
#line 3180 "DataCollection.c"
}


#line 578 "DataCollection.vala"
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
#line 578 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 579 "DataCollection.vala"
	data_set_set_comparator (self->priv->dataset, comparator, comparator_target, predicate, predicate_target);
#line 580 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 3192 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->set_comparator (self, comparator, comparator_target, predicate, predicate_target);
#line 3200 "DataCollection.c"
}


#line 584 "DataCollection.vala"
static void data_collection_real_reset_comparator (DataCollection* self) {
#line 584 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 585 "DataCollection.vala"
	data_set_reset_comparator (self->priv->dataset);
#line 586 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 3212 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_reset_comparator (DataCollection* self) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->reset_comparator (self);
#line 3220 "DataCollection.c"
}


#line 589 "DataCollection.vala"
static GeeCollection* data_collection_real_get_all (DataCollection* self) {
#line 3226 "DataCollection.c"
	GeeCollection* result = NULL;
#line 589 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3230 "DataCollection.c"
	result = data_set_get_all (self->priv->dataset);
#line 590 "DataCollection.vala"
	return result;
#line 3234 "DataCollection.c"
}


#line 509 "DataCollection.vala"
GeeCollection* data_collection_get_all (DataCollection* self) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_all (self);
#line 3242 "DataCollection.c"
}


#line 593 "DataCollection.vala"
DataSet* data_collection_get_dataset_copy (DataCollection* self) {
#line 3248 "DataCollection.c"
	DataSet* result = NULL;
#line 593 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3252 "DataCollection.c"
	result = data_set_copy (self->priv->dataset);
#line 594 "DataCollection.vala"
	return result;
#line 3256 "DataCollection.c"
}


#line 597 "DataCollection.vala"
static gint data_collection_real_get_count (DataCollection* self) {
#line 3262 "DataCollection.c"
	gint result = 0;
#line 597 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 3266 "DataCollection.c"
	result = data_set_get_count (self->priv->dataset);
#line 598 "DataCollection.vala"
	return result;
#line 3270 "DataCollection.c"
}


#line 509 "DataCollection.vala"
gint data_collection_get_count (DataCollection* self) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_count (self);
#line 3278 "DataCollection.c"
}


#line 601 "DataCollection.vala"
static DataObject* data_collection_real_get_at (DataCollection* self, gint index) {
#line 3284 "DataCollection.c"
	DataObject* result = NULL;
#line 601 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3288 "DataCollection.c"
	result = data_set_get_at (self->priv->dataset, index);
#line 602 "DataCollection.vala"
	return result;
#line 3292 "DataCollection.c"
}


#line 509 "DataCollection.vala"
DataObject* data_collection_get_at (DataCollection* self, gint index) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_at (self, index);
#line 3300 "DataCollection.c"
}


#line 605 "DataCollection.vala"
static gint data_collection_real_index_of (DataCollection* self, DataObject* object) {
#line 3306 "DataCollection.c"
	gint result = 0;
#line 605 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 605 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 3312 "DataCollection.c"
	result = data_set_index_of (self->priv->dataset, object);
#line 606 "DataCollection.vala"
	return result;
#line 3316 "DataCollection.c"
}


#line 509 "DataCollection.vala"
gint data_collection_index_of (DataCollection* self, DataObject* object) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->index_of (self, object);
#line 3324 "DataCollection.c"
}


#line 609 "DataCollection.vala"
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object) {
#line 3330 "DataCollection.c"
	gboolean result = FALSE;
#line 609 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 609 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 3336 "DataCollection.c"
	result = data_collection_internal_contains (self, object);
#line 610 "DataCollection.vala"
	return result;
#line 3340 "DataCollection.c"
}


#line 509 "DataCollection.vala"
gboolean data_collection_contains (DataCollection* self, DataObject* object) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->contains (self, object);
#line 3348 "DataCollection.c"
}


#line 615 "DataCollection.vala"
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object) {
#line 3354 "DataCollection.c"
	gboolean result = FALSE;
	DataCollection* _tmp0_;
#line 615 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 615 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 616 "DataCollection.vala"
	if (!data_set_contains (self->priv->dataset, object)) {
#line 3363 "DataCollection.c"
		result = FALSE;
#line 617 "DataCollection.vala"
		return result;
#line 3367 "DataCollection.c"
	}
#line 619 "DataCollection.vala"
	g_assert ((_tmp0_ = data_object_get_membership (object)) == self);
#line 3371 "DataCollection.c"
	_data_collection_unref0 (_tmp0_);
	result = TRUE;
#line 621 "DataCollection.vala"
	return result;
#line 3376 "DataCollection.c"
}


#line 624 "DataCollection.vala"
static void data_collection_internal_add (DataCollection* self, DataObject* object) {
#line 3382 "DataCollection.c"
	gboolean added;
#line 624 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 624 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 625 "DataCollection.vala"
	g_assert (data_collection_valid_type (self, object));
#line 627 "DataCollection.vala"
	data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 629 "DataCollection.vala"
	added = data_set_add (self->priv->dataset, object);
#line 630 "DataCollection.vala"
	g_assert (added);
#line 3396 "DataCollection.c"
}


#line 633 "DataCollection.vala"
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target) {
#line 3402 "DataCollection.c"
	gint count;
	gboolean added;
#line 633 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 633 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (objects));
#line 634 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (objects));
#line 3411 "DataCollection.c"
	{
		gint ctr;
#line 635 "DataCollection.vala"
		ctr = 0;
#line 3416 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 635 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 635 "DataCollection.vala"
			while (TRUE) {
#line 3423 "DataCollection.c"
				DataObject* object;
#line 635 "DataCollection.vala"
				if (!_tmp0_) {
#line 635 "DataCollection.vala"
					ctr++;
#line 3429 "DataCollection.c"
				}
#line 635 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 635 "DataCollection.vala"
				if (!(ctr < count)) {
#line 635 "DataCollection.vala"
					break;
#line 3437 "DataCollection.c"
				}
#line 636 "DataCollection.vala"
				object = (DataObject*) gee_list_get (objects, ctr);
#line 637 "DataCollection.vala"
				g_assert (data_collection_valid_type (self, object));
#line 639 "DataCollection.vala"
				data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 641 "DataCollection.vala"
				if (monitor != NULL) {
#line 642 "DataCollection.vala"
					monitor ((guint64) ctr, (guint64) count, monitor_target);
#line 3449 "DataCollection.c"
				}
				_g_object_unref0 (object);
			}
		}
	}
#line 645 "DataCollection.vala"
	added = data_set_add_many (self->priv->dataset, GEE_COLLECTION (objects));
#line 646 "DataCollection.vala"
	g_assert (added);
#line 3459 "DataCollection.c"
}


#line 649 "DataCollection.vala"
static void data_collection_internal_remove (DataCollection* self, DataObject* object) {
#line 3465 "DataCollection.c"
	gboolean removed;
#line 649 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 649 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 650 "DataCollection.vala"
	removed = data_set_remove (self->priv->dataset, object);
#line 651 "DataCollection.vala"
	g_assert (removed);
#line 653 "DataCollection.vala"
	data_object_internal_clear_membership (object);
#line 3477 "DataCollection.c"
}


#line 657 "DataCollection.vala"
static gboolean data_collection_real_add (DataCollection* self, DataObject* object) {
#line 3483 "DataCollection.c"
	gboolean result = FALSE;
	GeeCollection* added;
#line 657 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 657 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 658 "DataCollection.vala"
	if (data_collection_internal_contains (self, object)) {
#line 3492 "DataCollection.c"
		char* _tmp0_;
		char* _tmp1_;
#line 659 "DataCollection.vala"
		g_debug ("DataCollection.vala:659: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 3497 "DataCollection.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
		result = FALSE;
#line 661 "DataCollection.vala"
		return result;
#line 3503 "DataCollection.c"
	}
#line 664 "DataCollection.vala"
	data_collection_internal_add (self, object);
#line 667 "DataCollection.vala"
	added = data_collection_get_singleton (object);
#line 668 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 669 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 672 "DataCollection.vala"
	data_object_notify_membership_changed (object, self);
#line 3515 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (added);
#line 674 "DataCollection.vala"
	return result;
#line 3520 "DataCollection.c"
}


#line 509 "DataCollection.vala"
gboolean data_collection_add (DataCollection* self, DataObject* object) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->add (self, object);
#line 3528 "DataCollection.c"
}


#line 678 "DataCollection.vala"
static GeeCollection* data_collection_real_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 3534 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeArrayList* added;
	gint count;
#line 678 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 678 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 680 "DataCollection.vala"
	added = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3544 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 681 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (objects));
#line 681 "DataCollection.vala"
		while (TRUE) {
#line 3551 "DataCollection.c"
			DataObject* object;
#line 681 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 681 "DataCollection.vala"
				break;
#line 3557 "DataCollection.c"
			}
#line 681 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 682 "DataCollection.vala"
			if (data_collection_internal_contains (self, object)) {
#line 3563 "DataCollection.c"
				char* _tmp0_;
				char* _tmp1_;
#line 683 "DataCollection.vala"
				g_debug ("DataCollection.vala:683: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 3568 "DataCollection.c"
				_g_free0 (_tmp1_);
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 685 "DataCollection.vala"
				continue;
#line 3574 "DataCollection.c"
			}
#line 688 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added), object);
#line 3578 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 691 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (added));
#line 692 "DataCollection.vala"
	if (count == 0) {
#line 3587 "DataCollection.c"
		result = GEE_COLLECTION (added);
#line 693 "DataCollection.vala"
		return result;
#line 3591 "DataCollection.c"
	}
#line 695 "DataCollection.vala"
	data_collection_internal_add_many (self, GEE_LIST (added), monitor, monitor_target);
#line 698 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 699 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 3599 "DataCollection.c"
	{
		gint ctr;
#line 702 "DataCollection.vala"
		ctr = 0;
#line 3604 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 702 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 702 "DataCollection.vala"
			while (TRUE) {
#line 3611 "DataCollection.c"
				DataObject* _tmp3_;
#line 702 "DataCollection.vala"
				if (!_tmp2_) {
#line 702 "DataCollection.vala"
					ctr++;
#line 3617 "DataCollection.c"
				}
#line 702 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 702 "DataCollection.vala"
				if (!(ctr < count)) {
#line 702 "DataCollection.vala"
					break;
#line 3625 "DataCollection.c"
				}
#line 703 "DataCollection.vala"
				data_object_notify_membership_changed (_tmp3_ = (DataObject*) gee_abstract_list_get (GEE_ABSTRACT_LIST (added), ctr), self);
#line 3629 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	result = GEE_COLLECTION (added);
#line 705 "DataCollection.vala"
	return result;
#line 3637 "DataCollection.c"
}


#line 509 "DataCollection.vala"
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 509 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->add_many (self, objects, monitor, monitor_target);
#line 3645 "DataCollection.c"
}


#line 709 "DataCollection.vala"
Marker* data_collection_start_marking (DataCollection* self) {
#line 3651 "DataCollection.c"
	Marker* result = NULL;
#line 709 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3655 "DataCollection.c"
	result = MARKER (data_collection_marker_impl_new (self));
#line 710 "DataCollection.vala"
	return result;
#line 3659 "DataCollection.c"
}


#line 714 "DataCollection.vala"
Marker* data_collection_mark (DataCollection* self, DataObject* object) {
#line 3665 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 714 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 714 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 715 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 716 "DataCollection.vala"
	marker_mark (marker, object);
#line 3676 "DataCollection.c"
	result = marker;
#line 718 "DataCollection.vala"
	return result;
#line 3680 "DataCollection.c"
}


#line 722 "DataCollection.vala"
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects) {
#line 3686 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 722 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 722 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 723 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 724 "DataCollection.vala"
	marker_mark_many (marker, objects);
#line 3697 "DataCollection.c"
	result = marker;
#line 726 "DataCollection.vala"
	return result;
#line 3701 "DataCollection.c"
}


#line 731 "DataCollection.vala"
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user) {
#line 3707 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
	guint64 count;
	guint64 total;
#line 731 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 731 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 731 "DataCollection.vala"
	g_return_if_fail ((user == NULL) || G_IS_OBJECT (user));
#line 733 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 735 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 738 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 740 "DataCollection.vala"
	count = (guint64) 0;
#line 741 "DataCollection.vala"
	total = (guint64) gee_collection_get_size (GEE_COLLECTION (marker->marked));
#line 3727 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 744 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 744 "DataCollection.vala"
		while (TRUE) {
#line 3734 "DataCollection.c"
			DataObject* object;
#line 744 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 744 "DataCollection.vala"
				break;
#line 3740 "DataCollection.c"
			}
#line 744 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 746 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 3746 "DataCollection.c"
				char* _tmp0_;
#line 747 "DataCollection.vala"
				g_warning ("DataCollection.vala:747: act_on_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 3750 "DataCollection.c"
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 749 "DataCollection.vala"
				continue;
#line 3755 "DataCollection.c"
			}
#line 752 "DataCollection.vala"
			if (!action (object, user, action_target)) {
#line 3759 "DataCollection.c"
				_g_object_unref0 (object);
#line 753 "DataCollection.vala"
				break;
#line 3763 "DataCollection.c"
			}
#line 755 "DataCollection.vala"
			if (monitor != NULL) {
#line 756 "DataCollection.vala"
				if (!monitor (count = count + 1, total, monitor_target)) {
#line 3769 "DataCollection.c"
					_g_object_unref0 (object);
#line 757 "DataCollection.vala"
					break;
#line 3773 "DataCollection.c"
				}
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 762 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 3782 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 767 "DataCollection.vala"
static void data_collection_real_remove_marked (DataCollection* self, Marker* m) {
#line 3789 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
	GeeArrayList* skipped;
#line 767 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 767 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 768 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 770 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 773 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 776 "DataCollection.vala"
	skipped = NULL;
#line 3804 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 777 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 777 "DataCollection.vala"
		while (TRUE) {
#line 3811 "DataCollection.c"
			DataObject* object;
#line 777 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 777 "DataCollection.vala"
				break;
#line 3817 "DataCollection.c"
			}
#line 777 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 779 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 3823 "DataCollection.c"
				char* _tmp0_;
#line 780 "DataCollection.vala"
				g_warning ("DataCollection.vala:780: remove_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 3827 "DataCollection.c"
				_g_free0 (_tmp0_);
#line 782 "DataCollection.vala"
				if (skipped == NULL) {
#line 3831 "DataCollection.c"
					GeeArrayList* _tmp1_;
#line 783 "DataCollection.vala"
					skipped = (_tmp1_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (skipped), _tmp1_);
#line 3835 "DataCollection.c"
				}
#line 785 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (skipped), object);
#line 3839 "DataCollection.c"
				_g_object_unref0 (object);
#line 787 "DataCollection.vala"
				continue;
#line 3843 "DataCollection.c"
			}
#line 790 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 3847 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 793 "DataCollection.vala"
	if (skipped != NULL) {
#line 794 "DataCollection.vala"
		gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (marker->marked), GEE_COLLECTION (skipped));
#line 3856 "DataCollection.c"
	}
#line 797 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (marker->marked)) > 0) {
#line 798 "DataCollection.vala"
		data_collection_notify_items_removed (self, GEE_ITERABLE (marker->marked));
#line 799 "DataCollection.vala"
		data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (marker->marked));
#line 3864 "DataCollection.c"
		{
			GeeIterator* _object_it;
#line 802 "DataCollection.vala"
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 802 "DataCollection.vala"
			while (TRUE) {
#line 3871 "DataCollection.c"
				DataObject* object;
#line 802 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 802 "DataCollection.vala"
					break;
#line 3877 "DataCollection.c"
				}
#line 802 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 803 "DataCollection.vala"
				data_object_notify_membership_changed (object, NULL);
#line 3883 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
#line 807 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 3891 "DataCollection.c"
	_g_object_unref0 (skipped);
	_g_object_unref0 (marker);
}


#line 509 "DataCollection.vala"
void data_collection_remove_marked (DataCollection* self, Marker* m) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->remove_marked (self, m);
#line 3901 "DataCollection.c"
}


#line 810 "DataCollection.vala"
static void data_collection_real_clear (DataCollection* self) {
#line 3907 "DataCollection.c"
	GeeArrayList* removed;
#line 810 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 811 "DataCollection.vala"
	if (data_set_get_count (self->priv->dataset) == 0) {
#line 812 "DataCollection.vala"
		return;
#line 3915 "DataCollection.c"
	}
#line 816 "DataCollection.vala"
	removed = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3919 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 817 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 817 "DataCollection.vala"
		while (TRUE) {
#line 3926 "DataCollection.c"
			DataObject* object;
#line 817 "DataCollection.vala"
			if (!_tmp0_) {
#line 823 "DataCollection.vala"
				if (!(data_set_get_count (self->priv->dataset) > 0)) {
#line 823 "DataCollection.vala"
					break;
#line 3934 "DataCollection.c"
				}
			}
#line 817 "DataCollection.vala"
			_tmp0_ = FALSE;
#line 818 "DataCollection.vala"
			object = data_set_get_at (self->priv->dataset, 0);
#line 819 "DataCollection.vala"
			g_assert (object != NULL);
#line 821 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (removed), object);
#line 822 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 3947 "DataCollection.c"
			_g_object_unref0 (object);
		}
	}
#line 826 "DataCollection.vala"
	data_collection_notify_items_removed (self, GEE_ITERABLE (removed));
#line 827 "DataCollection.vala"
	data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (removed));
#line 3955 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 830 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (removed));
#line 830 "DataCollection.vala"
		while (TRUE) {
#line 3962 "DataCollection.c"
			DataObject* object;
#line 830 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 830 "DataCollection.vala"
				break;
#line 3968 "DataCollection.c"
			}
#line 830 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 831 "DataCollection.vala"
			data_object_notify_membership_changed (object, NULL);
#line 3974 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_g_object_unref0 (removed);
}


#line 509 "DataCollection.vala"
void data_collection_clear (DataCollection* self) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->clear (self);
#line 3987 "DataCollection.c"
}


#line 840 "DataCollection.vala"
static void data_collection_real_close (DataCollection* self) {
#line 840 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 841 "DataCollection.vala"
	data_collection_clear (self);
#line 3997 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_close (DataCollection* self) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->close (self);
#line 4005 "DataCollection.c"
}


static gpointer _alteration_ref0 (gpointer self) {
	return self ? alteration_ref (self) : NULL;
}


#line 846 "DataCollection.vala"
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration) {
#line 4016 "DataCollection.c"
	gboolean resort_occurred;
	GeeMap* _tmp4_;
#line 846 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 846 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 846 "DataCollection.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 847 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self, object));
#line 849 "DataCollection.vala"
	resort_occurred = data_set_resort_object (self->priv->dataset, object, alteration);
#line 851 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (self)) {
#line 4031 "DataCollection.c"
		Alteration* current;
		gboolean _tmp3_ = FALSE;
#line 852 "DataCollection.vala"
		if (self->priv->frozen_items_altered == NULL) {
#line 4036 "DataCollection.c"
			GeeHashMap* _tmp0_;
#line 853 "DataCollection.vala"
			self->priv->frozen_items_altered = (_tmp0_ = gee_hash_map_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_ALTERATION, (GBoxedCopyFunc) alteration_ref, alteration_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 4040 "DataCollection.c"
		}
#line 857 "DataCollection.vala"
		current = (Alteration*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->frozen_items_altered), object);
#line 858 "DataCollection.vala"
		if (current != NULL) {
#line 4046 "DataCollection.c"
			Alteration* _tmp1_;
#line 859 "DataCollection.vala"
			current = (_tmp1_ = alteration_compress (current, alteration), _alteration_unref0 (current), _tmp1_);
#line 4050 "DataCollection.c"
		} else {
			Alteration* _tmp2_;
#line 861 "DataCollection.vala"
			current = (_tmp2_ = _alteration_ref0 (alteration), _alteration_unref0 (current), _tmp2_);
#line 4055 "DataCollection.c"
		}
#line 863 "DataCollection.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->frozen_items_altered), object, current);
#line 865 "DataCollection.vala"
		if (self->priv->fire_ordering_changed) {
#line 865 "DataCollection.vala"
			_tmp3_ = TRUE;
#line 4063 "DataCollection.c"
		} else {
#line 865 "DataCollection.vala"
			_tmp3_ = resort_occurred;
#line 4067 "DataCollection.c"
		}
#line 865 "DataCollection.vala"
		self->priv->fire_ordering_changed = _tmp3_;
#line 4071 "DataCollection.c"
		_alteration_unref0 (current);
#line 867 "DataCollection.vala"
		return;
#line 4075 "DataCollection.c"
	}
#line 870 "DataCollection.vala"
	if (resort_occurred) {
#line 871 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 4081 "DataCollection.c"
	}
#line 873 "DataCollection.vala"
	data_collection_notify_item_altered (self, object, alteration);
#line 874 "DataCollection.vala"
	data_collection_notify_items_altered (self, _tmp4_ = data_collection_get_alteration_singleton (object, alteration));
#line 4087 "DataCollection.c"
	_g_object_unref0 (_tmp4_);
}


#line 877 "DataCollection.vala"
GValue* data_collection_get_property (DataCollection* self, const char* name) {
#line 4094 "DataCollection.c"
	GValue* result = NULL;
#line 877 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 877 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 4100 "DataCollection.c"
	result = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 878 "DataCollection.vala"
	return result;
#line 4104 "DataCollection.c"
}


#line 37 "util.vala"
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 4110 "DataCollection.c"
	gboolean result;
	result = bool_value_equals (a, b);
	return result;
}


#line 41 "util.vala"
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 4119 "DataCollection.c"
	gboolean result;
	result = int_value_equals (a, b);
	return result;
}


#line 881 "DataCollection.vala"
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 4128 "DataCollection.c"
	GValue* old;
	gint count;
#line 881 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 881 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 882 "DataCollection.vala"
	if (value_equals == NULL) {
#line 883 "DataCollection.vala"
		if (G_VALUE_HOLDS (val, G_TYPE_BOOLEAN)) {
#line 4139 "DataCollection.c"
			ValueEqualFunc _tmp0_;
#line 884 "DataCollection.vala"
			value_equals = (_tmp0_ = _bool_value_equals_value_equal_func, value_equals_target = NULL, _tmp0_);
#line 4143 "DataCollection.c"
		} else {
#line 885 "DataCollection.vala"
			if (G_VALUE_HOLDS (val, G_TYPE_INT)) {
#line 4147 "DataCollection.c"
				ValueEqualFunc _tmp1_;
#line 886 "DataCollection.vala"
				value_equals = (_tmp1_ = _int_value_equals_value_equal_func, value_equals_target = NULL, _tmp1_);
#line 4151 "DataCollection.c"
			} else {
#line 888 "DataCollection.vala"
				g_error ("DataCollection.vala:888: value_equals must be specified for this type");
#line 4155 "DataCollection.c"
			}
		}
	}
#line 891 "DataCollection.vala"
	old = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 892 "DataCollection.vala"
	if (old != NULL) {
#line 893 "DataCollection.vala"
		if (value_equals (old, val, value_equals_target)) {
#line 4165 "DataCollection.c"
			__vala_GValue_free0 (old);
#line 894 "DataCollection.vala"
			return;
#line 4169 "DataCollection.c"
		}
	}
#line 897 "DataCollection.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->properties), name, val);
#line 899 "DataCollection.vala"
	data_collection_notify_property_set (self, name, old, val);
#line 902 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 4178 "DataCollection.c"
	{
		gint ctr;
#line 903 "DataCollection.vala"
		ctr = 0;
#line 4183 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 903 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 903 "DataCollection.vala"
			while (TRUE) {
#line 4190 "DataCollection.c"
				DataObject* _tmp3_;
#line 903 "DataCollection.vala"
				if (!_tmp2_) {
#line 903 "DataCollection.vala"
					ctr++;
#line 4196 "DataCollection.c"
				}
#line 903 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 903 "DataCollection.vala"
				if (!(ctr < count)) {
#line 903 "DataCollection.vala"
					break;
#line 4204 "DataCollection.c"
				}
#line 904 "DataCollection.vala"
				data_object_notify_collection_property_set (_tmp3_ = data_set_get_at (self->priv->dataset, ctr), name, old, val);
#line 4208 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	__vala_GValue_free0 (old);
}


#line 907 "DataCollection.vala"
void data_collection_clear_property (DataCollection* self, const char* name) {
#line 4219 "DataCollection.c"
	gint count;
#line 907 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 907 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 908 "DataCollection.vala"
	if (!gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->properties), name, NULL)) {
#line 909 "DataCollection.vala"
		return;
#line 4229 "DataCollection.c"
	}
#line 912 "DataCollection.vala"
	data_collection_notify_property_cleared (self, name);
#line 915 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 4235 "DataCollection.c"
	{
		gint ctr;
#line 916 "DataCollection.vala"
		ctr = 0;
#line 4240 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 916 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 916 "DataCollection.vala"
			while (TRUE) {
#line 4247 "DataCollection.c"
				DataObject* _tmp1_;
#line 916 "DataCollection.vala"
				if (!_tmp0_) {
#line 916 "DataCollection.vala"
					ctr++;
#line 4253 "DataCollection.c"
				}
#line 916 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 916 "DataCollection.vala"
				if (!(ctr < count)) {
#line 916 "DataCollection.vala"
					break;
#line 4261 "DataCollection.c"
				}
#line 917 "DataCollection.vala"
				data_object_notify_collection_property_cleared (_tmp1_ = data_set_get_at (self->priv->dataset, ctr), name);
#line 4265 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
			}
		}
	}
}


#line 931 "DataCollection.vala"
void data_collection_freeze_notifications (DataCollection* self) {
#line 931 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 932 "DataCollection.vala"
	if ((self->priv->notifies_frozen++) == 0) {
#line 933 "DataCollection.vala"
		data_collection_notify_frozen (self);
#line 4281 "DataCollection.c"
	}
}


#line 936 "DataCollection.vala"
void data_collection_thaw_notifications (DataCollection* self) {
#line 936 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 937 "DataCollection.vala"
	if (self->priv->notifies_frozen == 0) {
#line 938 "DataCollection.vala"
		return;
#line 4294 "DataCollection.c"
	}
#line 940 "DataCollection.vala"
	if ((self->priv->notifies_frozen = self->priv->notifies_frozen - 1) == 0) {
#line 941 "DataCollection.vala"
		data_collection_notify_thawed (self);
#line 4300 "DataCollection.c"
	}
}


#line 944 "DataCollection.vala"
gboolean data_collection_are_notifications_frozen (DataCollection* self) {
#line 4307 "DataCollection.c"
	gboolean result = FALSE;
#line 944 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 4311 "DataCollection.c"
	result = self->priv->notifies_frozen > 0;
#line 945 "DataCollection.vala"
	return result;
#line 4315 "DataCollection.c"
}


#line 950 "DataCollection.vala"
static void data_collection_real_notify_frozen (DataCollection* self) {
#line 950 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 951 "DataCollection.vala"
	g_signal_emit_by_name (self, "frozen");
#line 4325 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_frozen (DataCollection* self) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_frozen (self);
#line 4333 "DataCollection.c"
}


#line 956 "DataCollection.vala"
static void data_collection_real_notify_thawed (DataCollection* self) {
#line 4339 "DataCollection.c"
	gint count;
#line 956 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 957 "DataCollection.vala"
	if (self->priv->frozen_items_altered != NULL) {
#line 4345 "DataCollection.c"
		GeeMap* copy;
		GeeHashMap* _tmp0_;
#line 959 "DataCollection.vala"
		copy = _g_object_ref0 (GEE_MAP (self->priv->frozen_items_altered));
#line 960 "DataCollection.vala"
		self->priv->frozen_items_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 4352 "DataCollection.c"
		{
			GeeSet* _tmp1_;
			GeeIterator* _tmp2_;
			GeeIterator* _object_it;
#line 962 "DataCollection.vala"
			_object_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = gee_map_get_keys (copy))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 962 "DataCollection.vala"
			while (TRUE) {
#line 4361 "DataCollection.c"
				DataObject* object;
				Alteration* _tmp3_;
#line 962 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 962 "DataCollection.vala"
					break;
#line 4368 "DataCollection.c"
				}
#line 962 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 963 "DataCollection.vala"
				data_collection_notify_item_altered (self, object, _tmp3_ = (Alteration*) gee_map_get (copy, object));
#line 4374 "DataCollection.c"
				_alteration_unref0 (_tmp3_);
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
#line 964 "DataCollection.vala"
		data_collection_notify_items_altered (self, copy);
#line 4382 "DataCollection.c"
		_g_object_unref0 (copy);
	}
#line 967 "DataCollection.vala"
	if (self->priv->fire_ordering_changed) {
#line 968 "DataCollection.vala"
		self->priv->fire_ordering_changed = FALSE;
#line 969 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 4391 "DataCollection.c"
	}
#line 973 "DataCollection.vala"
	count = data_collection_get_count (self);
#line 4395 "DataCollection.c"
	{
		gint ctr;
#line 974 "DataCollection.vala"
		ctr = 0;
#line 4400 "DataCollection.c"
		{
			gboolean _tmp4_;
#line 974 "DataCollection.vala"
			_tmp4_ = TRUE;
#line 974 "DataCollection.vala"
			while (TRUE) {
#line 4407 "DataCollection.c"
				DataObject* _tmp5_;
#line 974 "DataCollection.vala"
				if (!_tmp4_) {
#line 974 "DataCollection.vala"
					ctr++;
#line 4413 "DataCollection.c"
				}
#line 974 "DataCollection.vala"
				_tmp4_ = FALSE;
#line 974 "DataCollection.vala"
				if (!(ctr < count)) {
#line 974 "DataCollection.vala"
					break;
#line 4421 "DataCollection.c"
				}
#line 975 "DataCollection.vala"
				data_object_internal_collection_thawed (_tmp5_ = data_collection_get_at (self, ctr));
#line 4425 "DataCollection.c"
				_g_object_unref0 (_tmp5_);
			}
		}
	}
#line 977 "DataCollection.vala"
	g_signal_emit_by_name (self, "thawed");
#line 4432 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_thawed (DataCollection* self) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_thawed (self);
#line 4440 "DataCollection.c"
}


#line 462 "DataCollection.vala"
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added) {
#line 462 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 462 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 4450 "DataCollection.c"
}


#line 466 "DataCollection.vala"
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed) {
#line 466 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 466 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4460 "DataCollection.c"
}


#line 470 "DataCollection.vala"
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 470 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 470 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 470 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 4472 "DataCollection.c"
}


#line 477 "DataCollection.vala"
static void data_collection_real_item_altered (DataCollection* self, DataObject* item, Alteration* alteration) {
#line 477 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 477 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 477 "DataCollection.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 4484 "DataCollection.c"
}


#line 482 "DataCollection.vala"
static void data_collection_real_items_altered (DataCollection* self, GeeMap* items) {
#line 482 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 482 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 4494 "DataCollection.c"
}


#line 487 "DataCollection.vala"
static void data_collection_real_ordering_changed (DataCollection* self) {
#line 487 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4502 "DataCollection.c"
}


#line 492 "DataCollection.vala"
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 492 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 492 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 4512 "DataCollection.c"
}


#line 496 "DataCollection.vala"
static void data_collection_real_property_cleared (DataCollection* self, const char* name) {
#line 496 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 496 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 4522 "DataCollection.c"
}


#line 501 "DataCollection.vala"
static void data_collection_real_frozen (DataCollection* self) {
#line 501 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4530 "DataCollection.c"
}


#line 506 "DataCollection.vala"
static void data_collection_real_thawed (DataCollection* self) {
#line 506 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4538 "DataCollection.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 429 "DataCollection.vala"
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 4549 "DataCollection.c"
	data_collection_marker_impl_on_items_removed (self, removed);
}


#line 361 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner) {
#line 4556 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	DataCollection* _tmp0_;
#line 361 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (owner), NULL);
#line 361 "DataCollection.vala"
	self = (DataCollectionMarkerImpl*) g_object_new (object_type, NULL);
#line 362 "DataCollection.vala"
	self->owner = (_tmp0_ = _data_collection_ref0 (owner), _data_collection_unref0 (self->owner), _tmp0_);
#line 366 "DataCollection.vala"
	g_signal_connect_object (owner, "items-removed", (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self, 0);
#line 4567 "DataCollection.c"
	return self;
}


#line 361 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner) {
#line 361 "DataCollection.vala"
	return data_collection_marker_impl_construct (DATA_COLLECTION_TYPE_MARKER_IMPL, owner);
#line 4576 "DataCollection.c"
}


#line 373 "DataCollection.vala"
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object) {
#line 4582 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 373 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 374 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 376 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4591 "DataCollection.c"
}


#line 379 "DataCollection.vala"
static void data_collection_marker_impl_real_unmark (Marker* base, DataObject* object) {
#line 4597 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 379 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 380 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 382 "DataCollection.vala"
	gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4606 "DataCollection.c"
}


#line 385 "DataCollection.vala"
static gboolean data_collection_marker_impl_real_toggle (Marker* base, DataObject* object) {
#line 4612 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gboolean result = FALSE;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 385 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 386 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 388 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->marked), object)) {
#line 389 "DataCollection.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4624 "DataCollection.c"
	} else {
#line 391 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4628 "DataCollection.c"
	}
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 394 "DataCollection.vala"
	return result;
#line 4633 "DataCollection.c"
}


#line 397 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeCollection* list) {
#line 4639 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 397 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (list));
#line 4644 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 398 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (list));
#line 398 "DataCollection.vala"
		while (TRUE) {
#line 4651 "DataCollection.c"
			DataObject* object;
#line 398 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 398 "DataCollection.vala"
				break;
#line 4657 "DataCollection.c"
			}
#line 398 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 399 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 401 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4665 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 405 "DataCollection.vala"
static void data_collection_marker_impl_real_unmark_many (Marker* base, GeeCollection* list) {
#line 4675 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 405 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (list));
#line 4680 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 406 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (list));
#line 406 "DataCollection.vala"
		while (TRUE) {
#line 4687 "DataCollection.c"
			DataObject* object;
#line 406 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 406 "DataCollection.vala"
				break;
#line 4693 "DataCollection.c"
			}
#line 406 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 407 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 409 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4701 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 413 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_all (Marker* base) {
#line 4711 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 414 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (self->owner))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 414 "DataCollection.vala"
		while (TRUE) {
#line 4722 "DataCollection.c"
			DataObject* object;
#line 414 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 414 "DataCollection.vala"
				break;
#line 4728 "DataCollection.c"
			}
#line 414 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 415 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4734 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 418 "DataCollection.vala"
static gint data_collection_marker_impl_real_get_count (Marker* base) {
#line 4744 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 419 "DataCollection.vala"
	if (self->marked != NULL) {
#line 419 "DataCollection.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 4753 "DataCollection.c"
	} else {
#line 419 "DataCollection.vala"
		_tmp0_ = self->freeze_count;
#line 4757 "DataCollection.c"
	}
	result = _tmp0_;
#line 419 "DataCollection.vala"
	return result;
#line 4762 "DataCollection.c"
}


#line 422 "DataCollection.vala"
static GeeCollection* data_collection_marker_impl_real_get_all (Marker* base) {
#line 4768 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	GeeCollection* result = NULL;
	GeeArrayList* copy;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 423 "DataCollection.vala"
	copy = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 424 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (copy), GEE_COLLECTION (self->marked));
#line 4777 "DataCollection.c"
	result = GEE_COLLECTION (copy);
#line 426 "DataCollection.vala"
	return result;
#line 4781 "DataCollection.c"
}


#line 429 "DataCollection.vala"
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed) {
#line 429 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 429 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4791 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 430 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 430 "DataCollection.vala"
		while (TRUE) {
#line 4798 "DataCollection.c"
			DataObject* object;
#line 430 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 430 "DataCollection.vala"
				break;
#line 4804 "DataCollection.c"
			}
#line 430 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 431 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4810 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 437 "DataCollection.vala"
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self) {
#line 4820 "DataCollection.c"
	guint _tmp0_;
#line 437 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 438 "DataCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 438 "DataCollection.vala"
	g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 4828 "DataCollection.c"
}


#line 441 "DataCollection.vala"
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self) {
#line 4834 "DataCollection.c"
	GeeHashSet* _tmp0_;
#line 441 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 442 "DataCollection.vala"
	if (self->marked != NULL) {
#line 443 "DataCollection.vala"
		self->freeze_count = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 4842 "DataCollection.c"
	}
#line 445 "DataCollection.vala"
	self->marked = (_tmp0_ = NULL, _g_object_unref0 (self->marked), _tmp0_);
#line 4846 "DataCollection.c"
}


#line 448 "DataCollection.vala"
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection) {
#line 4852 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 448 "DataCollection.vala"
	g_return_val_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self), FALSE);
#line 448 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (collection), FALSE);
#line 449 "DataCollection.vala"
	if (collection == self->owner) {
#line 449 "DataCollection.vala"
		_tmp0_ = self->marked != NULL;
#line 4863 "DataCollection.c"
	} else {
#line 449 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 4867 "DataCollection.c"
	}
	result = _tmp0_;
#line 449 "DataCollection.vala"
	return result;
#line 4872 "DataCollection.c"
}


static void data_collection_marker_impl_class_init (DataCollectionMarkerImplClass * klass) {
	data_collection_marker_impl_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = data_collection_marker_impl_finalize;
}


static void data_collection_marker_impl_marker_interface_init (MarkerIface * iface) {
	data_collection_marker_impl_marker_parent_iface = g_type_interface_peek_parent (iface);
	iface->mark = data_collection_marker_impl_real_mark;
	iface->unmark = data_collection_marker_impl_real_unmark;
	iface->toggle = data_collection_marker_impl_real_toggle;
	iface->mark_many = data_collection_marker_impl_real_mark_many;
	iface->unmark_many = data_collection_marker_impl_real_unmark_many;
	iface->mark_all = data_collection_marker_impl_real_mark_all;
	iface->get_count = data_collection_marker_impl_real_get_count;
	iface->get_all = data_collection_marker_impl_real_get_all;
}


static void data_collection_marker_impl_instance_init (DataCollectionMarkerImpl * self) {
	self->marked = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->freeze_count = 0;
}


static void data_collection_marker_impl_finalize (GObject* obj) {
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (obj);
	{
		guint _tmp0_;
#line 370 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 370 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 4910 "DataCollection.c"
	}
	_data_collection_unref0 (self->owner);
	_g_object_unref0 (self->marked);
	G_OBJECT_CLASS (data_collection_marker_impl_parent_class)->finalize (obj);
}


static GType data_collection_marker_impl_get_type (void) {
	static volatile gsize data_collection_marker_impl_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_marker_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionMarkerImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_marker_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollectionMarkerImpl), 0, (GInstanceInitFunc) data_collection_marker_impl_instance_init, NULL };
		static const GInterfaceInfo marker_info = { (GInterfaceInitFunc) data_collection_marker_impl_marker_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType data_collection_marker_impl_type_id;
		data_collection_marker_impl_type_id = g_type_register_static (G_TYPE_OBJECT, "DataCollectionMarkerImpl", &g_define_type_info, 0);
		g_type_add_interface_static (data_collection_marker_impl_type_id, TYPE_MARKER, &marker_info);
		g_once_init_leave (&data_collection_marker_impl_type_id__volatile, data_collection_marker_impl_type_id);
	}
	return data_collection_marker_impl_type_id__volatile;
}


static void value_data_collection_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_collection_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_collection_unref (value->data[0].v_pointer);
	}
}


static void value_data_collection_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_collection_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_collection_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_collection_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataCollection* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_collection_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_collection_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataCollection** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_collection_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataCollection* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_COLLECTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_collection (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_collection_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


void value_take_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


static void data_collection_class_init (DataCollectionClass * klass) {
	data_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = data_collection_finalize;
	g_type_class_add_private (klass, sizeof (DataCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->to_string = data_collection_real_to_string;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = data_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = data_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = data_collection_real_notify_contents_altered;
	DATA_COLLECTION_CLASS (klass)->notify_item_altered = data_collection_real_notify_item_altered;
	DATA_COLLECTION_CLASS (klass)->notify_items_altered = data_collection_real_notify_items_altered;
	DATA_COLLECTION_CLASS (klass)->notify_ordering_changed = data_collection_real_notify_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->notify_property_set = data_collection_real_notify_property_set;
	DATA_COLLECTION_CLASS (klass)->notify_property_cleared = data_collection_real_notify_property_cleared;
	DATA_COLLECTION_CLASS (klass)->valid_type = data_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->set_comparator = data_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = data_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = data_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = data_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = data_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = data_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = data_collection_real_contains;
	DATA_COLLECTION_CLASS (klass)->add = data_collection_real_add;
	DATA_COLLECTION_CLASS (klass)->add_many = data_collection_real_add_many;
	DATA_COLLECTION_CLASS (klass)->remove_marked = data_collection_real_remove_marked;
	DATA_COLLECTION_CLASS (klass)->clear = data_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = data_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->notify_frozen = data_collection_real_notify_frozen;
	DATA_COLLECTION_CLASS (klass)->notify_thawed = data_collection_real_notify_thawed;
	DATA_COLLECTION_CLASS (klass)->items_added = data_collection_real_items_added;
	DATA_COLLECTION_CLASS (klass)->items_removed = data_collection_real_items_removed;
	DATA_COLLECTION_CLASS (klass)->contents_altered = data_collection_real_contents_altered;
	DATA_COLLECTION_CLASS (klass)->item_altered = data_collection_real_item_altered;
	DATA_COLLECTION_CLASS (klass)->items_altered = data_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->ordering_changed = data_collection_real_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->property_set = data_collection_real_property_set;
	DATA_COLLECTION_CLASS (klass)->property_cleared = data_collection_real_property_cleared;
	DATA_COLLECTION_CLASS (klass)->frozen = data_collection_real_frozen;
	DATA_COLLECTION_CLASS (klass)->thawed = data_collection_real_thawed;
	g_signal_new ("items_added", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_added), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_removed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_removed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("contents_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_ITERABLE, GEE_TYPE_ITERABLE);
	g_signal_new ("item_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, item_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ALTERATION, G_TYPE_NONE, 2, TYPE_DATA_OBJECT, TYPE_ALTERATION);
	g_signal_new ("items_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_MAP);
	g_signal_new ("ordering_changed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, ordering_changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("property_set", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_set), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_VALUE, G_TYPE_VALUE);
	g_signal_new ("property_cleared", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_cleared), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("frozen", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, frozen), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("thawed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, thawed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_collection_instance_init (DataCollection * self) {
	self->priv = DATA_COLLECTION_GET_PRIVATE (self);
	self->priv->dataset = data_set_new ();
	self->priv->properties = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_VALUE, (GBoxedCopyFunc) _g_value_dup, _vala_GValue_free, NULL, NULL, NULL);
	self->priv->object_ordinal_generator = (gint64) 0;
	self->priv->notifies_frozen = 0;
	self->priv->frozen_items_altered = NULL;
	self->priv->fire_ordering_changed = FALSE;
	self->ref_count = 1;
}


static void data_collection_finalize (DataCollection* obj) {
	DataCollection * self;
	self = DATA_COLLECTION (obj);
	{
	}
	_g_free0 (self->priv->name);
	_data_set_unref0 (self->priv->dataset);
	_g_object_unref0 (self->priv->properties);
	_g_object_unref0 (self->priv->frozen_items_altered);
}


GType data_collection_get_type (void) {
	static volatile gsize data_collection_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_collection_init, value_data_collection_free_value, value_data_collection_copy_value, value_data_collection_peek_pointer, "p", value_data_collection_collect_value, "p", value_data_collection_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollection), 0, (GInstanceInitFunc) data_collection_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_collection_type_id;
		data_collection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataCollection", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_collection_type_id__volatile, data_collection_type_id);
	}
	return data_collection_type_id__volatile;
}


gpointer data_collection_ref (gpointer instance) {
	DataCollection* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_collection_unref (gpointer instance) {
	DataCollection* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_COLLECTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1023 "DataCollection.vala"
SourceCollection* source_collection_construct (GType object_type, const char* name) {
#line 5151 "DataCollection.c"
	SourceCollection* self;
#line 1023 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1024 "DataCollection.vala"
	self = (SourceCollection*) data_collection_construct (object_type, name);
#line 5157 "DataCollection.c"
	return self;
}


#line 1023 "DataCollection.vala"
SourceCollection* source_collection_new (const char* name) {
#line 1023 "DataCollection.vala"
	return source_collection_construct (TYPE_SOURCE_COLLECTION, name);
#line 5166 "DataCollection.c"
}


#line 1027 "DataCollection.vala"
static void source_collection_real_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 1027 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1027 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 1028 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-unlinking", unlinking);
#line 5178 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
void source_collection_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 1023 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_unlinking (self, unlinking);
#line 5186 "DataCollection.c"
}


#line 1031 "DataCollection.vala"
static void source_collection_real_notify_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1031 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1031 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 1032 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-relinked", relinked);
#line 5198 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
void source_collection_notify_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1023 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_relinked (self, relinked);
#line 5206 "DataCollection.c"
}


#line 1035 "DataCollection.vala"
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1035 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1035 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1036 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-destroyed", source);
#line 5218 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1023 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_item_destroyed (self, source);
#line 5226 "DataCollection.c"
}


#line 1039 "DataCollection.vala"
static void source_collection_real_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1039 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1039 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 1040 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-destroyed", destroyed);
#line 5238 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
void source_collection_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1023 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_destroyed (self, destroyed);
#line 5246 "DataCollection.c"
}


#line 1044 "DataCollection.vala"
static void source_collection_real_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked) {
#line 1044 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1044 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (unlinked));
#line 1045 "DataCollection.vala"
	g_signal_emit_by_name (self, "unlinked-destroyed", unlinked);
#line 5258 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked) {
#line 1023 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_unlinked_destroyed (self, unlinked);
#line 5266 "DataCollection.c"
}


#line 1048 "DataCollection.vala"
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 5272 "DataCollection.c"
	SourceCollection * self;
	gboolean result = FALSE;
	self = SOURCE_COLLECTION (base);
#line 1048 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 5278 "DataCollection.c"
	result = IS_DATA_SOURCE (object);
#line 1049 "DataCollection.vala"
	return result;
#line 5282 "DataCollection.c"
}


#line 1073 "DataCollection.vala"
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5288 "DataCollection.c"
	gboolean result;
	result = source_collection_destroy_and_delete_source (self, object, user);
	return result;
}


#line 1087 "DataCollection.vala"
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5297 "DataCollection.c"
	gboolean result;
	result = source_collection_destroy_source (self, object, user);
	return result;
}


#line 1054 "DataCollection.vala"
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target) {
#line 5306 "DataCollection.c"
	gint result = 0;
	Marker* _tmp0_;
	SourceCollectionDestroyCounter* _tmp1_;
	SourceCollectionDestroyCounter* counter;
#line 1054 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), 0);
#line 1054 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), 0);
#line 1055 "DataCollection.vala"
	counter = (_tmp1_ = source_collection_destroy_counter_new (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1057 "DataCollection.vala"
	if (delete_backing) {
#line 1058 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_and_delete_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 5321 "DataCollection.c"
	} else {
#line 1060 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 5325 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1063 "DataCollection.vala"
		_source_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (counter->notify_list));
#line 1063 "DataCollection.vala"
		while (TRUE) {
#line 5333 "DataCollection.c"
			DataSource* source;
#line 1063 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1063 "DataCollection.vala"
				break;
#line 5339 "DataCollection.c"
			}
#line 1063 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1064 "DataCollection.vala"
			source_collection_notify_item_destroyed (self, source);
#line 5345 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1065 "DataCollection.vala"
	source_collection_notify_items_destroyed (self, GEE_COLLECTION (counter->notify_list));
#line 1068 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), counter->remove_marker);
#line 5354 "DataCollection.c"
	result = counter->delete_failed;
	_g_object_unref0 (counter);
#line 1070 "DataCollection.vala"
	return result;
#line 5359 "DataCollection.c"
}


#line 1073 "DataCollection.vala"
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 5365 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
	GError * _inner_error_ = NULL;
#line 1073 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1073 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1073 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1074 "DataCollection.vala"
	success = FALSE;
#line 5377 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 1076 "DataCollection.vala"
		_tmp0_ = data_source_internal_delete_backing (DATA_SOURCE (object), &_inner_error_);
#line 5382 "DataCollection.c"
		if (_inner_error_ != NULL) {
			goto __catch187_g_error;
		}
#line 1076 "DataCollection.vala"
		success = _tmp0_;
#line 5388 "DataCollection.c"
	}
	goto __finally187;
	__catch187_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1078 "DataCollection.vala"
			success = FALSE;
#line 5399 "DataCollection.c"
			_g_error_free0 (err);
		}
	}
	__finally187:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 1081 "DataCollection.vala"
	if (!success) {
#line 1082 "DataCollection.vala"
		SOURCE_COLLECTION_DESTROY_COUNTER (user)->delete_failed++;
#line 5413 "DataCollection.c"
	}
	result = source_collection_destroy_source (self, object, user);
#line 1084 "DataCollection.vala"
	return result;
#line 5418 "DataCollection.c"
}


#line 1087 "DataCollection.vala"
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 5424 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 1087 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1087 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1087 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1088 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1090 "DataCollection.vala"
	data_source_internal_mark_for_destroy (source);
#line 1091 "DataCollection.vala"
	data_source_destroy (source);
#line 1093 "DataCollection.vala"
	marker_mark (SOURCE_COLLECTION_DESTROY_COUNTER (user)->remove_marker, DATA_OBJECT (source));
#line 1094 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (SOURCE_COLLECTION_DESTROY_COUNTER (user)->notify_list), source);
#line 5443 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 1096 "DataCollection.vala"
	return result;
#line 5448 "DataCollection.c"
}


#line 533 "DataObject.vala"
static guint _source_backlink_hash_func_ghash_func (void* key) {
#line 5454 "DataCollection.c"
	guint result;
	result = source_backlink_hash_func (key);
	return result;
}


#line 539 "DataObject.vala"
static gboolean _source_backlink_equal_func_gequal_func (void* a, void* b) {
#line 5463 "DataCollection.c"
	gboolean result;
	result = source_backlink_equal_func (a, b);
	return result;
}


#line 1100 "DataCollection.vala"
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink) {
#line 1100 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1100 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1100 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1101 "DataCollection.vala"
	if (self->priv->backlinks == NULL) {
#line 5480 "DataCollection.c"
		GeeMultiMap* _tmp0_;
#line 1102 "DataCollection.vala"
		self->priv->backlinks = (_tmp0_ = GEE_MULTI_MAP (gee_hash_multi_map_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, source_backlink_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _source_backlink_hash_func_ghash_func, _source_backlink_equal_func_gequal_func, NULL, NULL)), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 5484 "DataCollection.c"
	}
#line 1106 "DataCollection.vala"
	gee_multi_map_set (self->priv->backlinks, backlink, source);
#line 5488 "DataCollection.c"
}


#line 1110 "DataCollection.vala"
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink) {
#line 5494 "DataCollection.c"
	gboolean removed;
#line 1110 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1110 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1110 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1111 "DataCollection.vala"
	g_assert (self->priv->backlinks != NULL);
#line 1113 "DataCollection.vala"
	removed = gee_multi_map_remove (self->priv->backlinks, backlink, source);
#line 1114 "DataCollection.vala"
	g_assert (removed);
#line 5508 "DataCollection.c"
}


#line 1117 "DataCollection.vala"
static gboolean source_collection_real_has_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 5514 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1117 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1117 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 1118 "DataCollection.vala"
	if (self->priv->backlinks != NULL) {
#line 1118 "DataCollection.vala"
		_tmp0_ = gee_multi_map_contains (self->priv->backlinks, backlink);
#line 5525 "DataCollection.c"
	} else {
#line 1118 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 5529 "DataCollection.c"
	}
	result = _tmp0_;
#line 1118 "DataCollection.vala"
	return result;
#line 5534 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1023 "DataCollection.vala"
	return SOURCE_COLLECTION_GET_CLASS (self)->has_backlink (self, backlink);
#line 5542 "DataCollection.c"
}


#line 1135 "DataCollection.vala"
static gboolean _source_collection_prepare_for_unlink_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5548 "DataCollection.c"
	gboolean result;
	result = source_collection_prepare_for_unlink (self, object, user);
	return result;
}


#line 1121 "DataCollection.vala"
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target) {
#line 5557 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeArrayList* list;
	Marker* _tmp0_;
#line 1121 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), NULL);
#line 1121 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), NULL);
#line 1122 "DataCollection.vala"
	list = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1123 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_prepare_for_unlink_marked_action, self, monitor, monitor_target, G_OBJECT (list));
#line 1125 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (list)) == 0) {
#line 5571 "DataCollection.c"
		result = NULL;
		_g_object_unref0 (list);
#line 1126 "DataCollection.vala"
		return result;
#line 5576 "DataCollection.c"
	}
#line 1128 "DataCollection.vala"
	source_collection_notify_items_unlinking (self, GEE_COLLECTION (list));
#line 1130 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), _tmp0_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (list)));
#line 5582 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
	result = GEE_COLLECTION (list);
#line 1132 "DataCollection.vala"
	return result;
#line 5587 "DataCollection.c"
}


#line 1135 "DataCollection.vala"
static gboolean source_collection_prepare_for_unlink (SourceCollection* self, DataObject* object, GObject* user) {
#line 5593 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 1135 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1135 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1135 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1136 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1138 "DataCollection.vala"
	data_source_notify_unlinking (source, self);
#line 1139 "DataCollection.vala"
	gee_collection_add (GEE_COLLECTION (GEE_LIST (user)), source);
#line 5608 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 1141 "DataCollection.vala"
	return result;
#line 5613 "DataCollection.c"
}


#line 1144 "DataCollection.vala"
void source_collection_relink (SourceCollection* self, DataSource* source) {
#line 5619 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1144 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1144 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1145 "DataCollection.vala"
	data_source_notify_relinking (source, self);
#line 1147 "DataCollection.vala"
	data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (source));
#line 1148 "DataCollection.vala"
	source_collection_notify_items_relinked (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (source))));
#line 5631 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1150 "DataCollection.vala"
	data_source_notify_relinked (source);
#line 5635 "DataCollection.c"
}


#line 1153 "DataCollection.vala"
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink) {
#line 5641 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1153 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1153 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relink));
#line 1154 "DataCollection.vala"
	if (gee_collection_get_size (relink) == 0) {
#line 1155 "DataCollection.vala"
		return;
#line 5651 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1157 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relink));
#line 1157 "DataCollection.vala"
		while (TRUE) {
#line 5659 "DataCollection.c"
			DataSource* source;
#line 1157 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1157 "DataCollection.vala"
				break;
#line 5665 "DataCollection.c"
			}
#line 1157 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1158 "DataCollection.vala"
			data_source_notify_relinking (source, self);
#line 5671 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1160 "DataCollection.vala"
	_tmp0_ = data_collection_add_many (DATA_COLLECTION (self), relink, NULL, NULL);
#line 5678 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1161 "DataCollection.vala"
	source_collection_notify_items_relinked (self, relink);
#line 5682 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1163 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relink));
#line 1163 "DataCollection.vala"
		while (TRUE) {
#line 5689 "DataCollection.c"
			DataSource* source;
#line 1163 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1163 "DataCollection.vala"
				break;
#line 5695 "DataCollection.c"
			}
#line 1163 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1164 "DataCollection.vala"
			data_source_notify_relinked (source);
#line 5701 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
}


#line 1167 "DataCollection.vala"
static void source_collection_real_remove_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 5711 "DataCollection.c"
	GeeArrayList* sources;
	GeeCollection* _tmp0_;
#line 1167 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1167 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1168 "DataCollection.vala"
	if (self->priv->backlinks == NULL) {
#line 1169 "DataCollection.vala"
		return;
#line 5722 "DataCollection.c"
	}
#line 1172 "DataCollection.vala"
	sources = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1173 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (sources), _tmp0_ = gee_multi_map_get (self->priv->backlinks, backlink));
#line 5728 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
	{
		GeeIterator* _source_it;
#line 1175 "DataCollection.vala"
		_source_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (sources));
#line 1175 "DataCollection.vala"
		while (TRUE) {
#line 5736 "DataCollection.c"
			DataSource* source;
#line 1175 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1175 "DataCollection.vala"
				break;
#line 5742 "DataCollection.c"
			}
#line 1175 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1176 "DataCollection.vala"
			data_source_remove_backlink (source, backlink);
#line 5748 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	_g_object_unref0 (sources);
}


#line 1023 "DataCollection.vala"
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1023 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->remove_backlink (self, backlink);
#line 5761 "DataCollection.c"
}


#line 998 "DataCollection.vala"
static void source_collection_real_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 998 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 998 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 5771 "DataCollection.c"
}


#line 1003 "DataCollection.vala"
static void source_collection_real_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1003 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1003 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 5781 "DataCollection.c"
}


#line 1008 "DataCollection.vala"
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1008 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1008 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5791 "DataCollection.c"
}


#line 1013 "DataCollection.vala"
static void source_collection_real_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1013 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1013 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 5801 "DataCollection.c"
}


#line 1018 "DataCollection.vala"
static void source_collection_real_unlinked_destroyed (SourceCollection* self, DataSource* source) {
#line 1018 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1018 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5811 "DataCollection.c"
}


#line 991 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker) {
#line 5817 "DataCollection.c"
	SourceCollectionDestroyCounter * self;
	Marker* _tmp0_;
#line 991 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (remove_marker), NULL);
#line 991 "DataCollection.vala"
	self = (SourceCollectionDestroyCounter*) g_object_new (object_type, NULL);
#line 992 "DataCollection.vala"
	self->remove_marker = (_tmp0_ = _g_object_ref0 (remove_marker), _g_object_unref0 (self->remove_marker), _tmp0_);
#line 5826 "DataCollection.c"
	return self;
}


#line 991 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker) {
#line 991 "DataCollection.vala"
	return source_collection_destroy_counter_construct (SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, remove_marker);
#line 5835 "DataCollection.c"
}


static void source_collection_destroy_counter_class_init (SourceCollectionDestroyCounterClass * klass) {
	source_collection_destroy_counter_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = source_collection_destroy_counter_finalize;
}


static void source_collection_destroy_counter_instance_init (SourceCollectionDestroyCounter * self) {
	self->notify_list = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->delete_failed = 0;
}


static void source_collection_destroy_counter_finalize (GObject* obj) {
	SourceCollectionDestroyCounter * self;
	self = SOURCE_COLLECTION_DESTROY_COUNTER (obj);
	_g_object_unref0 (self->remove_marker);
	_g_object_unref0 (self->notify_list);
	G_OBJECT_CLASS (source_collection_destroy_counter_parent_class)->finalize (obj);
}


static GType source_collection_destroy_counter_get_type (void) {
	static volatile gsize source_collection_destroy_counter_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_destroy_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionDestroyCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_destroy_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollectionDestroyCounter), 0, (GInstanceInitFunc) source_collection_destroy_counter_instance_init, NULL };
		GType source_collection_destroy_counter_type_id;
		source_collection_destroy_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "SourceCollectionDestroyCounter", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_destroy_counter_type_id__volatile, source_collection_destroy_counter_type_id);
	}
	return source_collection_destroy_counter_type_id__volatile;
}


static void source_collection_class_init (SourceCollectionClass * klass) {
	source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = source_collection_finalize;
	g_type_class_add_private (klass, sizeof (SourceCollectionPrivate));
	SOURCE_COLLECTION_CLASS (klass)->notify_items_unlinking = source_collection_real_notify_items_unlinking;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_relinked = source_collection_real_notify_items_relinked;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = source_collection_real_notify_item_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_destroyed = source_collection_real_notify_items_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->notify_unlinked_destroyed = source_collection_real_notify_unlinked_destroyed;
	DATA_COLLECTION_CLASS (klass)->valid_type = source_collection_real_valid_type;
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = source_collection_real_has_backlink;
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = source_collection_real_remove_backlink;
	SOURCE_COLLECTION_CLASS (klass)->items_unlinking = source_collection_real_items_unlinking;
	SOURCE_COLLECTION_CLASS (klass)->items_relinked = source_collection_real_items_relinked;
	SOURCE_COLLECTION_CLASS (klass)->item_destroyed = source_collection_real_item_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->items_destroyed = source_collection_real_items_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->unlinked_destroyed = source_collection_real_unlinked_destroyed;
	g_signal_new ("items_unlinking", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_unlinking), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_relinked", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_relinked), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, item_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("items_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("unlinked_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, unlinked_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
}


static void source_collection_instance_init (SourceCollection * self) {
	self->priv = SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->backlinks = NULL;
}


static void source_collection_finalize (DataCollection* obj) {
	SourceCollection * self;
	self = SOURCE_COLLECTION (obj);
	_g_object_unref0 (self->priv->backlinks);
	DATA_COLLECTION_CLASS (source_collection_parent_class)->finalize (obj);
}


GType source_collection_get_type (void) {
	static volatile gsize source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollection), 0, (GInstanceInitFunc) source_collection_instance_init, NULL };
		GType source_collection_type_id;
		source_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "SourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_type_id__volatile, source_collection_type_id);
	}
	return source_collection_type_id__volatile;
}


#line 7 "util.vala"
static guint _int64_hash_ghash_func (void* key) {
#line 5925 "DataCollection.c"
	guint result;
	result = int64_hash (key);
	return result;
}


#line 18 "util.vala"
static gboolean _int64_equal_gequal_func (void* a, void* b) {
#line 5934 "DataCollection.c"
	gboolean result;
	result = int64_equal (a, b);
	return result;
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


#line 1197 "DataCollection.vala"
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 5951 "DataCollection.c"
	DatabaseSourceCollection* self;
	GetSourceDatabaseKey _tmp0_;
#line 1197 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1198 "DataCollection.vala"
	self = (DatabaseSourceCollection*) source_collection_construct (object_type, name);
#line 1200 "DataCollection.vala"
	self->priv->source_key_func = (_tmp0_ = source_key_func, ((self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL), self->priv->source_key_func = NULL, self->priv->source_key_func_target = NULL, self->priv->source_key_func_target_destroy_notify = NULL), self->priv->source_key_func_target = source_key_func_target, self->priv->source_key_func_target_destroy_notify = NULL, _tmp0_);
#line 5960 "DataCollection.c"
	return self;
}


#line 1203 "DataCollection.vala"
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 5967 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 1203 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 5972 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1204 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 1204 "DataCollection.vala"
		while (TRUE) {
#line 5979 "DataCollection.c"
			DataObject* object;
			DataSource* source;
			gint64 key;
#line 1204 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1204 "DataCollection.vala"
				break;
#line 5987 "DataCollection.c"
			}
#line 1204 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1205 "DataCollection.vala"
			source = _g_object_ref0 (DATA_SOURCE (object));
#line 1206 "DataCollection.vala"
			key = self->priv->source_key_func (source, self->priv->source_key_func_target);
#line 1208 "DataCollection.vala"
			g_assert (!gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->map), &key));
#line 1210 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), &key, source);
#line 5999 "DataCollection.c"
			_g_object_unref0 (source);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1213 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_added (DATA_COLLECTION (SOURCE_COLLECTION (self)), added);
#line 6007 "DataCollection.c"
}


#line 1216 "DataCollection.vala"
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 6013 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 1216 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 6018 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1217 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 1217 "DataCollection.vala"
		while (TRUE) {
#line 6025 "DataCollection.c"
			DataObject* object;
			gint64 key;
			gboolean is_removed;
#line 1217 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1217 "DataCollection.vala"
				break;
#line 6033 "DataCollection.c"
			}
#line 1217 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1218 "DataCollection.vala"
			key = self->priv->source_key_func (DATA_SOURCE (object), self->priv->source_key_func_target);
#line 1220 "DataCollection.vala"
			is_removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), &key, NULL);
#line 1221 "DataCollection.vala"
			g_assert (is_removed);
#line 6043 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1224 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_removed (DATA_COLLECTION (SOURCE_COLLECTION (self)), removed);
#line 6050 "DataCollection.c"
}


#line 1227 "DataCollection.vala"
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key) {
#line 6056 "DataCollection.c"
	DataSource* result = NULL;
#line 1227 "DataCollection.vala"
	g_return_val_if_fail (IS_DATABASE_SOURCE_COLLECTION (self), NULL);
#line 6060 "DataCollection.c"
	result = (DataSource*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), &key);
#line 1228 "DataCollection.vala"
	return result;
#line 6064 "DataCollection.c"
}


static void database_source_collection_class_init (DatabaseSourceCollectionClass * klass) {
	database_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = database_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (DatabaseSourceCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->notify_items_added = database_source_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = database_source_collection_real_notify_items_removed;
}


static void database_source_collection_instance_init (DatabaseSourceCollection * self) {
	self->priv = DATABASE_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_hash_ghash_func, _int64_equal_gequal_func, g_direct_equal);
}


static void database_source_collection_finalize (DataCollection* obj) {
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (obj);
	(self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL);
	self->priv->source_key_func = NULL;
	self->priv->source_key_func_target = NULL;
	self->priv->source_key_func_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->map);
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->finalize (obj);
}


GType database_source_collection_get_type (void) {
	static volatile gsize database_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&database_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseSourceCollection), 0, (GInstanceInitFunc) database_source_collection_instance_init, NULL };
		GType database_source_collection_type_id;
		database_source_collection_type_id = g_type_register_static (TYPE_SOURCE_COLLECTION, "DatabaseSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_source_collection_type_id__volatile, database_source_collection_type_id);
	}
	return database_source_collection_type_id__volatile;
}


#line 1330 "DataCollection.vala"
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self) {
#line 6109 "DataCollection.c"
	container_source_collection_on_contained_sources_unlinking (self, unlinking);
}


#line 1353 "DataCollection.vala"
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self) {
#line 6116 "DataCollection.c"
	container_source_collection_on_contained_sources_relinked (self, relinked);
}


#line 1381 "DataCollection.vala"
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 6123 "DataCollection.c"
	container_source_collection_on_contained_source_destroyed (self, source);
}


#line 1381 "DataCollection.vala"
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 6130 "DataCollection.c"
	container_source_collection_on_contained_source_destroyed (self, source);
}


#line 1261 "DataCollection.vala"
ContainerSourceCollection* container_source_collection_construct (GType object_type, SourceCollection* contained_sources, const char* backlink_name, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 6137 "DataCollection.c"
	ContainerSourceCollection* self;
	SourceCollection* _tmp0_;
	char* _tmp1_;
#line 1261 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (contained_sources), NULL);
#line 1261 "DataCollection.vala"
	g_return_val_if_fail (backlink_name != NULL, NULL);
#line 1261 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1263 "DataCollection.vala"
	self = (ContainerSourceCollection*) database_source_collection_construct (object_type, name, source_key_func, source_key_func_target);
#line 1265 "DataCollection.vala"
	self->priv->contained_sources = (_tmp0_ = _data_collection_ref0 (contained_sources), _data_collection_unref0 (self->priv->contained_sources), _tmp0_);
#line 1266 "DataCollection.vala"
	self->priv->backlink_name = (_tmp1_ = g_strdup (backlink_name), _g_free0 (self->priv->backlink_name), _tmp1_);
#line 1268 "DataCollection.vala"
	g_signal_connect (contained_sources, "items-unlinking", (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 1269 "DataCollection.vala"
	g_signal_connect (contained_sources, "items-relinked", (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 1270 "DataCollection.vala"
	g_signal_connect (contained_sources, "item-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 1271 "DataCollection.vala"
	g_signal_connect (contained_sources, "unlinked-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 6161 "DataCollection.c"
	return self;
}


#line 1281 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added) {
#line 1281 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1281 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1281 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 1284 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container)) {
#line 6176 "DataCollection.c"
		gboolean removed;
#line 1285 "DataCollection.vala"
		removed = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
#line 1286 "DataCollection.vala"
		g_assert (removed);
#line 1288 "DataCollection.vala"
		source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (container));
#line 6184 "DataCollection.c"
	}
#line 1291 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-added", container, added);
#line 6188 "DataCollection.c"
}


#line 1261 "DataCollection.vala"
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added) {
#line 1261 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_added (self, container, added);
#line 6196 "DataCollection.c"
}


#line 1294 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed) {
#line 1294 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1294 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1294 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 1296 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-removed", container, removed);
#line 6210 "DataCollection.c"
}


#line 1261 "DataCollection.vala"
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed) {
#line 1261 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_removed (self, container, removed);
#line 6218 "DataCollection.c"
}


#line 1299 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed) {
#line 1299 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1299 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1299 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1299 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1301 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-altered", container, added, removed);
#line 6234 "DataCollection.c"
}


#line 1261 "DataCollection.vala"
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed) {
#line 1261 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_altered (self, container, added, removed);
#line 6242 "DataCollection.c"
}


#line 1304 "DataCollection.vala"
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 6248 "DataCollection.c"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_get_containers_holding_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1261 "DataCollection.vala"
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 1261 "DataCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->get_containers_holding_source (self, source);
#line 6259 "DataCollection.c"
}


#line 1307 "DataCollection.vala"
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 6265 "DataCollection.c"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_convert_backlink_to_container'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1261 "DataCollection.vala"
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 1261 "DataCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->convert_backlink_to_container (self, backlink);
#line 6276 "DataCollection.c"
}


#line 1309 "DataCollection.vala"
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self) {
#line 6282 "DataCollection.c"
	GeeCollection* result = NULL;
#line 1309 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
#line 6286 "DataCollection.c"
	result = GEE_COLLECTION (gee_abstract_set_get_read_only_view (GEE_ABSTRACT_SET (self->priv->holding_tank)));
#line 1310 "DataCollection.vala"
	return result;
#line 6290 "DataCollection.c"
}


#line 1313 "DataCollection.vala"
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked) {
#line 1313 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1313 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (unlinked));
#line 1314 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
#line 6302 "DataCollection.c"
}


#line 1317 "DataCollection.vala"
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked) {
#line 1317 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1317 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinked));
#line 1318 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
#line 6314 "DataCollection.c"
}


#line 1321 "DataCollection.vala"
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source) {
#line 6320 "DataCollection.c"
	gboolean result = FALSE;
#line 1321 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), FALSE);
#line 1321 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE (source), FALSE);
#line 1322 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), source)) {
#line 6328 "DataCollection.c"
		result = FALSE;
#line 1323 "DataCollection.vala"
		return result;
#line 6332 "DataCollection.c"
	}
#line 1325 "DataCollection.vala"
	source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (source));
#line 6336 "DataCollection.c"
	result = TRUE;
#line 1327 "DataCollection.vala"
	return result;
#line 6340 "DataCollection.c"
}


#line 1330 "DataCollection.vala"
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking) {
#line 6346 "DataCollection.c"
	GeeHashMultiMap* map;
#line 1330 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1330 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 1331 "DataCollection.vala"
	data_collection_freeze_notifications (DATA_COLLECTION (self->priv->contained_sources));
#line 1334 "DataCollection.vala"
	map = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 6356 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1336 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (unlinking));
#line 1336 "DataCollection.vala"
		while (TRUE) {
#line 6363 "DataCollection.c"
			DataSource* source;
			GeeCollection* containers;
			gboolean _tmp0_ = FALSE;
#line 1336 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1336 "DataCollection.vala"
				break;
#line 6371 "DataCollection.c"
			}
#line 1336 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1337 "DataCollection.vala"
			containers = container_source_collection_get_containers_holding_source (self, source);
#line 1338 "DataCollection.vala"
			if (containers == NULL) {
#line 1338 "DataCollection.vala"
				_tmp0_ = TRUE;
#line 6381 "DataCollection.c"
			} else {
#line 1338 "DataCollection.vala"
				_tmp0_ = gee_collection_get_size (containers) == 0;
#line 6385 "DataCollection.c"
			}
#line 1338 "DataCollection.vala"
			if (_tmp0_) {
#line 6389 "DataCollection.c"
				_g_object_unref0 (containers);
				_g_object_unref0 (source);
#line 1339 "DataCollection.vala"
				continue;
#line 6394 "DataCollection.c"
			}
			{
				GeeIterator* _container_it;
#line 1341 "DataCollection.vala"
				_container_it = gee_iterable_iterator (GEE_ITERABLE (containers));
#line 1341 "DataCollection.vala"
				while (TRUE) {
#line 6402 "DataCollection.c"
					ContainerSource* container;
					SourceBacklink* _tmp1_;
#line 1341 "DataCollection.vala"
					if (!gee_iterator_next (_container_it)) {
#line 1341 "DataCollection.vala"
						break;
#line 6409 "DataCollection.c"
					}
#line 1341 "DataCollection.vala"
					container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1342 "DataCollection.vala"
					gee_multi_map_set (GEE_MULTI_MAP (map), container, source);
#line 1343 "DataCollection.vala"
					data_source_set_backlink (source, _tmp1_ = container_source_get_backlink (container));
#line 6417 "DataCollection.c"
					_source_backlink_unref0 (_tmp1_);
					_g_object_unref0 (container);
				}
				_g_object_unref0 (_container_it);
			}
			_g_object_unref0 (containers);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	{
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _container_it;
#line 1347 "DataCollection.vala"
		_container_it = (_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map)))), _g_object_unref0 (_tmp2_), _tmp3_);
#line 1347 "DataCollection.vala"
		while (TRUE) {
#line 6436 "DataCollection.c"
			ContainerSource* container;
			GeeCollection* _tmp4_;
#line 1347 "DataCollection.vala"
			if (!gee_iterator_next (_container_it)) {
#line 1347 "DataCollection.vala"
				break;
#line 6443 "DataCollection.c"
			}
#line 1347 "DataCollection.vala"
			container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1348 "DataCollection.vala"
			container_source_break_link_many (container, _tmp4_ = gee_multi_map_get (GEE_MULTI_MAP (map), container));
#line 6449 "DataCollection.c"
			_g_object_unref0 (_tmp4_);
			_g_object_unref0 (container);
		}
		_g_object_unref0 (_container_it);
	}
#line 1350 "DataCollection.vala"
	data_collection_thaw_notifications (DATA_COLLECTION (self->priv->contained_sources));
#line 6457 "DataCollection.c"
	_g_object_unref0 (map);
}


#line 1353 "DataCollection.vala"
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked) {
#line 6464 "DataCollection.c"
	GeeHashMultiMap* map;
#line 1353 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1353 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 1354 "DataCollection.vala"
	data_collection_freeze_notifications (DATA_COLLECTION (self->priv->contained_sources));
#line 1357 "DataCollection.vala"
	map = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 6474 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1359 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relinked));
#line 1359 "DataCollection.vala"
		while (TRUE) {
#line 6481 "DataCollection.c"
			DataSource* source;
			GeeList* backlinks;
			gboolean _tmp0_ = FALSE;
#line 1359 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1359 "DataCollection.vala"
				break;
#line 6489 "DataCollection.c"
			}
#line 1359 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1360 "DataCollection.vala"
			backlinks = data_source_get_backlinks (source, self->priv->backlink_name);
#line 1361 "DataCollection.vala"
			if (backlinks == NULL) {
#line 1361 "DataCollection.vala"
				_tmp0_ = TRUE;
#line 6499 "DataCollection.c"
			} else {
#line 1361 "DataCollection.vala"
				_tmp0_ = gee_collection_get_size (GEE_COLLECTION (backlinks)) == 0;
#line 6503 "DataCollection.c"
			}
#line 1361 "DataCollection.vala"
			if (_tmp0_) {
#line 6507 "DataCollection.c"
				_g_object_unref0 (backlinks);
				_g_object_unref0 (source);
#line 1362 "DataCollection.vala"
				continue;
#line 6512 "DataCollection.c"
			}
			{
				GeeIterator* _backlink_it;
#line 1364 "DataCollection.vala"
				_backlink_it = gee_iterable_iterator (GEE_ITERABLE (backlinks));
#line 1364 "DataCollection.vala"
				while (TRUE) {
#line 6520 "DataCollection.c"
					SourceBacklink* backlink;
					ContainerSource* container;
#line 1364 "DataCollection.vala"
					if (!gee_iterator_next (_backlink_it)) {
#line 1364 "DataCollection.vala"
						break;
#line 6527 "DataCollection.c"
					}
#line 1364 "DataCollection.vala"
					backlink = (SourceBacklink*) gee_iterator_get (_backlink_it);
#line 1365 "DataCollection.vala"
					container = container_source_collection_convert_backlink_to_container (self, backlink);
#line 1366 "DataCollection.vala"
					if (container != NULL) {
#line 1367 "DataCollection.vala"
						gee_multi_map_set (GEE_MULTI_MAP (map), container, source);
#line 6537 "DataCollection.c"
					} else {
						char* _tmp1_;
						char* _tmp2_;
#line 1369 "DataCollection.vala"
						g_warning ("DataCollection.vala:1369: Unable to relink %s to container backlink %s", _tmp1_ = data_object_to_string (DATA_OBJECT (source)), _tmp2_ = source_backlink_to_string (backlink));
#line 6543 "DataCollection.c"
						_g_free0 (_tmp2_);
						_g_free0 (_tmp1_);
					}
					_g_object_unref0 (container);
					_source_backlink_unref0 (backlink);
				}
				_g_object_unref0 (_backlink_it);
			}
			_g_object_unref0 (backlinks);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	{
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _container_it;
#line 1375 "DataCollection.vala"
		_container_it = (_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map)))), _g_object_unref0 (_tmp3_), _tmp4_);
#line 1375 "DataCollection.vala"
		while (TRUE) {
#line 6565 "DataCollection.c"
			ContainerSource* container;
			GeeCollection* _tmp5_;
#line 1375 "DataCollection.vala"
			if (!gee_iterator_next (_container_it)) {
#line 1375 "DataCollection.vala"
				break;
#line 6572 "DataCollection.c"
			}
#line 1375 "DataCollection.vala"
			container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1376 "DataCollection.vala"
			container_source_establish_link_many (container, _tmp5_ = gee_multi_map_get (GEE_MULTI_MAP (map), container));
#line 6578 "DataCollection.c"
			_g_object_unref0 (_tmp5_);
			_g_object_unref0 (container);
		}
		_g_object_unref0 (_container_it);
	}
#line 1378 "DataCollection.vala"
	data_collection_thaw_notifications (DATA_COLLECTION (self->priv->contained_sources));
#line 6586 "DataCollection.c"
	_g_object_unref0 (map);
}


#line 1381 "DataCollection.vala"
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source) {
#line 6593 "DataCollection.c"
	GeeIterator* iter;
#line 1381 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1381 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1382 "DataCollection.vala"
	iter = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank));
#line 1383 "DataCollection.vala"
	while (TRUE) {
#line 6603 "DataCollection.c"
		ContainerSource* container;
#line 1383 "DataCollection.vala"
		if (!gee_iterator_next (iter)) {
#line 1383 "DataCollection.vala"
			break;
#line 6609 "DataCollection.c"
		}
#line 1384 "DataCollection.vala"
		container = (ContainerSource*) gee_iterator_get (iter);
#line 1385 "DataCollection.vala"
		if (!container_source_has_links (container)) {
#line 1386 "DataCollection.vala"
			gee_iterator_remove (iter);
#line 1387 "DataCollection.vala"
			data_source_destroy_orphan (DATA_SOURCE (container), TRUE);
#line 6619 "DataCollection.c"
		}
		_g_object_unref0 (container);
	}
	_g_object_unref0 (iter);
}


#line 1392 "DataCollection.vala"
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source) {
#line 6629 "DataCollection.c"
	ContainerSourceCollection * self;
	SourceBacklink* _tmp0_;
	self = CONTAINER_SOURCE_COLLECTION (base);
#line 1392 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1393 "DataCollection.vala"
	source_collection_remove_backlink (self->priv->contained_sources, _tmp0_ = container_source_get_backlink (CONTAINER_SOURCE (source)));
#line 6637 "DataCollection.c"
	_source_backlink_unref0 (_tmp0_);
#line 1395 "DataCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_item_destroyed (SOURCE_COLLECTION (DATABASE_SOURCE_COLLECTION (self)), source);
#line 6641 "DataCollection.c"
}


#line 1402 "DataCollection.vala"
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container) {
#line 6647 "DataCollection.c"
	SourceBacklink* _tmp0_;
	gboolean _tmp1_;
#line 1402 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1402 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1403 "DataCollection.vala"
	if ((_tmp1_ = source_collection_has_backlink (self->priv->contained_sources, _tmp0_ = container_source_get_backlink (container)), _source_backlink_unref0 (_tmp0_), _tmp1_)) {
#line 6656 "DataCollection.c"
		Marker* _tmp2_;
		GeeCollection* _tmp3_;
		gboolean added;
#line 1404 "DataCollection.vala"
		_tmp3_ = source_collection_unlink_marked (SOURCE_COLLECTION (self), _tmp2_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container)), NULL, NULL);
#line 6662 "DataCollection.c"
		_g_object_unref0 (_tmp3_);
		_g_object_unref0 (_tmp2_);
#line 1405 "DataCollection.vala"
		added = gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
#line 1406 "DataCollection.vala"
		g_assert (added);
#line 6669 "DataCollection.c"
	} else {
		Marker* _tmp4_;
#line 1408 "DataCollection.vala"
		source_collection_destroy_marked (SOURCE_COLLECTION (self), _tmp4_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container)), TRUE, NULL, NULL);
#line 6674 "DataCollection.c"
		_g_object_unref0 (_tmp4_);
	}
}


#line 1249 "DataCollection.vala"
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added) {
#line 1249 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1249 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1249 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 6688 "DataCollection.c"
}


#line 1253 "DataCollection.vala"
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed) {
#line 1253 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1253 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1253 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 6700 "DataCollection.c"
}


#line 1257 "DataCollection.vala"
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed) {
#line 1257 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1257 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1257 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1257 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 6714 "DataCollection.c"
}


static void container_source_collection_class_init (ContainerSourceCollectionClass * klass) {
	container_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = container_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (ContainerSourceCollectionPrivate));
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_added = container_source_collection_real_notify_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_removed = container_source_collection_real_notify_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_altered = container_source_collection_real_notify_container_contents_altered;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->get_containers_holding_source = container_source_collection_real_get_containers_holding_source;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->convert_backlink_to_container = container_source_collection_real_convert_backlink_to_container;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = container_source_collection_real_notify_item_destroyed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_added = container_source_collection_real_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_removed = container_source_collection_real_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_altered = container_source_collection_real_container_contents_altered;
	g_signal_new ("container_contents_added", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_added), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
	g_signal_new ("container_contents_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
	g_signal_new ("container_contents_altered", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
}


static void container_source_collection_instance_init (ContainerSourceCollection * self) {
	self->priv = CONTAINER_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->holding_tank = gee_hash_set_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
}


static void container_source_collection_finalize (DataCollection* obj) {
	ContainerSourceCollection * self;
	self = CONTAINER_SOURCE_COLLECTION (obj);
	{
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 1275 "DataCollection.vala"
		g_signal_parse_name ("items-unlinking", TYPE_SOURCE_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1275 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 1276 "DataCollection.vala"
		g_signal_parse_name ("items-relinked", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1276 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 1277 "DataCollection.vala"
		g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1277 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 1278 "DataCollection.vala"
		g_signal_parse_name ("unlinked-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 1278 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 6767 "DataCollection.c"
	}
	_data_collection_unref0 (self->priv->contained_sources);
	_g_free0 (self->priv->backlink_name);
	_g_object_unref0 (self->priv->holding_tank);
	DATA_COLLECTION_CLASS (container_source_collection_parent_class)->finalize (obj);
}


GType container_source_collection_get_type (void) {
	static volatile gsize container_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContainerSourceCollection), 0, (GInstanceInitFunc) container_source_collection_instance_init, NULL };
		GType container_source_collection_type_id;
		container_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "ContainerSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&container_source_collection_type_id__volatile, container_source_collection_type_id);
	}
	return container_source_collection_type_id__volatile;
}


#line 1559 "DataCollection.vala"
static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 6790 "DataCollection.c"
	source_holding_tank_on_source_destroyed (self, source);
}


#line 1592 "DataCollection.vala"
static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
#line 6797 "DataCollection.c"
	source_holding_tank_on_source_collection_thawed (self);
}


#line 1445 "DataCollection.vala"
SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
#line 6804 "DataCollection.c"
	SourceHoldingTank* self;
	SourceCollection* _tmp0_;
	SourceHoldingTankCheckToKeep _tmp1_;
#line 1445 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 6810 "DataCollection.c"
	self = (SourceHoldingTank*) g_type_create_instance (object_type);
#line 1446 "DataCollection.vala"
	self->priv->sources = (_tmp0_ = _data_collection_ref0 (sources), _data_collection_unref0 (self->priv->sources), _tmp0_);
#line 1447 "DataCollection.vala"
	self->priv->check_to_keep = (_tmp1_ = check_to_keep, ((self->priv->check_to_keep_target_destroy_notify == NULL) ? NULL : (self->priv->check_to_keep_target_destroy_notify (self->priv->check_to_keep_target), NULL), self->priv->check_to_keep = NULL, self->priv->check_to_keep_target = NULL, self->priv->check_to_keep_target_destroy_notify = NULL), self->priv->check_to_keep_target = check_to_keep_target, self->priv->check_to_keep_target_destroy_notify = NULL, _tmp1_);
#line 1449 "DataCollection.vala"
	g_signal_connect (self->priv->sources, "item-destroyed", (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
#line 1450 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->sources), "thawed", (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
#line 6820 "DataCollection.c"
	return self;
}


#line 1445 "DataCollection.vala"
SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
#line 1445 "DataCollection.vala"
	return source_holding_tank_construct (TYPE_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target);
#line 6829 "DataCollection.c"
}


#line 1569 "DataCollection.vala"
static void _source_holding_tank_on_held_source_altered_data_object_altered (DataObject* _sender, Alteration* alteration, gpointer self) {
#line 6835 "DataCollection.c"
	source_holding_tank_on_held_source_altered (self, _sender, alteration);
}


#line 1461 "DataCollection.vala"
static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 1461 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1461 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1461 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1463 "DataCollection.vala"
	if (added != NULL) {
#line 6850 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1464 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (added));
#line 1464 "DataCollection.vala"
			while (TRUE) {
#line 6857 "DataCollection.c"
				DataSource* source;
#line 1464 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1464 "DataCollection.vala"
					break;
#line 6863 "DataCollection.c"
				}
#line 1464 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1465 "DataCollection.vala"
				g_signal_connect (DATA_OBJECT (source), "altered", (GCallback) _source_holding_tank_on_held_source_altered_data_object_altered, self);
#line 6869 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1468 "DataCollection.vala"
	if (removed != NULL) {
#line 6877 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1469 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (removed));
#line 1469 "DataCollection.vala"
			while (TRUE) {
#line 6884 "DataCollection.c"
				DataSource* source;
				guint _tmp0_;
#line 1469 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1469 "DataCollection.vala"
					break;
#line 6891 "DataCollection.c"
				}
#line 1469 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1470 "DataCollection.vala"
				g_signal_parse_name ("altered", TYPE_DATA_OBJECT, &_tmp0_, NULL, FALSE);
#line 1470 "DataCollection.vala"
				g_signal_handlers_disconnect_matched (DATA_OBJECT (source), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_holding_tank_on_held_source_altered_data_object_altered, self);
#line 6899 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1473 "DataCollection.vala"
	g_signal_emit_by_name (self, "contents-altered", added, removed);
#line 6907 "DataCollection.c"
}


#line 1445 "DataCollection.vala"
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 1445 "DataCollection.vala"
	SOURCE_HOLDING_TANK_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 6915 "DataCollection.c"
}


#line 1476 "DataCollection.vala"
gint source_holding_tank_get_count (SourceHoldingTank* self) {
#line 6921 "DataCollection.c"
	gint result = 0;
#line 1476 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), 0);
#line 6925 "DataCollection.c"
	result = data_set_get_count (self->priv->tank);
#line 1477 "DataCollection.vala"
	return result;
#line 6929 "DataCollection.c"
}


#line 1480 "DataCollection.vala"
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self) {
#line 6935 "DataCollection.c"
	GeeCollection* result = NULL;
#line 1480 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), NULL);
#line 6939 "DataCollection.c"
	result = GEE_COLLECTION (data_set_get_all (self->priv->tank));
#line 1481 "DataCollection.vala"
	return result;
#line 6943 "DataCollection.c"
}


#line 1484 "DataCollection.vala"
gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source) {
#line 6949 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1484 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), FALSE);
#line 1484 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1485 "DataCollection.vala"
	if (data_set_contains (self->priv->tank, DATA_OBJECT (source))) {
#line 1485 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 6960 "DataCollection.c"
	} else {
#line 1485 "DataCollection.vala"
		_tmp0_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), source);
#line 6964 "DataCollection.c"
	}
	result = _tmp0_;
#line 1485 "DataCollection.vala"
	return result;
#line 6969 "DataCollection.c"
}


#line 1489 "DataCollection.vala"
void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many) {
#line 6975 "DataCollection.c"
	gboolean added;
#line 1489 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1489 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (many));
#line 1490 "DataCollection.vala"
	if (gee_collection_get_size (many) == 0) {
#line 1491 "DataCollection.vala"
		return;
#line 6985 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1493 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (many));
#line 1493 "DataCollection.vala"
		while (TRUE) {
#line 6993 "DataCollection.c"
			DataSource* source;
#line 1493 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1493 "DataCollection.vala"
				break;
#line 6999 "DataCollection.c"
			}
#line 1493 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1494 "DataCollection.vala"
			data_object_internal_set_ordinal (DATA_OBJECT (source), self->priv->ordinal++);
#line 7005 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1496 "DataCollection.vala"
	added = data_set_add_many (self->priv->tank, many);
#line 1497 "DataCollection.vala"
	g_assert (added);
#line 1499 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, many, NULL);
#line 7016 "DataCollection.c"
}


#line 1504 "DataCollection.vala"
void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink) {
#line 7022 "DataCollection.c"
	Marker* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean added;
#line 1504 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1504 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlink));
#line 1505 "DataCollection.vala"
	if (gee_collection_get_size (unlink) == 0) {
#line 1506 "DataCollection.vala"
		return;
#line 7034 "DataCollection.c"
	}
#line 1509 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), unlink);
#line 1511 "DataCollection.vala"
	_tmp1_ = source_collection_unlink_marked (self->priv->sources, _tmp0_ = data_collection_mark_many (DATA_COLLECTION (self->priv->sources), unlink), NULL, NULL);
#line 7040 "DataCollection.c"
	_g_object_unref0 (_tmp1_);
	_g_object_unref0 (_tmp0_);
	{
		GeeIterator* _source_it;
#line 1513 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (unlink));
#line 1513 "DataCollection.vala"
		while (TRUE) {
#line 7049 "DataCollection.c"
			DataSource* source;
#line 1513 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1513 "DataCollection.vala"
				break;
#line 7055 "DataCollection.c"
			}
#line 1513 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1514 "DataCollection.vala"
			data_object_internal_set_ordinal (DATA_OBJECT (source), self->priv->ordinal++);
#line 7061 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1516 "DataCollection.vala"
	added = data_set_add_many (self->priv->tank, unlink);
#line 1517 "DataCollection.vala"
	g_assert (added);
#line 1520 "DataCollection.vala"
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), unlink);
#line 1522 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, unlink, NULL);
#line 7074 "DataCollection.c"
}


#line 1525 "DataCollection.vala"
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
#line 7080 "DataCollection.c"
	gboolean result = FALSE;
	gint count;
#line 1525 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), FALSE);
#line 1525 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 1526 "DataCollection.vala"
	count = data_set_get_count (self->priv->tank);
#line 7089 "DataCollection.c"
	{
		gint ctr;
#line 1527 "DataCollection.vala"
		ctr = 0;
#line 7094 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1527 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1527 "DataCollection.vala"
			while (TRUE) {
#line 7101 "DataCollection.c"
				DataSource* _tmp1_;
				gboolean _tmp2_;
#line 1527 "DataCollection.vala"
				if (!_tmp0_) {
#line 1527 "DataCollection.vala"
					ctr++;
#line 7108 "DataCollection.c"
				}
#line 1527 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1527 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1527 "DataCollection.vala"
					break;
#line 7116 "DataCollection.c"
				}
#line 1528 "DataCollection.vala"
				if ((_tmp2_ = data_source_has_backlink (_tmp1_ = DATA_SOURCE (data_set_get_at (self->priv->tank, ctr)), backlink), _g_object_unref0 (_tmp1_), _tmp2_)) {
#line 7120 "DataCollection.c"
					result = TRUE;
#line 1529 "DataCollection.vala"
					return result;
#line 7124 "DataCollection.c"
				}
			}
		}
	}
	result = FALSE;
#line 1532 "DataCollection.vala"
	return result;
#line 7132 "DataCollection.c"
}


#line 1535 "DataCollection.vala"
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
#line 7138 "DataCollection.c"
	gint count;
#line 1535 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1535 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1536 "DataCollection.vala"
	count = data_set_get_count (self->priv->tank);
#line 7146 "DataCollection.c"
	{
		gint ctr;
#line 1537 "DataCollection.vala"
		ctr = 0;
#line 7151 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1537 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1537 "DataCollection.vala"
			while (TRUE) {
#line 7158 "DataCollection.c"
				DataSource* _tmp1_;
#line 1537 "DataCollection.vala"
				if (!_tmp0_) {
#line 1537 "DataCollection.vala"
					ctr++;
#line 7164 "DataCollection.c"
				}
#line 1537 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1537 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1537 "DataCollection.vala"
					break;
#line 7172 "DataCollection.c"
				}
#line 1538 "DataCollection.vala"
				data_source_remove_backlink (_tmp1_ = DATA_SOURCE (data_set_get_at (self->priv->tank, ctr)), backlink);
#line 7176 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
			}
		}
	}
}


#line 1541 "DataCollection.vala"
void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target) {
#line 7186 "DataCollection.c"
	gboolean removed;
	gint count;
#line 1541 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1541 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (destroy));
#line 1543 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (destroy)) == 0) {
#line 1544 "DataCollection.vala"
		return;
#line 7197 "DataCollection.c"
	}
#line 1546 "DataCollection.vala"
	removed = data_set_remove_many (self->priv->tank, destroy);
#line 1547 "DataCollection.vala"
	g_assert (removed);
#line 1549 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (destroy));
#line 1551 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (destroy));
#line 7207 "DataCollection.c"
	{
		gint ctr;
#line 1552 "DataCollection.vala"
		ctr = 0;
#line 7212 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1552 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1552 "DataCollection.vala"
			while (TRUE) {
#line 7219 "DataCollection.c"
				DataSource* _tmp1_;
#line 1552 "DataCollection.vala"
				if (!_tmp0_) {
#line 1552 "DataCollection.vala"
					ctr++;
#line 7225 "DataCollection.c"
				}
#line 1552 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1552 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1552 "DataCollection.vala"
					break;
#line 7233 "DataCollection.c"
				}
#line 1553 "DataCollection.vala"
				data_source_destroy_orphan (_tmp1_ = (DataSource*) gee_list_get (destroy, ctr), delete_backing);
#line 7237 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
#line 1554 "DataCollection.vala"
				if (monitor != NULL) {
#line 1555 "DataCollection.vala"
					monitor ((guint64) (ctr + 1), (guint64) count, monitor_target);
#line 7243 "DataCollection.c"
				}
			}
		}
	}
}


#line 1559 "DataCollection.vala"
static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source) {
#line 7253 "DataCollection.c"
	gboolean removed;
	SingletonCollection* _tmp0_;
#line 1559 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1559 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1560 "DataCollection.vala"
	if (!data_set_contains (self->priv->tank, DATA_OBJECT (source))) {
#line 1561 "DataCollection.vala"
		return;
#line 7264 "DataCollection.c"
	}
#line 1563 "DataCollection.vala"
	removed = data_set_remove (self->priv->tank, DATA_OBJECT (source));
#line 1564 "DataCollection.vala"
	g_assert (removed);
#line 1566 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (_tmp0_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, source)));
#line 7272 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
}


#line 1569 "DataCollection.vala"
static void source_holding_tank_on_held_source_altered (SourceHoldingTank* self, DataObject* object, Alteration* alteration) {
#line 7279 "DataCollection.c"
	DataSource* source;
	gboolean removed;
	SingletonCollection* _tmp0_;
#line 1569 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1569 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1569 "DataCollection.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 1570 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1572 "DataCollection.vala"
	g_assert (data_set_contains (self->priv->tank, DATA_OBJECT (source)));
#line 1575 "DataCollection.vala"
	if (self->priv->check_to_keep (source, alteration, self->priv->check_to_keep_target)) {
#line 7295 "DataCollection.c"
		_g_object_unref0 (source);
#line 1576 "DataCollection.vala"
		return;
#line 7299 "DataCollection.c"
	}
#line 1578 "DataCollection.vala"
	removed = data_set_remove (self->priv->tank, DATA_OBJECT (source));
#line 1579 "DataCollection.vala"
	g_assert (removed);
#line 1581 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (DATA_COLLECTION (self->priv->sources))) {
#line 1582 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->relinks), source);
#line 7309 "DataCollection.c"
		_g_object_unref0 (source);
#line 1584 "DataCollection.vala"
		return;
#line 7313 "DataCollection.c"
	}
#line 1587 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (_tmp0_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, source)));
#line 7317 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1589 "DataCollection.vala"
	source_collection_relink (self->priv->sources, source);
#line 7321 "DataCollection.c"
	_g_object_unref0 (source);
}


#line 1592 "DataCollection.vala"
static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self) {
#line 7328 "DataCollection.c"
	GeeHashSet* copy;
	GeeHashSet* _tmp0_;
#line 1592 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1593 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (self->priv->relinks)) == 0) {
#line 1594 "DataCollection.vala"
		return;
#line 7337 "DataCollection.c"
	}
#line 1597 "DataCollection.vala"
	copy = _g_object_ref0 (self->priv->relinks);
#line 1598 "DataCollection.vala"
	self->priv->relinks = (_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->relinks), _tmp0_);
#line 1600 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (copy));
#line 1602 "DataCollection.vala"
	source_collection_relink_many (self->priv->sources, GEE_COLLECTION (copy));
#line 7347 "DataCollection.c"
	_g_object_unref0 (copy);
}


#line 1441 "DataCollection.vala"
static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 1441 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1441 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1441 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 7360 "DataCollection.c"
}


static void value_source_holding_tank_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_holding_tank_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_holding_tank_unref (value->data[0].v_pointer);
	}
}


static void value_source_holding_tank_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_holding_tank_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_holding_tank_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_holding_tank_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceHoldingTank* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_holding_tank_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_holding_tank_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceHoldingTank** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_holding_tank_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceHoldingTank* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_HOLDING_TANK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_holding_tank (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_holding_tank_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_holding_tank_unref (old);
	}
}


void value_take_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_holding_tank_unref (old);
	}
}


static void source_holding_tank_class_init (SourceHoldingTankClass * klass) {
	source_holding_tank_parent_class = g_type_class_peek_parent (klass);
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = source_holding_tank_finalize;
	g_type_class_add_private (klass, sizeof (SourceHoldingTankPrivate));
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = source_holding_tank_real_notify_contents_altered;
	SOURCE_HOLDING_TANK_CLASS (klass)->contents_altered = source_holding_tank_real_contents_altered;
	g_signal_new ("contents_altered", TYPE_SOURCE_HOLDING_TANK, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceHoldingTankClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
}


static void source_holding_tank_instance_init (SourceHoldingTank * self) {
	self->priv = SOURCE_HOLDING_TANK_GET_PRIVATE (self);
	self->priv->tank = data_set_new ();
	self->priv->relinks = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->unlinking = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->ordinal = (gint64) 0;
	self->ref_count = 1;
}


static void source_holding_tank_finalize (SourceHoldingTank* obj) {
	SourceHoldingTank * self;
	self = SOURCE_HOLDING_TANK (obj);
	{
		guint _tmp0_;
		guint _tmp1_;
#line 1454 "DataCollection.vala"
		g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1454 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
#line 1455 "DataCollection.vala"
		g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1455 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
#line 7508 "DataCollection.c"
		{
			GeeCollection* _tmp2_;
			GeeIterator* _tmp3_;
			GeeIterator* _object_it;
#line 1457 "DataCollection.vala"
			_object_it = (_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_ = data_set_get_all (self->priv->tank))), _g_object_unref0 (_tmp2_), _tmp3_);
#line 1457 "DataCollection.vala"
			while (TRUE) {
#line 7517 "DataCollection.c"
				DataObject* object;
				guint _tmp4_;
#line 1457 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 1457 "DataCollection.vala"
					break;
#line 7524 "DataCollection.c"
				}
#line 1457 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 1458 "DataCollection.vala"
				g_signal_parse_name ("altered", TYPE_DATA_OBJECT, &_tmp4_, NULL, FALSE);
#line 1458 "DataCollection.vala"
				g_signal_handlers_disconnect_matched (DATA_OBJECT (DATA_SOURCE (object)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _source_holding_tank_on_held_source_altered_data_object_altered, self);
#line 7532 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
	_data_collection_unref0 (self->priv->sources);
	(self->priv->check_to_keep_target_destroy_notify == NULL) ? NULL : (self->priv->check_to_keep_target_destroy_notify (self->priv->check_to_keep_target), NULL);
	self->priv->check_to_keep = NULL;
	self->priv->check_to_keep_target = NULL;
	self->priv->check_to_keep_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->tank);
	_g_object_unref0 (self->priv->relinks);
	_g_object_unref0 (self->priv->unlinking);
}


GType source_holding_tank_get_type (void) {
	static volatile gsize source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&source_holding_tank_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_holding_tank_init, value_source_holding_tank_free_value, value_source_holding_tank_copy_value, value_source_holding_tank_peek_pointer, "p", value_source_holding_tank_collect_value, "p", value_source_holding_tank_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceHoldingTank), 0, (GInstanceInitFunc) source_holding_tank_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_holding_tank_type_id;
		source_holding_tank_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceHoldingTank", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_holding_tank_type_id__volatile, source_holding_tank_type_id);
	}
	return source_holding_tank_type_id__volatile;
}


gpointer source_holding_tank_ref (gpointer instance) {
	SourceHoldingTank* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_holding_tank_unref (gpointer instance) {
	SourceHoldingTank* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_HOLDING_TANK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1611 "DataCollection.vala"
DatabaseSourceHoldingTank* database_source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 7583 "DataCollection.c"
	DatabaseSourceHoldingTank* self;
	GetSourceDatabaseKey _tmp0_;
#line 1611 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 1613 "DataCollection.vala"
	self = (DatabaseSourceHoldingTank*) source_holding_tank_construct (object_type, sources, check_to_keep, check_to_keep_target);
#line 1615 "DataCollection.vala"
	self->priv->get_key = (_tmp0_ = get_key, ((self->priv->get_key_target_destroy_notify == NULL) ? NULL : (self->priv->get_key_target_destroy_notify (self->priv->get_key_target), NULL), self->priv->get_key = NULL, self->priv->get_key_target = NULL, self->priv->get_key_target_destroy_notify = NULL), self->priv->get_key_target = get_key_target, self->priv->get_key_target_destroy_notify = NULL, _tmp0_);
#line 7592 "DataCollection.c"
	return self;
}


#line 1611 "DataCollection.vala"
DatabaseSourceHoldingTank* database_source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 1611 "DataCollection.vala"
	return database_source_holding_tank_construct (TYPE_DATABASE_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 7601 "DataCollection.c"
}


#line 1618 "DataCollection.vala"
DataSource* database_source_holding_tank_get_by_id (DatabaseSourceHoldingTank* self, gint64 id) {
#line 7607 "DataCollection.c"
	DataSource* result = NULL;
#line 1618 "DataCollection.vala"
	g_return_val_if_fail (IS_DATABASE_SOURCE_HOLDING_TANK (self), NULL);
#line 7611 "DataCollection.c"
	result = (DataSource*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), &id);
#line 1619 "DataCollection.vala"
	return result;
#line 7615 "DataCollection.c"
}


#line 1622 "DataCollection.vala"
static void database_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed) {
#line 7621 "DataCollection.c"
	DatabaseSourceHoldingTank * self;
	self = DATABASE_SOURCE_HOLDING_TANK (base);
#line 1622 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1622 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1624 "DataCollection.vala"
	if (added != NULL) {
#line 7630 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1625 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (added));
#line 1625 "DataCollection.vala"
			while (TRUE) {
#line 7637 "DataCollection.c"
				DataSource* source;
				gint64 _tmp0_;
#line 1625 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1625 "DataCollection.vala"
					break;
#line 7644 "DataCollection.c"
				}
#line 1625 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1626 "DataCollection.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), (_tmp0_ = self->priv->get_key (source, self->priv->get_key_target), &_tmp0_), source);
#line 7650 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1629 "DataCollection.vala"
	if (removed != NULL) {
#line 7658 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1630 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (removed));
#line 1630 "DataCollection.vala"
			while (TRUE) {
#line 7665 "DataCollection.c"
				DataSource* source;
				gint64 _tmp1_;
#line 1630 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1630 "DataCollection.vala"
					break;
#line 7672 "DataCollection.c"
				}
#line 1630 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1631 "DataCollection.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), (_tmp1_ = self->priv->get_key (source, self->priv->get_key_target), &_tmp1_), NULL);
#line 7678 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1634 "DataCollection.vala"
	SOURCE_HOLDING_TANK_CLASS (database_source_holding_tank_parent_class)->notify_contents_altered (SOURCE_HOLDING_TANK (self), added, removed);
#line 7686 "DataCollection.c"
}


static void database_source_holding_tank_class_init (DatabaseSourceHoldingTankClass * klass) {
	database_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = database_source_holding_tank_finalize;
	g_type_class_add_private (klass, sizeof (DatabaseSourceHoldingTankPrivate));
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = database_source_holding_tank_real_notify_contents_altered;
}


static void database_source_holding_tank_instance_init (DatabaseSourceHoldingTank * self) {
	self->priv = DATABASE_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_hash_ghash_func, _int64_equal_gequal_func, NULL);
}


static void database_source_holding_tank_finalize (SourceHoldingTank* obj) {
	DatabaseSourceHoldingTank * self;
	self = DATABASE_SOURCE_HOLDING_TANK (obj);
	(self->priv->get_key_target_destroy_notify == NULL) ? NULL : (self->priv->get_key_target_destroy_notify (self->priv->get_key_target), NULL);
	self->priv->get_key = NULL;
	self->priv->get_key_target = NULL;
	self->priv->get_key_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->map);
	SOURCE_HOLDING_TANK_CLASS (database_source_holding_tank_parent_class)->finalize (obj);
}


GType database_source_holding_tank_get_type (void) {
	static volatile gsize database_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&database_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseSourceHoldingTank), 0, (GInstanceInitFunc) database_source_holding_tank_instance_init, NULL };
		GType database_source_holding_tank_type_id;
		database_source_holding_tank_type_id = g_type_register_static (TYPE_SOURCE_HOLDING_TANK, "DatabaseSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&database_source_holding_tank_type_id__volatile, database_source_holding_tank_type_id);
	}
	return database_source_holding_tank_type_id__volatile;
}


#line 1648 "DataCollection.vala"
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
#line 7730 "DataCollection.c"
	gboolean result = FALSE;
#line 1648 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 1648 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 7736 "DataCollection.c"
	result = TRUE;
#line 1649 "DataCollection.vala"
	return result;
#line 7740 "DataCollection.c"
}


#line 1611 "DataCollection.vala"
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
#line 1611 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 7748 "DataCollection.c"
}


#line 1654 "DataCollection.vala"
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
#line 7754 "DataCollection.c"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1611 "DataCollection.vala"
DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
#line 1611 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 7765 "DataCollection.c"
}


#line 1644 "DataCollection.vala"
ViewManager* view_manager_construct (GType object_type) {
#line 7771 "DataCollection.c"
	ViewManager* self;
	self = (ViewManager*) g_type_create_instance (object_type);
	return self;
}


static void value_view_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_view_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_manager_unref (value->data[0].v_pointer);
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_view_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
	view_manager_parent_class = g_type_class_peek_parent (klass);
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
}


static void view_manager_instance_init (ViewManager * self) {
	self->ref_count = 1;
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
	self = VIEW_MANAGER (obj);
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1754 "DataCollection.vala"
ViewCollection* view_collection_construct (GType object_type, const char* name) {
#line 7941 "DataCollection.c"
	ViewCollection* self;
#line 1754 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1755 "DataCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 7947 "DataCollection.c"
	return self;
}


#line 1754 "DataCollection.vala"
ViewCollection* view_collection_new (const char* name) {
#line 1754 "DataCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 7956 "DataCollection.c"
}


#line 1758 "DataCollection.vala"
static void view_collection_real_notify_items_selected (ViewCollection* self, GeeIterable* views) {
#line 1758 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1758 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (views));
#line 1759 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-selected", views);
#line 1760 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-state-changed", views);
#line 1762 "DataCollection.vala"
	view_collection_notify_selection_group_altered (self);
#line 7972 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_items_selected (ViewCollection* self, GeeIterable* views) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected (self, views);
#line 7980 "DataCollection.c"
}


#line 1765 "DataCollection.vala"
static void view_collection_real_notify_items_unselected (ViewCollection* self, GeeIterable* views) {
#line 1765 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1765 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (views));
#line 1766 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-unselected", views);
#line 1767 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-state-changed", views);
#line 1769 "DataCollection.vala"
	view_collection_notify_selection_group_altered (self);
#line 7996 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_items_unselected (ViewCollection* self, GeeIterable* views) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_unselected (self, views);
#line 8004 "DataCollection.c"
}


#line 1772 "DataCollection.vala"
static void view_collection_real_notify_selection_group_altered (ViewCollection* self) {
#line 1772 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1773 "DataCollection.vala"
	g_signal_emit_by_name (self, "selection-group-altered");
#line 8014 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_selection_group_altered (ViewCollection* self) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
#line 8022 "DataCollection.c"
}


#line 1776 "DataCollection.vala"
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1776 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1776 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1777 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-view-altered", view);
#line 8034 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 8042 "DataCollection.c"
}


#line 1780 "DataCollection.vala"
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1780 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1780 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1781 "DataCollection.vala"
	g_signal_emit_by_name (self, "views-altered", views);
#line 8054 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 8062 "DataCollection.c"
}


#line 1784 "DataCollection.vala"
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1784 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1784 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1785 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-geometry-altered", view);
#line 8074 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 8082 "DataCollection.c"
}


#line 1788 "DataCollection.vala"
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1788 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1788 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1789 "DataCollection.vala"
	g_signal_emit_by_name (self, "geometries-altered", views);
#line 8094 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 8102 "DataCollection.c"
}


#line 1792 "DataCollection.vala"
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
#line 1792 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1792 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (shown));
#line 1793 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-shown", shown);
#line 8114 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_shown (self, shown);
#line 8122 "DataCollection.c"
}


#line 1796 "DataCollection.vala"
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 1796 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1796 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 1797 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-hidden", hidden);
#line 8134 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_hidden (self, hidden);
#line 8142 "DataCollection.c"
}


#line 1800 "DataCollection.vala"
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 1800 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1800 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 1801 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-visibility-changed", changed);
#line 8154 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 1754 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_visibility_changed (self, changed);
#line 8162 "DataCollection.c"
}


#line 1804 "DataCollection.vala"
static void view_collection_real_clear (DataCollection* base) {
#line 8168 "DataCollection.c"
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	self = VIEW_COLLECTION (base);
#line 1807 "DataCollection.vala"
	if (self->priv->sources != NULL) {
#line 1807 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 8176 "DataCollection.c"
	} else {
#line 1807 "DataCollection.vala"
		_tmp0_ = self->priv->mirroring != NULL;
#line 8180 "DataCollection.c"
	}
#line 1807 "DataCollection.vala"
	if (_tmp0_) {
#line 8184 "DataCollection.c"
		char* _tmp1_;
#line 1808 "DataCollection.vala"
		g_warning ("DataCollection.vala:1808: Cannot clear %s: monitoring or mirroring in " \
"effect", _tmp1_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 8188 "DataCollection.c"
		_g_free0 (_tmp1_);
#line 1810 "DataCollection.vala"
		return;
#line 8192 "DataCollection.c"
	}
#line 1814 "DataCollection.vala"
	g_assert (self->priv->view_lock_count == 0);
#line 1816 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (DATA_COLLECTION (self));
#line 8198 "DataCollection.c"
}


#line 1819 "DataCollection.vala"
static void view_collection_real_close (DataCollection* base) {
#line 8204 "DataCollection.c"
	ViewCollection * self;
	ViewFilter _tmp0_;
	self = VIEW_COLLECTION (base);
#line 1820 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1821 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1822 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1824 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (DATA_COLLECTION (self));
#line 8216 "DataCollection.c"
}


static gpointer _view_manager_ref0 (gpointer self) {
	return self ? view_manager_ref (self) : NULL;
}


#line 1933 "DataCollection.vala"
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 8227 "DataCollection.c"
	view_collection_on_sources_added (self, added);
}


#line 1994 "DataCollection.vala"
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 8234 "DataCollection.c"
	view_collection_on_sources_removed (self, removed);
}


#line 2013 "DataCollection.vala"
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 8241 "DataCollection.c"
	view_collection_on_sources_altered (self, items);
}


#line 1827 "DataCollection.vala"
void view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* alteration, GeeIterable* initial, ProgressMonitor monitor, void* monitor_target) {
#line 8248 "DataCollection.c"
	SourceCollection* _tmp0_;
	ViewManager* _tmp1_;
	Alteration* _tmp2_;
#line 1827 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1827 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1827 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_MANAGER (manager));
#line 1827 "DataCollection.vala"
	g_return_if_fail ((alteration == NULL) || IS_ALTERATION (alteration));
#line 1827 "DataCollection.vala"
	g_return_if_fail ((initial == NULL) || GEE_IS_ITERABLE (initial));
#line 1829 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1830 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1831 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1833 "DataCollection.vala"
	self->priv->sources = (_tmp0_ = _data_collection_ref0 (sources), _data_collection_unref0 (self->priv->sources), _tmp0_);
#line 1834 "DataCollection.vala"
	self->priv->manager = (_tmp1_ = _view_manager_ref0 (manager), _view_manager_unref0 (self->priv->manager), _tmp1_);
#line 1835 "DataCollection.vala"
	self->priv->sources_alteration = (_tmp2_ = _alteration_ref0 (alteration), _alteration_unref0 (self->priv->sources_alteration), _tmp2_);
#line 1837 "DataCollection.vala"
	if (initial != NULL) {
#line 8276 "DataCollection.c"
		GeeArrayList* created_views;
		GeeCollection* _tmp4_;
#line 1839 "DataCollection.vala"
		created_views = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 8281 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1840 "DataCollection.vala"
			_source_it = gee_iterable_iterator (initial);
#line 1840 "DataCollection.vala"
			while (TRUE) {
#line 8288 "DataCollection.c"
				DataSource* source;
				DataView* _tmp3_;
#line 1840 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1840 "DataCollection.vala"
					break;
#line 8295 "DataCollection.c"
				}
#line 1840 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1841 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), _tmp3_ = view_manager_create_view (manager, source));
#line 8301 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
#line 1843 "DataCollection.vala"
		_tmp4_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), monitor, monitor_target);
#line 8309 "DataCollection.c"
		_g_object_unref0 (_tmp4_);
		_g_object_unref0 (created_views);
	} else {
		GeeIterable* _tmp5_;
#line 1846 "DataCollection.vala"
		view_collection_add_sources (self, _tmp5_ = GEE_ITERABLE (data_collection_get_all (DATA_COLLECTION (sources))), monitor, monitor_target);
#line 8316 "DataCollection.c"
		_g_object_unref0 (_tmp5_);
	}
#line 1851 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, self);
#line 1852 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self);
#line 1853 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, self);
#line 8325 "DataCollection.c"
}


#line 1856 "DataCollection.vala"
void view_collection_halt_monitoring (ViewCollection* self) {
#line 8331 "DataCollection.c"
	SourceCollection* _tmp3_;
	ViewManager* _tmp4_;
	Alteration* _tmp5_;
#line 1856 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1857 "DataCollection.vala"
	if (self->priv->sources != NULL) {
#line 8339 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
#line 1858 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1858 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, self);
#line 1859 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1859 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self);
#line 1860 "DataCollection.vala"
		g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1860 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, self);
#line 8355 "DataCollection.c"
	}
#line 1863 "DataCollection.vala"
	self->priv->sources = (_tmp3_ = NULL, _data_collection_unref0 (self->priv->sources), _tmp3_);
#line 1864 "DataCollection.vala"
	self->priv->manager = (_tmp4_ = NULL, _view_manager_unref0 (self->priv->manager), _tmp4_);
#line 1865 "DataCollection.vala"
	self->priv->sources_alteration = (_tmp5_ = NULL, _alteration_unref0 (self->priv->sources_alteration), _tmp5_);
#line 8363 "DataCollection.c"
}


#line 2060 "DataCollection.vala"
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 8369 "DataCollection.c"
	view_collection_on_mirror_contents_added (self, added);
}


#line 2072 "DataCollection.vala"
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 8376 "DataCollection.c"
	view_collection_on_mirror_contents_removed (self, removed);
}


#line 1868 "DataCollection.vala"
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target) {
#line 8383 "DataCollection.c"
	ViewCollection* _tmp0_;
	CreateView _tmp1_;
	GeeCollection* _tmp2_;
#line 1868 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1868 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 1869 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1870 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1871 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1873 "DataCollection.vala"
	self->priv->mirroring = (_tmp0_ = _data_collection_ref0 (to_mirror), _data_collection_unref0 (self->priv->mirroring), _tmp0_);
#line 1874 "DataCollection.vala"
	self->priv->mirroring_ctor = (_tmp1_ = mirroring_ctor, ((self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL), self->priv->mirroring_ctor = NULL, self->priv->mirroring_ctor_target = NULL, self->priv->mirroring_ctor_target_destroy_notify = NULL), self->priv->mirroring_ctor_target = mirroring_ctor_target, self->priv->mirroring_ctor_target_destroy_notify = NULL, _tmp1_);
#line 1877 "DataCollection.vala"
	view_collection_on_mirror_contents_added (self, GEE_ITERABLE (_tmp2_ = data_collection_get_all (DATA_COLLECTION (self->priv->mirroring))));
#line 8403 "DataCollection.c"
	_g_object_unref0 (_tmp2_);
#line 1879 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1880 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 8409 "DataCollection.c"
}


#line 1883 "DataCollection.vala"
void view_collection_halt_mirroring (ViewCollection* self) {
#line 8415 "DataCollection.c"
	ViewCollection* _tmp2_;
#line 1883 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1884 "DataCollection.vala"
	if (self->priv->mirroring != NULL) {
#line 8421 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
#line 1885 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1885 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1886 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1886 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 8432 "DataCollection.c"
	}
#line 1889 "DataCollection.vala"
	self->priv->mirroring = (_tmp2_ = NULL, _data_collection_unref0 (self->priv->mirroring), _tmp2_);
#line 8436 "DataCollection.c"
}


#line 1892 "DataCollection.vala"
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target) {
#line 8442 "DataCollection.c"
	ViewFilter _tmp0_;
#line 1892 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1893 "DataCollection.vala"
	if (self->priv->filter == filter) {
#line 1894 "DataCollection.vala"
		return;
#line 8450 "DataCollection.c"
	}
#line 1897 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = filter, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = filter_target, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1900 "DataCollection.vala"
	view_collection_reapply_view_filter (self);
#line 8456 "DataCollection.c"
}


#line 1905 "DataCollection.vala"
void view_collection_reapply_view_filter (ViewCollection* self) {
#line 8462 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1905 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1906 "DataCollection.vala"
	view_collection_filter_altered_items (self, _tmp0_ = GEE_COLLECTION (DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self))));
#line 8468 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
}


#line 1909 "DataCollection.vala"
void view_collection_reset_view_filter (ViewCollection* self) {
#line 8475 "DataCollection.c"
	ViewFilter _tmp0_;
	GeeArrayList* to_show;
#line 1909 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1910 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1914 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 8484 "DataCollection.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _object_it;
#line 1915 "DataCollection.vala"
		_object_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 1915 "DataCollection.vala"
		while (TRUE) {
#line 8493 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1915 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1915 "DataCollection.vala"
				break;
#line 8500 "DataCollection.c"
			}
#line 1915 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1916 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1917 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1918 "DataCollection.vala"
				g_assert (view_collection_is_visible (self, view));
#line 8510 "DataCollection.c"
				_g_object_unref0 (view);
				_g_object_unref0 (object);
#line 1920 "DataCollection.vala"
				continue;
#line 8515 "DataCollection.c"
			}
#line 1923 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 8519 "DataCollection.c"
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1926 "DataCollection.vala"
	view_collection_show_items (self, GEE_LIST (to_show));
#line 8527 "DataCollection.c"
	_g_object_unref0 (to_show);
}


#line 1929 "DataCollection.vala"
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 8534 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 1929 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 8540 "DataCollection.c"
	result = IS_DATA_VIEW (object);
#line 1930 "DataCollection.vala"
	return result;
#line 8544 "DataCollection.c"
}


#line 1933 "DataCollection.vala"
static void view_collection_on_sources_added (ViewCollection* self, GeeIterable* added) {
#line 1933 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1933 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1934 "DataCollection.vala"
	view_collection_add_sources (self, added, NULL, NULL);
#line 8556 "DataCollection.c"
}


#line 1937 "DataCollection.vala"
static void view_collection_add_sources (ViewCollection* self, GeeIterable* added, ProgressMonitor monitor, void* monitor_target) {
#line 8562 "DataCollection.c"
	DataView* created_view;
	GeeArrayList* created_views;
#line 1937 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1937 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1940 "DataCollection.vala"
	created_view = NULL;
#line 1941 "DataCollection.vala"
	created_views = NULL;
#line 8573 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1942 "DataCollection.vala"
		_source_it = gee_iterable_iterator (added);
#line 1942 "DataCollection.vala"
		while (TRUE) {
#line 8580 "DataCollection.c"
			DataSource* source;
#line 1942 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1942 "DataCollection.vala"
				break;
#line 8586 "DataCollection.c"
			}
#line 1942 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1943 "DataCollection.vala"
			if (view_manager_include_in_view (self->priv->manager, source)) {
#line 8592 "DataCollection.c"
				DataView* new_view;
#line 1944 "DataCollection.vala"
				new_view = view_manager_create_view (self->priv->manager, source);
#line 1948 "DataCollection.vala"
				if (created_views != NULL) {
#line 1949 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
#line 8600 "DataCollection.c"
				} else {
#line 1950 "DataCollection.vala"
					if (created_view == NULL) {
#line 8604 "DataCollection.c"
						DataView* _tmp0_;
#line 1951 "DataCollection.vala"
						created_view = (_tmp0_ = _g_object_ref0 (new_view), _g_object_unref0 (created_view), _tmp0_);
#line 8608 "DataCollection.c"
					} else {
						GeeArrayList* _tmp1_;
						DataView* _tmp2_;
#line 1953 "DataCollection.vala"
						created_views = (_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (created_views), _tmp1_);
#line 1954 "DataCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), created_view);
#line 1955 "DataCollection.vala"
						created_view = (_tmp2_ = NULL, _g_object_unref0 (created_view), _tmp2_);
#line 1956 "DataCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
#line 8620 "DataCollection.c"
					}
				}
				_g_object_unref0 (new_view);
			}
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1961 "DataCollection.vala"
	if (created_view != NULL) {
#line 1962 "DataCollection.vala"
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (created_view));
#line 8633 "DataCollection.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 1963 "DataCollection.vala"
		if (created_views != NULL) {
#line 1963 "DataCollection.vala"
			_tmp3_ = gee_collection_get_size (GEE_COLLECTION (created_views)) > 0;
#line 8640 "DataCollection.c"
		} else {
#line 1963 "DataCollection.vala"
			_tmp3_ = FALSE;
#line 8644 "DataCollection.c"
		}
#line 1963 "DataCollection.vala"
		if (_tmp3_) {
#line 8648 "DataCollection.c"
			GeeCollection* _tmp4_;
#line 1964 "DataCollection.vala"
			_tmp4_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), monitor, monitor_target);
#line 8652 "DataCollection.c"
			_g_object_unref0 (_tmp4_);
		}
	}
	_g_object_unref0 (created_views);
	_g_object_unref0 (created_view);
}


#line 1967 "DataCollection.vala"
static gboolean view_collection_real_add (DataCollection* base, DataObject* object) {
#line 8663 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	DataView* view;
	GeeCollection* views;
	self = VIEW_COLLECTION (base);
#line 1967 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1968 "DataCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->add (DATA_COLLECTION (self), object)) {
#line 8673 "DataCollection.c"
		result = FALSE;
#line 1969 "DataCollection.vala"
		return result;
#line 8677 "DataCollection.c"
	}
#line 1971 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 1972 "DataCollection.vala"
	views = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view)));
#line 1974 "DataCollection.vala"
	data_view_internal_set_visible (view, TRUE);
#line 1975 "DataCollection.vala"
	view_collection_add_many_visible (self, views);
#line 1976 "DataCollection.vala"
	view_collection_filter_altered_items (self, views);
#line 8689 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (views);
	_g_object_unref0 (view);
#line 1978 "DataCollection.vala"
	return result;
#line 8695 "DataCollection.c"
}


#line 1981 "DataCollection.vala"
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 8701 "DataCollection.c"
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* return_list;
	self = VIEW_COLLECTION (base);
#line 1981 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 1983 "DataCollection.vala"
	return_list = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (DATA_COLLECTION (self), objects, monitor, monitor_target);
#line 8710 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1985 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (return_list));
#line 1985 "DataCollection.vala"
		while (TRUE) {
#line 8717 "DataCollection.c"
			DataObject* object;
#line 1985 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1985 "DataCollection.vala"
				break;
#line 8723 "DataCollection.c"
			}
#line 1985 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1986 "DataCollection.vala"
			data_view_internal_set_visible (DATA_VIEW (object), TRUE);
#line 8729 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1988 "DataCollection.vala"
	view_collection_add_many_visible (self, GEE_COLLECTION (return_list));
#line 1989 "DataCollection.vala"
	view_collection_filter_altered_items (self, GEE_COLLECTION (return_list));
#line 8738 "DataCollection.c"
	result = return_list;
#line 1991 "DataCollection.vala"
	return result;
#line 8742 "DataCollection.c"
}


#line 1994 "DataCollection.vala"
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
#line 8748 "DataCollection.c"
	Marker* marker;
	gboolean _tmp1_ = FALSE;
#line 1994 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1994 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 1996 "DataCollection.vala"
	marker = NULL;
#line 8757 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1997 "DataCollection.vala"
		_source_it = gee_iterable_iterator (removed);
#line 1997 "DataCollection.vala"
		while (TRUE) {
#line 8764 "DataCollection.c"
			DataSource* source;
			DataView* view;
#line 1997 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1997 "DataCollection.vala"
				break;
#line 8771 "DataCollection.c"
			}
#line 1997 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1998 "DataCollection.vala"
			view = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2001 "DataCollection.vala"
			if (view != NULL) {
#line 2002 "DataCollection.vala"
				if (marker == NULL) {
#line 8781 "DataCollection.c"
					Marker* _tmp0_;
#line 2003 "DataCollection.vala"
					marker = (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self)), _g_object_unref0 (marker), _tmp0_);
#line 8785 "DataCollection.c"
				}
#line 2005 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 8789 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 2009 "DataCollection.vala"
	if (marker != NULL) {
#line 2009 "DataCollection.vala"
		_tmp1_ = marker_get_count (marker) != 0;
#line 8800 "DataCollection.c"
	} else {
#line 2009 "DataCollection.vala"
		_tmp1_ = FALSE;
#line 8804 "DataCollection.c"
	}
#line 2009 "DataCollection.vala"
	if (_tmp1_) {
#line 2010 "DataCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 8810 "DataCollection.c"
	}
	_g_object_unref0 (marker);
}


#line 2013 "DataCollection.vala"
static void view_collection_on_sources_altered (ViewCollection* self, GeeMap* items) {
#line 8818 "DataCollection.c"
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
	gboolean ordering_changed;
#line 2013 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2013 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 2016 "DataCollection.vala"
	to_add = NULL;
#line 2017 "DataCollection.vala"
	to_remove = NULL;
#line 2018 "DataCollection.vala"
	ordering_changed = FALSE;
#line 8832 "DataCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 2019 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (items))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2019 "DataCollection.vala"
		while (TRUE) {
#line 8841 "DataCollection.c"
			DataObject* object;
			Alteration* alteration;
			gboolean _tmp2_ = FALSE;
			DataSource* source;
			gboolean include;
			gboolean _tmp3_ = FALSE;
#line 2019 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2019 "DataCollection.vala"
				break;
#line 8852 "DataCollection.c"
			}
#line 2019 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2020 "DataCollection.vala"
			alteration = (Alteration*) gee_map_get (items, object);
#line 2021 "DataCollection.vala"
			if (self->priv->sources_alteration != NULL) {
#line 2021 "DataCollection.vala"
				_tmp2_ = !alteration_contains_any (alteration, self->priv->sources_alteration);
#line 8862 "DataCollection.c"
			} else {
#line 2021 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 8866 "DataCollection.c"
			}
#line 2021 "DataCollection.vala"
			if (_tmp2_) {
#line 8870 "DataCollection.c"
				_alteration_unref0 (alteration);
				_g_object_unref0 (object);
#line 2022 "DataCollection.vala"
				continue;
#line 8875 "DataCollection.c"
			}
#line 2024 "DataCollection.vala"
			source = _g_object_ref0 (DATA_SOURCE (object));
#line 2026 "DataCollection.vala"
			include = view_manager_include_in_view (self->priv->manager, source);
#line 2027 "DataCollection.vala"
			if (include) {
#line 2027 "DataCollection.vala"
				_tmp3_ = !view_collection_has_view_for_source (self, source);
#line 8885 "DataCollection.c"
			} else {
#line 2027 "DataCollection.vala"
				_tmp3_ = FALSE;
#line 8889 "DataCollection.c"
			}
#line 2027 "DataCollection.vala"
			if (_tmp3_) {
#line 8893 "DataCollection.c"
				DataView* _tmp5_;
#line 2028 "DataCollection.vala"
				if (to_add == NULL) {
#line 8897 "DataCollection.c"
					GeeArrayList* _tmp4_;
#line 2029 "DataCollection.vala"
					to_add = (_tmp4_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_add), _tmp4_);
#line 8901 "DataCollection.c"
				}
#line 2031 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp5_ = view_manager_create_view (self->priv->manager, source));
#line 8905 "DataCollection.c"
				_g_object_unref0 (_tmp5_);
			} else {
				gboolean _tmp6_ = FALSE;
#line 2032 "DataCollection.vala"
				if (!include) {
#line 2032 "DataCollection.vala"
					_tmp6_ = view_collection_has_view_for_source (self, source);
#line 8913 "DataCollection.c"
				} else {
#line 2032 "DataCollection.vala"
					_tmp6_ = FALSE;
#line 8917 "DataCollection.c"
				}
#line 2032 "DataCollection.vala"
				if (_tmp6_) {
#line 8921 "DataCollection.c"
					DataView* _tmp8_;
#line 2033 "DataCollection.vala"
					if (to_remove == NULL) {
#line 8925 "DataCollection.c"
						GeeArrayList* _tmp7_;
#line 2034 "DataCollection.vala"
						to_remove = (_tmp7_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_remove), _tmp7_);
#line 8929 "DataCollection.c"
					}
#line 2036 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_remove), _tmp8_ = view_collection_get_view_for_source (self, source));
#line 8933 "DataCollection.c"
					_g_object_unref0 (_tmp8_);
				} else {
					gboolean _tmp9_ = FALSE;
#line 2037 "DataCollection.vala"
					if (include) {
#line 2037 "DataCollection.vala"
						_tmp9_ = view_collection_has_view_for_source (self, source);
#line 8941 "DataCollection.c"
					} else {
#line 2037 "DataCollection.vala"
						_tmp9_ = FALSE;
#line 8945 "DataCollection.c"
					}
#line 2037 "DataCollection.vala"
					if (_tmp9_) {
#line 8949 "DataCollection.c"
						DataView* view;
						gboolean _tmp10_ = FALSE;
#line 2038 "DataCollection.vala"
						view = view_collection_get_view_for_source (self, source);
#line 2040 "DataCollection.vala"
						if (data_set_contains (self->priv->selected, DATA_OBJECT (view))) {
#line 2041 "DataCollection.vala"
							data_set_resort_object (self->priv->selected, DATA_OBJECT (view), alteration);
#line 8958 "DataCollection.c"
						}
#line 2043 "DataCollection.vala"
						if (self->priv->visible != NULL) {
#line 2043 "DataCollection.vala"
							_tmp10_ = view_collection_is_visible (self, view);
#line 8964 "DataCollection.c"
						} else {
#line 2043 "DataCollection.vala"
							_tmp10_ = FALSE;
#line 8968 "DataCollection.c"
						}
#line 2043 "DataCollection.vala"
						if (_tmp10_) {
#line 2044 "DataCollection.vala"
							if (data_set_resort_object (self->priv->visible, DATA_OBJECT (view), alteration)) {
#line 2045 "DataCollection.vala"
								ordering_changed = TRUE;
#line 8976 "DataCollection.c"
							}
						}
						_g_object_unref0 (view);
					}
				}
			}
			_g_object_unref0 (source);
			_alteration_unref0 (alteration);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2050 "DataCollection.vala"
	if (to_add != NULL) {
#line 8991 "DataCollection.c"
		GeeCollection* _tmp11_;
#line 2051 "DataCollection.vala"
		_tmp11_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
#line 8995 "DataCollection.c"
		_g_object_unref0 (_tmp11_);
	}
#line 2053 "DataCollection.vala"
	if (to_remove != NULL) {
#line 9000 "DataCollection.c"
		Marker* _tmp12_;
#line 2054 "DataCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), _tmp12_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (to_remove)));
#line 9004 "DataCollection.c"
		_g_object_unref0 (_tmp12_);
	}
#line 2056 "DataCollection.vala"
	if (ordering_changed) {
#line 2057 "DataCollection.vala"
		data_collection_notify_ordering_changed (DATA_COLLECTION (self));
#line 9011 "DataCollection.c"
	}
	_g_object_unref0 (to_remove);
	_g_object_unref0 (to_add);
}


#line 2060 "DataCollection.vala"
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
#line 9020 "DataCollection.c"
	GeeArrayList* to_add;
#line 2060 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2060 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 2061 "DataCollection.vala"
	to_add = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 9028 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2062 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 2062 "DataCollection.vala"
		while (TRUE) {
#line 9035 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			DataView* _tmp1_;
#line 2062 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2062 "DataCollection.vala"
				break;
#line 9044 "DataCollection.c"
			}
#line 2062 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2063 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2065 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp1_ = self->priv->mirroring_ctor (_tmp0_ = data_view_get_source (view), self->priv->mirroring_ctor_target));
#line 9052 "DataCollection.c"
			_g_object_unref0 (_tmp1_);
			_g_object_unref0 (_tmp0_);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2068 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_add)) > 0) {
#line 9062 "DataCollection.c"
		GeeCollection* _tmp2_;
#line 2069 "DataCollection.vala"
		_tmp2_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
#line 9066 "DataCollection.c"
		_g_object_unref0 (_tmp2_);
	}
	_g_object_unref0 (to_add);
}


#line 2072 "DataCollection.vala"
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
#line 9075 "DataCollection.c"
	Marker* marker;
#line 2072 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2072 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 2073 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 9083 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2074 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 2074 "DataCollection.vala"
		while (TRUE) {
#line 9090 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			DataView* _tmp1_;
			DataView* our_view;
#line 2074 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2074 "DataCollection.vala"
				break;
#line 9100 "DataCollection.c"
			}
#line 2074 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2075 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2077 "DataCollection.vala"
			our_view = (_tmp1_ = view_collection_get_view_for_source (self, _tmp0_ = data_view_get_source (view)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2078 "DataCollection.vala"
			marker_mark (marker, DATA_OBJECT (our_view));
#line 9110 "DataCollection.c"
			_g_object_unref0 (our_view);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2081 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 9119 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2085 "DataCollection.vala"
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 9126 "DataCollection.c"
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	self = VIEW_COLLECTION (base);
#line 2085 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 2086 "DataCollection.vala"
	added_visible = NULL;
#line 2087 "DataCollection.vala"
	added_selected = NULL;
#line 9137 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2089 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 2089 "DataCollection.vala"
		while (TRUE) {
#line 9144 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
#line 2089 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2089 "DataCollection.vala"
				break;
#line 9152 "DataCollection.c"
			}
#line 2089 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2090 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2091 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), view);
#line 9160 "DataCollection.c"
			_g_object_unref0 (_tmp0_);
#line 2093 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 2094 "DataCollection.vala"
				if (added_selected == NULL) {
#line 9166 "DataCollection.c"
					GeeArrayList* _tmp1_;
#line 2095 "DataCollection.vala"
					added_selected = (_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (added_selected), _tmp1_);
#line 9170 "DataCollection.c"
				}
#line 2097 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 9174 "DataCollection.c"
			}
#line 2100 "DataCollection.vala"
			if (self->priv->filter != NULL) {
#line 2101 "DataCollection.vala"
				data_view_internal_set_visible (view, self->priv->filter (view, self->priv->filter_target));
#line 9180 "DataCollection.c"
			}
#line 2103 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 2104 "DataCollection.vala"
				if (added_visible == NULL) {
#line 9186 "DataCollection.c"
					GeeArrayList* _tmp2_;
#line 2105 "DataCollection.vala"
					added_visible = (_tmp2_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (added_visible), _tmp2_);
#line 9190 "DataCollection.c"
				}
#line 2107 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_visible), view);
#line 9194 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2111 "DataCollection.vala"
	if (added_visible != NULL) {
#line 9203 "DataCollection.c"
		gboolean is_added;
#line 2112 "DataCollection.vala"
		is_added = view_collection_add_many_visible (self, GEE_COLLECTION (added_visible));
#line 2113 "DataCollection.vala"
		g_assert (is_added);
#line 9209 "DataCollection.c"
	}
#line 2116 "DataCollection.vala"
	if (added_selected != NULL) {
#line 9213 "DataCollection.c"
		gboolean is_added;
#line 2117 "DataCollection.vala"
		is_added = data_set_add_many (self->priv->selected, GEE_COLLECTION (added_selected));
#line 2118 "DataCollection.vala"
		g_assert (is_added);
#line 2120 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (added_selected));
#line 9221 "DataCollection.c"
	}
#line 2123 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (DATA_COLLECTION (self), added);
#line 9225 "DataCollection.c"
	_g_object_unref0 (added_selected);
	_g_object_unref0 (added_visible);
}


#line 2127 "DataCollection.vala"
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 9233 "DataCollection.c"
	ViewCollection * self;
	gboolean selected_removed;
	self = VIEW_COLLECTION (base);
#line 2127 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 2128 "DataCollection.vala"
	selected_removed = FALSE;
#line 9241 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2129 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 2129 "DataCollection.vala"
		while (TRUE) {
#line 9248 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			gboolean _tmp1_;
			gboolean is_removed;
			gboolean _tmp2_ = FALSE;
#line 2129 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2129 "DataCollection.vala"
				break;
#line 9259 "DataCollection.c"
			}
#line 2129 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2130 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2132 "DataCollection.vala"
			is_removed = (_tmp1_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), NULL), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2133 "DataCollection.vala"
			g_assert (is_removed);
#line 2135 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 2136 "DataCollection.vala"
				view_collection_remove_selected (self, view);
#line 2137 "DataCollection.vala"
				selected_removed = TRUE;
#line 9275 "DataCollection.c"
			}
#line 2140 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 2140 "DataCollection.vala"
				_tmp2_ = self->priv->visible != NULL;
#line 9281 "DataCollection.c"
			} else {
#line 2140 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 9285 "DataCollection.c"
			}
#line 2140 "DataCollection.vala"
			if (_tmp2_) {
#line 2141 "DataCollection.vala"
				is_removed = data_set_remove (self->priv->visible, DATA_OBJECT (view));
#line 2142 "DataCollection.vala"
				g_assert (is_removed);
#line 9293 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2149 "DataCollection.vala"
	if (selected_removed) {
#line 2150 "DataCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 9304 "DataCollection.c"
	}
#line 2152 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (DATA_COLLECTION (self), removed);
#line 9308 "DataCollection.c"
}


#line 2155 "DataCollection.vala"
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views) {
#line 9314 "DataCollection.c"
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
#line 2155 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2155 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 2156 "DataCollection.vala"
	if (self->priv->filter == NULL) {
#line 2157 "DataCollection.vala"
		return;
#line 9325 "DataCollection.c"
	}
#line 2161 "DataCollection.vala"
	to_show = NULL;
#line 2162 "DataCollection.vala"
	to_hide = NULL;
#line 9331 "DataCollection.c"
	{
		GeeIterator* _view_it;
#line 2164 "DataCollection.vala"
		_view_it = gee_iterable_iterator (GEE_ITERABLE (views));
#line 2164 "DataCollection.vala"
		while (TRUE) {
#line 9338 "DataCollection.c"
			DataView* view;
#line 2164 "DataCollection.vala"
			if (!gee_iterator_next (_view_it)) {
#line 2164 "DataCollection.vala"
				break;
#line 9344 "DataCollection.c"
			}
#line 2164 "DataCollection.vala"
			view = (DataView*) gee_iterator_get (_view_it);
#line 2165 "DataCollection.vala"
			if (self->priv->filter (view, self->priv->filter_target)) {
#line 9350 "DataCollection.c"
				gboolean _tmp0_ = FALSE;
#line 2166 "DataCollection.vala"
				if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view)) {
#line 2166 "DataCollection.vala"
					_tmp0_ = TRUE;
#line 9356 "DataCollection.c"
				} else {
#line 2166 "DataCollection.vala"
					_tmp0_ = !data_view_is_visible (view);
#line 9360 "DataCollection.c"
				}
#line 2166 "DataCollection.vala"
				if (_tmp0_) {
#line 2167 "DataCollection.vala"
					if (to_show == NULL) {
#line 9366 "DataCollection.c"
						GeeArrayList* _tmp1_;
#line 2168 "DataCollection.vala"
						to_show = (_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_show), _tmp1_);
#line 9370 "DataCollection.c"
					}
#line 2170 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 9374 "DataCollection.c"
				}
			} else {
				gboolean _tmp2_ = FALSE;
#line 2173 "DataCollection.vala"
				if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view)) {
#line 2173 "DataCollection.vala"
					_tmp2_ = TRUE;
#line 9382 "DataCollection.c"
				} else {
#line 2173 "DataCollection.vala"
					_tmp2_ = data_view_is_visible (view);
#line 9386 "DataCollection.c"
				}
#line 2173 "DataCollection.vala"
				if (_tmp2_) {
#line 2174 "DataCollection.vala"
					if (to_hide == NULL) {
#line 9392 "DataCollection.c"
						GeeArrayList* _tmp3_;
#line 2175 "DataCollection.vala"
						to_hide = (_tmp3_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_hide), _tmp3_);
#line 9396 "DataCollection.c"
					}
#line 2177 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), view);
#line 9400 "DataCollection.c"
				}
			}
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_it);
	}
#line 2182 "DataCollection.vala"
	if (self->priv->view_lock_count > 0) {
#line 2183 "DataCollection.vala"
		if (to_show != NULL) {
#line 9411 "DataCollection.c"
			{
				GeeIterator* _view_it;
#line 2184 "DataCollection.vala"
				_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (to_show));
#line 2184 "DataCollection.vala"
				while (TRUE) {
#line 9418 "DataCollection.c"
					DataView* view;
#line 2184 "DataCollection.vala"
					if (!gee_iterator_next (_view_it)) {
#line 2184 "DataCollection.vala"
						break;
#line 9424 "DataCollection.c"
					}
#line 2184 "DataCollection.vala"
					view = (DataView*) gee_iterator_get (_view_it);
#line 2185 "DataCollection.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view, GINT_TO_POINTER (TRUE));
#line 9430 "DataCollection.c"
					_g_object_unref0 (view);
				}
				_g_object_unref0 (_view_it);
			}
		}
#line 2189 "DataCollection.vala"
		if (to_hide != NULL) {
#line 9438 "DataCollection.c"
			{
				GeeIterator* _view_it;
#line 2190 "DataCollection.vala"
				_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (to_hide));
#line 2190 "DataCollection.vala"
				while (TRUE) {
#line 9445 "DataCollection.c"
					DataView* view;
#line 2190 "DataCollection.vala"
					if (!gee_iterator_next (_view_it)) {
#line 2190 "DataCollection.vala"
						break;
#line 9451 "DataCollection.c"
					}
#line 2190 "DataCollection.vala"
					view = (DataView*) gee_iterator_get (_view_it);
#line 2191 "DataCollection.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view, GINT_TO_POINTER (FALSE));
#line 9457 "DataCollection.c"
					_g_object_unref0 (view);
				}
				_g_object_unref0 (_view_it);
			}
		}
		_g_object_unref0 (to_hide);
		_g_object_unref0 (to_show);
#line 2194 "DataCollection.vala"
		return;
#line 9467 "DataCollection.c"
	}
#line 2197 "DataCollection.vala"
	if (to_show != NULL) {
#line 2198 "DataCollection.vala"
		view_collection_show_items (self, GEE_LIST (to_show));
#line 9473 "DataCollection.c"
	}
#line 2200 "DataCollection.vala"
	if (to_hide != NULL) {
#line 2201 "DataCollection.vala"
		view_collection_hide_items (self, GEE_LIST (to_hide));
#line 9479 "DataCollection.c"
	}
	_g_object_unref0 (to_hide);
	_g_object_unref0 (to_show);
}


#line 2204 "DataCollection.vala"
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map) {
#line 9488 "DataCollection.c"
	ViewCollection * self;
	GeeSet* _tmp0_;
	self = VIEW_COLLECTION (base);
#line 2204 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 2205 "DataCollection.vala"
	view_collection_filter_altered_items (self, GEE_COLLECTION (_tmp0_ = gee_map_get_keys (map)));
#line 9496 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 2207 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (DATA_COLLECTION (self), map);
#line 9500 "DataCollection.c"
}


#line 2210 "DataCollection.vala"
gboolean view_collection_is_view_locked (ViewCollection* self) {
#line 9506 "DataCollection.c"
	gboolean result = FALSE;
#line 2210 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 9510 "DataCollection.c"
	result = self->priv->view_lock_count > 0;
#line 2211 "DataCollection.vala"
	return result;
#line 9514 "DataCollection.c"
}


#line 2214 "DataCollection.vala"
void view_collection_lock_view (ViewCollection* self) {
#line 2214 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2215 "DataCollection.vala"
	self->priv->view_lock_count++;
#line 9524 "DataCollection.c"
}


#line 2218 "DataCollection.vala"
void view_collection_unlock_view (ViewCollection* self) {
#line 9530 "DataCollection.c"
	Marker* marker;
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
#line 2218 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2219 "DataCollection.vala"
	g_assert (self->priv->view_lock_count > 0);
#line 2220 "DataCollection.vala"
	if ((self->priv->view_lock_count = self->priv->view_lock_count - 1) != 0) {
#line 2221 "DataCollection.vala"
		return;
#line 9542 "DataCollection.c"
	}
	{
		GeeIterator* _view_it;
#line 2225 "DataCollection.vala"
		_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items));
#line 2225 "DataCollection.vala"
		while (TRUE) {
#line 9550 "DataCollection.c"
			DataView* view;
#line 2225 "DataCollection.vala"
			if (!gee_iterator_next (_view_it)) {
#line 2225 "DataCollection.vala"
				break;
#line 9556 "DataCollection.c"
			}
#line 2225 "DataCollection.vala"
			view = (DataView*) gee_iterator_get (_view_it);
#line 2226 "DataCollection.vala"
			gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view, NULL);
#line 9562 "DataCollection.c"
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_it);
	}
#line 2230 "DataCollection.vala"
	marker = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (self->priv->locked_unlinked_items));
#line 2231 "DataCollection.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items));
#line 2232 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 2235 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2236 "DataCollection.vala"
	to_hide = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 9577 "DataCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _key_it;
#line 2238 "DataCollection.vala"
		_key_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->locked_filter_items)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2238 "DataCollection.vala"
		while (TRUE) {
#line 9586 "DataCollection.c"
			DataView* key;
			gboolean _tmp2_ = FALSE;
#line 2238 "DataCollection.vala"
			if (!gee_iterator_next (_key_it)) {
#line 2238 "DataCollection.vala"
				break;
#line 9593 "DataCollection.c"
			}
#line 2238 "DataCollection.vala"
			key = (DataView*) gee_iterator_get (_key_it);
#line 2239 "DataCollection.vala"
			if (GPOINTER_TO_INT (gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), key))) {
#line 2239 "DataCollection.vala"
				_tmp2_ = !data_view_is_visible (key);
#line 9601 "DataCollection.c"
			} else {
#line 2239 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 9605 "DataCollection.c"
			}
#line 2239 "DataCollection.vala"
			if (_tmp2_) {
#line 2240 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), key);
#line 9611 "DataCollection.c"
			} else {
				gboolean _tmp3_ = FALSE;
#line 2241 "DataCollection.vala"
				if (!GPOINTER_TO_INT (gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), key))) {
#line 2241 "DataCollection.vala"
					_tmp3_ = data_view_is_visible (key);
#line 9618 "DataCollection.c"
				} else {
#line 2241 "DataCollection.vala"
					_tmp3_ = FALSE;
#line 9622 "DataCollection.c"
				}
#line 2241 "DataCollection.vala"
				if (_tmp3_) {
#line 2242 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), key);
#line 9628 "DataCollection.c"
				}
			}
			_g_object_unref0 (key);
		}
		_g_object_unref0 (_key_it);
	}
#line 2245 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 2246 "DataCollection.vala"
		view_collection_show_items (self, GEE_LIST (to_show));
#line 9639 "DataCollection.c"
	}
#line 2248 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 2249 "DataCollection.vala"
		view_collection_hide_items (self, GEE_LIST (to_hide));
#line 9645 "DataCollection.c"
	}
#line 2251 "DataCollection.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (self->priv->locked_filter_items));
#line 9649 "DataCollection.c"
	_g_object_unref0 (to_hide);
	_g_object_unref0 (to_show);
	_g_object_unref0 (marker);
}


#line 2254 "DataCollection.vala"
static void view_collection_real_remove_marked (DataCollection* base, Marker* marker) {
#line 9658 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2254 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2256 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (self->priv->locked_unlinked_items)) > 0) {
#line 9665 "DataCollection.c"
		{
			GeeCollection* _tmp0_;
			GeeIterator* _tmp1_;
			GeeIterator* _object_it;
#line 2257 "DataCollection.vala"
			_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = marker_get_all (marker))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2257 "DataCollection.vala"
			while (TRUE) {
#line 9674 "DataCollection.c"
				DataObject* object;
#line 2257 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 2257 "DataCollection.vala"
					break;
#line 9680 "DataCollection.c"
				}
#line 2257 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 2258 "DataCollection.vala"
				if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items), DATA_VIEW (object))) {
#line 2259 "DataCollection.vala"
					marker_unmark (marker, object);
#line 9688 "DataCollection.c"
				}
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
#line 2263 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->remove_marked (DATA_COLLECTION (self), marker);
#line 9697 "DataCollection.c"
}


#line 2266 "DataCollection.vala"
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
#line 9703 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2267 "DataCollection.vala"
	data_set_set_comparator (self->priv->selected, comparator, comparator_target, predicate, predicate_target);
#line 2268 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2269 "DataCollection.vala"
		data_set_set_comparator (self->priv->visible, comparator, comparator_target, predicate, predicate_target);
#line 9712 "DataCollection.c"
	}
#line 2271 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (DATA_COLLECTION (self), comparator, comparator_target, predicate, predicate_target);
#line 9716 "DataCollection.c"
}


#line 2274 "DataCollection.vala"
static void view_collection_real_reset_comparator (DataCollection* base) {
#line 9722 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2275 "DataCollection.vala"
	data_set_reset_comparator (self->priv->selected);
#line 2276 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2277 "DataCollection.vala"
		data_set_reset_comparator (self->priv->visible);
#line 9731 "DataCollection.c"
	}
#line 2279 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (DATA_COLLECTION (self));
#line 9735 "DataCollection.c"
}


#line 2282 "DataCollection.vala"
static GeeCollection* view_collection_real_get_all (DataCollection* base) {
#line 9741 "DataCollection.c"
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 2283 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 9749 "DataCollection.c"
		GeeCollection* _tmp1_;
#line 2283 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_all (self->priv->visible), _g_object_unref0 (_tmp0_), _tmp1_);
#line 9753 "DataCollection.c"
	} else {
		GeeCollection* _tmp2_;
#line 2283 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)), _g_object_unref0 (_tmp0_), _tmp2_);
#line 9758 "DataCollection.c"
	}
	result = _tmp0_;
#line 2283 "DataCollection.vala"
	return result;
#line 9763 "DataCollection.c"
}


#line 2286 "DataCollection.vala"
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self) {
#line 9769 "DataCollection.c"
	GeeCollection* result = NULL;
#line 2286 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 9773 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 2287 "DataCollection.vala"
	return result;
#line 9777 "DataCollection.c"
}


#line 2290 "DataCollection.vala"
static gint view_collection_real_get_count (DataCollection* base) {
#line 9783 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 2291 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2291 "DataCollection.vala"
		_tmp0_ = data_set_get_count (self->priv->visible);
#line 9792 "DataCollection.c"
	} else {
#line 2291 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 9796 "DataCollection.c"
	}
	result = _tmp0_;
#line 2291 "DataCollection.vala"
	return result;
#line 9801 "DataCollection.c"
}


#line 2294 "DataCollection.vala"
gint view_collection_get_unfiltered_count (ViewCollection* self) {
#line 9807 "DataCollection.c"
	gint result = 0;
#line 2294 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 9811 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 2295 "DataCollection.vala"
	return result;
#line 9815 "DataCollection.c"
}


#line 2298 "DataCollection.vala"
static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
#line 9821 "DataCollection.c"
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 2299 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 9829 "DataCollection.c"
		DataObject* _tmp1_;
#line 2299 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_at (self->priv->visible, index), _g_object_unref0 (_tmp0_), _tmp1_);
#line 9833 "DataCollection.c"
	} else {
		DataObject* _tmp2_;
#line 2299 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (DATA_COLLECTION (self), index), _g_object_unref0 (_tmp0_), _tmp2_);
#line 9838 "DataCollection.c"
	}
	result = _tmp0_;
#line 2299 "DataCollection.vala"
	return result;
#line 9843 "DataCollection.c"
}


#line 2302 "DataCollection.vala"
static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
#line 9849 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 2302 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 2303 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2303 "DataCollection.vala"
		_tmp0_ = data_set_index_of (self->priv->visible, object);
#line 9860 "DataCollection.c"
	} else {
#line 2303 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (DATA_COLLECTION (self), object);
#line 9864 "DataCollection.c"
	}
	result = _tmp0_;
#line 2303 "DataCollection.vala"
	return result;
#line 9869 "DataCollection.c"
}


#line 2306 "DataCollection.vala"
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
#line 9875 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 2306 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2309 "DataCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (DATA_COLLECTION (self), object)) {
#line 9883 "DataCollection.c"
		result = FALSE;
#line 2310 "DataCollection.vala"
		return result;
#line 9887 "DataCollection.c"
	}
	result = view_collection_is_visible (self, DATA_VIEW (object));
#line 2313 "DataCollection.vala"
	return result;
#line 9892 "DataCollection.c"
}


#line 2316 "DataCollection.vala"
static DataView* view_collection_real_get_first (ViewCollection* self) {
#line 9898 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 2316 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 9903 "DataCollection.c"
	_tmp0_ = NULL;
#line 2317 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 9907 "DataCollection.c"
		DataView* _tmp1_;
#line 2317 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), 0)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 9911 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 2317 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 9916 "DataCollection.c"
	}
	result = _tmp0_;
#line 2317 "DataCollection.vala"
	return result;
#line 9921 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
DataView* view_collection_get_first (ViewCollection* self) {
#line 1754 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 9929 "DataCollection.c"
}


#line 2320 "DataCollection.vala"
static DataView* view_collection_real_get_last (ViewCollection* self) {
#line 9935 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 2320 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 9940 "DataCollection.c"
	_tmp0_ = NULL;
#line 2321 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 9944 "DataCollection.c"
		DataView* _tmp1_;
#line 2321 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), data_collection_get_count (DATA_COLLECTION (self)) - 1)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 9948 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 2321 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 9953 "DataCollection.c"
	}
	result = _tmp0_;
#line 2321 "DataCollection.vala"
	return result;
#line 9958 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
DataView* view_collection_get_last (ViewCollection* self) {
#line 1754 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 9966 "DataCollection.c"
}


#line 2324 "DataCollection.vala"
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
#line 9972 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 2324 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2324 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 2325 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 9981 "DataCollection.c"
		result = NULL;
#line 2326 "DataCollection.vala"
		return result;
#line 9985 "DataCollection.c"
	}
#line 2328 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 2329 "DataCollection.vala"
	if (index < 0) {
#line 9991 "DataCollection.c"
		result = NULL;
#line 2330 "DataCollection.vala"
		return result;
#line 9995 "DataCollection.c"
	}
#line 2332 "DataCollection.vala"
	index++;
#line 2333 "DataCollection.vala"
	if (index >= data_collection_get_count (DATA_COLLECTION (self))) {
#line 2334 "DataCollection.vala"
		index = 0;
#line 10003 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 2336 "DataCollection.vala"
	return result;
#line 10008 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
#line 1754 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 10016 "DataCollection.c"
}


#line 2339 "DataCollection.vala"
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
#line 10022 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 2339 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2339 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 2340 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 10031 "DataCollection.c"
		result = NULL;
#line 2341 "DataCollection.vala"
		return result;
#line 10035 "DataCollection.c"
	}
#line 2343 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 2344 "DataCollection.vala"
	if (index < 0) {
#line 10041 "DataCollection.c"
		result = NULL;
#line 2345 "DataCollection.vala"
		return result;
#line 10045 "DataCollection.c"
	}
#line 2347 "DataCollection.vala"
	index--;
#line 2348 "DataCollection.vala"
	if (index < 0) {
#line 2349 "DataCollection.vala"
		index = data_collection_get_count (DATA_COLLECTION (self)) - 1;
#line 10053 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 2351 "DataCollection.vala"
	return result;
#line 10058 "DataCollection.c"
}


#line 1754 "DataCollection.vala"
DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
#line 1754 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 10066 "DataCollection.c"
}


#line 2354 "DataCollection.vala"
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev) {
#line 10072 "DataCollection.c"
	gboolean result = FALSE;
	DataView* home_view;
	DataView* next_view;
	DataSource* _tmp0_;
	DataSource* _tmp3_;
	DataView* prev_view;
	DataSource* _tmp4_;
	DataSource* _tmp7_;
#line 2354 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2354 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 10085 "DataCollection.c"
	if (next != NULL) {
		*next = NULL;
	}
	if (prev != NULL) {
		*prev = NULL;
	}
#line 2355 "DataCollection.vala"
	home_view = view_collection_get_view_for_source (self, home);
#line 2356 "DataCollection.vala"
	if (home_view == NULL) {
#line 10096 "DataCollection.c"
		result = FALSE;
		_g_object_unref0 (home_view);
#line 2357 "DataCollection.vala"
		return result;
#line 10101 "DataCollection.c"
	}
#line 2359 "DataCollection.vala"
	next_view = view_collection_get_next (self, home_view);
#line 10105 "DataCollection.c"
	_tmp0_ = NULL;
#line 2360 "DataCollection.vala"
	if (next_view != NULL) {
#line 10109 "DataCollection.c"
		DataSource* _tmp1_;
#line 2360 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_view_get_source (next_view), _g_object_unref0 (_tmp0_), _tmp1_);
#line 10113 "DataCollection.c"
	} else {
		DataSource* _tmp2_;
#line 2360 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 10118 "DataCollection.c"
	}
#line 2360 "DataCollection.vala"
	*next = (_tmp3_ = _g_object_ref0 (_tmp0_), _g_object_unref0 (*next), _tmp3_);
#line 2362 "DataCollection.vala"
	prev_view = view_collection_get_previous (self, home_view);
#line 10124 "DataCollection.c"
	_tmp4_ = NULL;
#line 2363 "DataCollection.vala"
	if (prev_view != NULL) {
#line 10128 "DataCollection.c"
		DataSource* _tmp5_;
#line 2363 "DataCollection.vala"
		_tmp4_ = (_tmp5_ = data_view_get_source (prev_view), _g_object_unref0 (_tmp4_), _tmp5_);
#line 10132 "DataCollection.c"
	} else {
		DataSource* _tmp6_;
#line 2363 "DataCollection.vala"
		_tmp4_ = (_tmp6_ = NULL, _g_object_unref0 (_tmp4_), _tmp6_);
#line 10137 "DataCollection.c"
	}
#line 2363 "DataCollection.vala"
	*prev = (_tmp7_ = _g_object_ref0 (_tmp4_), _g_object_unref0 (*prev), _tmp7_);
#line 10141 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (prev_view);
	_g_object_unref0 (_tmp0_);
	_g_object_unref0 (next_view);
	_g_object_unref0 (home_view);
#line 2365 "DataCollection.vala"
	return result;
#line 10150 "DataCollection.c"
}


#line 2369 "DataCollection.vala"
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home) {
#line 10156 "DataCollection.c"
	GeeSet* result = NULL;
	GeeSet* neighbors;
	DataSource* next;
	DataSource* prev;
	DataSource* _tmp0_ = NULL;
	gboolean _tmp1_;
	DataSource* _tmp2_;
	DataSource* _tmp3_ = NULL;
	gboolean _tmp4_;
	DataSource* _tmp5_;
#line 2369 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2369 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 2371 "DataCollection.vala"
	neighbors = GEE_SET (gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL));
#line 10173 "DataCollection.c"
	next = NULL;
	prev = NULL;
#line 2375 "DataCollection.vala"
	if (!(_tmp4_ = (_tmp1_ = view_collection_get_immediate_neighbors (self, home, &_tmp0_, &_tmp3_), next = (_tmp2_ = _tmp0_, _g_object_unref0 (next), _tmp2_), _tmp1_), prev = (_tmp5_ = _tmp3_, _g_object_unref0 (prev), _tmp5_), _tmp4_)) {
#line 10178 "DataCollection.c"
		result = neighbors;
		_g_object_unref0 (prev);
		_g_object_unref0 (next);
#line 2376 "DataCollection.vala"
		return result;
#line 10184 "DataCollection.c"
	}
#line 2379 "DataCollection.vala"
	if (next != NULL) {
#line 10188 "DataCollection.c"
		DataSource* next_next;
		DataSource* next_prev;
		DataSource* _tmp6_ = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp9_;
#line 2380 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), next);
#line 10197 "DataCollection.c"
		next_next = NULL;
		next_prev = NULL;
#line 2383 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, next, &_tmp6_, &_tmp8_), next_next = (_tmp7_ = _tmp6_, _g_object_unref0 (next_next), _tmp7_));
#line 2383 "DataCollection.vala"
		next_prev = (_tmp9_ = _tmp8_, _g_object_unref0 (next_prev), _tmp9_);
#line 2386 "DataCollection.vala"
		if (next_next != NULL) {
#line 2387 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), next_next);
#line 10208 "DataCollection.c"
		}
		_g_object_unref0 (next_prev);
		_g_object_unref0 (next_next);
	}
#line 2391 "DataCollection.vala"
	if (prev != NULL) {
#line 10215 "DataCollection.c"
		DataSource* next_prev;
		DataSource* prev_prev;
		DataSource* _tmp10_ = NULL;
		DataSource* _tmp11_;
		DataSource* _tmp12_ = NULL;
		DataSource* _tmp13_;
#line 2392 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), prev);
#line 10224 "DataCollection.c"
		next_prev = NULL;
		prev_prev = NULL;
#line 2395 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, prev, &_tmp10_, &_tmp12_), next_prev = (_tmp11_ = _tmp10_, _g_object_unref0 (next_prev), _tmp11_));
#line 2395 "DataCollection.vala"
		prev_prev = (_tmp13_ = _tmp12_, _g_object_unref0 (prev_prev), _tmp13_);
#line 2398 "DataCollection.vala"
		if (prev_prev != NULL) {
#line 2399 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), prev_prev);
#line 10235 "DataCollection.c"
		}
		_g_object_unref0 (prev_prev);
		_g_object_unref0 (next_prev);
	}
#line 2403 "DataCollection.vala"
	gee_collection_remove (GEE_COLLECTION (neighbors), home);
#line 10242 "DataCollection.c"
	result = neighbors;
	_g_object_unref0 (prev);
	_g_object_unref0 (next);
#line 2405 "DataCollection.vala"
	return result;
#line 10248 "DataCollection.c"
}


#line 2434 "DataCollection.vala"
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 10254 "DataCollection.c"
	gboolean result;
	result = view_collection_select_item (self, object, user);
	return result;
}


#line 2409 "DataCollection.vala"
void view_collection_select_marked (ViewCollection* self, Marker* marker) {
#line 10263 "DataCollection.c"
	GeeArrayList* selected;
#line 2409 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2409 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2410 "DataCollection.vala"
	selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2411 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
#line 2413 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (selected)) > 0) {
#line 2414 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (selected));
#line 10277 "DataCollection.c"
	}
	_g_object_unref0 (selected);
}


#line 2417 "DataCollection.vala"
static void view_collection_add_selected (ViewCollection* self, DataView* view) {
#line 10285 "DataCollection.c"
	gboolean added;
#line 2417 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2417 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2418 "DataCollection.vala"
	added = data_set_add (self->priv->selected, DATA_OBJECT (view));
#line 2419 "DataCollection.vala"
	g_assert (added);
#line 10295 "DataCollection.c"
}


#line 2422 "DataCollection.vala"
static void view_collection_remove_selected (ViewCollection* self, DataView* view) {
#line 10301 "DataCollection.c"
	gboolean removed;
#line 2422 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2422 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2423 "DataCollection.vala"
	removed = data_set_remove (self->priv->selected, DATA_OBJECT (view));
#line 2424 "DataCollection.vala"
	g_assert (removed);
#line 10311 "DataCollection.c"
}


#line 2428 "DataCollection.vala"
void view_collection_select_all (ViewCollection* self) {
#line 10317 "DataCollection.c"
	Marker* marker;
#line 2428 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2429 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 2430 "DataCollection.vala"
	marker_mark_all (marker);
#line 2431 "DataCollection.vala"
	view_collection_select_marked (self, marker);
#line 10327 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2434 "DataCollection.vala"
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 10334 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 2434 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2434 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2434 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2435 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2436 "DataCollection.vala"
	if (data_view_is_selected (view)) {
#line 2437 "DataCollection.vala"
		g_assert (data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 10349 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 2439 "DataCollection.vala"
		return result;
#line 10354 "DataCollection.c"
	}
#line 2442 "DataCollection.vala"
	data_view_internal_set_selected (view, TRUE);
#line 2443 "DataCollection.vala"
	view_collection_add_selected (self, view);
#line 2445 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 10362 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 2447 "DataCollection.vala"
	return result;
#line 10367 "DataCollection.c"
}


#line 2482 "DataCollection.vala"
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 10373 "DataCollection.c"
	gboolean result;
	result = view_collection_unselect_item (self, object, user);
	return result;
}


#line 2451 "DataCollection.vala"
void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
#line 10382 "DataCollection.c"
	GeeArrayList* unselected;
#line 2451 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2451 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2452 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2453 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
#line 2455 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 2456 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (unselected));
#line 10396 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 2460 "DataCollection.vala"
void view_collection_unselect_all (ViewCollection* self) {
#line 10404 "DataCollection.c"
	Marker* marker;
	GeeCollection* _tmp0_;
#line 2460 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2461 "DataCollection.vala"
	if (data_set_get_count (self->priv->selected) == 0) {
#line 2462 "DataCollection.vala"
		return;
#line 10413 "DataCollection.c"
	}
#line 2464 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 2465 "DataCollection.vala"
	marker_mark_many (marker, _tmp0_ = view_collection_get_selected (self));
#line 10419 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 2467 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 10423 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2471 "DataCollection.vala"
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
#line 10430 "DataCollection.c"
	Marker* marker;
#line 2471 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2471 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 2472 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 10438 "DataCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 2473 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2473 "DataCollection.vala"
		while (TRUE) {
#line 10447 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 2473 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2473 "DataCollection.vala"
				break;
#line 10454 "DataCollection.c"
			}
#line 2473 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2474 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2475 "DataCollection.vala"
			if (view != exception) {
#line 2476 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 10464 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2479 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 10473 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2482 "DataCollection.vala"
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 10480 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 2482 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2482 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2482 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2483 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2484 "DataCollection.vala"
	if (!data_view_is_selected (view)) {
#line 2485 "DataCollection.vala"
		g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 10495 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 2487 "DataCollection.vala"
		return result;
#line 10500 "DataCollection.c"
	}
#line 2490 "DataCollection.vala"
	data_view_internal_set_selected (view, FALSE);
#line 2491 "DataCollection.vala"
	view_collection_remove_selected (self, view);
#line 2493 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 10508 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 2495 "DataCollection.vala"
	return result;
#line 10513 "DataCollection.c"
}


#line 2511 "DataCollection.vala"
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 10519 "DataCollection.c"
	gboolean result;
	result = view_collection_toggle_item (self, object, user);
	return result;
}


#line 2500 "DataCollection.vala"
void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
#line 10528 "DataCollection.c"
	ViewCollectionToggleLists* lists;
#line 2500 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2500 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2501 "DataCollection.vala"
	lists = view_collection_toggle_lists_new ();
#line 2502 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_OBJECT (lists));
#line 2504 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->selected)) > 0) {
#line 2505 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (lists->selected));
#line 10542 "DataCollection.c"
	}
#line 2507 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->unselected)) > 0) {
#line 2508 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (lists->unselected));
#line 10548 "DataCollection.c"
	}
	_g_object_unref0 (lists);
}


#line 2511 "DataCollection.vala"
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 10556 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
	ViewCollectionToggleLists* lists;
#line 2511 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2511 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2511 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2512 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2513 "DataCollection.vala"
	lists = _g_object_ref0 (VIEW_COLLECTION_TOGGLE_LISTS (user));
#line 2517 "DataCollection.vala"
	if (data_view_internal_toggle (view)) {
#line 2518 "DataCollection.vala"
		view_collection_add_selected (self, view);
#line 2520 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->selected), view);
#line 10576 "DataCollection.c"
	} else {
#line 2522 "DataCollection.vala"
		view_collection_remove_selected (self, view);
#line 2524 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->unselected), view);
#line 10582 "DataCollection.c"
	}
	result = TRUE;
	_g_object_unref0 (lists);
	_g_object_unref0 (view);
#line 2527 "DataCollection.vala"
	return result;
#line 10589 "DataCollection.c"
}


#line 2530 "DataCollection.vala"
gint view_collection_get_selected_count (ViewCollection* self) {
#line 10595 "DataCollection.c"
	gint result = 0;
#line 2530 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 10599 "DataCollection.c"
	result = data_set_get_count (self->priv->selected);
#line 2531 "DataCollection.vala"
	return result;
#line 10603 "DataCollection.c"
}


#line 2534 "DataCollection.vala"
GeeCollection* view_collection_get_selected (ViewCollection* self) {
#line 10609 "DataCollection.c"
	GeeCollection* result = NULL;
#line 2534 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 10613 "DataCollection.c"
	result = GEE_COLLECTION (data_set_get_all (self->priv->selected));
#line 2535 "DataCollection.vala"
	return result;
#line 10617 "DataCollection.c"
}


#line 2538 "DataCollection.vala"
DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
#line 10623 "DataCollection.c"
	DataView* result = NULL;
#line 2538 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 10627 "DataCollection.c"
	result = DATA_VIEW (data_set_get_at (self->priv->selected, index));
#line 2539 "DataCollection.vala"
	return result;
#line 10631 "DataCollection.c"
}


#line 2542 "DataCollection.vala"
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
#line 10637 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2542 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2542 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 2543 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2543 "DataCollection.vala"
		_tmp0_ = data_set_contains (self->priv->visible, DATA_OBJECT (view));
#line 10648 "DataCollection.c"
	} else {
#line 2543 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 10652 "DataCollection.c"
	}
	result = _tmp0_;
#line 2543 "DataCollection.vala"
	return result;
#line 10657 "DataCollection.c"
}


#line 2546 "DataCollection.vala"
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many) {
#line 10663 "DataCollection.c"
	gboolean result = FALSE;
#line 2546 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2546 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (many), FALSE);
#line 2547 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 10671 "DataCollection.c"
		result = TRUE;
#line 2548 "DataCollection.vala"
		return result;
#line 10675 "DataCollection.c"
	}
#line 2550 "DataCollection.vala"
	if (!data_set_add_many (self->priv->visible, many)) {
#line 10679 "DataCollection.c"
		result = FALSE;
#line 2551 "DataCollection.vala"
		return result;
#line 10683 "DataCollection.c"
	}
#line 2554 "DataCollection.vala"
	if (data_set_get_count (self->priv->visible) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self))) {
#line 10687 "DataCollection.c"
		DataSet* _tmp0_;
#line 2555 "DataCollection.vala"
		self->priv->visible = (_tmp0_ = NULL, _data_set_unref0 (self->priv->visible), _tmp0_);
#line 10691 "DataCollection.c"
	}
	result = TRUE;
#line 2557 "DataCollection.vala"
	return result;
#line 10696 "DataCollection.c"
}


#line 2561 "DataCollection.vala"
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
#line 10702 "DataCollection.c"
	GeeArrayList* unselected;
	gint count;
	gboolean removed;
#line 2561 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2561 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_hide));
#line 2562 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2564 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_hide));
#line 10714 "DataCollection.c"
	{
		gint ctr;
#line 2565 "DataCollection.vala"
		ctr = 0;
#line 10719 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2565 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2565 "DataCollection.vala"
			while (TRUE) {
#line 10726 "DataCollection.c"
				DataView* view;
#line 2565 "DataCollection.vala"
				if (!_tmp0_) {
#line 2565 "DataCollection.vala"
					ctr++;
#line 10732 "DataCollection.c"
				}
#line 2565 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2565 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2565 "DataCollection.vala"
					break;
#line 10740 "DataCollection.c"
				}
#line 2566 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_hide, ctr);
#line 2567 "DataCollection.vala"
				g_assert (data_view_is_visible (view));
#line 2569 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 2570 "DataCollection.vala"
					data_view_internal_set_selected (view, FALSE);
#line 2571 "DataCollection.vala"
					view_collection_remove_selected (self, view);
#line 2572 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (unselected), view);
#line 10754 "DataCollection.c"
				}
#line 2575 "DataCollection.vala"
				data_view_internal_set_visible (view, FALSE);
#line 10758 "DataCollection.c"
				_g_object_unref0 (view);
			}
		}
	}
#line 2578 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 10765 "DataCollection.c"
		DataSet* _tmp1_;
#line 2580 "DataCollection.vala"
		self->priv->visible = (_tmp1_ = data_collection_get_dataset_copy (DATA_COLLECTION (self)), _data_set_unref0 (self->priv->visible), _tmp1_);
#line 10769 "DataCollection.c"
	}
#line 2583 "DataCollection.vala"
	removed = data_set_remove_many (self->priv->visible, to_hide);
#line 2584 "DataCollection.vala"
	g_assert (removed);
#line 2586 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 2587 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (unselected));
#line 10779 "DataCollection.c"
	}
#line 2589 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 2590 "DataCollection.vala"
		view_collection_notify_items_hidden (self, GEE_COLLECTION (to_hide));
#line 2591 "DataCollection.vala"
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (to_hide));
#line 10787 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 2596 "DataCollection.vala"
static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
#line 10795 "DataCollection.c"
	GeeArrayList* added_selected;
	gint count;
	gboolean added;
#line 2596 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2596 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_show));
#line 2597 "DataCollection.vala"
	added_selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2599 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_show));
#line 10807 "DataCollection.c"
	{
		gint ctr;
#line 2600 "DataCollection.vala"
		ctr = 0;
#line 10812 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2600 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2600 "DataCollection.vala"
			while (TRUE) {
#line 10819 "DataCollection.c"
				DataView* view;
#line 2600 "DataCollection.vala"
				if (!_tmp0_) {
#line 2600 "DataCollection.vala"
					ctr++;
#line 10825 "DataCollection.c"
				}
#line 2600 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2600 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2600 "DataCollection.vala"
					break;
#line 10833 "DataCollection.c"
				}
#line 2601 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_show, ctr);
#line 2602 "DataCollection.vala"
				g_assert (!data_view_is_visible (view));
#line 2604 "DataCollection.vala"
				data_view_internal_set_visible (view, TRUE);
#line 2607 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 2608 "DataCollection.vala"
					g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 2609 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 10847 "DataCollection.c"
				}
				_g_object_unref0 (view);
			}
		}
	}
#line 2613 "DataCollection.vala"
	added = view_collection_add_many_visible (self, GEE_COLLECTION (to_show));
#line 2614 "DataCollection.vala"
	g_assert (added);
#line 2615 "DataCollection.vala"
	added = data_set_add_many (self->priv->selected, GEE_COLLECTION (added_selected));
#line 2616 "DataCollection.vala"
	g_assert (added);
#line 2618 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 2619 "DataCollection.vala"
		view_collection_notify_items_shown (self, GEE_COLLECTION (to_show));
#line 2620 "DataCollection.vala"
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (to_show));
#line 10867 "DataCollection.c"
	}
	_g_object_unref0 (added_selected);
}


#line 2624 "DataCollection.vala"
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
#line 10875 "DataCollection.c"
	gboolean result = FALSE;
#line 2624 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2624 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 10881 "DataCollection.c"
	result = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2625 "DataCollection.vala"
	return result;
#line 10885 "DataCollection.c"
}


#line 2628 "DataCollection.vala"
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
#line 10891 "DataCollection.c"
	DataView* result = NULL;
#line 2628 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2628 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 10897 "DataCollection.c"
	result = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2629 "DataCollection.vala"
	return result;
#line 10901 "DataCollection.c"
}


#line 2632 "DataCollection.vala"
GeeCollection* view_collection_get_sources (ViewCollection* self) {
#line 10907 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeSet* _tmp0_;
	GeeCollection* _tmp1_;
#line 2632 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 10913 "DataCollection.c"
	result = (_tmp1_ = GEE_COLLECTION (gee_set_get_read_only_view (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->source_map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2633 "DataCollection.vala"
	return result;
#line 10917 "DataCollection.c"
}


#line 2636 "DataCollection.vala"
GeeCollection* view_collection_get_selected_sources (ViewCollection* self) {
#line 10923 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeCollection* sources;
	gint count;
#line 2636 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2637 "DataCollection.vala"
	sources = GEE_COLLECTION (gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
#line 2639 "DataCollection.vala"
	count = data_set_get_count (self->priv->selected);
#line 10933 "DataCollection.c"
	{
		gint ctr;
#line 2640 "DataCollection.vala"
		ctr = 0;
#line 10938 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2640 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2640 "DataCollection.vala"
			while (TRUE) {
#line 10945 "DataCollection.c"
				DataView* _tmp1_;
				DataSource* _tmp2_;
#line 2640 "DataCollection.vala"
				if (!_tmp0_) {
#line 2640 "DataCollection.vala"
					ctr++;
#line 10952 "DataCollection.c"
				}
#line 2640 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2640 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2640 "DataCollection.vala"
					break;
#line 10960 "DataCollection.c"
				}
#line 2641 "DataCollection.vala"
				gee_collection_add (sources, _tmp2_ = data_view_get_source (_tmp1_ = DATA_VIEW (data_set_get_at (self->priv->selected, ctr))));
#line 10964 "DataCollection.c"
				_g_object_unref0 (_tmp2_);
				_g_object_unref0 (_tmp1_);
			}
		}
	}
	result = sources;
#line 2643 "DataCollection.vala"
	return result;
#line 10973 "DataCollection.c"
}


#line 2647 "DataCollection.vala"
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
#line 2647 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2647 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2648 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 10985 "DataCollection.c"
		GeeCollection* _tmp0_;
#line 2649 "DataCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 2650 "DataCollection.vala"
		view_collection_notify_views_altered (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view))));
#line 10991 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 2652 "DataCollection.vala"
		if (self->priv->frozen_views_altered == NULL) {
#line 10996 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 2653 "DataCollection.vala"
			self->priv->frozen_views_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_views_altered), _tmp1_);
#line 11000 "DataCollection.c"
		}
#line 2654 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered), view);
#line 11004 "DataCollection.c"
	}
}


#line 2659 "DataCollection.vala"
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
#line 2659 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2659 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2660 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 11017 "DataCollection.c"
		GeeCollection* _tmp0_;
#line 2661 "DataCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 2662 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view))));
#line 11023 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 2664 "DataCollection.vala"
		if (self->priv->frozen_geometries_altered == NULL) {
#line 11028 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 2665 "DataCollection.vala"
			self->priv->frozen_geometries_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 11032 "DataCollection.c"
		}
#line 2666 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered), view);
#line 11036 "DataCollection.c"
	}
}


#line 2671 "DataCollection.vala"
void view_collection_internal_notify_unlinking (ViewCollection* self, DataView* view, SourceCollection* sources) {
#line 2671 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2671 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2671 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2672 "DataCollection.vala"
	if (self->priv->view_lock_count > 0) {
#line 11051 "DataCollection.c"
		gboolean added;
#line 2673 "DataCollection.vala"
		added = gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items), view);
#line 2674 "DataCollection.vala"
		g_assert (added);
#line 11057 "DataCollection.c"
	}
}


#line 2679 "DataCollection.vala"
void view_collection_internal_notify_relinked (ViewCollection* self, DataView* view, SourceCollection* sources) {
#line 2679 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2679 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2679 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2682 "DataCollection.vala"
	if (self->priv->view_lock_count > 0) {
#line 2683 "DataCollection.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items), view);
#line 11074 "DataCollection.c"
	}
}


#line 2686 "DataCollection.vala"
static void view_collection_real_notify_thawed (DataCollection* base) {
#line 11081 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2687 "DataCollection.vala"
	if (self->priv->frozen_views_altered != NULL) {
#line 11086 "DataCollection.c"
		GeeHashSet* _tmp0_;
		{
			GeeIterator* _view_it;
#line 2688 "DataCollection.vala"
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered));
#line 2688 "DataCollection.vala"
			while (TRUE) {
#line 11094 "DataCollection.c"
				DataView* view;
#line 2688 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 2688 "DataCollection.vala"
					break;
#line 11100 "DataCollection.c"
				}
#line 2688 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 2689 "DataCollection.vala"
				view_collection_notify_item_view_altered (self, view);
#line 11106 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 2690 "DataCollection.vala"
		view_collection_notify_views_altered (self, GEE_COLLECTION (self->priv->frozen_views_altered));
#line 2691 "DataCollection.vala"
		self->priv->frozen_views_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_views_altered), _tmp0_);
#line 11115 "DataCollection.c"
	}
#line 2694 "DataCollection.vala"
	if (self->priv->frozen_geometries_altered != NULL) {
#line 11119 "DataCollection.c"
		GeeHashSet* _tmp1_;
		{
			GeeIterator* _view_it;
#line 2695 "DataCollection.vala"
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered));
#line 2695 "DataCollection.vala"
			while (TRUE) {
#line 11127 "DataCollection.c"
				DataView* view;
#line 2695 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 2695 "DataCollection.vala"
					break;
#line 11133 "DataCollection.c"
				}
#line 2695 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 2696 "DataCollection.vala"
				view_collection_notify_item_geometry_altered (self, view);
#line 11139 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 2697 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (self->priv->frozen_geometries_altered));
#line 2698 "DataCollection.vala"
		self->priv->frozen_geometries_altered = (_tmp1_ = NULL, _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 11148 "DataCollection.c"
	}
#line 2701 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (DATA_COLLECTION (self));
#line 11152 "DataCollection.c"
}


#line 1710 "DataCollection.vala"
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
#line 1710 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1710 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (selected));
#line 11162 "DataCollection.c"
}


#line 1714 "DataCollection.vala"
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
#line 1714 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1714 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
#line 11172 "DataCollection.c"
}


#line 1718 "DataCollection.vala"
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
#line 1718 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1718 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 11182 "DataCollection.c"
}


#line 1725 "DataCollection.vala"
static void view_collection_real_selection_group_altered (ViewCollection* self) {
#line 1725 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 11190 "DataCollection.c"
}


#line 1729 "DataCollection.vala"
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible) {
#line 1729 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1729 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (visible));
#line 11200 "DataCollection.c"
}


#line 1733 "DataCollection.vala"
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 1733 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1733 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 11210 "DataCollection.c"
}


#line 1737 "DataCollection.vala"
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 1737 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1737 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 11220 "DataCollection.c"
}


#line 1741 "DataCollection.vala"
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
#line 1741 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1741 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 11230 "DataCollection.c"
}


#line 1745 "DataCollection.vala"
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1745 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1745 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 11240 "DataCollection.c"
}


#line 1748 "DataCollection.vala"
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1748 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1748 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 11250 "DataCollection.c"
}


#line 1751 "DataCollection.vala"
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1751 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1751 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 11260 "DataCollection.c"
}


#line 1684 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
#line 11266 "DataCollection.c"
	ViewCollectionToggleLists * self;
#line 1684 "DataCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 11270 "DataCollection.c"
	return self;
}


#line 1684 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
#line 1684 "DataCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 11279 "DataCollection.c"
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	self->selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
	self = VIEW_COLLECTION_TOGGLE_LISTS (obj);
	_g_object_unref0 (self->selected);
	_g_object_unref0 (self->unselected);
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
	view_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
	VIEW_COLLECTION_CLASS (klass)->notify_items_selected = view_collection_real_notify_items_selected;
	VIEW_COLLECTION_CLASS (klass)->notify_items_unselected = view_collection_real_notify_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->notify_selection_group_altered = view_collection_real_notify_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_items_shown = view_collection_real_notify_items_shown;
	VIEW_COLLECTION_CLASS (klass)->notify_items_hidden = view_collection_real_notify_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->notify_items_visibility_changed = view_collection_real_notify_items_visibility_changed;
	DATA_COLLECTION_CLASS (klass)->clear = view_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->add = view_collection_real_add;
	DATA_COLLECTION_CLASS (klass)->add_many = view_collection_real_add_many;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->items_altered = view_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->remove_marked = view_collection_real_remove_marked;
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
	DATA_COLLECTION_CLASS (klass)->notify_thawed = view_collection_real_notify_thawed;
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
	VIEW_COLLECTION_CLASS (klass)->selection_group_altered = view_collection_real_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("selection_group_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
}


static void view_collection_instance_init (ViewCollection * self) {
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
	self->priv->sources = NULL;
	self->priv->manager = NULL;
	self->priv->sources_alteration = NULL;
	self->priv->mirroring = NULL;
	self->priv->mirroring_ctor = NULL;
	self->priv->filter = NULL;
	self->priv->selected = data_set_new ();
	self->priv->visible = NULL;
	self->priv->frozen_views_altered = NULL;
	self->priv->frozen_geometries_altered = NULL;
	self->priv->view_lock_count = 0;
	self->priv->locked_filter_items = gee_hash_map_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_BOOLEAN, NULL, NULL, NULL, NULL, NULL);
	self->priv->locked_unlinked_items = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->source_map = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal, g_direct_equal);
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
	self = VIEW_COLLECTION (obj);
	_data_collection_unref0 (self->priv->sources);
	_view_manager_unref0 (self->priv->manager);
	_alteration_unref0 (self->priv->sources_alteration);
	_data_collection_unref0 (self->priv->mirroring);
	(self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL);
	self->priv->mirroring_ctor = NULL;
	self->priv->mirroring_ctor_target = NULL;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	(self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL);
	self->priv->filter = NULL;
	self->priv->filter_target = NULL;
	self->priv->filter_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->selected);
	_data_set_unref0 (self->priv->visible);
	_g_object_unref0 (self->priv->frozen_views_altered);
	_g_object_unref0 (self->priv->frozen_geometries_altered);
	_g_object_unref0 (self->priv->locked_filter_items);
	_g_object_unref0 (self->priv->locked_unlinked_items);
	_g_object_unref0 (self->priv->source_map);
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_ALTERATION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_ALTERATION) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ALTERATION callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_ALTERATION) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), value_get_alteration (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED_BOXED) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_boxed (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
}



