/* DataObject.c generated by valac 0.9.8, the Vala compiler
 * generated from DataObject.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataObject*/
/**/
/* Object IDs are incremented for each DataObject, and therefore may be used to compare*/
/* creation order.  This behavior may be relied upon elsewhere.  Object IDs may be recycled when*/
/* DataObjects are reconstituted by a proxy.*/
/**/
/* Ordinal IDs are supplied by DataCollections to record the ordering of the object being added*/
/* to the collection.  This value is primarily only used by DataCollection, but may be used*/
/* elsewhere to resolve ordering questions (including stabilizing a sort).*/
/**/
/**/
/* Alteration represents a description of what has changed in the DataObject (reported via the*/
/* "altered" signal).  Since the descriptions can vary wildly depending on the semantics of each*/
/* DataObject, no assumptions or requirements are placed on Alteration other than it must have*/
/* one or more "subjects", each with a "detail".  Subscribers to the "altered" signal can query*/
/* the Alteration object to determine if the change is important to them.*/
/**/
/* Alteration is an immutable type.  This means it's possible to store const Alterations of oft-used*/
/* values for reuse.*/
/**/
/* Alterations may be compressed, merging their subjects and details into a new aggregated*/
/* Alteration.  Generally this is handled automatically by DataObject and DataCollection, when*/
/* necessary.*/
/**/
/* NOTE: subjects and details should be ASCII labels (as in, plain-old ASCII, no code pages).*/
/* They are treated as case-sensitive strings.*/
/**/
/* Recommended subjects include: image, thumbnail, metadata.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <time.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _AlterationPrivate AlterationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecAlteration ParamSpecAlteration;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;
typedef struct _SourceSnapshotPrivate SourceSnapshotPrivate;
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
typedef struct _SourceBacklinkPrivate SourceBacklinkPrivate;
typedef struct _ParamSpecSourceBacklink ParamSpecSourceBacklink;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;
typedef struct _EventSourcePrivate EventSourcePrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
typedef struct _SourceProxyPrivate SourceProxyPrivate;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;
typedef struct _DataViewPrivate DataViewPrivate;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ThumbnailViewPrivate ThumbnailViewPrivate;

#define TYPE_PHOTO_VIEW (photo_view_get_type ())
#define PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_VIEW, PhotoView))
#define PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_VIEW, PhotoViewClass))
#define IS_PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_VIEW))
#define IS_PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_VIEW))
#define PHOTO_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_VIEW, PhotoViewClass))

typedef struct _PhotoView PhotoView;
typedef struct _PhotoViewClass PhotoViewClass;
typedef struct _PhotoViewPrivate PhotoViewPrivate;

#define TYPE_EVENT_VIEW (event_view_get_type ())
#define EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_VIEW, EventView))
#define EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_VIEW, EventViewClass))
#define IS_EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_VIEW))
#define IS_EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_VIEW))
#define EVENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_VIEW, EventViewClass))

typedef struct _EventView EventView;
typedef struct _EventViewClass EventViewClass;
typedef struct _EventViewPrivate EventViewPrivate;

struct _Alteration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AlterationPrivate * priv;
};

struct _AlterationClass {
	GTypeClass parent_class;
	void (*finalize) (Alteration *self);
};

struct _AlterationPrivate {
	char* subject;
	char* detail;
	GeeMultiMap* map;
};

struct _ParamSpecAlteration {
	GParamSpec parent_instance;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const char* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const char* name);
	char* (*get_name) (DataObject* self);
	char* (*to_string) (DataObject* self);
	void (*internal_collection_thawed) (DataObject* self);
	void (*altered) (DataObject* self, Alteration* alteration);
};

struct _DataObjectPrivate {
	gint64 object_id;
	DataCollection* member_of;
	gint64 ordinal;
	Alteration* frozen_alteration;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _SourceSnapshot {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceSnapshotPrivate * priv;
};

struct _SourceSnapshotClass {
	GTypeClass parent_class;
	void (*finalize) (SourceSnapshot *self);
	void (*notify_broken) (SourceSnapshot* self);
	void (*broken) (SourceSnapshot* self);
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _SourceBacklink {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceBacklinkPrivate * priv;
};

struct _SourceBacklinkClass {
	GTypeClass parent_class;
	void (*finalize) (SourceBacklink *self);
};

struct _SourceBacklinkPrivate {
	char* _name;
	char* _value;
};

struct _ParamSpecSourceBacklink {
	GParamSpec parent_instance;
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const char* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	SourceCollection* unlinked_from_collection;
	GeeHashMap* backlinks;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
	Alteration* frozen_alteration;
};

typedef void (*DataSourceContactSubscriberAlteration) (DataView* view, Alteration* alteration, void* user_data);
typedef void (*DataSourceContactSubscriber) (DataView* view, void* user_data);
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	char* (*get_unique_thumbnail_name) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _PhotoSource {
	ThumbnailSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_exposure_time) (PhotoSource* self);
	void (*get_dimensions) (PhotoSource* self, Dimensions* result);
	guint64 (*get_filesize) (PhotoSource* self);
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _EventSource {
	ThumbnailSource parent_instance;
	EventSourcePrivate * priv;
};

struct _EventSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_start_time) (EventSource* self);
	time_t (*get_end_time) (EventSource* self);
	guint64 (*get_total_filesize) (EventSource* self);
	gint (*get_photo_count) (EventSource* self);
	GeeIterable* (*get_photos) (EventSource* self);
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

struct _SourceProxy {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceProxyPrivate * priv;
};

struct _SourceProxyClass {
	GTypeClass parent_class;
	void (*finalize) (SourceProxy *self);
	DataSource* (*reconstitute) (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
	void (*notify_reconstituted) (SourceProxy* self, DataSource* source);
	void (*notify_dehydrated) (SourceProxy* self);
	void (*notify_broken) (SourceProxy* self);
	void (*reconstituted) (SourceProxy* self, DataSource* source);
	void (*dehydrated) (SourceProxy* self);
	void (*broken) (SourceProxy* self);
};

struct _SourceProxyPrivate {
	gint64 object_id;
	char* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};

struct _DataView {
	DataObject parent_instance;
	DataViewPrivate * priv;
};

struct _DataViewClass {
	DataObjectClass parent_class;
	void (*notify_view_altered) (DataView* self);
	void (*notify_geometry_altered) (DataView* self);
	void (*notify_unsubscribed) (DataView* self, DataSource* source);
	void (*notify_source_unlinking) (DataView* self, SourceCollection* sources);
	void (*notify_source_relinked) (DataView* self, SourceCollection* sources);
	void (*state_changed) (DataView* self, gboolean selected);
	void (*visibility_changed) (DataView* self, gboolean visible);
	void (*view_altered) (DataView* self);
	void (*geometry_altered) (DataView* self);
	void (*unsubscribed) (DataView* self, DataSource* source);
};

struct _DataViewPrivate {
	DataSource* source;
	gboolean selected;
	gboolean visible;
};

struct _ThumbnailView {
	DataView parent_instance;
	ThumbnailViewPrivate * priv;
};

struct _ThumbnailViewClass {
	DataViewClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailView* self);
	void (*thumbnail_altered) (ThumbnailView* self);
};

struct _PhotoView {
	ThumbnailView parent_instance;
	PhotoViewPrivate * priv;
};

struct _PhotoViewClass {
	ThumbnailViewClass parent_class;
};

struct _EventView {
	ThumbnailView parent_instance;
	EventViewPrivate * priv;
};

struct _EventViewClass {
	ThumbnailViewClass parent_class;
};


static gpointer alteration_parent_class = NULL;
static gint64 data_object_object_id_generator;
static gint64 data_object_object_id_generator = (gint64) 0;
static gpointer data_object_parent_class = NULL;
static gpointer source_snapshot_parent_class = NULL;
static gpointer source_backlink_parent_class = NULL;
static gpointer data_source_parent_class = NULL;
static gpointer thumbnail_source_parent_class = NULL;
static gpointer photo_source_parent_class = NULL;
static gpointer event_source_parent_class = NULL;
static gpointer source_proxy_parent_class = NULL;
static gpointer data_view_parent_class = NULL;
static gpointer thumbnail_view_parent_class = NULL;
static gpointer photo_view_parent_class = NULL;
static gpointer event_view_parent_class = NULL;

gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
#define ALTERATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ALTERATION, AlterationPrivate))
enum  {
	ALTERATION_DUMMY_PROPERTY
};
Alteration* alteration_new (const char* subject, const char* detail);
Alteration* alteration_construct (GType object_type, const char* subject, const char* detail);
static void alteration_add_detail (Alteration* self, const char* sub, const char* det);
Alteration* alteration_new_from_list (const char* list);
Alteration* alteration_construct_from_list (GType object_type, const char* list);
static Alteration* alteration_new_from_map (GeeMultiMap* map);
static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map);
static GeeMultiMap* alteration_create_map (Alteration* self);
static guint alteration_case_hash (void* a);
static guint _alteration_case_hash_ghash_func (void* key);
static gboolean alteration_case_equal (void* a, void* b);
static gboolean _alteration_case_equal_gequal_func (void* a, void* b);
static inline gboolean alteration_equal_values (const char* str1, const char* str2);
static inline guint alteration_hash_value (const char* str);
gboolean alteration_has_subject (Alteration* self, const char* subject);
gboolean alteration_has_detail (Alteration* self, const char* subject, const char* detail);
char* alteration_to_string (Alteration* self);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean alteration_equals (Alteration* self, Alteration* other);
static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src);
Alteration* alteration_compress (Alteration* self, Alteration* other);
static void alteration_finalize (Alteration* obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_OBJECT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_OBJECT, DataObjectPrivate))
enum  {
	DATA_OBJECT_DUMMY_PROPERTY
};
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataObject* data_object_construct (GType object_type, gint64 object_id);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
static void data_object_real_notify_altered (DataObject* self, Alteration* alteration);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name);
char* data_object_get_name (DataObject* self);
static char* data_object_real_get_name (DataObject* self);
char* data_object_to_string (DataObject* self);
static char* data_object_real_to_string (DataObject* self);
DataCollection* data_object_get_membership (DataObject* self);
gboolean data_object_has_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
void data_object_internal_clear_membership (DataObject* self);
gint64 data_object_internal_get_ordinal (DataObject* self);
void data_object_internal_collection_thawed (DataObject* self);
static void data_object_real_internal_collection_thawed (DataObject* self);
gint64 data_object_get_object_id (DataObject* self);
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def);
static GValue* _g_value_dup (GValue* self);
GValue* data_collection_get_property (DataCollection* self, const char* name);
static void _vala_GValue_free (GValue* self);
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_clear_collection_property (DataObject* self, const char* name);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_object_altered (DataObject* self, Alteration* alteration);
static void data_object_real_altered (DataObject* self, Alteration* alteration);
static void data_object_finalize (GObject* obj);
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
#define SOURCE_SNAPSHOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_SNAPSHOT, SourceSnapshotPrivate))
enum  {
	SOURCE_SNAPSHOT_DUMMY_PROPERTY
};
void source_snapshot_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
gboolean source_snapshot_is_broken (SourceSnapshot* self);
SourceSnapshot* source_snapshot_construct (GType object_type);
void source_snapshot_broken (SourceSnapshot* self);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot* obj);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
#define SOURCE_BACKLINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_BACKLINK, SourceBacklinkPrivate))
enum  {
	SOURCE_BACKLINK_DUMMY_PROPERTY
};
SourceBacklink* source_backlink_new (const char* name, const char* value);
SourceBacklink* source_backlink_construct (GType object_type, const char* name, const char* value);
char* source_backlink_to_string (SourceBacklink* self);
const char* source_backlink_get_name (SourceBacklink* self);
const char* source_backlink_get_value (SourceBacklink* self);
guint source_backlink_hash_func (void* key);
gboolean source_backlink_equal_func (void* a, void* b);
static void source_backlink_finalize (SourceBacklink* obj);
GType data_source_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
#define DATA_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SOURCE, DataSourcePrivate))
enum  {
	DATA_SOURCE_DUMMY_PROPERTY
};
DataSource* data_source_construct (GType object_type, gint64 object_id);
static void data_source_real_notify_altered (DataObject* base, Alteration* alteration);
void data_source_contact_subscribers_alteration (DataSource* self, DataSourceContactSubscriberAlteration contact_subscriber, void* contact_subscriber_target, Alteration* alteration);
static void data_source_subscriber_altered (DataSource* self, DataView* view, Alteration* alteration);
static void _data_source_subscriber_altered_data_source_contact_subscriber_alteration (DataView* view, Alteration* alteration, gpointer self);
static void data_source_real_internal_collection_thawed (DataObject* base);
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection);
void data_source_notify_unlinked (DataSource* self);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection);
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target);
static void data_source_subscriber_unlinking (DataSource* self, DataView* view);
static void _data_source_subscriber_unlinking_data_source_contact_subscriber (DataView* view, gpointer self);
static void data_source_real_notify_unlinked (DataSource* self);
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated);
static char* data_source_dehydrate_backlinks (DataSource* self);
void data_view_notify_source_unlinking (DataView* self, SourceCollection* sources);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
static void data_source_real_notify_relinked (DataSource* self);
static void data_source_subscriber_relinked (DataSource* self, DataView* view);
static void _data_source_subscriber_relinked_data_source_contact_subscriber (DataView* view, gpointer self);
void data_view_notify_source_relinked (DataView* self, SourceCollection* sources);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
GeeList* data_source_get_backlinks (DataSource* self, const char* name);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const char* dehydrated);
SourceSnapshot* data_source_save_snapshot (DataSource* self);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
void data_source_internal_mark_for_destroy (DataSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error);
gboolean data_source_equals (DataSource* self, DataSource* source);
static gboolean data_source_real_equals (DataSource* self, DataSource* source);
void data_source_destroy (DataSource* self);
static void data_source_real_destroy (DataSource* self);
void data_view_notify_unsubscribed (DataView* self, DataSource* source);
void data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
void data_source_internal_subscribe (DataSource* self, DataView* view);
static void _vala_array_add194 (DataView*** array, int* length, int* size, DataView* value);
void data_source_internal_unsubscribe (DataSource* self, DataView* view);
void data_source_unlinked (DataSource* self, SourceCollection* sources);
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources);
void data_source_relinked (DataSource* self, SourceCollection* sources);
static void data_source_real_relinked (DataSource* self, SourceCollection* sources);
void data_source_destroyed (DataSource* self);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject* obj);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
enum  {
	THUMBNAIL_SOURCE_DUMMY_PROPERTY
};
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view);
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self);
GType thumbnail_view_get_type (void) G_GNUC_CONST;
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GdkPixbuf* thumbnail_source_create_thumbnail (ThumbnailSource* self, gint scale, GError** error);
static GdkPixbuf* thumbnail_source_real_create_thumbnail (ThumbnailSource* self, gint scale, GError** error);
char* thumbnail_source_get_unique_thumbnail_name (ThumbnailSource* self);
static char* thumbnail_source_real_get_unique_thumbnail_name (ThumbnailSource* self);
PhotoFileFormat thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self);
static PhotoFileFormat thumbnail_source_real_get_preferred_thumbnail_format (ThumbnailSource* self);
void thumbnail_source_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self);
GType photo_source_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
gpointer photo_metadata_ref (gpointer instance);
void photo_metadata_unref (gpointer instance);
GParamSpec* param_spec_photo_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_metadata (GValue* value, gpointer v_object);
void value_take_photo_metadata (GValue* value, gpointer v_object);
gpointer value_get_photo_metadata (const GValue* value);
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
enum  {
	PHOTO_SOURCE_DUMMY_PROPERTY
};
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
time_t photo_source_get_exposure_time (PhotoSource* self);
static time_t photo_source_real_get_exposure_time (PhotoSource* self);
void photo_source_get_dimensions (PhotoSource* self, Dimensions* result);
static void photo_source_real_get_dimensions (PhotoSource* self, Dimensions* result);
guint64 photo_source_get_filesize (PhotoSource* self);
static guint64 photo_source_real_get_filesize (PhotoSource* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
GType event_source_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_SOURCE_DUMMY_PROPERTY
};
EventSource* event_source_construct (GType object_type, gint64 object_id);
time_t event_source_get_start_time (EventSource* self);
static time_t event_source_real_get_start_time (EventSource* self);
time_t event_source_get_end_time (EventSource* self);
static time_t event_source_real_get_end_time (EventSource* self);
guint64 event_source_get_total_filesize (EventSource* self);
static guint64 event_source_real_get_total_filesize (EventSource* self);
gint event_source_get_photo_count (EventSource* self);
static gint event_source_real_get_photo_count (EventSource* self);
GeeIterable* event_source_get_photos (EventSource* self);
static GeeIterable* event_source_real_get_photos (EventSource* self);
GType container_source_get_type (void) G_GNUC_CONST;
gboolean container_source_has_links (ContainerSource* self);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link (ContainerSource* self, DataSource* source);
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources);
void container_source_establish_link (ContainerSource* self, DataSource* source);
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources);
gpointer source_proxy_ref (gpointer instance);
void source_proxy_unref (gpointer instance);
GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_proxy (GValue* value, gpointer v_object);
void value_take_source_proxy (GValue* value, gpointer v_object);
gpointer value_get_source_proxy (const GValue* value);
GType source_proxy_get_type (void) G_GNUC_CONST;
#define SOURCE_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_PROXY, SourceProxyPrivate))
enum  {
	SOURCE_PROXY_DUMMY_PROPERTY
};
SourceProxy* source_proxy_construct (GType object_type, DataSource* source);
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self);
static void source_proxy_set_source (SourceProxy* self, DataSource* source);
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
void source_proxy_notify_broken (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self);
DataSource* source_proxy_get_source (SourceProxy* self);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
void source_proxy_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_dehydrated (SourceProxy* self);
static void source_proxy_real_dehydrated (SourceProxy* self);
void source_proxy_broken (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy* obj);
GType proxyable_get_type (void) G_GNUC_CONST;
SourceProxy* proxyable_get_proxy (Proxyable* self);
#define DATA_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_VIEW, DataViewPrivate))
enum  {
	DATA_VIEW_DUMMY_PROPERTY
};
DataView* data_view_new (DataSource* source);
DataView* data_view_construct (GType object_type, DataSource* source);
static char* data_view_real_get_name (DataObject* base);
static char* data_view_real_to_string (DataObject* base);
DataSource* data_view_get_source (DataView* self);
gboolean data_view_is_selected (DataView* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
gboolean data_view_internal_toggle (DataView* self);
gboolean data_view_is_visible (DataView* self);
void data_view_internal_set_visible (DataView* self, gboolean visible);
void data_view_notify_view_altered (DataView* self);
static void data_view_real_notify_view_altered (DataView* self);
GType view_collection_get_type (void) G_GNUC_CONST;
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void data_view_notify_geometry_altered (DataView* self);
static void data_view_real_notify_geometry_altered (DataView* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void data_view_real_notify_unsubscribed (DataView* self, DataSource* source);
static void data_view_real_notify_source_unlinking (DataView* self, SourceCollection* sources);
void view_collection_internal_notify_unlinking (ViewCollection* self, DataView* view, SourceCollection* sources);
static void data_view_real_notify_source_relinked (DataView* self, SourceCollection* sources);
void view_collection_internal_notify_relinked (ViewCollection* self, DataView* view, SourceCollection* sources);
void data_view_state_changed (DataView* self, gboolean selected);
static void data_view_real_state_changed (DataView* self, gboolean selected);
void data_view_visibility_changed (DataView* self, gboolean visible);
static void data_view_real_visibility_changed (DataView* self, gboolean visible);
void data_view_view_altered (DataView* self);
static void data_view_real_view_altered (DataView* self);
void data_view_geometry_altered (DataView* self);
static void data_view_real_geometry_altered (DataView* self);
void data_view_unsubscribed (DataView* self, DataSource* source);
static void data_view_real_unsubscribed (DataView* self, DataSource* source);
static void data_view_finalize (GObject* obj);
enum  {
	THUMBNAIL_VIEW_DUMMY_PROPERTY
};
ThumbnailView* thumbnail_view_new (ThumbnailSource* source);
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source);
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self);
void thumbnail_view_thumbnail_altered (ThumbnailView* self);
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self);
GType photo_view_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_VIEW_DUMMY_PROPERTY
};
PhotoView* photo_view_new (PhotoSource* source);
PhotoView* photo_view_construct (GType object_type, PhotoSource* source);
PhotoSource* photo_view_get_photo_source (PhotoView* self);
GType event_view_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_VIEW_DUMMY_PROPERTY
};
EventView* event_view_new (EventSource* source);
EventView* event_view_construct (GType object_type, EventSource* source);
EventSource* event_view_get_event_source (EventView* self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__ALTERATION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 44 "DataObject.vala"
Alteration* alteration_construct (GType object_type, const char* subject, const char* detail) {
#line 943 "DataObject.c"
	Alteration* self;
#line 44 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 44 "DataObject.vala"
	g_return_val_if_fail (detail != NULL, NULL);
#line 949 "DataObject.c"
	self = (Alteration*) g_type_create_instance (object_type);
#line 45 "DataObject.vala"
	alteration_add_detail (self, subject, detail);
#line 953 "DataObject.c"
	return self;
}


#line 44 "DataObject.vala"
Alteration* alteration_new (const char* subject, const char* detail) {
#line 44 "DataObject.vala"
	return alteration_construct (TYPE_ALTERATION, subject, detail);
#line 962 "DataObject.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1170 "glib-2.0.vapi"
	return result;
#line 972 "DataObject.c"
}


#line 50 "DataObject.vala"
Alteration* alteration_construct_from_list (GType object_type, const char* list) {
#line 978 "DataObject.c"
	Alteration* self;
	gint pairs_length1;
	gint _pairs_size_;
	char** _tmp1_;
	char** _tmp0_;
	char** pairs;
#line 50 "DataObject.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 987 "DataObject.c"
	self = (Alteration*) g_type_create_instance (object_type);
	g_return_val_if_fail (string_get_length (list) > 0, NULL);
	pairs = (_tmp1_ = _tmp0_ = g_strsplit (list, ",", 0), pairs_length1 = _vala_array_length (_tmp0_), _pairs_size_ = pairs_length1, _tmp1_);
#line 52 "DataObject.vala"
	g_assert (pairs_length1 >= 1);
#line 993 "DataObject.c"
	{
		char** pair_collection;
		int pair_collection_length1;
		int pair_it;
#line 54 "DataObject.vala"
		pair_collection = pairs;
#line 1000 "DataObject.c"
		pair_collection_length1 = pairs_length1;
		for (pair_it = 0; pair_it < pairs_length1; pair_it = pair_it + 1) {
			char* pair;
			pair = g_strdup (pair_collection[pair_it]);
			{
				gint subject_detail_length1;
				gint _subject_detail_size_;
				char** _tmp3_;
				char** _tmp2_;
				char** subject_detail;
				subject_detail = (_tmp3_ = _tmp2_ = g_strsplit (pair, ":", 2), subject_detail_length1 = _vala_array_length (_tmp2_), _subject_detail_size_ = subject_detail_length1, _tmp3_);
#line 56 "DataObject.vala"
				g_assert (subject_detail_length1 == 2);
#line 58 "DataObject.vala"
				alteration_add_detail (self, subject_detail[0], subject_detail[1]);
#line 1016 "DataObject.c"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (pair);
			}
		}
	}
	pairs = (_vala_array_free (pairs, pairs_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


#line 50 "DataObject.vala"
Alteration* alteration_new_from_list (const char* list) {
#line 50 "DataObject.vala"
	return alteration_construct_from_list (TYPE_ALTERATION, list);
#line 1031 "DataObject.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 63 "DataObject.vala"
static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map) {
#line 1042 "DataObject.c"
	Alteration* self;
	GeeMultiMap* _tmp0_;
#line 63 "DataObject.vala"
	g_return_val_if_fail (GEE_IS_MULTI_MAP (map), NULL);
#line 1047 "DataObject.c"
	self = (Alteration*) g_type_create_instance (object_type);
#line 64 "DataObject.vala"
	self->priv->map = (_tmp0_ = _g_object_ref0 (map), _g_object_unref0 (self->priv->map), _tmp0_);
#line 1051 "DataObject.c"
	return self;
}


#line 63 "DataObject.vala"
static Alteration* alteration_new_from_map (GeeMultiMap* map) {
#line 63 "DataObject.vala"
	return alteration_construct_from_map (TYPE_ALTERATION, map);
#line 1060 "DataObject.c"
}


#line 1027 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 1066 "DataObject.c"
	char* result = NULL;
	char* _result_;
#line 1027 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1028 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1029 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1075 "DataObject.c"
	result = _result_;
#line 1030 "glib-2.0.vapi"
	return result;
#line 1079 "DataObject.c"
}


#line 67 "DataObject.vala"
static void alteration_add_detail (Alteration* self, const char* sub, const char* det) {
#line 1085 "DataObject.c"
	char* subject;
	char* detail;
	gboolean _tmp0_ = FALSE;
#line 67 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (self));
#line 67 "DataObject.vala"
	g_return_if_fail (sub != NULL);
#line 67 "DataObject.vala"
	g_return_if_fail (det != NULL);
#line 69 "DataObject.vala"
	subject = string_strip (sub);
#line 70 "DataObject.vala"
	g_assert (string_get_length (subject) > 0);
#line 72 "DataObject.vala"
	detail = string_strip (det);
#line 73 "DataObject.vala"
	g_assert (string_get_length (detail) > 0);
#line 76 "DataObject.vala"
	if (self->priv->subject == NULL) {
#line 76 "DataObject.vala"
		_tmp0_ = self->priv->map == NULL;
#line 1107 "DataObject.c"
	} else {
#line 76 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1111 "DataObject.c"
	}
#line 76 "DataObject.vala"
	if (_tmp0_) {
#line 1115 "DataObject.c"
		char* _tmp1_;
		char* _tmp2_;
#line 77 "DataObject.vala"
		g_assert (self->priv->detail == NULL);
#line 79 "DataObject.vala"
		self->priv->subject = (_tmp1_ = g_strdup (subject), _g_free0 (self->priv->subject), _tmp1_);
#line 80 "DataObject.vala"
		self->priv->detail = (_tmp2_ = g_strdup (detail), _g_free0 (self->priv->detail), _tmp2_);
#line 1124 "DataObject.c"
		_g_free0 (detail);
		_g_free0 (subject);
#line 82 "DataObject.vala"
		return;
#line 1129 "DataObject.c"
	}
#line 86 "DataObject.vala"
	if (self->priv->map == NULL) {
#line 1133 "DataObject.c"
		GeeMultiMap* _tmp3_;
#line 87 "DataObject.vala"
		self->priv->map = (_tmp3_ = alteration_create_map (self), _g_object_unref0 (self->priv->map), _tmp3_);
#line 1137 "DataObject.c"
	}
#line 90 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 1141 "DataObject.c"
		char* _tmp4_;
		char* _tmp5_;
#line 91 "DataObject.vala"
		g_assert (self->priv->detail != NULL);
#line 93 "DataObject.vala"
		gee_multi_map_set (self->priv->map, self->priv->subject, self->priv->detail);
#line 94 "DataObject.vala"
		self->priv->subject = (_tmp4_ = NULL, _g_free0 (self->priv->subject), _tmp4_);
#line 95 "DataObject.vala"
		self->priv->detail = (_tmp5_ = NULL, _g_free0 (self->priv->detail), _tmp5_);
#line 1152 "DataObject.c"
	}
#line 99 "DataObject.vala"
	gee_multi_map_set (self->priv->map, subject, detail);
#line 1156 "DataObject.c"
	_g_free0 (detail);
	_g_free0 (subject);
}


#line 110 "DataObject.vala"
static guint _alteration_case_hash_ghash_func (void* key) {
#line 1164 "DataObject.c"
	guint result;
	result = alteration_case_hash (key);
	return result;
}


#line 106 "DataObject.vala"
static gboolean _alteration_case_equal_gequal_func (void* a, void* b) {
#line 1173 "DataObject.c"
	gboolean result;
	result = alteration_case_equal (a, b);
	return result;
}


#line 102 "DataObject.vala"
static GeeMultiMap* alteration_create_map (Alteration* self) {
#line 1182 "DataObject.c"
	GeeMultiMap* result = NULL;
#line 102 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 1186 "DataObject.c"
	result = GEE_MULTI_MAP (gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _alteration_case_hash_ghash_func, _alteration_case_equal_gequal_func, _alteration_case_hash_ghash_func, _alteration_case_equal_gequal_func));
#line 103 "DataObject.vala"
	return result;
#line 1190 "DataObject.c"
}


#line 106 "DataObject.vala"
static gboolean alteration_case_equal (void* a, void* b) {
#line 1196 "DataObject.c"
	gboolean result = FALSE;
	result = alteration_equal_values ((const char*) a, (const char*) b);
#line 107 "DataObject.vala"
	return result;
#line 1201 "DataObject.c"
}


#line 110 "DataObject.vala"
static guint alteration_case_hash (void* a) {
#line 1207 "DataObject.c"
	guint result = 0U;
	result = alteration_hash_value ((const char*) a);
#line 111 "DataObject.vala"
	return result;
#line 1212 "DataObject.c"
}


#line 114 "DataObject.vala"
static inline gboolean alteration_equal_values (const char* str1, const char* str2) {
#line 1218 "DataObject.c"
	gboolean result = FALSE;
#line 114 "DataObject.vala"
	g_return_val_if_fail (str1 != NULL, FALSE);
#line 114 "DataObject.vala"
	g_return_val_if_fail (str2 != NULL, FALSE);
#line 1224 "DataObject.c"
	result = g_ascii_strcasecmp (str1, str2) == 0;
#line 115 "DataObject.vala"
	return result;
#line 1228 "DataObject.c"
}


#line 118 "DataObject.vala"
static inline guint alteration_hash_value (const char* str) {
#line 1234 "DataObject.c"
	guint result = 0U;
#line 118 "DataObject.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 1238 "DataObject.c"
	result = g_str_hash (str);
#line 119 "DataObject.vala"
	return result;
#line 1242 "DataObject.c"
}


#line 122 "DataObject.vala"
gboolean alteration_has_subject (Alteration* self, const char* subject) {
#line 1248 "DataObject.c"
	gboolean result = FALSE;
	GeeSet* keys;
#line 122 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 122 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 123 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 1257 "DataObject.c"
		result = alteration_equal_values (self->priv->subject, subject);
#line 124 "DataObject.vala"
		return result;
#line 1261 "DataObject.c"
	}
#line 126 "DataObject.vala"
	g_assert (self->priv->map != NULL);
#line 127 "DataObject.vala"
	keys = gee_multi_map_get_keys (self->priv->map);
#line 128 "DataObject.vala"
	if (keys != NULL) {
#line 1269 "DataObject.c"
		{
			GeeIterator* _key_it;
#line 129 "DataObject.vala"
			_key_it = gee_iterable_iterator (GEE_ITERABLE (keys));
#line 129 "DataObject.vala"
			while (TRUE) {
#line 1276 "DataObject.c"
				char* key;
#line 129 "DataObject.vala"
				if (!gee_iterator_next (_key_it)) {
#line 129 "DataObject.vala"
					break;
#line 1282 "DataObject.c"
				}
#line 129 "DataObject.vala"
				key = (char*) gee_iterator_get (_key_it);
#line 130 "DataObject.vala"
				if (alteration_equal_values (key, subject)) {
#line 1288 "DataObject.c"
					result = TRUE;
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (keys);
#line 131 "DataObject.vala"
					return result;
#line 1295 "DataObject.c"
				}
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
	}
	result = FALSE;
	_g_object_unref0 (keys);
#line 135 "DataObject.vala"
	return result;
#line 1306 "DataObject.c"
}


#line 138 "DataObject.vala"
gboolean alteration_has_detail (Alteration* self, const char* subject, const char* detail) {
#line 1312 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GeeCollection* values;
#line 138 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 138 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 138 "DataObject.vala"
	g_return_val_if_fail (detail != NULL, FALSE);
#line 139 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 139 "DataObject.vala"
		_tmp0_ = self->priv->detail != NULL;
#line 1326 "DataObject.c"
	} else {
#line 139 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1330 "DataObject.c"
	}
#line 139 "DataObject.vala"
	if (_tmp0_) {
#line 1334 "DataObject.c"
		gboolean _tmp1_ = FALSE;
#line 140 "DataObject.vala"
		if (alteration_equal_values (self->priv->subject, subject)) {
#line 140 "DataObject.vala"
			_tmp1_ = alteration_equal_values (self->priv->detail, detail);
#line 1340 "DataObject.c"
		} else {
#line 140 "DataObject.vala"
			_tmp1_ = FALSE;
#line 1344 "DataObject.c"
		}
		result = _tmp1_;
#line 140 "DataObject.vala"
		return result;
#line 1349 "DataObject.c"
	}
#line 142 "DataObject.vala"
	g_assert (self->priv->map != NULL);
#line 143 "DataObject.vala"
	values = gee_multi_map_get (self->priv->map, subject);
#line 144 "DataObject.vala"
	if (values != NULL) {
#line 1357 "DataObject.c"
		{
			GeeIterator* _value_it;
#line 145 "DataObject.vala"
			_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 145 "DataObject.vala"
			while (TRUE) {
#line 1364 "DataObject.c"
				char* value;
#line 145 "DataObject.vala"
				if (!gee_iterator_next (_value_it)) {
#line 145 "DataObject.vala"
					break;
#line 1370 "DataObject.c"
				}
#line 145 "DataObject.vala"
				value = (char*) gee_iterator_get (_value_it);
#line 146 "DataObject.vala"
				if (alteration_equal_values (value, detail)) {
#line 1376 "DataObject.c"
					result = TRUE;
					_g_free0 (value);
					_g_object_unref0 (_value_it);
					_g_object_unref0 (values);
#line 147 "DataObject.vala"
					return result;
#line 1383 "DataObject.c"
				}
				_g_free0 (value);
			}
			_g_object_unref0 (_value_it);
		}
	}
	result = FALSE;
	_g_object_unref0 (values);
#line 151 "DataObject.vala"
	return result;
#line 1394 "DataObject.c"
}


#line 154 "DataObject.vala"
char* alteration_to_string (Alteration* self) {
#line 1400 "DataObject.c"
	char* result = NULL;
	char* str;
#line 154 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 155 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 156 "DataObject.vala"
		g_assert (self->priv->detail != NULL);
#line 1409 "DataObject.c"
		result = g_strdup_printf ("%s:%s", self->priv->subject, self->priv->detail);
#line 158 "DataObject.vala"
		return result;
#line 1413 "DataObject.c"
	}
#line 161 "DataObject.vala"
	g_assert (self->priv->map != NULL);
#line 163 "DataObject.vala"
	str = g_strdup ("");
#line 1419 "DataObject.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _key_it;
#line 164 "DataObject.vala"
		_key_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_multi_map_get_keys (self->priv->map))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 164 "DataObject.vala"
		while (TRUE) {
#line 1428 "DataObject.c"
			char* key;
#line 164 "DataObject.vala"
			if (!gee_iterator_next (_key_it)) {
#line 164 "DataObject.vala"
				break;
#line 1434 "DataObject.c"
			}
#line 164 "DataObject.vala"
			key = (char*) gee_iterator_get (_key_it);
#line 1438 "DataObject.c"
			{
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _value_it;
#line 165 "DataObject.vala"
				_value_it = (_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_ = gee_multi_map_get (self->priv->map, key))), _g_object_unref0 (_tmp2_), _tmp3_);
#line 165 "DataObject.vala"
				while (TRUE) {
#line 1447 "DataObject.c"
					char* value;
					char* _tmp5_;
					char* _tmp6_;
#line 165 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 165 "DataObject.vala"
						break;
#line 1455 "DataObject.c"
					}
#line 165 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 166 "DataObject.vala"
					if (string_get_length (str) != 0) {
#line 1461 "DataObject.c"
						char* _tmp4_;
#line 167 "DataObject.vala"
						str = (_tmp4_ = g_strconcat (str, ", ", NULL), _g_free0 (str), _tmp4_);
#line 1465 "DataObject.c"
					}
#line 169 "DataObject.vala"
					str = (_tmp6_ = g_strconcat (str, _tmp5_ = g_strdup_printf ("%s:%s", key, value), NULL), _g_free0 (str), _tmp6_);
#line 1469 "DataObject.c"
					_g_free0 (_tmp5_);
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	result = str;
#line 173 "DataObject.vala"
	return result;
#line 1482 "DataObject.c"
}


#line 177 "DataObject.vala"
gboolean alteration_contains_any (Alteration* self, Alteration* other) {
#line 1488 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 177 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 177 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
#line 179 "DataObject.vala"
	if (self == other) {
#line 1500 "DataObject.c"
		result = TRUE;
#line 180 "DataObject.vala"
		return result;
#line 1504 "DataObject.c"
	}
#line 183 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 183 "DataObject.vala"
		_tmp2_ = other->priv->subject != NULL;
#line 1510 "DataObject.c"
	} else {
#line 183 "DataObject.vala"
		_tmp2_ = FALSE;
#line 1514 "DataObject.c"
	}
#line 183 "DataObject.vala"
	if (_tmp2_) {
#line 183 "DataObject.vala"
		_tmp1_ = self->priv->detail != NULL;
#line 1520 "DataObject.c"
	} else {
#line 183 "DataObject.vala"
		_tmp1_ = FALSE;
#line 1524 "DataObject.c"
	}
#line 183 "DataObject.vala"
	if (_tmp1_) {
#line 183 "DataObject.vala"
		_tmp0_ = other->priv->detail != NULL;
#line 1530 "DataObject.c"
	} else {
#line 183 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1534 "DataObject.c"
	}
#line 183 "DataObject.vala"
	if (_tmp0_) {
#line 1538 "DataObject.c"
		gboolean _tmp3_ = FALSE;
#line 184 "DataObject.vala"
		if (alteration_equal_values (self->priv->subject, other->priv->subject)) {
#line 184 "DataObject.vala"
			_tmp3_ = alteration_equal_values (self->priv->detail, other->priv->detail);
#line 1544 "DataObject.c"
		} else {
#line 184 "DataObject.vala"
			_tmp3_ = FALSE;
#line 1548 "DataObject.c"
		}
		result = _tmp3_;
#line 184 "DataObject.vala"
		return result;
#line 1553 "DataObject.c"
	}
#line 187 "DataObject.vala"
	if (self->priv->map != NULL) {
#line 187 "DataObject.vala"
		_tmp4_ = other->priv->map != NULL;
#line 1559 "DataObject.c"
	} else {
#line 187 "DataObject.vala"
		_tmp4_ = FALSE;
#line 1563 "DataObject.c"
	}
#line 187 "DataObject.vala"
	if (_tmp4_) {
#line 1567 "DataObject.c"
		GeeSet* keys;
		GeeSet* other_keys;
#line 188 "DataObject.vala"
		keys = gee_multi_map_get_keys (self->priv->map);
#line 189 "DataObject.vala"
		g_assert (keys != NULL);
#line 190 "DataObject.vala"
		other_keys = gee_multi_map_get_keys (other->priv->map);
#line 191 "DataObject.vala"
		g_assert (other_keys != NULL);
#line 1578 "DataObject.c"
		{
			GeeIterator* _subject_it;
#line 193 "DataObject.vala"
			_subject_it = gee_iterable_iterator (GEE_ITERABLE (other_keys));
#line 193 "DataObject.vala"
			while (TRUE) {
#line 1585 "DataObject.c"
				char* subject;
				GeeCollection* details;
				GeeCollection* other_details;
				gboolean _tmp5_ = FALSE;
#line 193 "DataObject.vala"
				if (!gee_iterator_next (_subject_it)) {
#line 193 "DataObject.vala"
					break;
#line 1594 "DataObject.c"
				}
#line 193 "DataObject.vala"
				subject = (char*) gee_iterator_get (_subject_it);
#line 194 "DataObject.vala"
				if (!gee_collection_contains (GEE_COLLECTION (keys), subject)) {
#line 1600 "DataObject.c"
					_g_free0 (subject);
#line 195 "DataObject.vala"
					continue;
#line 1604 "DataObject.c"
				}
#line 197 "DataObject.vala"
				details = gee_multi_map_get (self->priv->map, subject);
#line 198 "DataObject.vala"
				other_details = gee_multi_map_get (other->priv->map, subject);
#line 200 "DataObject.vala"
				if (details != NULL) {
#line 200 "DataObject.vala"
					_tmp5_ = other_details != NULL;
#line 1614 "DataObject.c"
				} else {
#line 200 "DataObject.vala"
					_tmp5_ = FALSE;
#line 1618 "DataObject.c"
				}
#line 200 "DataObject.vala"
				if (_tmp5_) {
#line 1622 "DataObject.c"
					{
						GeeIterator* _detail_it;
#line 201 "DataObject.vala"
						_detail_it = gee_iterable_iterator (GEE_ITERABLE (other_details));
#line 201 "DataObject.vala"
						while (TRUE) {
#line 1629 "DataObject.c"
							char* detail;
#line 201 "DataObject.vala"
							if (!gee_iterator_next (_detail_it)) {
#line 201 "DataObject.vala"
								break;
#line 1635 "DataObject.c"
							}
#line 201 "DataObject.vala"
							detail = (char*) gee_iterator_get (_detail_it);
#line 202 "DataObject.vala"
							if (gee_collection_contains (details, detail)) {
#line 1641 "DataObject.c"
								result = TRUE;
								_g_free0 (detail);
								_g_object_unref0 (_detail_it);
								_g_object_unref0 (other_details);
								_g_object_unref0 (details);
								_g_free0 (subject);
								_g_object_unref0 (_subject_it);
								_g_object_unref0 (other_keys);
								_g_object_unref0 (keys);
#line 203 "DataObject.vala"
								return result;
#line 1653 "DataObject.c"
							}
							_g_free0 (detail);
						}
						_g_object_unref0 (_detail_it);
					}
				}
				_g_object_unref0 (other_details);
				_g_object_unref0 (details);
				_g_free0 (subject);
			}
			_g_object_unref0 (_subject_it);
		}
		_g_object_unref0 (other_keys);
		_g_object_unref0 (keys);
	}
	result = FALSE;
#line 209 "DataObject.vala"
	return result;
#line 1672 "DataObject.c"
}


#line 212 "DataObject.vala"
gboolean alteration_equals (Alteration* self, Alteration* other) {
#line 1678 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 212 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 212 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
#line 214 "DataObject.vala"
	if (self == other) {
#line 1690 "DataObject.c"
		result = TRUE;
#line 215 "DataObject.vala"
		return result;
#line 1694 "DataObject.c"
	}
#line 218 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 218 "DataObject.vala"
		_tmp2_ = other->priv->subject != NULL;
#line 1700 "DataObject.c"
	} else {
#line 218 "DataObject.vala"
		_tmp2_ = FALSE;
#line 1704 "DataObject.c"
	}
#line 218 "DataObject.vala"
	if (_tmp2_) {
#line 218 "DataObject.vala"
		_tmp1_ = self->priv->detail != NULL;
#line 1710 "DataObject.c"
	} else {
#line 218 "DataObject.vala"
		_tmp1_ = FALSE;
#line 1714 "DataObject.c"
	}
#line 218 "DataObject.vala"
	if (_tmp1_) {
#line 218 "DataObject.vala"
		_tmp0_ = other->priv->detail != NULL;
#line 1720 "DataObject.c"
	} else {
#line 218 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1724 "DataObject.c"
	}
#line 218 "DataObject.vala"
	if (_tmp0_) {
#line 1728 "DataObject.c"
		gboolean _tmp3_ = FALSE;
#line 219 "DataObject.vala"
		if (alteration_equal_values (self->priv->subject, other->priv->subject)) {
#line 219 "DataObject.vala"
			_tmp3_ = alteration_equal_values (self->priv->detail, other->priv->detail);
#line 1734 "DataObject.c"
		} else {
#line 219 "DataObject.vala"
			_tmp3_ = FALSE;
#line 1738 "DataObject.c"
		}
		result = _tmp3_;
#line 219 "DataObject.vala"
		return result;
#line 1743 "DataObject.c"
	}
#line 222 "DataObject.vala"
	if (self->priv->map != NULL) {
#line 222 "DataObject.vala"
		_tmp4_ = other->priv->map != NULL;
#line 1749 "DataObject.c"
	} else {
#line 222 "DataObject.vala"
		_tmp4_ = FALSE;
#line 1753 "DataObject.c"
	}
#line 222 "DataObject.vala"
	if (_tmp4_) {
#line 1757 "DataObject.c"
		GeeSet* keys;
		GeeSet* other_keys;
#line 224 "DataObject.vala"
		keys = gee_multi_map_get_keys (self->priv->map);
#line 225 "DataObject.vala"
		g_assert (keys != NULL);
#line 226 "DataObject.vala"
		other_keys = gee_multi_map_get_keys (other->priv->map);
#line 227 "DataObject.vala"
		g_assert (other_keys != NULL);
#line 229 "DataObject.vala"
		if (gee_collection_get_size (GEE_COLLECTION (keys)) != gee_collection_get_size (GEE_COLLECTION (other_keys))) {
#line 1770 "DataObject.c"
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
#line 230 "DataObject.vala"
			return result;
#line 1776 "DataObject.c"
		}
#line 232 "DataObject.vala"
		if (!gee_collection_contains_all (GEE_COLLECTION (keys), GEE_COLLECTION (other_keys))) {
#line 1780 "DataObject.c"
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
#line 233 "DataObject.vala"
			return result;
#line 1786 "DataObject.c"
		}
#line 235 "DataObject.vala"
		if (!gee_collection_contains_all (GEE_COLLECTION (other_keys), GEE_COLLECTION (keys))) {
#line 1790 "DataObject.c"
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
#line 236 "DataObject.vala"
			return result;
#line 1796 "DataObject.c"
		}
		{
			GeeIterator* _key_it;
#line 238 "DataObject.vala"
			_key_it = gee_iterable_iterator (GEE_ITERABLE (keys));
#line 238 "DataObject.vala"
			while (TRUE) {
#line 1804 "DataObject.c"
				char* key;
				GeeCollection* values;
				GeeCollection* other_values;
#line 238 "DataObject.vala"
				if (!gee_iterator_next (_key_it)) {
#line 238 "DataObject.vala"
					break;
#line 1812 "DataObject.c"
				}
#line 238 "DataObject.vala"
				key = (char*) gee_iterator_get (_key_it);
#line 239 "DataObject.vala"
				values = gee_multi_map_get (self->priv->map, key);
#line 240 "DataObject.vala"
				other_values = gee_multi_map_get (other->priv->map, key);
#line 242 "DataObject.vala"
				if (gee_collection_get_size (values) != gee_collection_get_size (other_values)) {
#line 1822 "DataObject.c"
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
#line 243 "DataObject.vala"
					return result;
#line 1832 "DataObject.c"
				}
#line 245 "DataObject.vala"
				if (!gee_collection_contains_all (values, other_values)) {
#line 1836 "DataObject.c"
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
#line 246 "DataObject.vala"
					return result;
#line 1846 "DataObject.c"
				}
#line 248 "DataObject.vala"
				if (!gee_collection_contains_all (other_values, values)) {
#line 1850 "DataObject.c"
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
#line 249 "DataObject.vala"
					return result;
#line 1860 "DataObject.c"
				}
				_g_object_unref0 (other_values);
				_g_object_unref0 (values);
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
		result = TRUE;
		_g_object_unref0 (other_keys);
		_g_object_unref0 (keys);
#line 253 "DataObject.vala"
		return result;
#line 1873 "DataObject.c"
	}
	result = FALSE;
#line 257 "DataObject.vala"
	return result;
#line 1878 "DataObject.c"
}


#line 260 "DataObject.vala"
static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src) {
#line 1884 "DataObject.c"
	GeeSet* keys;
#line 260 "DataObject.vala"
	g_return_if_fail (GEE_IS_MULTI_MAP (dest));
#line 260 "DataObject.vala"
	g_return_if_fail (GEE_IS_MULTI_MAP (src));
#line 262 "DataObject.vala"
	keys = gee_multi_map_get_keys (src);
#line 1892 "DataObject.c"
	{
		GeeIterator* _key_it;
#line 263 "DataObject.vala"
		_key_it = gee_iterable_iterator (GEE_ITERABLE (keys));
#line 263 "DataObject.vala"
		while (TRUE) {
#line 1899 "DataObject.c"
			char* key;
			GeeCollection* values;
#line 263 "DataObject.vala"
			if (!gee_iterator_next (_key_it)) {
#line 263 "DataObject.vala"
				break;
#line 1906 "DataObject.c"
			}
#line 263 "DataObject.vala"
			key = (char*) gee_iterator_get (_key_it);
#line 264 "DataObject.vala"
			values = gee_multi_map_get (src, key);
#line 1912 "DataObject.c"
			{
				GeeIterator* _value_it;
#line 265 "DataObject.vala"
				_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 265 "DataObject.vala"
				while (TRUE) {
#line 1919 "DataObject.c"
					char* value;
#line 265 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 265 "DataObject.vala"
						break;
#line 1925 "DataObject.c"
					}
#line 265 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 266 "DataObject.vala"
					gee_multi_map_set (dest, key, value);
#line 1931 "DataObject.c"
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
			_g_object_unref0 (values);
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	_g_object_unref0 (keys);
}


static gpointer _alteration_ref0 (gpointer self) {
	return self ? alteration_ref (self) : NULL;
}


#line 272 "DataObject.vala"
Alteration* alteration_compress (Alteration* self, Alteration* other) {
#line 1952 "DataObject.c"
	Alteration* result = NULL;
	GeeMultiMap* compressed;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 272 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 272 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (other), NULL);
#line 273 "DataObject.vala"
	if (alteration_equals (self, other)) {
#line 1963 "DataObject.c"
		result = _alteration_ref0 (self);
#line 274 "DataObject.vala"
		return result;
#line 1967 "DataObject.c"
	}
#line 278 "DataObject.vala"
	compressed = alteration_create_map (self);
#line 280 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 280 "DataObject.vala"
		_tmp0_ = self->priv->detail != NULL;
#line 1975 "DataObject.c"
	} else {
#line 280 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1979 "DataObject.c"
	}
#line 280 "DataObject.vala"
	if (_tmp0_) {
#line 281 "DataObject.vala"
		gee_multi_map_set (compressed, self->priv->subject, self->priv->detail);
#line 1985 "DataObject.c"
	} else {
#line 283 "DataObject.vala"
		g_assert (self->priv->map != NULL);
#line 284 "DataObject.vala"
		alteration_multimap_add_all (compressed, self->priv->map);
#line 1991 "DataObject.c"
	}
#line 287 "DataObject.vala"
	if (other->priv->subject != NULL) {
#line 287 "DataObject.vala"
		_tmp1_ = other->priv->detail != NULL;
#line 1997 "DataObject.c"
	} else {
#line 287 "DataObject.vala"
		_tmp1_ = FALSE;
#line 2001 "DataObject.c"
	}
#line 287 "DataObject.vala"
	if (_tmp1_) {
#line 288 "DataObject.vala"
		gee_multi_map_set (compressed, other->priv->subject, other->priv->detail);
#line 2007 "DataObject.c"
	} else {
#line 290 "DataObject.vala"
		g_assert (other->priv->map != NULL);
#line 291 "DataObject.vala"
		alteration_multimap_add_all (compressed, other->priv->map);
#line 2013 "DataObject.c"
	}
	result = alteration_new_from_map (compressed);
	_g_object_unref0 (compressed);
#line 294 "DataObject.vala"
	return result;
#line 2019 "DataObject.c"
}


static void value_alteration_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_alteration_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		alteration_unref (value->data[0].v_pointer);
	}
}


static void value_alteration_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = alteration_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_alteration_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_alteration_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Alteration* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = alteration_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_alteration_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Alteration** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = alteration_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAlteration* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ALTERATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_alteration (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION), NULL);
	return value->data[0].v_pointer;
}


void value_set_alteration (GValue* value, gpointer v_object) {
	Alteration* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		alteration_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		alteration_unref (old);
	}
}


void value_take_alteration (GValue* value, gpointer v_object) {
	Alteration* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		alteration_unref (old);
	}
}


static void alteration_class_init (AlterationClass * klass) {
	alteration_parent_class = g_type_class_peek_parent (klass);
	ALTERATION_CLASS (klass)->finalize = alteration_finalize;
	g_type_class_add_private (klass, sizeof (AlterationPrivate));
}


static void alteration_instance_init (Alteration * self) {
	self->priv = ALTERATION_GET_PRIVATE (self);
	self->priv->subject = NULL;
	self->priv->detail = NULL;
	self->priv->map = NULL;
	self->ref_count = 1;
}


static void alteration_finalize (Alteration* obj) {
	Alteration * self;
	self = ALTERATION (obj);
	_g_free0 (self->priv->subject);
	_g_free0 (self->priv->detail);
	_g_object_unref0 (self->priv->map);
}


GType alteration_get_type (void) {
	static volatile gsize alteration_type_id__volatile = 0;
	if (g_once_init_enter (&alteration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_alteration_init, value_alteration_free_value, value_alteration_copy_value, value_alteration_peek_pointer, "p", value_alteration_collect_value, "p", value_alteration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AlterationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) alteration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Alteration), 0, (GInstanceInitFunc) alteration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType alteration_type_id;
		alteration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Alteration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&alteration_type_id__volatile, alteration_type_id);
	}
	return alteration_type_id__volatile;
}


gpointer alteration_ref (gpointer instance) {
	Alteration* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void alteration_unref (gpointer instance) {
	Alteration* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ALTERATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 324 "DataObject.vala"
DataObject* data_object_construct (GType object_type, gint64 object_id) {
#line 2192 "DataObject.c"
	DataObject * self;
	gint64 _tmp0_ = 0LL;
#line 324 "DataObject.vala"
	self = (DataObject*) g_object_new (object_type, NULL);
#line 325 "DataObject.vala"
	if (object_id == DATA_OBJECT_INVALID_OBJECT_ID) {
#line 325 "DataObject.vala"
		_tmp0_ = data_object_object_id_generator++;
#line 2201 "DataObject.c"
	} else {
#line 325 "DataObject.vala"
		_tmp0_ = object_id;
#line 2205 "DataObject.c"
	}
#line 325 "DataObject.vala"
	self->priv->object_id = _tmp0_;
#line 2209 "DataObject.c"
	return self;
}


#line 328 "DataObject.vala"
static void data_object_real_notify_altered (DataObject* self, Alteration* alteration) {
#line 328 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 328 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 330 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 331 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (self->priv->member_of)) {
#line 332 "DataObject.vala"
			g_signal_emit_by_name (self, "altered", alteration);
#line 2226 "DataObject.c"
		} else {
			Alteration* _tmp0_;
			Alteration* _tmp3_;
			_tmp0_ = NULL;
#line 334 "DataObject.vala"
			if (self->priv->frozen_alteration == NULL) {
#line 2233 "DataObject.c"
				Alteration* _tmp1_;
#line 334 "DataObject.vala"
				_tmp0_ = (_tmp1_ = _alteration_ref0 (alteration), _alteration_unref0 (_tmp0_), _tmp1_);
#line 2237 "DataObject.c"
			} else {
				Alteration* _tmp2_;
#line 335 "DataObject.vala"
				_tmp0_ = (_tmp2_ = alteration_compress (self->priv->frozen_alteration, alteration), _alteration_unref0 (_tmp0_), _tmp2_);
#line 2242 "DataObject.c"
			}
#line 334 "DataObject.vala"
			self->priv->frozen_alteration = (_tmp3_ = _alteration_ref0 (_tmp0_), _alteration_unref0 (self->priv->frozen_alteration), _tmp3_);
#line 2246 "DataObject.c"
			_alteration_unref0 (_tmp0_);
		}
	} else {
#line 337 "DataObject.vala"
		g_signal_emit_by_name (self, "altered", alteration);
#line 2252 "DataObject.c"
	}
#line 341 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 342 "DataObject.vala"
		data_collection_internal_notify_altered (self->priv->member_of, self, alteration);
#line 2258 "DataObject.c"
	}
}


#line 324 "DataObject.vala"
void data_object_notify_altered (DataObject* self, Alteration* alteration) {
#line 324 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_altered (self, alteration);
#line 2267 "DataObject.c"
}


#line 354 "DataObject.vala"
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 354 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 354 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 2277 "DataObject.c"
}


#line 324 "DataObject.vala"
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 324 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_membership_changed (self, collection);
#line 2285 "DataObject.c"
}


#line 359 "DataObject.vala"
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 359 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 359 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 2295 "DataObject.c"
}


#line 324 "DataObject.vala"
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 324 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_set (self, name, old, val);
#line 2303 "DataObject.c"
}


#line 364 "DataObject.vala"
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 364 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 364 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 2313 "DataObject.c"
}


#line 324 "DataObject.vala"
void data_object_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 324 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_cleared (self, name);
#line 2321 "DataObject.c"
}


#line 367 "DataObject.vala"
static char* data_object_real_get_name (DataObject* self) {
#line 2327 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_get_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 324 "DataObject.vala"
char* data_object_get_name (DataObject* self) {
#line 324 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->get_name (self);
#line 2338 "DataObject.c"
}


#line 369 "DataObject.vala"
static char* data_object_real_to_string (DataObject* self) {
#line 2344 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 324 "DataObject.vala"
char* data_object_to_string (DataObject* self) {
#line 324 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->to_string (self);
#line 2355 "DataObject.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 371 "DataObject.vala"
DataCollection* data_object_get_membership (DataObject* self) {
#line 2366 "DataObject.c"
	DataCollection* result = NULL;
#line 371 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 2370 "DataObject.c"
	result = _data_collection_ref0 (self->priv->member_of);
#line 372 "DataObject.vala"
	return result;
#line 2374 "DataObject.c"
}


#line 375 "DataObject.vala"
gboolean data_object_has_membership (DataObject* self) {
#line 2380 "DataObject.c"
	gboolean result = FALSE;
#line 375 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), FALSE);
#line 2384 "DataObject.c"
	result = self->priv->member_of != NULL;
#line 376 "DataObject.vala"
	return result;
#line 2388 "DataObject.c"
}


#line 381 "DataObject.vala"
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal) {
#line 2394 "DataObject.c"
	DataCollection* _tmp0_;
#line 381 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 381 "DataObject.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 382 "DataObject.vala"
	g_assert (self->priv->member_of == NULL);
#line 384 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = _data_collection_ref0 (collection), _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 385 "DataObject.vala"
	self->priv->ordinal = ordinal;
#line 2406 "DataObject.c"
}


#line 394 "DataObject.vala"
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal) {
#line 394 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 395 "DataObject.vala"
	g_assert (self->priv->member_of == NULL);
#line 397 "DataObject.vala"
	self->priv->ordinal = ordinal;
#line 2418 "DataObject.c"
}


#line 402 "DataObject.vala"
void data_object_internal_clear_membership (DataObject* self) {
#line 2424 "DataObject.c"
	DataCollection* _tmp0_;
#line 402 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 403 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = NULL, _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 404 "DataObject.vala"
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
#line 2432 "DataObject.c"
}


#line 408 "DataObject.vala"
inline gint64 data_object_internal_get_ordinal (DataObject* self) {
#line 2438 "DataObject.c"
	gint64 result = 0LL;
#line 408 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 2442 "DataObject.c"
	result = self->priv->ordinal;
#line 409 "DataObject.vala"
	return result;
#line 2446 "DataObject.c"
}


#line 413 "DataObject.vala"
static void data_object_real_internal_collection_thawed (DataObject* self) {
#line 2452 "DataObject.c"
	Alteration* copy;
	Alteration* _tmp0_;
#line 413 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 415 "DataObject.vala"
	if (self->priv->frozen_alteration == NULL) {
#line 416 "DataObject.vala"
		return;
#line 2461 "DataObject.c"
	}
#line 419 "DataObject.vala"
	copy = _alteration_ref0 (self->priv->frozen_alteration);
#line 420 "DataObject.vala"
	self->priv->frozen_alteration = (_tmp0_ = NULL, _alteration_unref0 (self->priv->frozen_alteration), _tmp0_);
#line 424 "DataObject.vala"
	g_signal_emit_by_name (self, "altered", copy);
#line 2469 "DataObject.c"
	_alteration_unref0 (copy);
}


#line 324 "DataObject.vala"
void data_object_internal_collection_thawed (DataObject* self) {
#line 324 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->internal_collection_thawed (self);
#line 2478 "DataObject.c"
}


#line 427 "DataObject.vala"
inline gint64 data_object_get_object_id (DataObject* self) {
#line 2484 "DataObject.c"
	gint64 result = 0LL;
#line 427 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 2488 "DataObject.c"
	result = self->priv->object_id;
#line 428 "DataObject.vala"
	return result;
#line 2492 "DataObject.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


#line 431 "DataObject.vala"
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def) {
#line 2514 "DataObject.c"
	GValue* result = NULL;
	GValue* _result_;
	GValue* _tmp0_ = NULL;
#line 431 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 431 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 432 "DataObject.vala"
	if (self->priv->member_of == NULL) {
#line 2524 "DataObject.c"
		result = __g_value_dup0 (def);
#line 433 "DataObject.vala"
		return result;
#line 2528 "DataObject.c"
	}
#line 435 "DataObject.vala"
	_result_ = data_collection_get_property (self->priv->member_of, name);
#line 437 "DataObject.vala"
	if (_result_ != NULL) {
#line 437 "DataObject.vala"
		_tmp0_ = _result_;
#line 2536 "DataObject.c"
	} else {
#line 437 "DataObject.vala"
		_tmp0_ = def;
#line 2540 "DataObject.c"
	}
	result = __g_value_dup0 (_tmp0_);
	__vala_GValue_free0 (_result_);
#line 437 "DataObject.vala"
	return result;
#line 2546 "DataObject.c"
}


#line 440 "DataObject.vala"
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 440 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 440 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 441 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 442 "DataObject.vala"
		data_collection_set_property (self->priv->member_of, name, val, value_equals, value_equals_target);
#line 2560 "DataObject.c"
	}
}


#line 445 "DataObject.vala"
void data_object_clear_collection_property (DataObject* self, const char* name) {
#line 445 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 445 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 446 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 447 "DataObject.vala"
		data_collection_clear_property (self->priv->member_of, name);
#line 2575 "DataObject.c"
	}
}


#line 319 "DataObject.vala"
static void data_object_real_altered (DataObject* self, Alteration* alteration) {
#line 319 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 319 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 2586 "DataObject.c"
}


static void data_object_class_init (DataObjectClass * klass) {
	data_object_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataObjectPrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_object_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_object_real_notify_membership_changed;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_set = data_object_real_notify_collection_property_set;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_cleared = data_object_real_notify_collection_property_cleared;
	DATA_OBJECT_CLASS (klass)->get_name = data_object_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_object_real_to_string;
	DATA_OBJECT_CLASS (klass)->internal_collection_thawed = data_object_real_internal_collection_thawed;
	DATA_OBJECT_CLASS (klass)->altered = data_object_real_altered;
	G_OBJECT_CLASS (klass)->finalize = data_object_finalize;
	g_signal_new ("altered", TYPE_DATA_OBJECT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataObjectClass, altered), NULL, NULL, g_cclosure_user_marshal_VOID__ALTERATION, G_TYPE_NONE, 1, TYPE_ALTERATION);
}


static void data_object_instance_init (DataObject * self) {
	self->priv = DATA_OBJECT_GET_PRIVATE (self);
	self->priv->object_id = DATA_OBJECT_INVALID_OBJECT_ID;
	self->priv->member_of = NULL;
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
	self->priv->frozen_alteration = NULL;
}


static void data_object_finalize (GObject* obj) {
	DataObject * self;
	self = DATA_OBJECT (obj);
	_data_collection_unref0 (self->priv->member_of);
	_alteration_unref0 (self->priv->frozen_alteration);
	G_OBJECT_CLASS (data_object_parent_class)->finalize (obj);
}


GType data_object_get_type (void) {
	static volatile gsize data_object_type_id__volatile = 0;
	if (g_once_init_enter (&data_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataObject), 0, (GInstanceInitFunc) data_object_instance_init, NULL };
		GType data_object_type_id;
		data_object_type_id = g_type_register_static (G_TYPE_OBJECT, "DataObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_object_type_id__volatile, data_object_type_id);
	}
	return data_object_type_id__volatile;
}


#line 490 "DataObject.vala"
static void source_snapshot_real_notify_broken (SourceSnapshot* self) {
#line 490 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 491 "DataObject.vala"
	self->priv->snapshot_broken = TRUE;
#line 493 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 2644 "DataObject.c"
}


#line 324 "DataObject.vala"
void source_snapshot_notify_broken (SourceSnapshot* self) {
#line 324 "DataObject.vala"
	SOURCE_SNAPSHOT_GET_CLASS (self)->notify_broken (self);
#line 2652 "DataObject.c"
}


#line 496 "DataObject.vala"
gboolean source_snapshot_is_broken (SourceSnapshot* self) {
#line 2658 "DataObject.c"
	gboolean result = FALSE;
#line 496 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_SNAPSHOT (self), FALSE);
#line 2662 "DataObject.c"
	result = self->priv->snapshot_broken;
#line 497 "DataObject.vala"
	return result;
#line 2666 "DataObject.c"
}


#line 482 "DataObject.vala"
SourceSnapshot* source_snapshot_construct (GType object_type) {
#line 2672 "DataObject.c"
	SourceSnapshot* self;
	self = (SourceSnapshot*) g_type_create_instance (object_type);
	return self;
}


#line 487 "DataObject.vala"
static void source_snapshot_real_broken (SourceSnapshot* self) {
#line 487 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 2683 "DataObject.c"
}


static void value_source_snapshot_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_snapshot_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_snapshot_unref (value->data[0].v_pointer);
	}
}


static void value_source_snapshot_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_snapshot_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_snapshot_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceSnapshot* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_snapshot_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_snapshot_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceSnapshot** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceSnapshot* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_snapshot (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_snapshot_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


void value_take_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


static void source_snapshot_class_init (SourceSnapshotClass * klass) {
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
	SOURCE_SNAPSHOT_CLASS (klass)->finalize = source_snapshot_finalize;
	g_type_class_add_private (klass, sizeof (SourceSnapshotPrivate));
	SOURCE_SNAPSHOT_CLASS (klass)->notify_broken = source_snapshot_real_notify_broken;
	SOURCE_SNAPSHOT_CLASS (klass)->broken = source_snapshot_real_broken;
	g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_snapshot_instance_init (SourceSnapshot * self) {
	self->priv = SOURCE_SNAPSHOT_GET_PRIVATE (self);
	self->priv->snapshot_broken = FALSE;
	self->ref_count = 1;
}


static void source_snapshot_finalize (SourceSnapshot* obj) {
	SourceSnapshot * self;
	self = SOURCE_SNAPSHOT (obj);
}


GType source_snapshot_get_type (void) {
	static volatile gsize source_snapshot_type_id__volatile = 0;
	if (g_once_init_enter (&source_snapshot_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_snapshot_type_id;
		source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_snapshot_type_id__volatile, source_snapshot_type_id);
	}
	return source_snapshot_type_id__volatile;
}


gpointer source_snapshot_ref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_snapshot_unref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1153 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 2854 "DataObject.c"
	gboolean result = FALSE;
#line 1153 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1153 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 2860 "DataObject.c"
	result = strstr (self, needle) != NULL;
#line 1154 "glib-2.0.vapi"
	return result;
#line 2864 "DataObject.c"
}


#line 520 "DataObject.vala"
SourceBacklink* source_backlink_construct (GType object_type, const char* name, const char* value) {
#line 2870 "DataObject.c"
	SourceBacklink* self;
	char* _tmp0_;
	char* _tmp1_;
#line 520 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 520 "DataObject.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 2878 "DataObject.c"
	self = (SourceBacklink*) g_type_create_instance (object_type);
#line 521 "DataObject.vala"
	g_assert (!string_contains (name, "="));
#line 522 "DataObject.vala"
	g_assert (!string_contains (name, "|"));
#line 523 "DataObject.vala"
	g_assert (!string_contains (value, "|"));
#line 525 "DataObject.vala"
	self->priv->_name = (_tmp0_ = string_strip (name), _g_free0 (self->priv->_name), _tmp0_);
#line 526 "DataObject.vala"
	self->priv->_value = (_tmp1_ = string_strip (value), _g_free0 (self->priv->_value), _tmp1_);
#line 2890 "DataObject.c"
	return self;
}


#line 520 "DataObject.vala"
SourceBacklink* source_backlink_new (const char* name, const char* value) {
#line 520 "DataObject.vala"
	return source_backlink_construct (TYPE_SOURCE_BACKLINK, name, value);
#line 2899 "DataObject.c"
}


#line 529 "DataObject.vala"
char* source_backlink_to_string (SourceBacklink* self) {
#line 2905 "DataObject.c"
	char* result = NULL;
#line 529 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
#line 2909 "DataObject.c"
	result = g_strdup_printf ("Backlink %s=%s", source_backlink_get_name (self), source_backlink_get_value (self));
#line 530 "DataObject.vala"
	return result;
#line 2913 "DataObject.c"
}


#line 533 "DataObject.vala"
guint source_backlink_hash_func (void* key) {
#line 2919 "DataObject.c"
	guint result = 0U;
	SourceBacklink* backlink;
#line 534 "DataObject.vala"
	backlink = (SourceBacklink*) key;
#line 2924 "DataObject.c"
	result = g_str_hash (SOURCE_BACKLINK (backlink)->priv->_name) ^ g_str_hash (SOURCE_BACKLINK (backlink)->priv->_value);
#line 536 "DataObject.vala"
	return result;
#line 2928 "DataObject.c"
}


#line 539 "DataObject.vala"
gboolean source_backlink_equal_func (void* a, void* b) {
#line 2934 "DataObject.c"
	gboolean result = FALSE;
	SourceBacklink* alink;
	SourceBacklink* blink;
	gboolean _tmp0_ = FALSE;
#line 540 "DataObject.vala"
	alink = (SourceBacklink*) a;
#line 541 "DataObject.vala"
	blink = (SourceBacklink*) b;
#line 543 "DataObject.vala"
	if (g_str_equal (SOURCE_BACKLINK (alink)->priv->_name, SOURCE_BACKLINK (blink)->priv->_name)) {
#line 543 "DataObject.vala"
		_tmp0_ = g_str_equal (SOURCE_BACKLINK (alink)->priv->_value, SOURCE_BACKLINK (blink)->priv->_value);
#line 2947 "DataObject.c"
	} else {
#line 543 "DataObject.vala"
		_tmp0_ = FALSE;
#line 2951 "DataObject.c"
	}
	result = _tmp0_;
#line 543 "DataObject.vala"
	return result;
#line 2956 "DataObject.c"
}


const char* source_backlink_get_name (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_name;
#line 510 "DataObject.vala"
	return result;
#line 2966 "DataObject.c"
}


const char* source_backlink_get_value (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_value;
#line 516 "DataObject.vala"
	return result;
#line 2976 "DataObject.c"
}


static void value_source_backlink_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_backlink_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_backlink_unref (value->data[0].v_pointer);
	}
}


static void value_source_backlink_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_backlink_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_backlink_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_backlink_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceBacklink* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_backlink_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_backlink_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceBacklink** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_backlink_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceBacklink* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_BACKLINK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_backlink (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_backlink_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


void value_take_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


static void source_backlink_class_init (SourceBacklinkClass * klass) {
	source_backlink_parent_class = g_type_class_peek_parent (klass);
	SOURCE_BACKLINK_CLASS (klass)->finalize = source_backlink_finalize;
	g_type_class_add_private (klass, sizeof (SourceBacklinkPrivate));
}


static void source_backlink_instance_init (SourceBacklink * self) {
	self->priv = SOURCE_BACKLINK_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_backlink_finalize (SourceBacklink* obj) {
	SourceBacklink * self;
	self = SOURCE_BACKLINK (obj);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_value);
}


GType source_backlink_get_type (void) {
	static volatile gsize source_backlink_type_id__volatile = 0;
	if (g_once_init_enter (&source_backlink_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_backlink_init, value_source_backlink_free_value, value_source_backlink_copy_value, value_source_backlink_peek_pointer, "p", value_source_backlink_collect_value, "p", value_source_backlink_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceBacklinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_backlink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBacklink), 0, (GInstanceInitFunc) source_backlink_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_backlink_type_id;
		source_backlink_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceBacklink", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_backlink_type_id__volatile, source_backlink_type_id);
	}
	return source_backlink_type_id__volatile;
}


gpointer source_backlink_ref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_backlink_unref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_BACKLINK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 572 "DataObject.vala"
DataSource* data_source_construct (GType object_type, gint64 object_id) {
#line 3145 "DataObject.c"
	DataSource * self;
#line 573 "DataObject.vala"
	self = (DataSource*) data_object_construct (object_type, object_id);
#line 3149 "DataObject.c"
	return self;
}


#line 608 "DataObject.vala"
static void _data_source_subscriber_altered_data_source_contact_subscriber_alteration (DataView* view, Alteration* alteration, gpointer self) {
#line 3156 "DataObject.c"
	data_source_subscriber_altered (self, view, alteration);
}


#line 582 "DataObject.vala"
static void data_source_real_notify_altered (DataObject* base, Alteration* alteration) {
#line 3163 "DataObject.c"
	DataSource * self;
	gboolean _tmp0_ = FALSE;
	DataCollection* _tmp1_;
	gboolean _tmp2_;
	self = DATA_SOURCE (base);
#line 582 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 584 "DataObject.vala"
	if ((_tmp2_ = (_tmp1_ = data_object_get_membership (DATA_OBJECT (self))) != NULL, _data_collection_unref0 (_tmp1_), _tmp2_)) {
#line 3173 "DataObject.c"
		DataCollection* _tmp3_;
#line 584 "DataObject.vala"
		_tmp0_ = data_collection_are_notifications_frozen (_tmp3_ = data_object_get_membership (DATA_OBJECT (self)));
#line 3177 "DataObject.c"
		_data_collection_unref0 (_tmp3_);
	} else {
#line 584 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3182 "DataObject.c"
	}
#line 584 "DataObject.vala"
	if (_tmp0_) {
#line 3186 "DataObject.c"
		Alteration* _tmp4_;
		Alteration* _tmp7_;
		_tmp4_ = NULL;
#line 585 "DataObject.vala"
		if (self->priv->frozen_alteration == NULL) {
#line 3192 "DataObject.c"
			Alteration* _tmp5_;
#line 585 "DataObject.vala"
			_tmp4_ = (_tmp5_ = _alteration_ref0 (alteration), _alteration_unref0 (_tmp4_), _tmp5_);
#line 3196 "DataObject.c"
		} else {
			Alteration* _tmp6_;
#line 586 "DataObject.vala"
			_tmp4_ = (_tmp6_ = alteration_compress (self->priv->frozen_alteration, alteration), _alteration_unref0 (_tmp4_), _tmp6_);
#line 3201 "DataObject.c"
		}
#line 585 "DataObject.vala"
		self->priv->frozen_alteration = (_tmp7_ = _alteration_ref0 (_tmp4_), _alteration_unref0 (self->priv->frozen_alteration), _tmp7_);
#line 3205 "DataObject.c"
		_alteration_unref0 (_tmp4_);
	} else {
#line 589 "DataObject.vala"
		data_source_contact_subscribers_alteration (self, _data_source_subscriber_altered_data_source_contact_subscriber_alteration, self, alteration);
#line 3210 "DataObject.c"
	}
#line 593 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (DATA_OBJECT (self), alteration);
#line 3214 "DataObject.c"
}


#line 596 "DataObject.vala"
static void data_source_real_internal_collection_thawed (DataObject* base) {
#line 3220 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 597 "DataObject.vala"
	if (self->priv->frozen_alteration != NULL) {
#line 3225 "DataObject.c"
		Alteration* alteration;
		Alteration* _tmp0_;
#line 599 "DataObject.vala"
		alteration = _alteration_ref0 (self->priv->frozen_alteration);
#line 600 "DataObject.vala"
		self->priv->frozen_alteration = (_tmp0_ = NULL, _alteration_unref0 (self->priv->frozen_alteration), _tmp0_);
#line 602 "DataObject.vala"
		data_source_contact_subscribers_alteration (self, _data_source_subscriber_altered_data_source_contact_subscriber_alteration, self, alteration);
#line 3234 "DataObject.c"
		_alteration_unref0 (alteration);
	}
#line 605 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->internal_collection_thawed (DATA_OBJECT (self));
#line 3239 "DataObject.c"
}


#line 608 "DataObject.vala"
static void data_source_subscriber_altered (DataSource* self, DataView* view, Alteration* alteration) {
#line 608 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 608 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 608 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 609 "DataObject.vala"
	data_object_notify_altered (DATA_OBJECT (view), alteration);
#line 3253 "DataObject.c"
}


#line 612 "DataObject.vala"
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection) {
#line 3259 "DataObject.c"
	DataSource * self;
	gboolean _tmp0_ = FALSE;
	self = DATA_SOURCE (base);
#line 612 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 614 "DataObject.vala"
	if (collection == NULL) {
#line 615 "DataObject.vala"
		g_assert (self->priv->is_destroyed || (self->priv->backlinks != NULL));
#line 3269 "DataObject.c"
	} else {
#line 617 "DataObject.vala"
		g_assert (!self->priv->is_destroyed);
#line 3273 "DataObject.c"
	}
#line 621 "DataObject.vala"
	if (collection == NULL) {
#line 621 "DataObject.vala"
		_tmp0_ = self->priv->backlinks != NULL;
#line 3279 "DataObject.c"
	} else {
#line 621 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3283 "DataObject.c"
	}
#line 621 "DataObject.vala"
	if (_tmp0_) {
#line 622 "DataObject.vala"
		data_source_notify_unlinked (self);
#line 3289 "DataObject.c"
	}
#line 624 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (DATA_OBJECT (self), collection);
#line 3293 "DataObject.c"
}


#line 648 "DataObject.vala"
static void _data_source_subscriber_unlinking_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 3299 "DataObject.c"
	data_source_subscriber_unlinking (self, view);
}


#line 628 "DataObject.vala"
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection) {
#line 3306 "DataObject.c"
	GeeHashMap* _tmp0_;
#line 628 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 628 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 629 "DataObject.vala"
	g_assert ((self->priv->backlinks == NULL) && (self->priv->unlinked_from_collection == NULL));
#line 631 "DataObject.vala"
	self->priv->unlinked_from_collection = collection;
#line 632 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 634 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_unlinking_data_source_contact_subscriber, self);
#line 3320 "DataObject.c"
}


#line 572 "DataObject.vala"
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection) {
#line 572 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinking (self, collection);
#line 3328 "DataObject.c"
}


#line 638 "DataObject.vala"
static void data_source_real_notify_unlinked (DataSource* self) {
#line 638 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 639 "DataObject.vala"
	g_assert ((self->priv->unlinked_from_collection != NULL) && (self->priv->backlinks != NULL));
#line 641 "DataObject.vala"
	g_signal_emit_by_name (self, "unlinked", self->priv->unlinked_from_collection);
#line 644 "DataObject.vala"
	if (gee_map_get_size (GEE_MAP (self->priv->backlinks)) > 0) {
#line 3342 "DataObject.c"
		char* _tmp0_;
#line 645 "DataObject.vala"
		data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp0_ = data_source_dehydrate_backlinks (self));
#line 3346 "DataObject.c"
		_g_free0 (_tmp0_);
	}
}


#line 572 "DataObject.vala"
void data_source_notify_unlinked (DataSource* self) {
#line 572 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinked (self);
#line 3356 "DataObject.c"
}


#line 648 "DataObject.vala"
static void data_source_subscriber_unlinking (DataSource* self, DataView* view) {
#line 648 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 648 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 649 "DataObject.vala"
	data_view_notify_source_unlinking (view, self->priv->unlinked_from_collection);
#line 3368 "DataObject.c"
}


#line 653 "DataObject.vala"
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection) {
#line 653 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 653 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 654 "DataObject.vala"
	g_assert ((self->priv->backlinks != NULL) && (self->priv->unlinked_from_collection == collection));
#line 3380 "DataObject.c"
}


#line 572 "DataObject.vala"
void data_source_notify_relinking (DataSource* self, SourceCollection* collection) {
#line 572 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinking (self, collection);
#line 3388 "DataObject.c"
}


#line 671 "DataObject.vala"
static void _data_source_subscriber_relinked_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 3394 "DataObject.c"
	data_source_subscriber_relinked (self, view);
}


#line 658 "DataObject.vala"
static void data_source_real_notify_relinked (DataSource* self) {
#line 3401 "DataObject.c"
	SourceCollection* relinked_to;
	GeeHashMap* _tmp0_;
#line 658 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 659 "DataObject.vala"
	g_assert ((self->priv->backlinks != NULL) && (self->priv->unlinked_from_collection != NULL));
#line 661 "DataObject.vala"
	relinked_to = _data_collection_ref0 (self->priv->unlinked_from_collection);
#line 662 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = NULL, _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 663 "DataObject.vala"
	self->priv->unlinked_from_collection = NULL;
#line 664 "DataObject.vala"
	g_signal_emit_by_name (self, "relinked", relinked_to);
#line 665 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_relinked_data_source_contact_subscriber, self);
#line 668 "DataObject.vala"
	data_source_commit_backlinks (self, NULL, NULL);
#line 3420 "DataObject.c"
	_data_collection_unref0 (relinked_to);
}


#line 572 "DataObject.vala"
void data_source_notify_relinked (DataSource* self) {
#line 572 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinked (self);
#line 3429 "DataObject.c"
}


#line 671 "DataObject.vala"
static void data_source_subscriber_relinked (DataSource* self, DataView* view) {
#line 3435 "DataObject.c"
	SourceCollection* _tmp0_;
#line 671 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 671 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 672 "DataObject.vala"
	data_view_notify_source_relinked (view, _tmp0_ = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (self))));
#line 3443 "DataObject.c"
	_data_collection_unref0 (_tmp0_);
}


#line 675 "DataObject.vala"
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink) {
#line 3450 "DataObject.c"
	gboolean result = FALSE;
	GeeList* values;
	gboolean _tmp0_ = FALSE;
#line 675 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 675 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 676 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 3460 "DataObject.c"
		result = FALSE;
#line 677 "DataObject.vala"
		return result;
#line 3464 "DataObject.c"
	}
#line 679 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 681 "DataObject.vala"
	if (values != NULL) {
#line 681 "DataObject.vala"
		_tmp0_ = gee_collection_contains (GEE_COLLECTION (values), source_backlink_get_value (backlink));
#line 3472 "DataObject.c"
	} else {
#line 681 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3476 "DataObject.c"
	}
	result = _tmp0_;
	_g_object_unref0 (values);
#line 681 "DataObject.vala"
	return result;
#line 3482 "DataObject.c"
}


#line 684 "DataObject.vala"
GeeList* data_source_get_backlinks (DataSource* self, const char* name) {
#line 3488 "DataObject.c"
	GeeList* result = NULL;
	GeeList* values;
	gboolean _tmp0_ = FALSE;
	GeeList* backlinks;
#line 684 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 684 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 685 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 3499 "DataObject.c"
		result = NULL;
#line 686 "DataObject.vala"
		return result;
#line 3503 "DataObject.c"
	}
#line 688 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
#line 689 "DataObject.vala"
	if (values == NULL) {
#line 689 "DataObject.vala"
		_tmp0_ = TRUE;
#line 3511 "DataObject.c"
	} else {
#line 689 "DataObject.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (values)) == 0;
#line 3515 "DataObject.c"
	}
#line 689 "DataObject.vala"
	if (_tmp0_) {
#line 3519 "DataObject.c"
		result = NULL;
		_g_object_unref0 (values);
#line 690 "DataObject.vala"
		return result;
#line 3524 "DataObject.c"
	}
#line 692 "DataObject.vala"
	backlinks = GEE_LIST (gee_array_list_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, source_backlink_unref, NULL));
#line 3528 "DataObject.c"
	{
		GeeIterator* _value_it;
#line 693 "DataObject.vala"
		_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 693 "DataObject.vala"
		while (TRUE) {
#line 3535 "DataObject.c"
			char* value;
			SourceBacklink* _tmp1_;
#line 693 "DataObject.vala"
			if (!gee_iterator_next (_value_it)) {
#line 693 "DataObject.vala"
				break;
#line 3542 "DataObject.c"
			}
#line 693 "DataObject.vala"
			value = (char*) gee_iterator_get (_value_it);
#line 694 "DataObject.vala"
			gee_collection_add (GEE_COLLECTION (backlinks), _tmp1_ = source_backlink_new (name, value));
#line 3548 "DataObject.c"
			_source_backlink_unref0 (_tmp1_);
			_g_free0 (value);
		}
		_g_object_unref0 (_value_it);
	}
	result = backlinks;
	_g_object_unref0 (values);
#line 696 "DataObject.vala"
	return result;
#line 3558 "DataObject.c"
}


#line 699 "DataObject.vala"
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink) {
#line 3564 "DataObject.c"
	GeeList* values;
	SourceCollection* sources;
#line 699 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 699 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 701 "DataObject.vala"
	g_assert (self->priv->backlinks != NULL);
#line 703 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 704 "DataObject.vala"
	if (values == NULL) {
#line 3577 "DataObject.c"
		GeeList* _tmp0_;
#line 705 "DataObject.vala"
		values = (_tmp0_ = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL)), _g_object_unref0 (values), _tmp0_);
#line 706 "DataObject.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink), values);
#line 3583 "DataObject.c"
	}
#line 709 "DataObject.vala"
	gee_collection_add (GEE_COLLECTION (values), source_backlink_get_value (backlink));
#line 711 "DataObject.vala"
	sources = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 712 "DataObject.vala"
	if (sources != NULL) {
#line 713 "DataObject.vala"
		source_collection_internal_backlink_set (sources, self, backlink);
#line 3593 "DataObject.c"
	}
	_data_collection_unref0 (sources);
	_g_object_unref0 (values);
}


#line 716 "DataObject.vala"
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink) {
#line 3602 "DataObject.c"
	gboolean result = FALSE;
	GeeList* values;
	gint original_size;
	GeeIterator* iter;
	char* _tmp2_;
	SourceCollection* sources;
#line 716 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 716 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 717 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 3615 "DataObject.c"
		result = FALSE;
#line 718 "DataObject.vala"
		return result;
#line 3619 "DataObject.c"
	}
#line 720 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 721 "DataObject.vala"
	if (values == NULL) {
#line 3625 "DataObject.c"
		result = FALSE;
		_g_object_unref0 (values);
#line 722 "DataObject.vala"
		return result;
#line 3630 "DataObject.c"
	}
#line 724 "DataObject.vala"
	original_size = gee_collection_get_size (GEE_COLLECTION (values));
#line 725 "DataObject.vala"
	g_assert (original_size > 0);
#line 727 "DataObject.vala"
	iter = gee_iterable_iterator (GEE_ITERABLE (values));
#line 728 "DataObject.vala"
	while (TRUE) {
#line 3640 "DataObject.c"
		char* _tmp0_;
		gboolean _tmp1_;
#line 728 "DataObject.vala"
		if (!gee_iterator_next (iter)) {
#line 728 "DataObject.vala"
			break;
#line 3647 "DataObject.c"
		}
#line 729 "DataObject.vala"
		if ((_tmp1_ = _vala_strcmp0 (_tmp0_ = (char*) gee_iterator_get (iter), source_backlink_get_value (backlink)) == 0, _g_free0 (_tmp0_), _tmp1_)) {
#line 730 "DataObject.vala"
			gee_iterator_remove (iter);
#line 3653 "DataObject.c"
		}
	}
#line 733 "DataObject.vala"
	if (gee_collection_get_size (GEE_COLLECTION (values)) == 0) {
#line 734 "DataObject.vala"
		gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink), NULL);
#line 3660 "DataObject.c"
	}
#line 738 "DataObject.vala"
	data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp2_ = data_source_dehydrate_backlinks (self));
#line 3664 "DataObject.c"
	_g_free0 (_tmp2_);
#line 740 "DataObject.vala"
	sources = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 741 "DataObject.vala"
	if (sources != NULL) {
#line 742 "DataObject.vala"
		source_collection_internal_backlink_removed (sources, self, backlink);
#line 3672 "DataObject.c"
	}
	result = gee_collection_get_size (GEE_COLLECTION (values)) != original_size;
	_data_collection_unref0 (sources);
	_g_object_unref0 (iter);
	_g_object_unref0 (values);
#line 744 "DataObject.vala"
	return result;
#line 3680 "DataObject.c"
}


#line 753 "DataObject.vala"
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated) {
#line 3686 "DataObject.c"
	gboolean _tmp0_ = FALSE;
#line 753 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 753 "DataObject.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 754 "DataObject.vala"
	if (sources != NULL) {
#line 754 "DataObject.vala"
		_tmp0_ = TRUE;
#line 3696 "DataObject.c"
	} else {
#line 754 "DataObject.vala"
		_tmp0_ = dehydrated != NULL;
#line 3700 "DataObject.c"
	}
#line 754 "DataObject.vala"
	if (_tmp0_) {
#line 3704 "DataObject.c"
		char* _tmp1_;
#line 755 "DataObject.vala"
		g_warning ("DataObject.vala:755: No implementation to commit link state for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (self)));
#line 3708 "DataObject.c"
		_g_free0 (_tmp1_);
	}
}


#line 572 "DataObject.vala"
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated) {
#line 572 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->commit_backlinks (self, sources, dehydrated);
#line 3718 "DataObject.c"
}


#line 758 "DataObject.vala"
static char* data_source_dehydrate_backlinks (DataSource* self) {
#line 3724 "DataObject.c"
	char* result = NULL;
	gboolean _tmp0_ = FALSE;
	GString* builder;
	const char* _tmp8_;
#line 758 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 759 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 759 "DataObject.vala"
		_tmp0_ = TRUE;
#line 3735 "DataObject.c"
	} else {
#line 759 "DataObject.vala"
		_tmp0_ = gee_map_get_size (GEE_MAP (self->priv->backlinks)) == 0;
#line 3739 "DataObject.c"
	}
#line 759 "DataObject.vala"
	if (_tmp0_) {
#line 3743 "DataObject.c"
		result = NULL;
#line 760 "DataObject.vala"
		return result;
#line 3747 "DataObject.c"
	}
#line 762 "DataObject.vala"
	builder = g_string_new ("");
#line 3751 "DataObject.c"
	{
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _name_it;
#line 763 "DataObject.vala"
		_name_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = gee_map_get_keys (GEE_MAP (self->priv->backlinks)))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 763 "DataObject.vala"
		while (TRUE) {
#line 3760 "DataObject.c"
			char* name;
			GeeList* values;
			gboolean _tmp3_ = FALSE;
			char* value_field;
#line 763 "DataObject.vala"
			if (!gee_iterator_next (_name_it)) {
#line 763 "DataObject.vala"
				break;
#line 3769 "DataObject.c"
			}
#line 763 "DataObject.vala"
			name = (char*) gee_iterator_get (_name_it);
#line 764 "DataObject.vala"
			values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
#line 765 "DataObject.vala"
			if (values == NULL) {
#line 765 "DataObject.vala"
				_tmp3_ = TRUE;
#line 3779 "DataObject.c"
			} else {
#line 765 "DataObject.vala"
				_tmp3_ = gee_collection_get_size (GEE_COLLECTION (values)) == 0;
#line 3783 "DataObject.c"
			}
#line 765 "DataObject.vala"
			if (_tmp3_) {
#line 3787 "DataObject.c"
				_g_object_unref0 (values);
				_g_free0 (name);
#line 766 "DataObject.vala"
				continue;
#line 3792 "DataObject.c"
			}
#line 768 "DataObject.vala"
			value_field = g_strdup ("");
#line 3796 "DataObject.c"
			{
				GeeIterator* _value_it;
#line 769 "DataObject.vala"
				_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 769 "DataObject.vala"
				while (TRUE) {
#line 3803 "DataObject.c"
					char* value;
					gboolean _tmp4_ = FALSE;
#line 769 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 769 "DataObject.vala"
						break;
#line 3810 "DataObject.c"
					}
#line 769 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 770 "DataObject.vala"
					if (value != NULL) {
#line 770 "DataObject.vala"
						_tmp4_ = string_get_length (value) > 0;
#line 3818 "DataObject.c"
					} else {
#line 770 "DataObject.vala"
						_tmp4_ = FALSE;
#line 3822 "DataObject.c"
					}
#line 770 "DataObject.vala"
					if (_tmp4_) {
#line 3826 "DataObject.c"
						char* _tmp5_;
						char* _tmp6_;
#line 771 "DataObject.vala"
						value_field = (_tmp6_ = g_strconcat (value_field, _tmp5_ = g_strconcat (value, "|", NULL), NULL), _g_free0 (value_field), _tmp6_);
#line 3831 "DataObject.c"
						_g_free0 (_tmp5_);
					}
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
#line 774 "DataObject.vala"
			if (string_get_length (value_field) > 0) {
#line 3840 "DataObject.c"
				char* _tmp7_;
#line 775 "DataObject.vala"
				g_string_append (builder, _tmp7_ = g_strdup_printf ("%s=%s\n", name, value_field));
#line 3844 "DataObject.c"
				_g_free0 (_tmp7_);
			}
			_g_free0 (value_field);
			_g_object_unref0 (values);
			_g_free0 (name);
		}
		_g_object_unref0 (_name_it);
	}
	_tmp8_ = NULL;
#line 778 "DataObject.vala"
	if (string_get_length (builder->str) > 0) {
#line 778 "DataObject.vala"
		_tmp8_ = builder->str;
#line 3858 "DataObject.c"
	} else {
#line 778 "DataObject.vala"
		_tmp8_ = NULL;
#line 3862 "DataObject.c"
	}
	result = g_strdup (_tmp8_);
	_g_string_free0 (builder);
#line 778 "DataObject.vala"
	return result;
#line 3868 "DataObject.c"
}


#line 783 "DataObject.vala"
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const char* dehydrated) {
#line 3874 "DataObject.c"
	GeeHashMap* _tmp0_;
	gint lines_length1;
	gint _lines_size_;
	char** _tmp2_;
	char** _tmp1_;
	char** lines;
#line 783 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 783 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (unlinked_from));
#line 784 "DataObject.vala"
	self->priv->unlinked_from_collection = unlinked_from;
#line 785 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 787 "DataObject.vala"
	if (dehydrated == NULL) {
#line 788 "DataObject.vala"
		return;
#line 3893 "DataObject.c"
	}
	lines = (_tmp2_ = _tmp1_ = g_strsplit (dehydrated, "\n", 0), lines_length1 = _vala_array_length (_tmp1_), _lines_size_ = lines_length1, _tmp2_);
	{
		char** line_collection;
		int line_collection_length1;
		int line_it;
#line 791 "DataObject.vala"
		line_collection = lines;
#line 3902 "DataObject.c"
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			char* line;
			line = g_strdup (line_collection[line_it]);
			{
				gint tokens_length1;
				gint _tokens_size_;
				char** _tmp4_;
				char** _tmp3_;
				char** tokens;
				gint decoded_values_length1;
				gint _decoded_values_size_;
				char** _tmp7_;
				char** _tmp6_;
				char** decoded_values;
				GeeList* values;
#line 792 "DataObject.vala"
				if (string_get_length (line) == 0) {
#line 3921 "DataObject.c"
					_g_free0 (line);
#line 793 "DataObject.vala"
					continue;
#line 3925 "DataObject.c"
				}
				tokens = (_tmp4_ = _tmp3_ = g_strsplit (line, "=", 2), tokens_length1 = _vala_array_length (_tmp3_), _tokens_size_ = tokens_length1, _tmp4_);
#line 796 "DataObject.vala"
				if (tokens_length1 < 2) {
#line 3930 "DataObject.c"
					char* _tmp5_;
#line 797 "DataObject.vala"
					g_warning ("DataObject.vala:797: Unable to rehydrate \"%s\" for %s: name and value" \
" not present", line, _tmp5_ = data_object_to_string (DATA_OBJECT (self)));
#line 3934 "DataObject.c"
					_g_free0 (_tmp5_);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (line);
#line 800 "DataObject.vala"
					continue;
#line 3940 "DataObject.c"
				}
				decoded_values = (_tmp7_ = _tmp6_ = g_strsplit (tokens[1], "|", 0), decoded_values_length1 = _vala_array_length (_tmp6_), _decoded_values_size_ = decoded_values_length1, _tmp7_);
#line 804 "DataObject.vala"
				values = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL));
#line 3945 "DataObject.c"
				{
					char** value_collection;
					int value_collection_length1;
					int value_it;
#line 805 "DataObject.vala"
					value_collection = decoded_values;
#line 3952 "DataObject.c"
					value_collection_length1 = decoded_values_length1;
					for (value_it = 0; value_it < decoded_values_length1; value_it = value_it + 1) {
						char* value;
						value = g_strdup (value_collection[value_it]);
						{
							gboolean _tmp8_ = FALSE;
#line 806 "DataObject.vala"
							if (value != NULL) {
#line 806 "DataObject.vala"
								_tmp8_ = string_get_length (value) > 0;
#line 3963 "DataObject.c"
							} else {
#line 806 "DataObject.vala"
								_tmp8_ = FALSE;
#line 3967 "DataObject.c"
							}
#line 806 "DataObject.vala"
							if (_tmp8_) {
#line 807 "DataObject.vala"
								gee_collection_add (GEE_COLLECTION (values), value);
#line 3973 "DataObject.c"
							}
							_g_free0 (value);
						}
					}
				}
#line 810 "DataObject.vala"
				if (gee_collection_get_size (GEE_COLLECTION (values)) > 0) {
#line 811 "DataObject.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), tokens[0], values);
#line 3983 "DataObject.c"
				}
				_g_object_unref0 (values);
				decoded_values = (_vala_array_free (decoded_values, decoded_values_length1, (GDestroyNotify) g_free), NULL);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (line);
			}
		}
	}
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
}


#line 816 "DataObject.vala"
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self) {
#line 3998 "DataObject.c"
	SourceSnapshot* result = NULL;
#line 816 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 4002 "DataObject.c"
	result = NULL;
#line 817 "DataObject.vala"
	return result;
#line 4006 "DataObject.c"
}


#line 572 "DataObject.vala"
SourceSnapshot* data_source_save_snapshot (DataSource* self) {
#line 572 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->save_snapshot (self);
#line 4014 "DataObject.c"
}


#line 821 "DataObject.vala"
void data_source_internal_mark_for_destroy (DataSource* self) {
#line 821 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 822 "DataObject.vala"
	self->priv->marked_for_destroy = TRUE;
#line 4024 "DataObject.c"
}


#line 829 "DataObject.vala"
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error) {
#line 4030 "DataObject.c"
	gboolean result = FALSE;
#line 829 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 4034 "DataObject.c"
	result = TRUE;
#line 830 "DataObject.vala"
	return result;
#line 4038 "DataObject.c"
}


#line 572 "DataObject.vala"
gboolean data_source_internal_delete_backing (DataSource* self, GError** error) {
#line 572 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->internal_delete_backing (self, error);
#line 4046 "DataObject.c"
}


#line 835 "DataObject.vala"
static gboolean data_source_real_equals (DataSource* self, DataSource* source) {
#line 4052 "DataObject.c"
	gboolean result = FALSE;
#line 835 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 835 "DataObject.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 4058 "DataObject.c"
	result = self == source;
#line 836 "DataObject.vala"
	return result;
#line 4062 "DataObject.c"
}


#line 572 "DataObject.vala"
gboolean data_source_equals (DataSource* self, DataSource* source) {
#line 572 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->equals (self, source);
#line 4070 "DataObject.c"
}


#line 845 "DataObject.vala"
static void data_source_real_destroy (DataSource* self) {
#line 845 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 846 "DataObject.vala"
	g_assert (self->priv->marked_for_destroy);
#line 849 "DataObject.vala"
	self->priv->is_destroyed = TRUE;
#line 4082 "DataObject.c"
	{
		gint ctr;
#line 852 "DataObject.vala"
		ctr = 0;
#line 4087 "DataObject.c"
		{
			gboolean _tmp0_;
#line 852 "DataObject.vala"
			_tmp0_ = TRUE;
#line 852 "DataObject.vala"
			while (TRUE) {
#line 852 "DataObject.vala"
				if (!_tmp0_) {
#line 852 "DataObject.vala"
					ctr++;
#line 4098 "DataObject.c"
				}
#line 852 "DataObject.vala"
				_tmp0_ = FALSE;
#line 852 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 852 "DataObject.vala"
					break;
#line 4106 "DataObject.c"
				}
#line 853 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 4110 "DataObject.c"
					DataView* view;
					DataView* _tmp1_;
#line 854 "DataObject.vala"
					view = _g_object_ref0 (self->priv->subscribers[ctr]);
#line 855 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 857 "DataObject.vala"
					data_view_notify_unsubscribed (view, self);
#line 4119 "DataObject.c"
					_g_object_unref0 (view);
				}
			}
		}
	}
#line 862 "DataObject.vala"
	g_signal_emit_by_name (self, "destroyed");
#line 4127 "DataObject.c"
}


#line 572 "DataObject.vala"
void data_source_destroy (DataSource* self) {
#line 572 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->destroy (self);
#line 4135 "DataObject.c"
}


#line 870 "DataObject.vala"
void data_source_destroy_orphan (DataSource* self, gboolean delete_backing) {
#line 4141 "DataObject.c"
	GError * _inner_error_ = NULL;
#line 870 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 871 "DataObject.vala"
	if (delete_backing) {
#line 4147 "DataObject.c"
		{
			gboolean _tmp0_;
#line 873 "DataObject.vala"
			_tmp0_ = data_source_internal_delete_backing (self, &_inner_error_);
#line 4152 "DataObject.c"
			if (_inner_error_ != NULL) {
				goto __catch186_g_error;
			}
#line 873 "DataObject.vala"
			if (!_tmp0_) {
#line 4158 "DataObject.c"
				char* _tmp1_;
#line 874 "DataObject.vala"
				g_warning ("DataObject.vala:874: Unable to delete backing for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (self)));
#line 4162 "DataObject.c"
				_g_free0 (_tmp1_);
			}
		}
		goto __finally186;
		__catch186_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp2_;
#line 876 "DataObject.vala"
				g_warning ("DataObject.vala:876: Unable to delete backing for %s: %s", _tmp2_ = data_object_to_string (DATA_OBJECT (self)), err->message);
#line 4176 "DataObject.c"
				_g_free0 (_tmp2_);
				_g_error_free0 (err);
			}
		}
		__finally186:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 880 "DataObject.vala"
	data_source_internal_mark_for_destroy (self);
#line 881 "DataObject.vala"
	data_source_destroy (self);
#line 883 "DataObject.vala"
	if (self->priv->unlinked_from_collection != NULL) {
#line 884 "DataObject.vala"
		source_collection_notify_unlinked_destroyed (self->priv->unlinked_from_collection, self);
#line 4196 "DataObject.c"
	}
}


static void _vala_array_add194 (DataView*** array, int* length, int* size, DataView* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DataView*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 893 "DataObject.vala"
void data_source_internal_subscribe (DataSource* self, DataView* view) {
#line 893 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 893 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 894 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 4219 "DataObject.c"
	{
		gint ctr;
#line 896 "DataObject.vala"
		ctr = 0;
#line 4224 "DataObject.c"
		{
			gboolean _tmp0_;
#line 896 "DataObject.vala"
			_tmp0_ = TRUE;
#line 896 "DataObject.vala"
			while (TRUE) {
#line 896 "DataObject.vala"
				if (!_tmp0_) {
#line 896 "DataObject.vala"
					ctr++;
#line 4235 "DataObject.c"
				}
#line 896 "DataObject.vala"
				_tmp0_ = FALSE;
#line 896 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 896 "DataObject.vala"
					break;
#line 4243 "DataObject.c"
				}
#line 897 "DataObject.vala"
				if (self->priv->subscribers[ctr] == NULL) {
#line 4247 "DataObject.c"
					DataView* _tmp1_;
#line 898 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = _g_object_ref0 (view), _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 900 "DataObject.vala"
					return;
#line 4253 "DataObject.c"
				}
			}
		}
	}
#line 904 "DataObject.vala"
	_vala_array_add194 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _g_object_ref0 (view));
#line 4260 "DataObject.c"
}


#line 909 "DataObject.vala"
void data_source_internal_unsubscribe (DataSource* self, DataView* view) {
#line 909 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 909 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 910 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 4272 "DataObject.c"
	{
		gint ctr;
#line 912 "DataObject.vala"
		ctr = 0;
#line 4277 "DataObject.c"
		{
			gboolean _tmp0_;
#line 912 "DataObject.vala"
			_tmp0_ = TRUE;
#line 912 "DataObject.vala"
			while (TRUE) {
#line 912 "DataObject.vala"
				if (!_tmp0_) {
#line 912 "DataObject.vala"
					ctr++;
#line 4288 "DataObject.c"
				}
#line 912 "DataObject.vala"
				_tmp0_ = FALSE;
#line 912 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 912 "DataObject.vala"
					break;
#line 4296 "DataObject.c"
				}
#line 913 "DataObject.vala"
				if (self->priv->subscribers[ctr] == view) {
#line 4300 "DataObject.c"
					DataView* _tmp1_;
#line 914 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 916 "DataObject.vala"
					return;
#line 4306 "DataObject.c"
				}
			}
		}
	}
}


#line 921 "DataObject.vala"
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target) {
#line 921 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 922 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 924 "DataObject.vala"
	self->priv->in_contact = TRUE;
#line 4322 "DataObject.c"
	{
		gint ctr;
#line 925 "DataObject.vala"
		ctr = 0;
#line 4327 "DataObject.c"
		{
			gboolean _tmp0_;
#line 925 "DataObject.vala"
			_tmp0_ = TRUE;
#line 925 "DataObject.vala"
			while (TRUE) {
#line 925 "DataObject.vala"
				if (!_tmp0_) {
#line 925 "DataObject.vala"
					ctr++;
#line 4338 "DataObject.c"
				}
#line 925 "DataObject.vala"
				_tmp0_ = FALSE;
#line 925 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 925 "DataObject.vala"
					break;
#line 4346 "DataObject.c"
				}
#line 926 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 927 "DataObject.vala"
					contact_subscriber (self->priv->subscribers[ctr], contact_subscriber_target);
#line 4352 "DataObject.c"
				}
			}
		}
	}
#line 929 "DataObject.vala"
	self->priv->in_contact = FALSE;
#line 4359 "DataObject.c"
}


#line 932 "DataObject.vala"
void data_source_contact_subscribers_alteration (DataSource* self, DataSourceContactSubscriberAlteration contact_subscriber, void* contact_subscriber_target, Alteration* alteration) {
#line 932 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 932 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 934 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 936 "DataObject.vala"
	self->priv->in_contact = TRUE;
#line 4373 "DataObject.c"
	{
		gint ctr;
#line 937 "DataObject.vala"
		ctr = 0;
#line 4378 "DataObject.c"
		{
			gboolean _tmp0_;
#line 937 "DataObject.vala"
			_tmp0_ = TRUE;
#line 937 "DataObject.vala"
			while (TRUE) {
#line 937 "DataObject.vala"
				if (!_tmp0_) {
#line 937 "DataObject.vala"
					ctr++;
#line 4389 "DataObject.c"
				}
#line 937 "DataObject.vala"
				_tmp0_ = FALSE;
#line 937 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 937 "DataObject.vala"
					break;
#line 4397 "DataObject.c"
				}
#line 938 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 939 "DataObject.vala"
					contact_subscriber (self->priv->subscribers[ctr], alteration, contact_subscriber_target);
#line 4403 "DataObject.c"
				}
			}
		}
	}
#line 941 "DataObject.vala"
	self->priv->in_contact = FALSE;
#line 4410 "DataObject.c"
}


#line 560 "DataObject.vala"
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources) {
#line 560 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 560 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 4420 "DataObject.c"
}


#line 564 "DataObject.vala"
static void data_source_real_relinked (DataSource* self, SourceCollection* sources) {
#line 564 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 564 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 4430 "DataObject.c"
}


#line 569 "DataObject.vala"
static void data_source_real_destroyed (DataSource* self) {
#line 569 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 4438 "DataObject.c"
}


static void data_source_class_init (DataSourceClass * klass) {
	data_source_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataSourcePrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_source_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->internal_collection_thawed = data_source_real_internal_collection_thawed;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_source_real_notify_membership_changed;
	DATA_SOURCE_CLASS (klass)->notify_unlinking = data_source_real_notify_unlinking;
	DATA_SOURCE_CLASS (klass)->notify_unlinked = data_source_real_notify_unlinked;
	DATA_SOURCE_CLASS (klass)->notify_relinking = data_source_real_notify_relinking;
	DATA_SOURCE_CLASS (klass)->notify_relinked = data_source_real_notify_relinked;
	DATA_SOURCE_CLASS (klass)->commit_backlinks = data_source_real_commit_backlinks;
	DATA_SOURCE_CLASS (klass)->save_snapshot = data_source_real_save_snapshot;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = data_source_real_internal_delete_backing;
	DATA_SOURCE_CLASS (klass)->equals = data_source_real_equals;
	DATA_SOURCE_CLASS (klass)->destroy = data_source_real_destroy;
	DATA_SOURCE_CLASS (klass)->unlinked = data_source_real_unlinked;
	DATA_SOURCE_CLASS (klass)->relinked = data_source_real_relinked;
	DATA_SOURCE_CLASS (klass)->destroyed = data_source_real_destroyed;
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
	g_signal_new ("unlinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, unlinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("relinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, relinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_source_instance_init (DataSource * self) {
	self->priv = DATA_SOURCE_GET_PRIVATE (self);
	self->priv->subscribers = g_new0 (DataView*, 4 + 1);
	self->priv->subscribers_length1 = 4;
	self->priv->_subscribers_size_ = self->priv->subscribers_length1;
	self->priv->unlinked_from_collection = NULL;
	self->priv->backlinks = NULL;
	self->priv->in_contact = FALSE;
	self->priv->marked_for_destroy = FALSE;
	self->priv->is_destroyed = FALSE;
	self->priv->frozen_alteration = NULL;
}


static void data_source_finalize (GObject* obj) {
	DataSource * self;
	self = DATA_SOURCE (obj);
	{
	}
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->backlinks);
	_alteration_unref0 (self->priv->frozen_alteration);
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
}


GType data_source_get_type (void) {
	static volatile gsize data_source_type_id__volatile = 0;
	if (g_once_init_enter (&data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
		GType data_source_type_id;
		data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_source_type_id__volatile, data_source_type_id);
	}
	return data_source_type_id__volatile;
}


#line 949 "DataObject.vala"
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id) {
#line 4507 "DataObject.c"
	ThumbnailSource * self;
#line 950 "DataObject.vala"
	self = (ThumbnailSource*) data_source_construct (object_type, object_id);
#line 4511 "DataObject.c"
	return self;
}


#line 961 "DataObject.vala"
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 4518 "DataObject.c"
	thumbnail_source_subscriber_thumbnail_altered (self, view);
}


#line 953 "DataObject.vala"
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self) {
#line 953 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 955 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 958 "DataObject.vala"
	data_source_contact_subscribers (DATA_SOURCE (self), _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber, self);
#line 4531 "DataObject.c"
}


#line 949 "DataObject.vala"
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self) {
#line 949 "DataObject.vala"
	THUMBNAIL_SOURCE_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 4539 "DataObject.c"
}


#line 961 "DataObject.vala"
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view) {
#line 961 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 961 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 962 "DataObject.vala"
	thumbnail_view_notify_thumbnail_altered (THUMBNAIL_VIEW (view));
#line 4551 "DataObject.c"
}


#line 965 "DataObject.vala"
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 4557 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 949 "DataObject.vala"
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 949 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_thumbnail (self, scale, error);
#line 4568 "DataObject.c"
}


#line 969 "DataObject.vala"
static GdkPixbuf* thumbnail_source_real_create_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 4574 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_create_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 949 "DataObject.vala"
GdkPixbuf* thumbnail_source_create_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 949 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->create_thumbnail (self, scale, error);
#line 4585 "DataObject.c"
}


#line 971 "DataObject.vala"
static char* thumbnail_source_real_get_unique_thumbnail_name (ThumbnailSource* self) {
#line 4591 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_unique_thumbnail_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 949 "DataObject.vala"
char* thumbnail_source_get_unique_thumbnail_name (ThumbnailSource* self) {
#line 949 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_unique_thumbnail_name (self);
#line 4602 "DataObject.c"
}


#line 973 "DataObject.vala"
static PhotoFileFormat thumbnail_source_real_get_preferred_thumbnail_format (ThumbnailSource* self) {
#line 4608 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_preferred_thumbnail_format'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 949 "DataObject.vala"
PhotoFileFormat thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self) {
#line 949 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_preferred_thumbnail_format (self);
#line 4619 "DataObject.c"
}


#line 946 "DataObject.vala"
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self) {
#line 946 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 4627 "DataObject.c"
}


static void thumbnail_source_class_init (ThumbnailSourceClass * klass) {
	thumbnail_source_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_SOURCE_CLASS (klass)->notify_thumbnail_altered = thumbnail_source_real_notify_thumbnail_altered;
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = thumbnail_source_real_get_thumbnail;
	THUMBNAIL_SOURCE_CLASS (klass)->create_thumbnail = thumbnail_source_real_create_thumbnail;
	THUMBNAIL_SOURCE_CLASS (klass)->get_unique_thumbnail_name = thumbnail_source_real_get_unique_thumbnail_name;
	THUMBNAIL_SOURCE_CLASS (klass)->get_preferred_thumbnail_format = thumbnail_source_real_get_preferred_thumbnail_format;
	THUMBNAIL_SOURCE_CLASS (klass)->thumbnail_altered = thumbnail_source_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailSourceClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_source_instance_init (ThumbnailSource * self) {
}


GType thumbnail_source_get_type (void) {
	static volatile gsize thumbnail_source_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailSource), 0, (GInstanceInitFunc) thumbnail_source_instance_init, NULL };
		GType thumbnail_source_type_id;
		thumbnail_source_type_id = g_type_register_static (TYPE_DATA_SOURCE, "ThumbnailSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&thumbnail_source_type_id__volatile, thumbnail_source_type_id);
	}
	return thumbnail_source_type_id__volatile;
}


#line 977 "DataObject.vala"
PhotoSource* photo_source_construct (GType object_type, gint64 object_id) {
#line 4661 "DataObject.c"
	PhotoSource * self;
#line 978 "DataObject.vala"
	self = (PhotoSource*) thumbnail_source_construct (object_type, object_id);
#line 4665 "DataObject.c"
	return self;
}


#line 981 "DataObject.vala"
static time_t photo_source_real_get_exposure_time (PhotoSource* self) {
#line 4672 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_exposure_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 977 "DataObject.vala"
time_t photo_source_get_exposure_time (PhotoSource* self) {
#line 977 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_exposure_time (self);
#line 4682 "DataObject.c"
}


#line 983 "DataObject.vala"
static void photo_source_real_get_dimensions (PhotoSource* self, Dimensions* result) {
#line 4688 "DataObject.c"
	g_return_if_fail (IS_PHOTO_SOURCE (self));
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_dimensions'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 977 "DataObject.vala"
void photo_source_get_dimensions (PhotoSource* self, Dimensions* result) {
#line 977 "DataObject.vala"
	PHOTO_SOURCE_GET_CLASS (self)->get_dimensions (self, result);
#line 4699 "DataObject.c"
}


#line 985 "DataObject.vala"
static guint64 photo_source_real_get_filesize (PhotoSource* self) {
#line 4705 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 977 "DataObject.vala"
guint64 photo_source_get_filesize (PhotoSource* self) {
#line 977 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_filesize (self);
#line 4716 "DataObject.c"
}


#line 987 "DataObject.vala"
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self) {
#line 4722 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 977 "DataObject.vala"
PhotoMetadata* photo_source_get_metadata (PhotoSource* self) {
#line 977 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_metadata (self);
#line 4733 "DataObject.c"
}


#line 989 "DataObject.vala"
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 4739 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 977 "DataObject.vala"
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 977 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_pixbuf (self, scaling, error);
#line 4750 "DataObject.c"
}


static void photo_source_class_init (PhotoSourceClass * klass) {
	photo_source_parent_class = g_type_class_peek_parent (klass);
	PHOTO_SOURCE_CLASS (klass)->get_exposure_time = photo_source_real_get_exposure_time;
	PHOTO_SOURCE_CLASS (klass)->get_dimensions = photo_source_real_get_dimensions;
	PHOTO_SOURCE_CLASS (klass)->get_filesize = photo_source_real_get_filesize;
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_source_real_get_metadata;
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_source_real_get_pixbuf;
}


static void photo_source_instance_init (PhotoSource * self) {
}


GType photo_source_get_type (void) {
	static volatile gsize photo_source_type_id__volatile = 0;
	if (g_once_init_enter (&photo_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoSource), 0, (GInstanceInitFunc) photo_source_instance_init, NULL };
		GType photo_source_type_id;
		photo_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "PhotoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_source_type_id__volatile, photo_source_type_id);
	}
	return photo_source_type_id__volatile;
}


#line 993 "DataObject.vala"
EventSource* event_source_construct (GType object_type, gint64 object_id) {
#line 4782 "DataObject.c"
	EventSource * self;
#line 994 "DataObject.vala"
	self = (EventSource*) thumbnail_source_construct (object_type, object_id);
#line 4786 "DataObject.c"
	return self;
}


#line 997 "DataObject.vala"
static time_t event_source_real_get_start_time (EventSource* self) {
#line 4793 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_start_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 993 "DataObject.vala"
time_t event_source_get_start_time (EventSource* self) {
#line 993 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_start_time (self);
#line 4803 "DataObject.c"
}


#line 999 "DataObject.vala"
static time_t event_source_real_get_end_time (EventSource* self) {
#line 4809 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_end_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 993 "DataObject.vala"
time_t event_source_get_end_time (EventSource* self) {
#line 993 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_end_time (self);
#line 4819 "DataObject.c"
}


#line 1001 "DataObject.vala"
static guint64 event_source_real_get_total_filesize (EventSource* self) {
#line 4825 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_total_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 993 "DataObject.vala"
guint64 event_source_get_total_filesize (EventSource* self) {
#line 993 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_total_filesize (self);
#line 4836 "DataObject.c"
}


#line 1003 "DataObject.vala"
static gint event_source_real_get_photo_count (EventSource* self) {
#line 4842 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_photo_count'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 993 "DataObject.vala"
gint event_source_get_photo_count (EventSource* self) {
#line 993 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_photo_count (self);
#line 4853 "DataObject.c"
}


#line 1005 "DataObject.vala"
static GeeIterable* event_source_real_get_photos (EventSource* self) {
#line 4859 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_photos'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 993 "DataObject.vala"
GeeIterable* event_source_get_photos (EventSource* self) {
#line 993 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_photos (self);
#line 4870 "DataObject.c"
}


static void event_source_class_init (EventSourceClass * klass) {
	event_source_parent_class = g_type_class_peek_parent (klass);
	EVENT_SOURCE_CLASS (klass)->get_start_time = event_source_real_get_start_time;
	EVENT_SOURCE_CLASS (klass)->get_end_time = event_source_real_get_end_time;
	EVENT_SOURCE_CLASS (klass)->get_total_filesize = event_source_real_get_total_filesize;
	EVENT_SOURCE_CLASS (klass)->get_photo_count = event_source_real_get_photo_count;
	EVENT_SOURCE_CLASS (klass)->get_photos = event_source_real_get_photos;
}


static void event_source_instance_init (EventSource * self) {
}


GType event_source_get_type (void) {
	static volatile gsize event_source_type_id__volatile = 0;
	if (g_once_init_enter (&event_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventSource), 0, (GInstanceInitFunc) event_source_instance_init, NULL };
		GType event_source_type_id;
		event_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "EventSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&event_source_type_id__volatile, event_source_type_id);
	}
	return event_source_type_id__volatile;
}


#line 993 "DataObject.vala"
gboolean container_source_has_links (ContainerSource* self) {
#line 993 "DataObject.vala"
	return CONTAINER_SOURCE_GET_INTERFACE (self)->has_links (self);
#line 4904 "DataObject.c"
}


#line 993 "DataObject.vala"
SourceBacklink* container_source_get_backlink (ContainerSource* self) {
#line 993 "DataObject.vala"
	return CONTAINER_SOURCE_GET_INTERFACE (self)->get_backlink (self);
#line 4912 "DataObject.c"
}


#line 993 "DataObject.vala"
void container_source_break_link (ContainerSource* self, DataSource* source) {
#line 993 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->break_link (self, source);
#line 4920 "DataObject.c"
}


#line 993 "DataObject.vala"
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources) {
#line 993 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->break_link_many (self, sources);
#line 4928 "DataObject.c"
}


#line 993 "DataObject.vala"
void container_source_establish_link (ContainerSource* self, DataSource* source) {
#line 993 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->establish_link (self, source);
#line 4936 "DataObject.c"
}


#line 993 "DataObject.vala"
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources) {
#line 993 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->establish_link_many (self, sources);
#line 4944 "DataObject.c"
}


static void container_source_base_init (ContainerSourceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType container_source_get_type (void) {
	static volatile gsize container_source_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceIface), (GBaseInitFunc) container_source_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType container_source_type_id;
		container_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "ContainerSource", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (container_source_type_id, TYPE_DATA_SOURCE);
		g_once_init_leave (&container_source_type_id__volatile, container_source_type_id);
	}
	return container_source_type_id__volatile;
}


#line 1102 "DataObject.vala"
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self) {
#line 4971 "DataObject.c"
	source_proxy_on_snapshot_broken (self);
}


#line 1150 "DataObject.vala"
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 4978 "DataObject.c"
	source_proxy_on_source_added (self, added);
}


#line 1068 "DataObject.vala"
SourceProxy* source_proxy_construct (GType object_type, DataSource* source) {
#line 4985 "DataObject.c"
	SourceProxy* self;
	char* _tmp0_;
	SourceSnapshot* _tmp1_;
	SourceCollection* _tmp2_;
#line 1068 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 4992 "DataObject.c"
	self = (SourceProxy*) g_type_create_instance (object_type);
#line 1069 "DataObject.vala"
	self->priv->object_id = data_object_get_object_id (DATA_OBJECT (source));
#line 1070 "DataObject.vala"
	self->priv->source_string = (_tmp0_ = data_object_to_string (DATA_OBJECT (source)), _g_free0 (self->priv->source_string), _tmp0_);
#line 1072 "DataObject.vala"
	self->priv->snapshot = (_tmp1_ = data_source_save_snapshot (source), _source_snapshot_unref0 (self->priv->snapshot), _tmp1_);
#line 1073 "DataObject.vala"
	g_assert (self->priv->snapshot != NULL);
#line 1074 "DataObject.vala"
	g_signal_connect (self->priv->snapshot, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
#line 1076 "DataObject.vala"
	source_proxy_set_source (self, source);
#line 1078 "DataObject.vala"
	self->priv->membership = (_tmp2_ = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (source))), _data_collection_unref0 (self->priv->membership), _tmp2_);
#line 1079 "DataObject.vala"
	g_assert (self->priv->membership != NULL);
#line 1080 "DataObject.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->membership), "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 5012 "DataObject.c"
	return self;
}


#line 1088 "DataObject.vala"
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 5019 "DataObject.c"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1068 "DataObject.vala"
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 1068 "DataObject.vala"
	return SOURCE_PROXY_GET_CLASS (self)->reconstitute (self, object_id, snapshot);
#line 5030 "DataObject.c"
}


#line 1090 "DataObject.vala"
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 1090 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1090 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1091 "DataObject.vala"
	g_signal_emit_by_name (self, "reconstituted", source);
#line 5042 "DataObject.c"
}


#line 1068 "DataObject.vala"
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 1068 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_reconstituted (self, source);
#line 5050 "DataObject.c"
}


#line 1094 "DataObject.vala"
static void source_proxy_real_notify_dehydrated (SourceProxy* self) {
#line 1094 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1095 "DataObject.vala"
	g_signal_emit_by_name (self, "dehydrated");
#line 5060 "DataObject.c"
}


#line 1068 "DataObject.vala"
void source_proxy_notify_dehydrated (SourceProxy* self) {
#line 1068 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_dehydrated (self);
#line 5068 "DataObject.c"
}


#line 1098 "DataObject.vala"
static void source_proxy_real_notify_broken (SourceProxy* self) {
#line 1098 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1099 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 5078 "DataObject.c"
}


#line 1068 "DataObject.vala"
void source_proxy_notify_broken (SourceProxy* self) {
#line 1068 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_broken (self);
#line 5086 "DataObject.c"
}


#line 1102 "DataObject.vala"
static void source_proxy_on_snapshot_broken (SourceProxy* self) {
#line 1102 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1103 "DataObject.vala"
	source_proxy_drop_source (self);
#line 1105 "DataObject.vala"
	source_proxy_notify_broken (self);
#line 5098 "DataObject.c"
}


#line 1141 "DataObject.vala"
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self) {
#line 5104 "DataObject.c"
	source_proxy_on_destroyed (self);
}


#line 1108 "DataObject.vala"
static void source_proxy_set_source (SourceProxy* self, DataSource* source) {
#line 5111 "DataObject.c"
	DataSource* _tmp0_;
#line 1108 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1108 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1109 "DataObject.vala"
	source_proxy_drop_source (self);
#line 1111 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 1112 "DataObject.vala"
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 5123 "DataObject.c"
}


#line 1115 "DataObject.vala"
static void source_proxy_drop_source (SourceProxy* self) {
#line 5129 "DataObject.c"
	guint _tmp0_;
	DataSource* _tmp1_;
#line 1115 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1116 "DataObject.vala"
	if (self->priv->source == NULL) {
#line 1117 "DataObject.vala"
		return;
#line 5138 "DataObject.c"
	}
#line 1119 "DataObject.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp0_, NULL, FALSE);
#line 1119 "DataObject.vala"
	g_signal_handlers_disconnect_matched (self->priv->source, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 1120 "DataObject.vala"
	self->priv->source = (_tmp1_ = NULL, _g_object_unref0 (self->priv->source), _tmp1_);
#line 5146 "DataObject.c"
}


#line 1123 "DataObject.vala"
DataSource* source_proxy_get_source (SourceProxy* self) {
#line 5152 "DataObject.c"
	DataSource* result = NULL;
	DataSource* new_source;
#line 1123 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
#line 1124 "DataObject.vala"
	if (source_snapshot_is_broken (self->priv->snapshot)) {
#line 5159 "DataObject.c"
		result = NULL;
#line 1125 "DataObject.vala"
		return result;
#line 5163 "DataObject.c"
	}
#line 1127 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 5167 "DataObject.c"
		result = _g_object_ref0 (self->priv->source);
#line 1128 "DataObject.vala"
		return result;
#line 5171 "DataObject.c"
	}
#line 1133 "DataObject.vala"
	new_source = source_proxy_reconstitute (self, self->priv->object_id, self->priv->snapshot);
#line 1134 "DataObject.vala"
	g_assert (self->priv->source == new_source);
#line 1135 "DataObject.vala"
	g_assert (data_object_get_object_id (DATA_OBJECT (self->priv->source)) == self->priv->object_id);
#line 1136 "DataObject.vala"
	g_assert (data_collection_contains (DATA_COLLECTION (self->priv->membership), DATA_OBJECT (self->priv->source)));
#line 5181 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
	_g_object_unref0 (new_source);
#line 1138 "DataObject.vala"
	return result;
#line 5186 "DataObject.c"
}


#line 1141 "DataObject.vala"
static void source_proxy_on_destroyed (SourceProxy* self) {
#line 1141 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1142 "DataObject.vala"
	g_assert (self->priv->source != NULL);
#line 1145 "DataObject.vala"
	source_proxy_drop_source (self);
#line 1147 "DataObject.vala"
	source_proxy_notify_dehydrated (self);
#line 5200 "DataObject.c"
}


#line 1150 "DataObject.vala"
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added) {
#line 1150 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1150 "DataObject.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1152 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 1153 "DataObject.vala"
		return;
#line 5214 "DataObject.c"
	}
	{
		GeeIterator* _object_it;
#line 1155 "DataObject.vala"
		_object_it = gee_iterable_iterator (added);
#line 1155 "DataObject.vala"
		while (TRUE) {
#line 5222 "DataObject.c"
			DataObject* object;
#line 1155 "DataObject.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1155 "DataObject.vala"
				break;
#line 5228 "DataObject.c"
			}
#line 1155 "DataObject.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1157 "DataObject.vala"
			if (data_object_get_object_id (object) != self->priv->object_id) {
#line 5234 "DataObject.c"
				_g_object_unref0 (object);
#line 1158 "DataObject.vala"
				continue;
#line 5238 "DataObject.c"
			}
#line 1161 "DataObject.vala"
			source_proxy_set_source (self, DATA_SOURCE (object));
#line 1163 "DataObject.vala"
			source_proxy_notify_reconstituted (self, DATA_SOURCE (object));
#line 5244 "DataObject.c"
			_g_object_unref0 (object);
#line 1165 "DataObject.vala"
			break;
#line 5248 "DataObject.c"
		}
		_g_object_unref0 (_object_it);
	}
}


#line 1055 "DataObject.vala"
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source) {
#line 1055 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1055 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5261 "DataObject.c"
}


#line 1060 "DataObject.vala"
static void source_proxy_real_dehydrated (SourceProxy* self) {
#line 1060 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 5269 "DataObject.c"
}


#line 1065 "DataObject.vala"
static void source_proxy_real_broken (SourceProxy* self) {
#line 1065 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 5277 "DataObject.c"
}


static void value_source_proxy_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_proxy_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_proxy_unref (value->data[0].v_pointer);
	}
}


static void value_source_proxy_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_proxy_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_proxy_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceProxy* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_proxy_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_proxy_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceProxy** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_proxy_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceProxy* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_proxy (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_proxy_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


void value_take_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


static void source_proxy_class_init (SourceProxyClass * klass) {
	source_proxy_parent_class = g_type_class_peek_parent (klass);
	SOURCE_PROXY_CLASS (klass)->finalize = source_proxy_finalize;
	g_type_class_add_private (klass, sizeof (SourceProxyPrivate));
	SOURCE_PROXY_CLASS (klass)->reconstitute = source_proxy_real_reconstitute;
	SOURCE_PROXY_CLASS (klass)->notify_reconstituted = source_proxy_real_notify_reconstituted;
	SOURCE_PROXY_CLASS (klass)->notify_dehydrated = source_proxy_real_notify_dehydrated;
	SOURCE_PROXY_CLASS (klass)->notify_broken = source_proxy_real_notify_broken;
	SOURCE_PROXY_CLASS (klass)->reconstituted = source_proxy_real_reconstituted;
	SOURCE_PROXY_CLASS (klass)->dehydrated = source_proxy_real_dehydrated;
	SOURCE_PROXY_CLASS (klass)->broken = source_proxy_real_broken;
	g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_proxy_instance_init (SourceProxy * self) {
	self->priv = SOURCE_PROXY_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_proxy_finalize (SourceProxy* obj) {
	SourceProxy * self;
	self = SOURCE_PROXY (obj);
	{
		guint _tmp0_;
#line 1084 "DataObject.vala"
		source_proxy_drop_source (self);
#line 1085 "DataObject.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1085 "DataObject.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->membership), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 5425 "DataObject.c"
	}
	_g_free0 (self->priv->source_string);
	_g_object_unref0 (self->priv->source);
	_source_snapshot_unref0 (self->priv->snapshot);
	_data_collection_unref0 (self->priv->membership);
}


GType source_proxy_get_type (void) {
	static volatile gsize source_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&source_proxy_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_proxy_type_id;
		source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_proxy_type_id__volatile, source_proxy_type_id);
	}
	return source_proxy_type_id__volatile;
}


gpointer source_proxy_ref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_proxy_unref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1068 "DataObject.vala"
SourceProxy* proxyable_get_proxy (Proxyable* self) {
#line 1068 "DataObject.vala"
	return PROXYABLE_GET_INTERFACE (self)->get_proxy (self);
#line 5470 "DataObject.c"
}


static void proxyable_base_init (ProxyableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType proxyable_get_type (void) {
	static volatile gsize proxyable_type_id__volatile = 0;
	if (g_once_init_enter (&proxyable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) proxyable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType proxyable_type_id;
		proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
		g_once_init_leave (&proxyable_type_id__volatile, proxyable_type_id);
	}
	return proxyable_type_id__volatile;
}


#line 1203 "DataObject.vala"
DataView* data_view_construct (GType object_type, DataSource* source) {
#line 5496 "DataObject.c"
	DataView * self;
	DataSource* _tmp0_;
#line 1203 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1203 "DataObject.vala"
	self = (DataView*) data_object_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 1204 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 1208 "DataObject.vala"
	data_source_internal_subscribe (source, self);
#line 5507 "DataObject.c"
	return self;
}


#line 1203 "DataObject.vala"
DataView* data_view_new (DataSource* source) {
#line 1203 "DataObject.vala"
	return data_view_construct (TYPE_DATA_VIEW, source);
#line 5516 "DataObject.c"
}


#line 1218 "DataObject.vala"
static char* data_view_real_get_name (DataObject* base) {
#line 5522 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	self = DATA_VIEW (base);
	result = (_tmp1_ = g_strdup_printf ("View of %s", _tmp0_ = data_object_get_name (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp0_), _tmp1_);
#line 1219 "DataObject.vala"
	return result;
#line 5531 "DataObject.c"
}


#line 1222 "DataObject.vala"
static char* data_view_real_to_string (DataObject* base) {
#line 5537 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	self = DATA_VIEW (base);
	result = (_tmp2_ = g_strdup_printf ("DataView %s [DataSource %s]", _tmp0_ = data_object_get_name (DATA_OBJECT (self)), _tmp1_ = data_object_to_string (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
#line 1223 "DataObject.vala"
	return result;
#line 5547 "DataObject.c"
}


#line 1226 "DataObject.vala"
DataSource* data_view_get_source (DataView* self) {
#line 5553 "DataObject.c"
	DataSource* result = NULL;
#line 1226 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), NULL);
#line 5557 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
#line 1227 "DataObject.vala"
	return result;
#line 5561 "DataObject.c"
}


#line 1230 "DataObject.vala"
gboolean data_view_is_selected (DataView* self) {
#line 5567 "DataObject.c"
	gboolean result = FALSE;
#line 1230 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 5571 "DataObject.c"
	result = self->priv->selected;
#line 1231 "DataObject.vala"
	return result;
#line 5575 "DataObject.c"
}


#line 1235 "DataObject.vala"
void data_view_internal_set_selected (DataView* self, gboolean selected) {
#line 1235 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1236 "DataObject.vala"
	if (self->priv->selected == selected) {
#line 1237 "DataObject.vala"
		return;
#line 5587 "DataObject.c"
	}
#line 1239 "DataObject.vala"
	self->priv->selected = selected;
#line 1240 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", selected);
#line 5593 "DataObject.c"
}


#line 1244 "DataObject.vala"
gboolean data_view_internal_toggle (DataView* self) {
#line 5599 "DataObject.c"
	gboolean result = FALSE;
#line 1244 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 1245 "DataObject.vala"
	self->priv->selected = !self->priv->selected;
#line 1246 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", self->priv->selected);
#line 5607 "DataObject.c"
	result = self->priv->selected;
#line 1248 "DataObject.vala"
	return result;
#line 5611 "DataObject.c"
}


#line 1251 "DataObject.vala"
gboolean data_view_is_visible (DataView* self) {
#line 5617 "DataObject.c"
	gboolean result = FALSE;
#line 1251 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 5621 "DataObject.c"
	result = self->priv->visible;
#line 1252 "DataObject.vala"
	return result;
#line 5625 "DataObject.c"
}


#line 1256 "DataObject.vala"
void data_view_internal_set_visible (DataView* self, gboolean visible) {
#line 1256 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1257 "DataObject.vala"
	if (self->priv->visible == visible) {
#line 1258 "DataObject.vala"
		return;
#line 5637 "DataObject.c"
	}
#line 1260 "DataObject.vala"
	self->priv->visible = visible;
#line 1261 "DataObject.vala"
	g_signal_emit_by_name (self, "visibility-changed", visible);
#line 5643 "DataObject.c"
}


#line 1264 "DataObject.vala"
static void data_view_real_notify_view_altered (DataView* self) {
#line 5649 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 1264 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1266 "DataObject.vala"
	if (!self->priv->visible) {
#line 1267 "DataObject.vala"
		return;
#line 5658 "DataObject.c"
	}
#line 1269 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 1270 "DataObject.vala"
	if (vc != NULL) {
#line 1271 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 1272 "DataObject.vala"
			g_signal_emit_by_name (self, "view-altered");
#line 5668 "DataObject.c"
		}
#line 1275 "DataObject.vala"
		view_collection_internal_notify_view_altered (vc, self);
#line 5672 "DataObject.c"
	} else {
#line 1277 "DataObject.vala"
		g_signal_emit_by_name (self, "view-altered");
#line 5676 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 1203 "DataObject.vala"
void data_view_notify_view_altered (DataView* self) {
#line 1203 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_view_altered (self);
#line 5686 "DataObject.c"
}


#line 1281 "DataObject.vala"
static void data_view_real_notify_geometry_altered (DataView* self) {
#line 5692 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 1281 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1283 "DataObject.vala"
	if (!self->priv->visible) {
#line 1284 "DataObject.vala"
		return;
#line 5701 "DataObject.c"
	}
#line 1286 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 1287 "DataObject.vala"
	if (vc != NULL) {
#line 1288 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 1289 "DataObject.vala"
			g_signal_emit_by_name (self, "geometry-altered");
#line 5711 "DataObject.c"
		}
#line 1292 "DataObject.vala"
		view_collection_internal_notify_geometry_altered (vc, self);
#line 5715 "DataObject.c"
	} else {
#line 1294 "DataObject.vala"
		g_signal_emit_by_name (self, "geometry-altered");
#line 5719 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 1203 "DataObject.vala"
void data_view_notify_geometry_altered (DataView* self) {
#line 1203 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_geometry_altered (self);
#line 5729 "DataObject.c"
}


#line 1299 "DataObject.vala"
static void data_view_real_notify_unsubscribed (DataView* self, DataSource* source) {
#line 1299 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1299 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1300 "DataObject.vala"
	g_signal_emit_by_name (self, "unsubscribed", source);
#line 5741 "DataObject.c"
}


#line 1203 "DataObject.vala"
void data_view_notify_unsubscribed (DataView* self, DataSource* source) {
#line 1203 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_unsubscribed (self, source);
#line 5749 "DataObject.c"
}


#line 1304 "DataObject.vala"
static void data_view_real_notify_source_unlinking (DataView* self, SourceCollection* sources) {
#line 5755 "DataObject.c"
	ViewCollection* membership;
#line 1304 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1304 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1305 "DataObject.vala"
	membership = VIEW_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 1306 "DataObject.vala"
	if (membership != NULL) {
#line 1307 "DataObject.vala"
		view_collection_internal_notify_unlinking (membership, self, sources);
#line 5767 "DataObject.c"
	}
	_data_collection_unref0 (membership);
}


#line 1203 "DataObject.vala"
void data_view_notify_source_unlinking (DataView* self, SourceCollection* sources) {
#line 1203 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_source_unlinking (self, sources);
#line 5777 "DataObject.c"
}


#line 1311 "DataObject.vala"
static void data_view_real_notify_source_relinked (DataView* self, SourceCollection* sources) {
#line 5783 "DataObject.c"
	ViewCollection* membership;
#line 1311 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1311 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1312 "DataObject.vala"
	membership = VIEW_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 1313 "DataObject.vala"
	if (membership != NULL) {
#line 1314 "DataObject.vala"
		view_collection_internal_notify_relinked (membership, self, sources);
#line 5795 "DataObject.c"
	}
	_data_collection_unref0 (membership);
}


#line 1203 "DataObject.vala"
void data_view_notify_source_relinked (DataView* self, SourceCollection* sources) {
#line 1203 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_source_relinked (self, sources);
#line 5805 "DataObject.c"
}


#line 1184 "DataObject.vala"
static void data_view_real_state_changed (DataView* self, gboolean selected) {
#line 1184 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 5813 "DataObject.c"
}


#line 1188 "DataObject.vala"
static void data_view_real_visibility_changed (DataView* self, gboolean visible) {
#line 1188 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 5821 "DataObject.c"
}


#line 1192 "DataObject.vala"
static void data_view_real_view_altered (DataView* self) {
#line 1192 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 5829 "DataObject.c"
}


#line 1197 "DataObject.vala"
static void data_view_real_geometry_altered (DataView* self) {
#line 1197 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 5837 "DataObject.c"
}


#line 1200 "DataObject.vala"
static void data_view_real_unsubscribed (DataView* self, DataSource* source) {
#line 1200 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1200 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5847 "DataObject.c"
}


static void data_view_class_init (DataViewClass * klass) {
	data_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataViewPrivate));
	DATA_OBJECT_CLASS (klass)->get_name = data_view_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_view_real_to_string;
	DATA_VIEW_CLASS (klass)->notify_view_altered = data_view_real_notify_view_altered;
	DATA_VIEW_CLASS (klass)->notify_geometry_altered = data_view_real_notify_geometry_altered;
	DATA_VIEW_CLASS (klass)->notify_unsubscribed = data_view_real_notify_unsubscribed;
	DATA_VIEW_CLASS (klass)->notify_source_unlinking = data_view_real_notify_source_unlinking;
	DATA_VIEW_CLASS (klass)->notify_source_relinked = data_view_real_notify_source_relinked;
	DATA_VIEW_CLASS (klass)->state_changed = data_view_real_state_changed;
	DATA_VIEW_CLASS (klass)->visibility_changed = data_view_real_visibility_changed;
	DATA_VIEW_CLASS (klass)->view_altered = data_view_real_view_altered;
	DATA_VIEW_CLASS (klass)->geometry_altered = data_view_real_geometry_altered;
	DATA_VIEW_CLASS (klass)->unsubscribed = data_view_real_unsubscribed;
	G_OBJECT_CLASS (klass)->finalize = data_view_finalize;
	g_signal_new ("state_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, state_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("visibility_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("view_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, view_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("geometry_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("unsubscribed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, unsubscribed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
}


static void data_view_instance_init (DataView * self) {
	self->priv = DATA_VIEW_GET_PRIVATE (self);
	self->priv->selected = FALSE;
	self->priv->visible = TRUE;
}


static void data_view_finalize (GObject* obj) {
	DataView * self;
	self = DATA_VIEW (obj);
	{
#line 1215 "DataObject.vala"
		data_source_internal_unsubscribe (self->priv->source, self);
#line 5888 "DataObject.c"
	}
	_g_object_unref0 (self->priv->source);
	G_OBJECT_CLASS (data_view_parent_class)->finalize (obj);
}


GType data_view_get_type (void) {
	static volatile gsize data_view_type_id__volatile = 0;
	if (g_once_init_enter (&data_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataView), 0, (GInstanceInitFunc) data_view_instance_init, NULL };
		GType data_view_type_id;
		data_view_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataView", &g_define_type_info, 0);
		g_once_init_leave (&data_view_type_id__volatile, data_view_type_id);
	}
	return data_view_type_id__volatile;
}


#line 1322 "DataObject.vala"
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source) {
#line 5909 "DataObject.c"
	ThumbnailView * self;
#line 1322 "DataObject.vala"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (source), NULL);
#line 1323 "DataObject.vala"
	self = (ThumbnailView*) data_view_construct (object_type, DATA_SOURCE (source));
#line 5915 "DataObject.c"
	return self;
}


#line 1322 "DataObject.vala"
ThumbnailView* thumbnail_view_new (ThumbnailSource* source) {
#line 1322 "DataObject.vala"
	return thumbnail_view_construct (TYPE_THUMBNAIL_VIEW, source);
#line 5924 "DataObject.c"
}


#line 1326 "DataObject.vala"
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self) {
#line 1326 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 1328 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 5934 "DataObject.c"
}


#line 1322 "DataObject.vala"
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self) {
#line 1322 "DataObject.vala"
	THUMBNAIL_VIEW_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 5942 "DataObject.c"
}


#line 1319 "DataObject.vala"
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self) {
#line 1319 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 5950 "DataObject.c"
}


static void thumbnail_view_class_init (ThumbnailViewClass * klass) {
	thumbnail_view_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_VIEW_CLASS (klass)->notify_thumbnail_altered = thumbnail_view_real_notify_thumbnail_altered;
	THUMBNAIL_VIEW_CLASS (klass)->thumbnail_altered = thumbnail_view_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailViewClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_view_instance_init (ThumbnailView * self) {
}


GType thumbnail_view_get_type (void) {
	static volatile gsize thumbnail_view_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailView), 0, (GInstanceInitFunc) thumbnail_view_instance_init, NULL };
		GType thumbnail_view_type_id;
		thumbnail_view_type_id = g_type_register_static (TYPE_DATA_VIEW, "ThumbnailView", &g_define_type_info, 0);
		g_once_init_leave (&thumbnail_view_type_id__volatile, thumbnail_view_type_id);
	}
	return thumbnail_view_type_id__volatile;
}


#line 1333 "DataObject.vala"
PhotoView* photo_view_construct (GType object_type, PhotoSource* source) {
#line 5980 "DataObject.c"
	PhotoView * self;
#line 1333 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_SOURCE (source), NULL);
#line 1334 "DataObject.vala"
	self = (PhotoView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 5986 "DataObject.c"
	return self;
}


#line 1333 "DataObject.vala"
PhotoView* photo_view_new (PhotoSource* source) {
#line 1333 "DataObject.vala"
	return photo_view_construct (TYPE_PHOTO_VIEW, source);
#line 5995 "DataObject.c"
}


#line 1337 "DataObject.vala"
PhotoSource* photo_view_get_photo_source (PhotoView* self) {
#line 6001 "DataObject.c"
	PhotoSource* result = NULL;
#line 1337 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_VIEW (self), NULL);
#line 6005 "DataObject.c"
	result = PHOTO_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 1338 "DataObject.vala"
	return result;
#line 6009 "DataObject.c"
}


static void photo_view_class_init (PhotoViewClass * klass) {
	photo_view_parent_class = g_type_class_peek_parent (klass);
}


static void photo_view_instance_init (PhotoView * self) {
}


GType photo_view_get_type (void) {
	static volatile gsize photo_view_type_id__volatile = 0;
	if (g_once_init_enter (&photo_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoView), 0, (GInstanceInitFunc) photo_view_instance_init, NULL };
		GType photo_view_type_id;
		photo_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "PhotoView", &g_define_type_info, 0);
		g_once_init_leave (&photo_view_type_id__volatile, photo_view_type_id);
	}
	return photo_view_type_id__volatile;
}


#line 1343 "DataObject.vala"
EventView* event_view_construct (GType object_type, EventSource* source) {
#line 6036 "DataObject.c"
	EventView * self;
#line 1343 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_SOURCE (source), NULL);
#line 1344 "DataObject.vala"
	self = (EventView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 6042 "DataObject.c"
	return self;
}


#line 1343 "DataObject.vala"
EventView* event_view_new (EventSource* source) {
#line 1343 "DataObject.vala"
	return event_view_construct (TYPE_EVENT_VIEW, source);
#line 6051 "DataObject.c"
}


#line 1347 "DataObject.vala"
EventSource* event_view_get_event_source (EventView* self) {
#line 6057 "DataObject.c"
	EventSource* result = NULL;
#line 1347 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_VIEW (self), NULL);
#line 6061 "DataObject.c"
	result = EVENT_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 1348 "DataObject.vala"
	return result;
#line 6065 "DataObject.c"
}


static void event_view_class_init (EventViewClass * klass) {
	event_view_parent_class = g_type_class_peek_parent (klass);
}


static void event_view_instance_init (EventView * self) {
}


GType event_view_get_type (void) {
	static volatile gsize event_view_type_id__volatile = 0;
	if (g_once_init_enter (&event_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventView), 0, (GInstanceInitFunc) event_view_instance_init, NULL };
		GType event_view_type_id;
		event_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "EventView", &g_define_type_info, 0);
		g_once_init_leave (&event_view_type_id__volatile, event_view_type_id);
	}
	return event_view_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__ALTERATION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ALTERATION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__ALTERATION callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ALTERATION) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_alteration (param_values + 1), data2);
}


static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__DATA_COLLECTION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DATA_COLLECTION callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DATA_COLLECTION) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_data_collection (param_values + 1), data2);
}



