/* DirectoryMonitor.c generated by valac 0.9.8, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery() must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories */
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e. */
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info(), get_file_id(), and*/
/* get_etag().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;

#define DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP (directory_monitor_timed_file_info_map_get_type ())
#define DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP, DirectoryMonitorTimedFileInfoMap))
#define DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP, DirectoryMonitorTimedFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_TIMED_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_TIMED_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP, DirectoryMonitorTimedFileInfoMapClass))

typedef struct _DirectoryMonitorTimedFileInfoMap DirectoryMonitorTimedFileInfoMap;
typedef struct _DirectoryMonitorTimedFileInfoMapClass DirectoryMonitorTimedFileInfoMapClass;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;
typedef struct _DirectoryMonitorTimedFileInfoMapPrivate DirectoryMonitorTimedFileInfoMapPrivate;

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorTimedFileInfoMap* deleted;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean has_discovery_started;
	gboolean delete_timer_active;
};

typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	char* _tmp2_;
	GError * err;
	char* _tmp3_;
	char* _tmp4_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFileEnumerator* enumerator;
	gboolean _tmp5_;
	GList* infos;
	GeeHashMap* _tmp6_;
	GFile* _tmp7_;
	GeeHashMap* _tmp8_;
	GFile* _tmp9_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* info;
	char* _tmp10_;
	GError * err2;
	GeeIterator* _file_it;
	GeeSet* _tmp11_;
	GeeIterator* _tmp12_;
	GFile* file;
	GFileInfo* _tmp13_;
	GFileInfo* _tmp14_;
	gboolean _tmp15_;
	GeeIterator* _subdir_it;
	GeeSet* _tmp16_;
	GeeIterator* _tmp17_;
	GFile* subdir;
	GFileInfo* _tmp18_;
	GError * _inner_error_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
	gboolean (*update) (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
	gboolean (*remove) (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
	void (*remove_all) (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
	void (*remove_map) (DirectoryMonitorFileInfoMap* self, GeeMap* file_map);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorTimedFileInfoMap {
	DirectoryMonitorFileInfoMap parent_instance;
	DirectoryMonitorTimedFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorTimedFileInfoMapClass {
	DirectoryMonitorFileInfoMapClass parent_class;
};

struct _DirectoryMonitorTimedFileInfoMapPrivate {
	GeeHashMap* time_added;
};


static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static gpointer directory_monitor_file_info_map_parent_class = NULL;
static gpointer directory_monitor_timed_file_info_map_parent_class = NULL;
static gpointer directory_monitor_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType directory_monitor_timed_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define DIRECTORY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIRECTORY_MONITOR, DirectoryMonitorPrivate))
enum  {
	DIRECTORY_MONITOR_DUMMY_PROPERTY
};
static GType directory_monitor_ftype_get_type (void) G_GNUC_UNUSED;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
static DirectoryMonitorTimedFileInfoMap* directory_monitor_timed_file_info_map_new (void);
static DirectoryMonitorTimedFileInfoMap* directory_monitor_timed_file_info_map_construct (GType object_type);
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
void directory_monitor_mdbg (DirectoryMonitor* self, const char* msg);
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const char* reason);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const char* reason);
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_internal_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static gboolean directory_monitor_on_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_internal_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file);
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_notify_closed (DirectoryMonitor* self);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file);
void directory_monitor_start_discovery (DirectoryMonitor* self, GError** error);
static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_);
void directory_monitor_close (DirectoryMonitor* self);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (DirectoryMonitor* self, GFileInfo* info);
static void directory_monitor_explore_async_data_free (gpointer _data);
static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* data);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery);
static void _g_list_free_g_object_unref (GList* self);
static char* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void directory_monitor_on_query_finished (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* queue_event);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_on_deleted_timeout (DirectoryMonitor* self);
static gboolean _directory_monitor_on_deleted_timeout_gsource_func (gpointer self);
gulong now_ms (void);
static GeeMap* directory_monitor_timed_file_info_map_remove_older_than (DirectoryMonitorTimedFileInfoMap* self, gulong time);
static gint directory_monitor_file_info_map_get_count (DirectoryMonitorFileInfoMap* self);
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable);
void directory_monitor_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root);
void directory_monitor_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
void directory_monitor_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_discovery_failed (DirectoryMonitor* self, const char* reason);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const char* reason);
void directory_monitor_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
void directory_monitor_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file);
void directory_monitor_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir);
void directory_monitor_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_closed (DirectoryMonitor* self);
static void directory_monitor_real_closed (DirectoryMonitor* self);
enum  {
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_DUMMY_PROPERTY
};
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj);
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapPrivate))
enum  {
	DIRECTORY_MONITOR_FILE_INFO_MAP_DUMMY_PROPERTY
};
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, char** id);
char* get_file_info_id (GFileInfo* info);
static gboolean directory_monitor_file_info_map_real_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_file_info_map_real_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
static void directory_monitor_file_info_map_real_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
static void directory_monitor_file_info_map_remove_map (DirectoryMonitorFileInfoMap* self, GeeMap* file_map);
static void directory_monitor_file_info_map_real_remove_map (DirectoryMonitorFileInfoMap* self, GeeMap* file_map);
static GFile* directory_monitor_file_info_map_get_file (DirectoryMonitorFileInfoMap* self, const char* id);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj);
#define DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP, DirectoryMonitorTimedFileInfoMapPrivate))
enum  {
	DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP_DUMMY_PROPERTY
};
static gboolean directory_monitor_timed_file_info_map_real_update (DirectoryMonitorFileInfoMap* base, GFile* file, GFileInfo* info);
static gboolean directory_monitor_timed_file_info_map_real_remove (DirectoryMonitorFileInfoMap* base, GFile* file, GFileInfo* info);
static void directory_monitor_timed_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj);
static void directory_monitor_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static GType directory_monitor_ftype_get_type (void) {
	static volatile gsize directory_monitor_ftype_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
		g_once_init_leave (&directory_monitor_ftype_type_id__volatile, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 448 "DirectoryMonitor.vala"
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
#line 522 "DirectoryMonitor.c"
	DirectoryMonitor * self;
	GFile* _tmp0_;
#line 448 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), NULL);
#line 448 "DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 449 "DirectoryMonitor.vala"
	self->priv->root = (_tmp0_ = _g_object_ref0 (root), _g_object_unref0 (self->priv->root), _tmp0_);
#line 450 "DirectoryMonitor.vala"
	self->priv->recurse = recurse;
#line 451 "DirectoryMonitor.vala"
	self->priv->monitoring = monitoring;
#line 535 "DirectoryMonitor.c"
	return self;
}


#line 448 "DirectoryMonitor.vala"
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
#line 448 "DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 544 "DirectoryMonitor.c"
}


#line 458 "DirectoryMonitor.vala"
void directory_monitor_mdbg (DirectoryMonitor* self, const char* msg) {
#line 458 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 458 "DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 554 "DirectoryMonitor.c"
}


#line 464 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 464 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 464 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 465 "DirectoryMonitor.vala"
	g_assert (g_file_equal (self->priv->root, root));
#line 467 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, "root deleted");
#line 468 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-deleted", root);
#line 570 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_deleted (self, root);
#line 578 "DirectoryMonitor.c"
}


#line 471 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 584 "DirectoryMonitor.c"
	gboolean removed;
	gboolean updated;
	GFile* _tmp0_;
#line 471 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 471 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 471 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 471 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 472 "DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (self->priv->files, old_root, NULL);
#line 473 "DirectoryMonitor.vala"
	g_assert (removed);
#line 475 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, new_root, new_root_info);
#line 476 "DirectoryMonitor.vala"
	g_assert (updated);
#line 478 "DirectoryMonitor.vala"
	self->priv->root = (_tmp0_ = _g_object_ref0 (new_root), _g_object_unref0 (self->priv->root), _tmp0_);
#line 480 "DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, old_root, new_root, new_root_info);
#line 608 "DirectoryMonitor.c"
}


#line 483 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 614 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 483 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 483 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 483 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 483 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 484 "DirectoryMonitor.vala"
	g_assert (g_file_equal (self->priv->root, old_root));
#line 486 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp2_ = g_strdup_printf ("root moved: %s -> %s", _tmp0_ = g_file_get_path (old_root), _tmp1_ = g_file_get_path (new_root)));
#line 630 "DirectoryMonitor.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 487 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-moved", old_root, new_root, new_root_info);
#line 636 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_moved (self, old_root, new_root, new_root_info);
#line 644 "DirectoryMonitor.c"
}


#line 490 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self) {
#line 490 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 491 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, "discovery started");
#line 492 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-started");
#line 656 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_discovery_started (DirectoryMonitor* self) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_started (self);
#line 664 "DirectoryMonitor.c"
}


#line 495 "DirectoryMonitor.vala"
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 670 "DirectoryMonitor.c"
	gboolean updated;
#line 495 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 495 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 495 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 496 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 497 "DirectoryMonitor.vala"
	g_assert (updated);
#line 499 "DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, file, info);
#line 684 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_file_discovered (self, file, info);
#line 692 "DirectoryMonitor.c"
}


#line 502 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 698 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 502 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 502 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 502 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 503 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("file discovered: %s", _tmp0_ = g_file_get_path (file)));
#line 709 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 504 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-discovered", file, info);
#line 714 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_discovered (self, file, info);
#line 722 "DirectoryMonitor.c"
}


#line 507 "DirectoryMonitor.vala"
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 728 "DirectoryMonitor.c"
	gboolean updated;
#line 507 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 507 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 507 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 508 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 509 "DirectoryMonitor.vala"
	g_assert (updated);
#line 511 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, dir, info);
#line 742 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_directory_discovered (self, dir, info);
#line 750 "DirectoryMonitor.c"
}


#line 514 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 756 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 514 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 514 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 514 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 515 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("directory discovered: %s", _tmp0_ = g_file_get_path (dir)));
#line 767 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 516 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-discovered", dir, info);
#line 772 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_discovered (self, dir, info);
#line 780 "DirectoryMonitor.c"
}


#line 519 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const char* reason) {
#line 786 "DirectoryMonitor.c"
	char* _tmp0_;
#line 519 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 519 "DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 520 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp0_ = g_strdup_printf ("discovery failed: %s", reason));
#line 794 "DirectoryMonitor.c"
	_g_free0 (_tmp0_);
#line 521 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-failed", reason);
#line 798 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const char* reason) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_failed (self, reason);
#line 806 "DirectoryMonitor.c"
}


#line 524 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self) {
#line 524 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 525 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, "discovery completed");
#line 526 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-completed");
#line 818 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_completed (self);
#line 826 "DirectoryMonitor.c"
}


#line 529 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 832 "DirectoryMonitor.c"
	GFile* old_file;
	GFileInfo* old_file_info;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_;
	GFileInfo* _tmp5_;
#line 529 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 529 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 529 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 847 "DirectoryMonitor.c"
	old_file = NULL;
	old_file_info = NULL;
#line 532 "DirectoryMonitor.vala"
	if ((_tmp4_ = (_tmp1_ = directory_monitor_is_file_create_move (self, file, info, &_tmp0_, &_tmp3_), old_file = (_tmp2_ = _tmp0_, _g_object_unref0 (old_file), _tmp2_), _tmp1_), old_file_info = (_tmp5_ = _tmp3_, _g_object_unref0 (old_file_info), _tmp5_), _tmp4_)) {
#line 533 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, old_file, file, info);
#line 854 "DirectoryMonitor.c"
	} else {
		gboolean updated;
#line 535 "DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 536 "DirectoryMonitor.vala"
		g_assert (updated);
#line 538 "DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, file, info);
#line 863 "DirectoryMonitor.c"
	}
	_g_object_unref0 (old_file_info);
	_g_object_unref0 (old_file);
}


#line 542 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 872 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 542 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 542 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 542 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 543 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("file created: %s", _tmp0_ = g_file_get_path (file)));
#line 883 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 544 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-created", file, info);
#line 888 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_created (self, file, info);
#line 896 "DirectoryMonitor.c"
}


#line 547 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 902 "DirectoryMonitor.c"
	gboolean updated;
#line 547 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 547 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 547 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 547 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 550 "DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (self->priv->files, old_file, NULL);
#line 552 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, new_file, new_file_info);
#line 553 "DirectoryMonitor.vala"
	g_assert (updated);
#line 555 "DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, old_file, new_file, new_file_info);
#line 920 "DirectoryMonitor.c"
}


#line 558 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 926 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 558 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 558 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 558 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 558 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 559 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp2_ = g_strdup_printf ("file moved: %s -> %s", _tmp0_ = g_file_get_path (old_file), _tmp1_ = g_file_get_path (new_file)));
#line 940 "DirectoryMonitor.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 560 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-moved", old_file, new_file, new_file_info);
#line 946 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_moved (self, old_file, new_file, new_file_info);
#line 954 "DirectoryMonitor.c"
}


#line 563 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file) {
#line 960 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 563 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 563 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 564 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("file altered: %s", _tmp0_ = g_file_get_path (file)));
#line 969 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 565 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-altered", file);
#line 974 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_altered (self, file);
#line 982 "DirectoryMonitor.c"
}


#line 568 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 988 "DirectoryMonitor.c"
	gboolean updated;
#line 568 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 568 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 568 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 569 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 570 "DirectoryMonitor.vala"
	g_assert (updated);
#line 572 "DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, file, info);
#line 1002 "DirectoryMonitor.c"
}


#line 575 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 1008 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 575 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 575 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 575 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 576 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("file alteration completed: %s", _tmp0_ = g_file_get_path (file)));
#line 1019 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 577 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-alteration-completed", file, info);
#line 1024 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_alteration_completed (self, file, info);
#line 1032 "DirectoryMonitor.c"
}


#line 580 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 1038 "DirectoryMonitor.c"
	gboolean updated;
#line 580 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 580 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 580 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 581 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 582 "DirectoryMonitor.vala"
	g_assert (updated);
#line 584 "DirectoryMonitor.vala"
	directory_monitor_notify_file_attributes_altered (self, file, info);
#line 1052 "DirectoryMonitor.c"
}


#line 587 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 1058 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 587 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 587 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 587 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 588 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("file attributes altered: %s", _tmp0_ = g_file_get_path (file)));
#line 1069 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 589 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-attributes-altered", file, info);
#line 1074 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_attributes_altered (self, file, info);
#line 1082 "DirectoryMonitor.c"
}


#line 592 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 592 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 592 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 594 "DirectoryMonitor.vala"
	if (directory_monitor_on_file_deleted (self, file)) {
#line 595 "DirectoryMonitor.vala"
		return;
#line 1096 "DirectoryMonitor.c"
	}
#line 597 "DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, file);
#line 1100 "DirectoryMonitor.c"
}


#line 600 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 1106 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 600 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 600 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 601 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("file deleted: %s", _tmp0_ = g_file_get_path (file)));
#line 1115 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 602 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-deleted", file);
#line 1120 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_deleted (self, file);
#line 1128 "DirectoryMonitor.c"
}


#line 605 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1134 "DirectoryMonitor.c"
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_;
	GFileInfo* _tmp5_;
#line 605 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 605 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 605 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1149 "DirectoryMonitor.c"
	old_dir = NULL;
	old_dir_info = NULL;
#line 608 "DirectoryMonitor.vala"
	if ((_tmp4_ = (_tmp1_ = directory_monitor_is_file_create_move (self, dir, info, &_tmp0_, &_tmp3_), old_dir = (_tmp2_ = _tmp0_, _g_object_unref0 (old_dir), _tmp2_), _tmp1_), old_dir_info = (_tmp5_ = _tmp3_, _g_object_unref0 (old_dir_info), _tmp5_), _tmp4_)) {
#line 614 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (self->priv->files, old_dir, self->priv->parent_moved);
#line 616 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, old_dir, old_dir_info, dir, info);
#line 1158 "DirectoryMonitor.c"
	} else {
		gboolean updated;
#line 618 "DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 619 "DirectoryMonitor.vala"
		g_assert (updated);
#line 621 "DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, dir, info);
#line 1167 "DirectoryMonitor.c"
	}
	_g_object_unref0 (old_dir_info);
	_g_object_unref0 (old_dir);
}


#line 625 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1176 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 625 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 625 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 625 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 626 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("directory created: %s", _tmp0_ = g_file_get_path (dir)));
#line 1187 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 627 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-created", dir, info);
#line 1192 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_created (self, dir, info);
#line 1200 "DirectoryMonitor.c"
}


#line 630 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info) {
#line 1206 "DirectoryMonitor.c"
	gboolean updated;
#line 630 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 630 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 630 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (old_dir_info));
#line 630 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 630 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 634 "DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (self->priv->files, old_dir, NULL);
#line 636 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, new_dir, new_dir_info);
#line 637 "DirectoryMonitor.vala"
	g_assert (updated);
#line 640 "DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, old_dir, old_dir_info);
#line 641 "DirectoryMonitor.vala"
	directory_monitor_add_monitor (self, new_dir, new_dir_info);
#line 643 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 1230 "DirectoryMonitor.c"
}


#line 646 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 1236 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 646 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 646 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 646 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 646 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 647 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp2_ = g_strdup_printf ("directory moved: %s -> %s", _tmp0_ = g_file_get_path (old_dir), _tmp1_ = g_file_get_path (new_dir)));
#line 1250 "DirectoryMonitor.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 648 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-moved", old_dir, new_dir, new_dir_info);
#line 650 "DirectoryMonitor.vala"
	if (g_file_equal (old_dir, self->priv->root)) {
#line 651 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, old_dir, new_dir, new_dir_info);
#line 1260 "DirectoryMonitor.c"
	}
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 1269 "DirectoryMonitor.c"
}


#line 654 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 1275 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 654 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 654 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 655 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("directory altered: %s", _tmp0_ = g_file_get_path (dir)));
#line 1284 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 656 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-altered", dir);
#line 1289 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_altered (self, dir);
#line 1297 "DirectoryMonitor.c"
}


#line 659 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1303 "DirectoryMonitor.c"
	gboolean updated;
#line 659 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 659 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 659 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 660 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 661 "DirectoryMonitor.vala"
	g_assert (updated);
#line 663 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, dir, info);
#line 1317 "DirectoryMonitor.c"
}


#line 666 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1323 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 666 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 666 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 666 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 667 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("directory alteration completed: %s", _tmp0_ = g_file_get_path (dir)));
#line 1334 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 668 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-alteration-completed", dir, info);
#line 1339 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_alteration_completed (self, dir, info);
#line 1347 "DirectoryMonitor.c"
}


#line 671 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1353 "DirectoryMonitor.c"
	gboolean updated;
#line 671 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 671 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 671 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 672 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 673 "DirectoryMonitor.vala"
	g_assert (updated);
#line 675 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_attributes_altered (self, dir, info);
#line 1367 "DirectoryMonitor.c"
}


#line 678 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1373 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 678 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 678 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 678 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 679 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("directory attributes altered: %s", _tmp0_ = g_file_get_path (dir)));
#line 1384 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 680 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-attributes-altered", dir, info);
#line 1389 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_attributes_altered (self, dir, info);
#line 1397 "DirectoryMonitor.c"
}


#line 683 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 1403 "DirectoryMonitor.c"
	GFileInfo* info;
#line 683 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 683 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 684 "DirectoryMonitor.vala"
	info = directory_monitor_file_info_map_get_info (self->priv->files, dir);
#line 685 "DirectoryMonitor.vala"
	g_assert (info != NULL);
#line 688 "DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, dir, info);
#line 691 "DirectoryMonitor.vala"
	if (directory_monitor_on_file_deleted (self, dir)) {
#line 1417 "DirectoryMonitor.c"
		_g_object_unref0 (info);
#line 692 "DirectoryMonitor.vala"
		return;
#line 1421 "DirectoryMonitor.c"
	}
#line 694 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (self, dir);
#line 1425 "DirectoryMonitor.c"
	_g_object_unref0 (info);
}


#line 697 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 1432 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 697 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 697 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 698 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("directory deleted: %s", _tmp0_ = g_file_get_path (dir)));
#line 1441 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 699 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-deleted", dir);
#line 701 "DirectoryMonitor.vala"
	if (g_file_equal (dir, self->priv->root)) {
#line 702 "DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, dir);
#line 1450 "DirectoryMonitor.c"
	}
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_deleted (self, dir);
#line 1459 "DirectoryMonitor.c"
}


#line 705 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_closed (DirectoryMonitor* self) {
#line 1465 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 705 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 706 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("monitoring of %s closed", _tmp0_ = g_file_get_path (self->priv->root)));
#line 1472 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 707 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "closed");
#line 1477 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_notify_closed (DirectoryMonitor* self) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_closed (self);
#line 1485 "DirectoryMonitor.c"
}


#line 710 "DirectoryMonitor.vala"
GFile* directory_monitor_get_root (DirectoryMonitor* self) {
#line 1491 "DirectoryMonitor.c"
	GFile* result = NULL;
#line 710 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1495 "DirectoryMonitor.c"
	result = _g_object_ref0 (self->priv->root);
#line 711 "DirectoryMonitor.vala"
	return result;
#line 1499 "DirectoryMonitor.c"
}


#line 714 "DirectoryMonitor.vala"
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file) {
#line 1505 "DirectoryMonitor.c"
	gboolean result = FALSE;
	GFile* parent;
#line 714 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 714 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 715 "DirectoryMonitor.vala"
	parent = _g_object_ref0 (file);
#line 1514 "DirectoryMonitor.c"
	{
		gboolean _tmp0_;
#line 716 "DirectoryMonitor.vala"
		_tmp0_ = TRUE;
#line 716 "DirectoryMonitor.vala"
		while (TRUE) {
#line 1521 "DirectoryMonitor.c"
			GFile* _tmp1_;
#line 716 "DirectoryMonitor.vala"
			if (!_tmp0_) {
#line 721 "DirectoryMonitor.vala"
				if (!(parent != NULL)) {
#line 721 "DirectoryMonitor.vala"
					break;
#line 1529 "DirectoryMonitor.c"
				}
			}
#line 716 "DirectoryMonitor.vala"
			_tmp0_ = FALSE;
#line 717 "DirectoryMonitor.vala"
			if (g_file_equal (parent, self->priv->root)) {
#line 1536 "DirectoryMonitor.c"
				result = TRUE;
				_g_object_unref0 (parent);
#line 718 "DirectoryMonitor.vala"
				return result;
#line 1541 "DirectoryMonitor.c"
			}
#line 720 "DirectoryMonitor.vala"
			parent = (_tmp1_ = g_file_get_parent (parent), _g_object_unref0 (parent), _tmp1_);
#line 1545 "DirectoryMonitor.c"
		}
	}
	result = FALSE;
	_g_object_unref0 (parent);
#line 723 "DirectoryMonitor.vala"
	return result;
#line 1552 "DirectoryMonitor.c"
}


#line 726 "DirectoryMonitor.vala"
void directory_monitor_start_discovery (DirectoryMonitor* self, GError** error) {
#line 726 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 727 "DirectoryMonitor.vala"
	g_assert (!self->priv->has_discovery_started);
#line 729 "DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 730 "DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 733 "DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 734 "DirectoryMonitor.vala"
	directory_monitor_explore_async (self, self->priv->root, NULL, TRUE, NULL, NULL);
#line 1570 "DirectoryMonitor.c"
}


#line 739 "DirectoryMonitor.vala"
static void directory_monitor_real_close (DirectoryMonitor* self) {
#line 739 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 741 "DirectoryMonitor.vala"
	g_cancellable_cancel (self->priv->cancellable);
#line 1580 "DirectoryMonitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _monitor_it;
#line 744 "DirectoryMonitor.vala"
		_monitor_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_values (GEE_MAP (self->priv->monitors)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 744 "DirectoryMonitor.vala"
		while (TRUE) {
#line 1589 "DirectoryMonitor.c"
			GFileMonitor* monitor;
#line 744 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 744 "DirectoryMonitor.vala"
				break;
#line 1595 "DirectoryMonitor.c"
			}
#line 744 "DirectoryMonitor.vala"
			monitor = (GFileMonitor*) gee_iterator_get (_monitor_it);
#line 745 "DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, monitor);
#line 1601 "DirectoryMonitor.c"
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 747 "DirectoryMonitor.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (self->priv->monitors));
#line 749 "DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 1610 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
void directory_monitor_close (DirectoryMonitor* self) {
#line 448 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->close (self);
#line 1618 "DirectoryMonitor.c"
}


#line 752 "DirectoryMonitor.vala"
static DirectoryMonitorFType directory_monitor_get_ftype (DirectoryMonitor* self, GFileInfo* info) {
#line 1624 "DirectoryMonitor.c"
	DirectoryMonitorFType result = 0;
	GFileType file_type;
#line 752 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), 0);
#line 752 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), 0);
#line 753 "DirectoryMonitor.vala"
	file_type = g_file_info_get_file_type (info);
#line 754 "DirectoryMonitor.vala"
	switch (file_type) {
#line 1635 "DirectoryMonitor.c"
		case G_FILE_TYPE_REGULAR:
		{
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 756 "DirectoryMonitor.vala"
			return result;
#line 1641 "DirectoryMonitor.c"
		}
		case G_FILE_TYPE_DIRECTORY:
		{
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 759 "DirectoryMonitor.vala"
			return result;
#line 1648 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp0_;
			char* _tmp1_;
#line 762 "DirectoryMonitor.vala"
			directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp0_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), (int) file_type), (_tmp0_ != NULL) ? _tmp0_->value_name : NULL)));
#line 1656 "DirectoryMonitor.c"
			_g_free0 (_tmp1_);
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 763 "DirectoryMonitor.vala"
			return result;
#line 1661 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_explore_async_data_free (gpointer _data) {
	DirectoryMonitorExploreAsyncData* data;
	data = _data;
	_g_object_unref0 (data->dir);
	_g_object_unref0 (data->dir_info);
	g_object_unref (data->self);
	g_slice_free (DirectoryMonitorExploreAsyncData, data);
}


static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_explore_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
	_data_->self = g_object_ref (self);
	_data_->dir = _g_object_ref0 (dir);
	_data_->dir_info = _g_object_ref0 (dir_info);
	_data_->in_discovery = in_discovery;
	directory_monitor_explore_async_co (_data_);
}


static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* data;
	data = _user_data_;
	data->_res_ = _res_;
	directory_monitor_explore_async_co (data);
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
	}
	_state_0:
	data->local_dir_info = _g_object_ref0 (data->dir_info);
#line 770 "DirectoryMonitor.vala"
	if (data->local_dir_info == NULL) {
#line 1727 "DirectoryMonitor.c"
		{
			data->_state_ = 1;
			g_file_query_info_async (data->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
			return FALSE;
			_state_1:
			data->_tmp0_ = g_file_query_info_finish (data->dir, data->_res_, &data->_inner_error_);
			if (data->_inner_error_ != NULL) {
				goto __catch275_g_error;
			}
#line 772 "DirectoryMonitor.vala"
			data->local_dir_info = (data->_tmp1_ = data->_tmp0_, _g_object_unref0 (data->local_dir_info), data->_tmp1_);
#line 1739 "DirectoryMonitor.c"
		}
		goto __finally275;
		__catch275_g_error:
		{
			data->err = data->_inner_error_;
			data->_inner_error_ = NULL;
			{
#line 775 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:775: Unable to retrieve info on %s: %s", data->_tmp2_ = g_file_get_path (data->dir), data->err->message);
#line 1749 "DirectoryMonitor.c"
				_g_free0 (data->_tmp2_);
#line 777 "DirectoryMonitor.vala"
				directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 1753 "DirectoryMonitor.c"
				_g_error_free0 (data->err);
				_g_object_unref0 (data->local_dir_info);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
				_g_error_free0 (data->err);
			}
		}
		__finally275:
		if (data->_inner_error_ != NULL) {
			_g_object_unref0 (data->local_dir_info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
			g_clear_error (&data->_inner_error_);
			return FALSE;
		}
	}
#line 784 "DirectoryMonitor.vala"
	if (g_file_info_get_file_type (data->local_dir_info) != G_FILE_TYPE_DIRECTORY) {
#line 785 "DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (data->self, data->_tmp4_ = g_strdup_printf (_ ("Unable to monitor %s: Not a directory"), data->_tmp3_ = g_file_get_path (data->dir)));
#line 1780 "DirectoryMonitor.c"
		_g_free0 (data->_tmp4_);
		_g_free0 (data->_tmp3_);
#line 787 "DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 1785 "DirectoryMonitor.c"
		_g_object_unref0 (data->local_dir_info);
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
	data->dir_map = NULL;
	data->file_map = NULL;
	{
		data->_state_ = 2;
		g_file_enumerate_children_async (data->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
		return FALSE;
		_state_2:
		data->enumerator = g_file_enumerate_children_finish (data->dir, data->_res_, &data->_inner_error_);
		if (data->_inner_error_ != NULL) {
			goto __catch276_g_error;
		}
		{
			data->_tmp5_ = TRUE;
#line 802 "DirectoryMonitor.vala"
			while (TRUE) {
#line 802 "DirectoryMonitor.vala"
				if (!data->_tmp5_) {
#line 1814 "DirectoryMonitor.c"
				}
#line 802 "DirectoryMonitor.vala"
				data->_tmp5_ = FALSE;
#line 1818 "DirectoryMonitor.c"
				data->_state_ = 3;
				g_file_enumerator_next_files_async (data->enumerator, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
				return FALSE;
				_state_3:
				data->infos = g_file_enumerator_next_files_finish (data->enumerator, data->_res_, &data->_inner_error_);
				if (data->_inner_error_ != NULL) {
					_g_object_unref0 (data->enumerator);
					goto __catch276_g_error;
				}
#line 805 "DirectoryMonitor.vala"
				if (data->infos == NULL) {
#line 1830 "DirectoryMonitor.c"
					__g_list_free_g_object_unref0 (data->infos);
#line 806 "DirectoryMonitor.vala"
					break;
#line 1834 "DirectoryMonitor.c"
				}
				{
					data->info_collection = data->infos;
					for (data->info_it = data->info_collection; data->info_it != NULL; data->info_it = data->info_it->next) {
						data->info = _g_object_ref0 ((GFileInfo*) data->info_it->data);
						{
#line 809 "DirectoryMonitor.vala"
							switch (g_file_info_get_file_type (data->info)) {
#line 1843 "DirectoryMonitor.c"
								case G_FILE_TYPE_REGULAR:
								{
#line 811 "DirectoryMonitor.vala"
									if (data->file_map == NULL) {
#line 812 "DirectoryMonitor.vala"
										data->file_map = (data->_tmp6_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL), _g_object_unref0 (data->file_map), data->_tmp6_);
#line 1850 "DirectoryMonitor.c"
									}
#line 814 "DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (data->file_map), data->_tmp7_ = g_file_get_child (data->dir, g_file_info_get_name (data->info)), data->info);
#line 1854 "DirectoryMonitor.c"
									_g_object_unref0 (data->_tmp7_);
#line 815 "DirectoryMonitor.vala"
									break;
#line 1858 "DirectoryMonitor.c"
								}
								case G_FILE_TYPE_DIRECTORY:
								{
#line 818 "DirectoryMonitor.vala"
									if (data->dir_map == NULL) {
#line 819 "DirectoryMonitor.vala"
										data->dir_map = (data->_tmp8_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL), _g_object_unref0 (data->dir_map), data->_tmp8_);
#line 1866 "DirectoryMonitor.c"
									}
#line 821 "DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (data->dir_map), data->_tmp9_ = g_file_get_child (data->dir, g_file_info_get_name (data->info)), data->info);
#line 1870 "DirectoryMonitor.c"
									_g_object_unref0 (data->_tmp9_);
#line 822 "DirectoryMonitor.vala"
									break;
#line 1874 "DirectoryMonitor.c"
								}
								default:
								{
#line 826 "DirectoryMonitor.vala"
									break;
#line 1880 "DirectoryMonitor.c"
								}
							}
							_g_object_unref0 (data->info);
						}
					}
				}
				__g_list_free_g_object_unref0 (data->infos);
			}
		}
		_g_object_unref0 (data->enumerator);
	}
	goto __finally276;
	__catch276_g_error:
	{
		data->err2 = data->_inner_error_;
		data->_inner_error_ = NULL;
		{
#line 831 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:831: Aborted directory traversal of %s: %s", data->_tmp10_ = g_file_get_path (data->dir), data->err2->message);
#line 1900 "DirectoryMonitor.c"
			_g_free0 (data->_tmp10_);
#line 833 "DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 1904 "DirectoryMonitor.c"
			_g_error_free0 (data->err2);
			_g_object_unref0 (data->file_map);
			_g_object_unref0 (data->dir_map);
			_g_object_unref0 (data->local_dir_info);
			{
				if (data->_state_ == 0) {
					g_simple_async_result_complete_in_idle (data->_async_result);
				} else {
					g_simple_async_result_complete (data->_async_result);
				}
				g_object_unref (data->_async_result);
				return FALSE;
			}
			_g_error_free0 (data->err2);
		}
	}
	__finally276:
	if (data->_inner_error_ != NULL) {
		_g_object_unref0 (data->file_map);
		_g_object_unref0 (data->dir_map);
		_g_object_unref0 (data->local_dir_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
#line 839 "DirectoryMonitor.vala"
	if (data->in_discovery) {
#line 840 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (data->self, data->dir, data->local_dir_info);
#line 1934 "DirectoryMonitor.c"
	} else {
#line 842 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (data->self, data->dir, data->local_dir_info);
#line 1938 "DirectoryMonitor.c"
	}
#line 846 "DirectoryMonitor.vala"
	directory_monitor_add_monitor (data->self, data->dir, data->local_dir_info);
#line 849 "DirectoryMonitor.vala"
	if (data->file_map != NULL) {
#line 1944 "DirectoryMonitor.c"
		{
			data->_file_it = (data->_tmp12_ = gee_iterable_iterator (GEE_ITERABLE (data->_tmp11_ = gee_map_get_keys (GEE_MAP (data->file_map)))), _g_object_unref0 (data->_tmp11_), data->_tmp12_);
#line 850 "DirectoryMonitor.vala"
			while (TRUE) {
#line 850 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_file_it)) {
#line 850 "DirectoryMonitor.vala"
					break;
#line 1953 "DirectoryMonitor.c"
				}
				data->file = (GFile*) gee_iterator_get (data->_file_it);
#line 851 "DirectoryMonitor.vala"
				if (data->in_discovery) {
#line 852 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_discovered (data->self, data->file, data->_tmp13_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (data->file_map), data->file));
#line 1960 "DirectoryMonitor.c"
					_g_object_unref0 (data->_tmp13_);
				} else {
#line 854 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (data->self, data->file, data->_tmp14_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (data->file_map), data->file));
#line 1965 "DirectoryMonitor.c"
					_g_object_unref0 (data->_tmp14_);
				}
				_g_object_unref0 (data->file);
			}
			_g_object_unref0 (data->_file_it);
		}
	}
#line 859 "DirectoryMonitor.vala"
	if (data->self->priv->recurse) {
#line 859 "DirectoryMonitor.vala"
		data->_tmp15_ = data->dir_map != NULL;
#line 1977 "DirectoryMonitor.c"
	} else {
#line 859 "DirectoryMonitor.vala"
		data->_tmp15_ = FALSE;
#line 1981 "DirectoryMonitor.c"
	}
#line 859 "DirectoryMonitor.vala"
	if (data->_tmp15_) {
#line 1985 "DirectoryMonitor.c"
		{
			data->_subdir_it = (data->_tmp17_ = gee_iterable_iterator (GEE_ITERABLE (data->_tmp16_ = gee_map_get_keys (GEE_MAP (data->dir_map)))), _g_object_unref0 (data->_tmp16_), data->_tmp17_);
#line 860 "DirectoryMonitor.vala"
			while (TRUE) {
#line 860 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_subdir_it)) {
#line 860 "DirectoryMonitor.vala"
					break;
#line 1994 "DirectoryMonitor.c"
				}
				data->subdir = (GFile*) gee_iterator_get (data->_subdir_it);
#line 861 "DirectoryMonitor.vala"
				if (data->in_discovery) {
#line 862 "DirectoryMonitor.vala"
					data->self->priv->outstanding_exploration_dirs++;
#line 2001 "DirectoryMonitor.c"
				}
#line 863 "DirectoryMonitor.vala"
				directory_monitor_explore_async (data->self, data->subdir, data->_tmp18_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (data->dir_map), data->subdir), data->in_discovery, NULL, NULL);
#line 2005 "DirectoryMonitor.c"
				_g_object_unref0 (data->_tmp18_);
				_g_object_unref0 (data->subdir);
			}
			_g_object_unref0 (data->_subdir_it);
		}
	}
#line 867 "DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2014 "DirectoryMonitor.c"
	_g_object_unref0 (data->file_map);
	_g_object_unref0 (data->dir_map);
	_g_object_unref0 (data->local_dir_info);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 872 "DirectoryMonitor.vala"
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery) {
#line 872 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 873 "DirectoryMonitor.vala"
	if (in_discovery) {
#line 874 "DirectoryMonitor.vala"
		g_assert (self->priv->outstanding_exploration_dirs > 0);
#line 875 "DirectoryMonitor.vala"
		if ((self->priv->outstanding_exploration_dirs = self->priv->outstanding_exploration_dirs - 1) == 0) {
#line 876 "DirectoryMonitor.vala"
			directory_monitor_notify_discovery_completed (self);
#line 2042 "DirectoryMonitor.c"
		}
	}
}


#line 940 "DirectoryMonitor.vala"
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 2050 "DirectoryMonitor.c"
	directory_monitor_on_monitor_notification (self, file, other_file, event_type);
}


#line 883 "DirectoryMonitor.vala"
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 2057 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFileMonitor* monitor;
	char* _tmp3_;
	char* _tmp4_;
	GError * _inner_error_ = NULL;
#line 883 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 883 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 883 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 884 "DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 2072 "DirectoryMonitor.c"
		result = FALSE;
#line 885 "DirectoryMonitor.vala"
		return result;
#line 2076 "DirectoryMonitor.c"
	}
#line 887 "DirectoryMonitor.vala"
	id = directory_monitor_file_info_map_get_id (self->priv->files, dir, info);
#line 888 "DirectoryMonitor.vala"
	if (id == NULL) {
#line 2082 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (id);
#line 889 "DirectoryMonitor.vala"
		return result;
#line 2087 "DirectoryMonitor.c"
	}
#line 892 "DirectoryMonitor.vala"
	if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->monitors), id)) {
#line 2091 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (id);
#line 893 "DirectoryMonitor.vala"
		return result;
#line 2096 "DirectoryMonitor.c"
	}
#line 895 "DirectoryMonitor.vala"
	monitor = NULL;
#line 2100 "DirectoryMonitor.c"
	{
		GFileMonitor* _tmp0_;
		GFileMonitor* _tmp1_;
#line 897 "DirectoryMonitor.vala"
		_tmp0_ = g_file_monitor_directory (dir, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error_);
#line 2106 "DirectoryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch277_g_error;
		}
#line 897 "DirectoryMonitor.vala"
		monitor = (_tmp1_ = _tmp0_, _g_object_unref0 (monitor), _tmp1_);
#line 2112 "DirectoryMonitor.c"
	}
	goto __finally277;
	__catch277_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp2_;
#line 899 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:899: Unable to monitor %s: %s", _tmp2_ = g_file_get_path (dir), err->message);
#line 2124 "DirectoryMonitor.c"
			_g_free0 (_tmp2_);
			result = FALSE;
			_g_error_free0 (err);
			_g_object_unref0 (monitor);
			_g_free0 (id);
#line 901 "DirectoryMonitor.vala"
			return result;
#line 2132 "DirectoryMonitor.c"
		}
	}
	__finally277:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (monitor);
		_g_free0 (id);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 904 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->monitors), id, monitor);
#line 905 "DirectoryMonitor.vala"
	g_signal_connect_object (monitor, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 907 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp4_ = g_strdup_printf ("Added monitor for %s", _tmp3_ = g_file_get_path (dir)));
#line 2149 "DirectoryMonitor.c"
	_g_free0 (_tmp4_);
	_g_free0 (_tmp3_);
	result = TRUE;
	_g_object_unref0 (monitor);
	_g_free0 (id);
#line 909 "DirectoryMonitor.vala"
	return result;
#line 2157 "DirectoryMonitor.c"
}


#line 913 "DirectoryMonitor.vala"
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 2163 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFileMonitor* monitor;
	gboolean removed;
	char* _tmp0_;
	char* _tmp1_;
#line 913 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 913 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 913 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 914 "DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 2178 "DirectoryMonitor.c"
		result = FALSE;
#line 915 "DirectoryMonitor.vala"
		return result;
#line 2182 "DirectoryMonitor.c"
	}
#line 917 "DirectoryMonitor.vala"
	id = directory_monitor_file_info_map_get_id (self->priv->files, dir, info);
#line 918 "DirectoryMonitor.vala"
	if (id == NULL) {
#line 2188 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (id);
#line 919 "DirectoryMonitor.vala"
		return result;
#line 2193 "DirectoryMonitor.c"
	}
#line 921 "DirectoryMonitor.vala"
	monitor = (GFileMonitor*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->monitors), id);
#line 922 "DirectoryMonitor.vala"
	if (monitor == NULL) {
#line 2199 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (monitor);
		_g_free0 (id);
#line 923 "DirectoryMonitor.vala"
		return result;
#line 2205 "DirectoryMonitor.c"
	}
#line 925 "DirectoryMonitor.vala"
	removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->monitors), id, NULL);
#line 926 "DirectoryMonitor.vala"
	g_assert (removed);
#line 928 "DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, monitor);
#line 930 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp1_ = g_strdup_printf ("Removed monitor for %s", _tmp0_ = g_file_get_path (dir)));
#line 2215 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
	result = TRUE;
	_g_object_unref0 (monitor);
	_g_free0 (id);
#line 932 "DirectoryMonitor.vala"
	return result;
#line 2223 "DirectoryMonitor.c"
}


#line 935 "DirectoryMonitor.vala"
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor) {
#line 2229 "DirectoryMonitor.c"
	guint _tmp0_;
#line 935 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 935 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_MONITOR (monitor));
#line 936 "DirectoryMonitor.vala"
	g_signal_parse_name ("changed", G_TYPE_FILE_MONITOR, &_tmp0_, NULL, FALSE);
#line 936 "DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 937 "DirectoryMonitor.vala"
	g_file_monitor_cancel (monitor);
#line 2241 "DirectoryMonitor.c"
}


#line 84 "DirectoryMonitor.vala"
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 2247 "DirectoryMonitor.c"
	directory_monitor_query_info_queue_element_on_completed (self, source_object, res);
	directory_monitor_query_info_queue_element_unref (self);
}


#line 940 "DirectoryMonitor.vala"
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 2255 "DirectoryMonitor.c"
	char* _tmp0_;
	GEnumValue* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	DirectoryMonitorQueryInfoQueueElement* query_event;
#line 940 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 940 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 940 "DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 2267 "DirectoryMonitor.c"
	_tmp0_ = NULL;
#line 942 "DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 2271 "DirectoryMonitor.c"
		char* _tmp1_;
#line 942 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp1_ = g_file_get_path (other_file), _g_free0 (_tmp0_), _tmp1_);
#line 2275 "DirectoryMonitor.c"
	} else {
		char* _tmp2_;
#line 942 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp2_ = g_strdup ("(none)"), _g_free0 (_tmp0_), _tmp2_);
#line 2280 "DirectoryMonitor.c"
	}
#line 941 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp5_ = g_strdup_printf ("%s: file=%s other_file=%s", (_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event), (_tmp3_ != NULL) ? _tmp3_->value_name : NULL), _tmp4_ = g_file_get_path (file), _tmp0_));
#line 2284 "DirectoryMonitor.c"
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
#line 951 "DirectoryMonitor.vala"
	query_event = directory_monitor_query_info_queue_element_new (self, file, other_file, event);
#line 952 "DirectoryMonitor.vala"
	gee_queue_offer (self->priv->query_info_queue, query_event);
#line 954 "DirectoryMonitor.vala"
	switch (event) {
#line 2293 "DirectoryMonitor.c"
		case G_FILE_MONITOR_EVENT_CREATED:
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
		{
#line 958 "DirectoryMonitor.vala"
			g_file_query_info_async (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, self->priv->cancellable, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (query_event));
#line 960 "DirectoryMonitor.vala"
			break;
#line 2302 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
#line 965 "DirectoryMonitor.vala"
			if (other_file != NULL) {
#line 966 "DirectoryMonitor.vala"
				g_file_query_info_async (other_file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, self->priv->cancellable, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (query_event));
#line 2310 "DirectoryMonitor.c"
			} else {
#line 969 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:969: Unable to process MOVED event: no other_fil" \
"e");
#line 970 "DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (self->priv->query_info_queue), query_event);
#line 2316 "DirectoryMonitor.c"
			}
#line 972 "DirectoryMonitor.vala"
			break;
#line 2320 "DirectoryMonitor.c"
		}
		default:
		{
#line 976 "DirectoryMonitor.vala"
			query_event->completed = TRUE;
#line 977 "DirectoryMonitor.vala"
			directory_monitor_on_query_finished (self, query_event);
#line 978 "DirectoryMonitor.vala"
			break;
#line 2330 "DirectoryMonitor.c"
		}
	}
	_directory_monitor_query_info_queue_element_unref0 (query_event);
	_g_free0 (_tmp0_);
}


#line 982 "DirectoryMonitor.vala"
static void directory_monitor_on_query_finished (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* queue_event) {
#line 982 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 982 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (queue_event));
#line 2344 "DirectoryMonitor.c"
	{
		gboolean _tmp0_;
#line 984 "DirectoryMonitor.vala"
		_tmp0_ = TRUE;
#line 984 "DirectoryMonitor.vala"
		while (TRUE) {
#line 2351 "DirectoryMonitor.c"
			DirectoryMonitorQueryInfoQueueElement* next;
			gboolean _tmp1_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp2_;
			GEnumValue* _tmp3_;
			char* _tmp4_;
			char* _tmp5_;
#line 984 "DirectoryMonitor.vala"
			if (!_tmp0_) {
#line 2360 "DirectoryMonitor.c"
			}
#line 984 "DirectoryMonitor.vala"
			_tmp0_ = FALSE;
#line 986 "DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) gee_queue_peek (self->priv->query_info_queue);
#line 987 "DirectoryMonitor.vala"
			if (next == NULL) {
#line 987 "DirectoryMonitor.vala"
				_tmp1_ = TRUE;
#line 2370 "DirectoryMonitor.c"
			} else {
#line 987 "DirectoryMonitor.vala"
				_tmp1_ = !next->completed;
#line 2374 "DirectoryMonitor.c"
			}
#line 987 "DirectoryMonitor.vala"
			if (_tmp1_) {
#line 2378 "DirectoryMonitor.c"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 988 "DirectoryMonitor.vala"
				break;
#line 2382 "DirectoryMonitor.c"
			}
#line 991 "DirectoryMonitor.vala"
			_tmp2_ = (DirectoryMonitorQueryInfoQueueElement*) gee_queue_poll (self->priv->query_info_queue);
#line 2386 "DirectoryMonitor.c"
			_directory_monitor_query_info_queue_element_unref0 (_tmp2_);
#line 993 "DirectoryMonitor.vala"
			directory_monitor_mdbg (self, _tmp5_ = g_strdup_printf ("Completed info query %u for %s on %s", next->position, (_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) next->event), (_tmp3_ != NULL) ? _tmp3_->value_name : NULL), _tmp4_ = g_file_get_path (next->file)));
#line 2390 "DirectoryMonitor.c"
			_g_free0 (_tmp5_);
			_g_free0 (_tmp4_);
#line 996 "DirectoryMonitor.vala"
			if (next->err != NULL) {
#line 2395 "DirectoryMonitor.c"
				char* _tmp6_;
				GEnumValue* _tmp7_;
#line 997 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:997: Unable to retrieve file information for %s," \
" dropping %s: %s", _tmp6_ = g_file_get_path (next->file), (_tmp7_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) next->event), (_tmp7_ != NULL) ? _tmp7_->value_name : NULL), next->err->message);
#line 2400 "DirectoryMonitor.c"
				_g_free0 (_tmp6_);
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1000 "DirectoryMonitor.vala"
				continue;
#line 2405 "DirectoryMonitor.c"
			}
#line 1003 "DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, next->file, next->other_file, next->info, next->event);
#line 2409 "DirectoryMonitor.c"
			_directory_monitor_query_info_queue_element_unref0 (next);
		}
	}
}


#line 1007 "DirectoryMonitor.vala"
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event) {
#line 2418 "DirectoryMonitor.c"
	char* _tmp0_;
	GEnumValue* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
#line 1007 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1007 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1007 "DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 1007 "DirectoryMonitor.vala"
	g_return_if_fail ((info == NULL) || G_IS_FILE_INFO (info));
#line 2431 "DirectoryMonitor.c"
	_tmp0_ = NULL;
#line 1010 "DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 2435 "DirectoryMonitor.c"
		char* _tmp1_;
#line 1010 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp1_ = g_file_get_path (other_file), _g_free0 (_tmp0_), _tmp1_);
#line 2439 "DirectoryMonitor.c"
	} else {
		char* _tmp2_;
#line 1010 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp2_ = g_strdup ("(null)"), _g_free0 (_tmp0_), _tmp2_);
#line 2444 "DirectoryMonitor.c"
	}
#line 1009 "DirectoryMonitor.vala"
	directory_monitor_mdbg (self, _tmp5_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event), (_tmp3_ != NULL) ? _tmp3_->value_name : NULL), _tmp4_ = g_file_get_path (file), _tmp0_));
#line 2448 "DirectoryMonitor.c"
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
#line 1014 "DirectoryMonitor.vala"
	switch (event) {
#line 2453 "DirectoryMonitor.c"
		case G_FILE_MONITOR_EVENT_CREATED:
		{
			DirectoryMonitorFType ftype;
#line 1016 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1018 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (self, info);
#line 1019 "DirectoryMonitor.vala"
			switch (ftype) {
#line 2463 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1021 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, file, info);
#line 1022 "DirectoryMonitor.vala"
					break;
#line 2470 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1029 "DirectoryMonitor.vala"
					directory_monitor_explore_async (self, file, info, FALSE, NULL, NULL);
#line 1030 "DirectoryMonitor.vala"
					break;
#line 2478 "DirectoryMonitor.c"
				}
				default:
				{
#line 1033 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1034 "DirectoryMonitor.vala"
					break;
#line 2486 "DirectoryMonitor.c"
				}
			}
#line 1036 "DirectoryMonitor.vala"
			break;
#line 2491 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_CHANGED:
		{
			GFileInfo* local_info;
			DirectoryMonitorFType ftype;
#line 1040 "DirectoryMonitor.vala"
			g_assert (info == NULL);
#line 1042 "DirectoryMonitor.vala"
			local_info = directory_monitor_get_file_info (self, file);
#line 1043 "DirectoryMonitor.vala"
			if (local_info == NULL) {
#line 2503 "DirectoryMonitor.c"
				char* _tmp6_;
#line 1044 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1044: Changed event for unknown file %s", _tmp6_ = g_file_get_path (file));
#line 2507 "DirectoryMonitor.c"
				_g_free0 (_tmp6_);
				_g_object_unref0 (local_info);
#line 1046 "DirectoryMonitor.vala"
				break;
#line 2512 "DirectoryMonitor.c"
			}
#line 1049 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (self, local_info);
#line 1050 "DirectoryMonitor.vala"
			switch (ftype) {
#line 2518 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1052 "DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, file);
#line 1053 "DirectoryMonitor.vala"
					break;
#line 2525 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1056 "DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, file);
#line 1057 "DirectoryMonitor.vala"
					break;
#line 2533 "DirectoryMonitor.c"
				}
				default:
				{
#line 1060 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1061 "DirectoryMonitor.vala"
					break;
#line 2541 "DirectoryMonitor.c"
				}
			}
			_g_object_unref0 (local_info);
#line 1063 "DirectoryMonitor.vala"
			break;
#line 2547 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			DirectoryMonitorFType ftype;
#line 1066 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1068 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (self, info);
#line 1069 "DirectoryMonitor.vala"
			switch (ftype) {
#line 2558 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1071 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, file, info);
#line 1072 "DirectoryMonitor.vala"
					break;
#line 2565 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1075 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, file, info);
#line 1076 "DirectoryMonitor.vala"
					break;
#line 2573 "DirectoryMonitor.c"
				}
				default:
				{
#line 1079 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1080 "DirectoryMonitor.vala"
					break;
#line 2581 "DirectoryMonitor.c"
				}
			}
#line 1082 "DirectoryMonitor.vala"
			break;
#line 2586 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
			DirectoryMonitorFType ftype;
#line 1085 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1086 "DirectoryMonitor.vala"
			g_assert (other_file != NULL);
#line 1090 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (self, info);
#line 1091 "DirectoryMonitor.vala"
			switch (ftype) {
#line 2599 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1093 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, file, other_file, info);
#line 1094 "DirectoryMonitor.vala"
					break;
#line 2606 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					GFileInfo* old_dir_info;
#line 1098 "DirectoryMonitor.vala"
					old_dir_info = directory_monitor_file_info_map_get_info (self->priv->files, file);
#line 1099 "DirectoryMonitor.vala"
					if (old_dir_info == NULL) {
#line 2615 "DirectoryMonitor.c"
						char* _tmp7_;
#line 1100 "DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1100: Directory moved event for unknown file %s", _tmp7_ = g_file_get_path (file));
#line 2619 "DirectoryMonitor.c"
						_g_free0 (_tmp7_);
						_g_object_unref0 (old_dir_info);
#line 1102 "DirectoryMonitor.vala"
						break;
#line 2624 "DirectoryMonitor.c"
					}
#line 1105 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, file, old_dir_info, other_file, info);
#line 2628 "DirectoryMonitor.c"
					_g_object_unref0 (old_dir_info);
#line 1106 "DirectoryMonitor.vala"
					break;
#line 2632 "DirectoryMonitor.c"
				}
				default:
				{
#line 1109 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1110 "DirectoryMonitor.vala"
					break;
#line 2640 "DirectoryMonitor.c"
				}
			}
#line 1112 "DirectoryMonitor.vala"
			break;
#line 2645 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			GFileInfo* local_info;
			DirectoryMonitorFType ftype;
#line 1115 "DirectoryMonitor.vala"
			g_assert (info == NULL);
#line 1117 "DirectoryMonitor.vala"
			local_info = directory_monitor_get_file_info (self, file);
#line 1118 "DirectoryMonitor.vala"
			if (local_info == NULL) {
#line 2657 "DirectoryMonitor.c"
				char* _tmp8_;
#line 1119 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1119: Deleted event for unknown file %s", _tmp8_ = g_file_get_path (file));
#line 2661 "DirectoryMonitor.c"
				_g_free0 (_tmp8_);
				_g_object_unref0 (local_info);
#line 1121 "DirectoryMonitor.vala"
				break;
#line 2666 "DirectoryMonitor.c"
			}
#line 1124 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (self, local_info);
#line 1125 "DirectoryMonitor.vala"
			switch (ftype) {
#line 2672 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1127 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, file);
#line 1128 "DirectoryMonitor.vala"
					break;
#line 2679 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1131 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, file);
#line 1132 "DirectoryMonitor.vala"
					break;
#line 2687 "DirectoryMonitor.c"
				}
				default:
				{
#line 1135 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1136 "DirectoryMonitor.vala"
					break;
#line 2695 "DirectoryMonitor.c"
				}
			}
			_g_object_unref0 (local_info);
#line 1138 "DirectoryMonitor.vala"
			break;
#line 2701 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
		{
			DirectoryMonitorFType ftype;
#line 1141 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1143 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (self, info);
#line 1144 "DirectoryMonitor.vala"
			switch (ftype) {
#line 2712 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1146 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_attributes_altered (self, file, info);
#line 1147 "DirectoryMonitor.vala"
					break;
#line 2719 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1150 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_attributes_altered (self, file, info);
#line 1151 "DirectoryMonitor.vala"
					break;
#line 2727 "DirectoryMonitor.c"
				}
				default:
				{
#line 1154 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1155 "DirectoryMonitor.vala"
					break;
#line 2735 "DirectoryMonitor.c"
				}
			}
#line 1157 "DirectoryMonitor.vala"
			break;
#line 2740 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
		{
#line 1162 "DirectoryMonitor.vala"
			break;
#line 2747 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp9_;
#line 1165 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1165: Unknown directory monitor event %s", (_tmp9_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event), (_tmp9_ != NULL) ? _tmp9_->value_name : NULL));
#line 1166 "DirectoryMonitor.vala"
			break;
#line 2756 "DirectoryMonitor.c"
		}
	}
	_g_free0 (_tmp0_);
}


#line 1172 "DirectoryMonitor.vala"
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info) {
#line 2765 "DirectoryMonitor.c"
	gboolean result = FALSE;
	GFile* match;
	GFile* _tmp2_;
#line 1172 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1172 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1172 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 2775 "DirectoryMonitor.c"
	if (old_file != NULL) {
		*old_file = NULL;
	}
	if (old_file_info != NULL) {
		*old_file_info = NULL;
	}
#line 1175 "DirectoryMonitor.vala"
	match = directory_monitor_file_info_map_find_match (self->priv->parent_moved, info);
#line 1176 "DirectoryMonitor.vala"
	if (match != NULL) {
#line 2786 "DirectoryMonitor.c"
		GFile* _tmp0_;
		GFileInfo* _tmp1_;
#line 1177 "DirectoryMonitor.vala"
		*old_file = (_tmp0_ = _g_object_ref0 (match), _g_object_unref0 (*old_file), _tmp0_);
#line 1178 "DirectoryMonitor.vala"
		*old_file_info = (_tmp1_ = directory_monitor_file_info_map_get_info (self->priv->parent_moved, match), _g_object_unref0 (*old_file_info), _tmp1_);
#line 1180 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (self->priv->parent_moved, match, info);
#line 2795 "DirectoryMonitor.c"
		result = TRUE;
		_g_object_unref0 (match);
#line 1182 "DirectoryMonitor.vala"
		return result;
#line 2800 "DirectoryMonitor.c"
	}
#line 1186 "DirectoryMonitor.vala"
	match = (_tmp2_ = directory_monitor_file_info_map_find_match (DIRECTORY_MONITOR_FILE_INFO_MAP (self->priv->deleted), info), _g_object_unref0 (match), _tmp2_);
#line 1187 "DirectoryMonitor.vala"
	if (match != NULL) {
#line 2806 "DirectoryMonitor.c"
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
#line 1188 "DirectoryMonitor.vala"
		*old_file = (_tmp3_ = _g_object_ref0 (match), _g_object_unref0 (*old_file), _tmp3_);
#line 1189 "DirectoryMonitor.vala"
		*old_file_info = (_tmp4_ = directory_monitor_file_info_map_get_info (DIRECTORY_MONITOR_FILE_INFO_MAP (self->priv->deleted), match), _g_object_unref0 (*old_file_info), _tmp4_);
#line 1191 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (DIRECTORY_MONITOR_FILE_INFO_MAP (self->priv->deleted), match, info);
#line 2815 "DirectoryMonitor.c"
		result = TRUE;
		_g_object_unref0 (match);
#line 1193 "DirectoryMonitor.vala"
		return result;
#line 2820 "DirectoryMonitor.c"
	}
	result = FALSE;
	_g_object_unref0 (match);
#line 1196 "DirectoryMonitor.vala"
	return result;
#line 2826 "DirectoryMonitor.c"
}


#line 1231 "DirectoryMonitor.vala"
static gboolean _directory_monitor_on_deleted_timeout_gsource_func (gpointer self) {
#line 2832 "DirectoryMonitor.c"
	gboolean result;
	result = directory_monitor_on_deleted_timeout (self);
	return result;
}


#line 1201 "DirectoryMonitor.vala"
static gboolean directory_monitor_on_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 2841 "DirectoryMonitor.c"
	gboolean result = FALSE;
	GFileInfo* info;
	gboolean removed;
	gboolean updated;
#line 1201 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1201 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1205 "DirectoryMonitor.vala"
	info = directory_monitor_file_info_map_get_info (self->priv->files, file);
#line 1206 "DirectoryMonitor.vala"
	if (info == NULL) {
#line 2854 "DirectoryMonitor.c"
		char* _tmp0_;
		GFile* _tmp1_;
		char* _tmp2_;
#line 1208 "DirectoryMonitor.vala"
		if (directory_monitor_file_info_map_contains (DIRECTORY_MONITOR_FILE_INFO_MAP (self->priv->deleted), file, NULL)) {
#line 2860 "DirectoryMonitor.c"
			result = TRUE;
			_g_object_unref0 (info);
#line 1209 "DirectoryMonitor.vala"
			return result;
#line 2865 "DirectoryMonitor.c"
		}
#line 1211 "DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:1211: Unknown file %s deleted from monitor on %s", _tmp0_ = g_file_get_path (file), _tmp2_ = g_file_get_path (_tmp1_ = directory_monitor_get_root (self)));
#line 2869 "DirectoryMonitor.c"
		_g_free0 (_tmp2_);
		_g_object_unref0 (_tmp1_);
		_g_free0 (_tmp0_);
		result = FALSE;
		_g_object_unref0 (info);
#line 1214 "DirectoryMonitor.vala"
		return result;
#line 2877 "DirectoryMonitor.c"
	}
#line 1217 "DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (self->priv->files, file, info);
#line 1218 "DirectoryMonitor.vala"
	g_assert (removed);
#line 1220 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (DIRECTORY_MONITOR_FILE_INFO_MAP (self->priv->deleted), file, info);
#line 1221 "DirectoryMonitor.vala"
	g_assert (updated);
#line 1223 "DirectoryMonitor.vala"
	if (!self->priv->delete_timer_active) {
#line 1224 "DirectoryMonitor.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_on_deleted_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 1225 "DirectoryMonitor.vala"
		self->priv->delete_timer_active = TRUE;
#line 2893 "DirectoryMonitor.c"
	}
	result = TRUE;
	_g_object_unref0 (info);
#line 1228 "DirectoryMonitor.vala"
	return result;
#line 2899 "DirectoryMonitor.c"
}


#line 1231 "DirectoryMonitor.vala"
static gboolean directory_monitor_on_deleted_timeout (DirectoryMonitor* self) {
#line 2905 "DirectoryMonitor.c"
	gboolean result = FALSE;
	gulong expiration;
	GeeMap* overdue;
#line 1231 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1232 "DirectoryMonitor.vala"
	expiration = now_ms () - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1235 "DirectoryMonitor.vala"
	overdue = directory_monitor_timed_file_info_map_remove_older_than (self->priv->deleted, expiration);
#line 1236 "DirectoryMonitor.vala"
	if (overdue != NULL) {
#line 2917 "DirectoryMonitor.c"
		{
			GeeSet* _tmp0_;
			GeeIterator* _tmp1_;
			GeeIterator* _file_it;
#line 1237 "DirectoryMonitor.vala"
			_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (overdue))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1237 "DirectoryMonitor.vala"
			while (TRUE) {
#line 2926 "DirectoryMonitor.c"
				GFile* file;
				GFileInfo* _tmp2_;
				DirectoryMonitorFType _tmp3_;
				DirectoryMonitorFType ftype;
#line 1237 "DirectoryMonitor.vala"
				if (!gee_iterator_next (_file_it)) {
#line 1237 "DirectoryMonitor.vala"
					break;
#line 2935 "DirectoryMonitor.c"
				}
#line 1237 "DirectoryMonitor.vala"
				file = (GFile*) gee_iterator_get (_file_it);
#line 1241 "DirectoryMonitor.vala"
				ftype = (_tmp3_ = directory_monitor_get_ftype (self, _tmp2_ = (GFileInfo*) gee_map_get (overdue, file)), _g_object_unref0 (_tmp2_), _tmp3_);
#line 1242 "DirectoryMonitor.vala"
				switch (ftype) {
#line 2943 "DirectoryMonitor.c"
					case DIRECTORY_MONITOR_FTYPE_FILE:
					{
#line 1244 "DirectoryMonitor.vala"
						directory_monitor_notify_file_deleted (self, file);
#line 1245 "DirectoryMonitor.vala"
						break;
#line 2950 "DirectoryMonitor.c"
					}
					case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
					{
#line 1248 "DirectoryMonitor.vala"
						directory_monitor_notify_directory_deleted (self, file);
#line 1249 "DirectoryMonitor.vala"
						break;
#line 2958 "DirectoryMonitor.c"
					}
					default:
					{
#line 1252 "DirectoryMonitor.vala"
						g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1253 "DirectoryMonitor.vala"
						break;
#line 2966 "DirectoryMonitor.c"
					}
				}
				_g_object_unref0 (file);
			}
			_g_object_unref0 (_file_it);
		}
	}
#line 1258 "DirectoryMonitor.vala"
	self->priv->delete_timer_active = directory_monitor_file_info_map_get_count (DIRECTORY_MONITOR_FILE_INFO_MAP (self->priv->deleted)) > 0;
#line 2976 "DirectoryMonitor.c"
	result = self->priv->delete_timer_active;
	_g_object_unref0 (overdue);
#line 1260 "DirectoryMonitor.vala"
	return result;
#line 2981 "DirectoryMonitor.c"
}


#line 1264 "DirectoryMonitor.vala"
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file) {
#line 2987 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
#line 1264 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1264 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 2993 "DirectoryMonitor.c"
	result = directory_monitor_file_info_map_get_info (self->priv->files, file);
#line 1265 "DirectoryMonitor.vala"
	return result;
#line 2997 "DirectoryMonitor.c"
}


#line 1271 "DirectoryMonitor.vala"
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file) {
#line 3003 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
#line 1271 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1271 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3009 "DirectoryMonitor.c"
	result = directory_monitor_file_info_map_query_info (self->priv->files, file, self->priv->cancellable);
#line 1272 "DirectoryMonitor.vala"
	return result;
#line 3013 "DirectoryMonitor.c"
}


#line 375 "DirectoryMonitor.vala"
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 375 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 375 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 375 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 375 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 3027 "DirectoryMonitor.c"
}


#line 383 "DirectoryMonitor.vala"
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 383 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 383 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 3037 "DirectoryMonitor.c"
}


#line 386 "DirectoryMonitor.vala"
static void directory_monitor_real_discovery_started (DirectoryMonitor* self) {
#line 386 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 3045 "DirectoryMonitor.c"
}


#line 389 "DirectoryMonitor.vala"
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 389 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 389 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 389 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3057 "DirectoryMonitor.c"
}


#line 392 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 392 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 392 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 392 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3069 "DirectoryMonitor.c"
}


#line 397 "DirectoryMonitor.vala"
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const char* reason) {
#line 397 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 397 "DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 3079 "DirectoryMonitor.c"
}


#line 400 "DirectoryMonitor.vala"
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self) {
#line 400 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 401 "DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 3089 "DirectoryMonitor.c"
}


#line 404 "DirectoryMonitor.vala"
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 404 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 404 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 404 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3101 "DirectoryMonitor.c"
}


#line 407 "DirectoryMonitor.vala"
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 407 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 407 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 407 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 407 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 3115 "DirectoryMonitor.c"
}


#line 411 "DirectoryMonitor.vala"
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file) {
#line 411 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 411 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3125 "DirectoryMonitor.c"
}


#line 414 "DirectoryMonitor.vala"
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 414 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 414 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 414 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3137 "DirectoryMonitor.c"
}


#line 417 "DirectoryMonitor.vala"
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 417 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 417 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 417 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3149 "DirectoryMonitor.c"
}


#line 420 "DirectoryMonitor.vala"
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 420 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 420 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3159 "DirectoryMonitor.c"
}


#line 424 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 424 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 424 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 424 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3171 "DirectoryMonitor.c"
}


#line 428 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 428 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 428 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 428 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 428 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 3185 "DirectoryMonitor.c"
}


#line 432 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 432 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 432 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 3195 "DirectoryMonitor.c"
}


#line 435 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 435 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 435 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 435 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3207 "DirectoryMonitor.c"
}


#line 438 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 438 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 438 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 438 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3219 "DirectoryMonitor.c"
}


#line 442 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 442 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 442 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 3229 "DirectoryMonitor.c"
}


#line 445 "DirectoryMonitor.vala"
static void directory_monitor_real_closed (DirectoryMonitor* self) {
#line 445 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 3237 "DirectoryMonitor.c"
}


#line 75 "DirectoryMonitor.vala"
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 3243 "DirectoryMonitor.c"
	DirectoryMonitorQueryInfoQueueElement* self;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 75 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (owner), NULL);
#line 75 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 75 "DirectoryMonitor.vala"
	g_return_val_if_fail ((other_file == NULL) || G_IS_FILE (other_file), NULL);
#line 3254 "DirectoryMonitor.c"
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
#line 77 "DirectoryMonitor.vala"
	self->owner = (_tmp0_ = _g_object_ref0 (owner), _g_object_unref0 (self->owner), _tmp0_);
#line 78 "DirectoryMonitor.vala"
	self->file = (_tmp1_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp1_);
#line 79 "DirectoryMonitor.vala"
	self->other_file = (_tmp2_ = _g_object_ref0 (other_file), _g_object_unref0 (self->other_file), _tmp2_);
#line 80 "DirectoryMonitor.vala"
	self->event = event;
#line 81 "DirectoryMonitor.vala"
	self->position = directory_monitor_query_info_queue_element_current++;
#line 3266 "DirectoryMonitor.c"
	return self;
}


#line 75 "DirectoryMonitor.vala"
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 75 "DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 3275 "DirectoryMonitor.c"
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


#line 84 "DirectoryMonitor.vala"
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult) {
#line 3286 "DirectoryMonitor.c"
	GFile* source_file;
	GError * _inner_error_ = NULL;
#line 84 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (self));
#line 84 "DirectoryMonitor.vala"
	g_return_if_fail ((source == NULL) || G_IS_OBJECT (source));
#line 84 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (aresult));
#line 85 "DirectoryMonitor.vala"
	source_file = _g_object_ref0 (G_FILE (source));
#line 3297 "DirectoryMonitor.c"
	{
		GFileInfo* _tmp0_;
		GFileInfo* _tmp1_;
#line 89 "DirectoryMonitor.vala"
		_tmp0_ = g_file_query_info_finish (source_file, aresult, &_inner_error_);
#line 3303 "DirectoryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch278_g_error;
		}
#line 89 "DirectoryMonitor.vala"
		self->info = (_tmp1_ = _tmp0_, _g_object_unref0 (self->info), _tmp1_);
#line 3309 "DirectoryMonitor.c"
	}
	goto __finally278;
	__catch278_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			GError* _tmp2_;
#line 91 "DirectoryMonitor.vala"
			self->err = (_tmp2_ = _g_error_copy0 (err), _g_error_free0 (self->err), _tmp2_);
#line 3321 "DirectoryMonitor.c"
			_g_error_free0 (err);
		}
	}
	__finally278:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (source_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
#line 95 "DirectoryMonitor.vala"
	self->completed = TRUE;
#line 98 "DirectoryMonitor.vala"
	directory_monitor_on_query_finished (self->owner, self);
#line 3336 "DirectoryMonitor.c"
	_g_object_unref0 (source_file);
}


static void directory_monitor_value_query_info_queue_element_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void directory_monitor_value_query_info_queue_element_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
	}
}


static void directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* directory_monitor_value_query_info_queue_element_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DirectoryMonitorQueryInfoQueueElement* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorQueryInfoQueueElement** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
	return value->data[0].v_pointer;
}


static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_query_info_queue_element_unref (old);
	}
}


static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_query_info_queue_element_unref (old);
	}
}


static void directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass) {
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS (klass)->finalize = directory_monitor_query_info_queue_element_finalize;
}


static void directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self) {
	self->info = NULL;
	self->err = NULL;
	self->completed = FALSE;
	self->ref_count = 1;
}


static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj) {
	DirectoryMonitorQueryInfoQueueElement * self;
	self = DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT (obj);
	_g_object_unref0 (self->owner);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->other_file);
	_g_object_unref0 (self->info);
	_g_error_free0 (self->err);
}


static GType directory_monitor_query_info_queue_element_get_type (void) {
	static volatile gsize directory_monitor_query_info_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__volatile, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__volatile;
}


static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void directory_monitor_query_info_queue_element_unref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 112 "DirectoryMonitor.vala"
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type) {
#line 3510 "DirectoryMonitor.c"
	DirectoryMonitorFileInfoMap* self;
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
	return self;
}


#line 112 "DirectoryMonitor.vala"
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void) {
#line 112 "DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 3521 "DirectoryMonitor.c"
}


#line 115 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, char** id) {
#line 3527 "DirectoryMonitor.c"
	gboolean result = FALSE;
	GFileInfo* local_info;
	char* file_id;
	GFile* known_file;
	char* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 115 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 115 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 115 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 3541 "DirectoryMonitor.c"
	if (normalized != NULL) {
		*normalized = NULL;
	}
	if (id != NULL) {
		*id = NULL;
	}
#line 118 "DirectoryMonitor.vala"
	local_info = _g_object_ref0 (info);
#line 119 "DirectoryMonitor.vala"
	if (local_info == NULL) {
#line 3552 "DirectoryMonitor.c"
		GFileInfo* _tmp0_;
#line 120 "DirectoryMonitor.vala"
		local_info = (_tmp0_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file), _g_object_unref0 (local_info), _tmp0_);
#line 121 "DirectoryMonitor.vala"
		if (local_info == NULL) {
#line 3558 "DirectoryMonitor.c"
			result = FALSE;
			_g_object_unref0 (local_info);
#line 122 "DirectoryMonitor.vala"
			return result;
#line 3563 "DirectoryMonitor.c"
		}
	}
#line 125 "DirectoryMonitor.vala"
	file_id = get_file_info_id (local_info);
#line 126 "DirectoryMonitor.vala"
	if (file_id == NULL) {
#line 3570 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (file_id);
		_g_object_unref0 (local_info);
#line 127 "DirectoryMonitor.vala"
		return result;
#line 3576 "DirectoryMonitor.c"
	}
#line 129 "DirectoryMonitor.vala"
	known_file = (GFile*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), file_id);
#line 131 "DirectoryMonitor.vala"
	*id = (_tmp1_ = g_strdup ((const char*) file_id), _g_free0 (*id), _tmp1_);
#line 3582 "DirectoryMonitor.c"
	_tmp2_ = NULL;
#line 132 "DirectoryMonitor.vala"
	if (known_file != NULL) {
#line 132 "DirectoryMonitor.vala"
		_tmp2_ = known_file;
#line 3588 "DirectoryMonitor.c"
	} else {
#line 132 "DirectoryMonitor.vala"
		_tmp2_ = file;
#line 3592 "DirectoryMonitor.c"
	}
#line 132 "DirectoryMonitor.vala"
	*normalized = (_tmp3_ = _g_object_ref0 (_tmp2_), _g_object_unref0 (*normalized), _tmp3_);
#line 3596 "DirectoryMonitor.c"
	result = TRUE;
	_g_object_unref0 (known_file);
	_g_free0 (file_id);
	_g_object_unref0 (local_info);
#line 134 "DirectoryMonitor.vala"
	return result;
#line 3603 "DirectoryMonitor.c"
}


#line 137 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_real_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 3609 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 137 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 137 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 137 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 3625 "DirectoryMonitor.c"
	id = NULL;
	normalized = NULL;
#line 140 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 3630 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 141 "DirectoryMonitor.vala"
		return result;
#line 3636 "DirectoryMonitor.c"
	}
#line 143 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), normalized, info);
#line 144 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->id_map), id, normalized);
#line 3642 "DirectoryMonitor.c"
	result = TRUE;
	_g_object_unref0 (normalized);
	_g_free0 (id);
#line 146 "DirectoryMonitor.vala"
	return result;
#line 3648 "DirectoryMonitor.c"
}


#line 112 "DirectoryMonitor.vala"
gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 112 "DirectoryMonitor.vala"
	return DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->update (self, file, info);
#line 3656 "DirectoryMonitor.c"
}


#line 149 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_real_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 3662 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 149 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 149 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 149 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 3678 "DirectoryMonitor.c"
	id = NULL;
	normalized = NULL;
#line 152 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 3683 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 153 "DirectoryMonitor.vala"
		return result;
#line 3689 "DirectoryMonitor.c"
	}
#line 155 "DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), normalized, NULL);
#line 156 "DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->id_map), id, NULL);
#line 3695 "DirectoryMonitor.c"
	result = TRUE;
	_g_object_unref0 (normalized);
	_g_free0 (id);
#line 158 "DirectoryMonitor.vala"
	return result;
#line 3701 "DirectoryMonitor.c"
}


#line 112 "DirectoryMonitor.vala"
gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 112 "DirectoryMonitor.vala"
	return DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->remove (self, file, info);
#line 3709 "DirectoryMonitor.c"
}


#line 163 "DirectoryMonitor.vala"
static void directory_monitor_file_info_map_real_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files) {
#line 163 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 163 "DirectoryMonitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (files));
#line 3719 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it;
#line 164 "DirectoryMonitor.vala"
		_file_it = gee_iterable_iterator (GEE_ITERABLE (files));
#line 164 "DirectoryMonitor.vala"
		while (TRUE) {
#line 3726 "DirectoryMonitor.c"
			GFile* file;
#line 164 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 164 "DirectoryMonitor.vala"
				break;
#line 3732 "DirectoryMonitor.c"
			}
#line 164 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 165 "DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, file, NULL);
#line 3738 "DirectoryMonitor.c"
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
}


#line 112 "DirectoryMonitor.vala"
void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files) {
#line 112 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->remove_all (self, files);
#line 3750 "DirectoryMonitor.c"
}


#line 169 "DirectoryMonitor.vala"
static void directory_monitor_file_info_map_real_remove_map (DirectoryMonitorFileInfoMap* self, GeeMap* file_map) {
#line 169 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 169 "DirectoryMonitor.vala"
	g_return_if_fail (GEE_IS_MAP (file_map));
#line 3760 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 170 "DirectoryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (file_map))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 170 "DirectoryMonitor.vala"
		while (TRUE) {
#line 3769 "DirectoryMonitor.c"
			GFile* file;
			GFileInfo* _tmp2_;
#line 170 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 170 "DirectoryMonitor.vala"
				break;
#line 3776 "DirectoryMonitor.c"
			}
#line 170 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 171 "DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, file, _tmp2_ = (GFileInfo*) gee_map_get (file_map, file));
#line 3782 "DirectoryMonitor.c"
			_g_object_unref0 (_tmp2_);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
}


#line 112 "DirectoryMonitor.vala"
void directory_monitor_file_info_map_remove_map (DirectoryMonitorFileInfoMap* self, GeeMap* file_map) {
#line 112 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->remove_map (self, file_map);
#line 3795 "DirectoryMonitor.c"
}


#line 174 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 3801 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 174 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 174 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 174 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 3817 "DirectoryMonitor.c"
	id = NULL;
	normalized = NULL;
#line 177 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 3822 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 178 "DirectoryMonitor.vala"
		return result;
#line 3828 "DirectoryMonitor.c"
	}
	result = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->id_map), id);
	_g_object_unref0 (normalized);
	_g_free0 (id);
#line 180 "DirectoryMonitor.vala"
	return result;
#line 3835 "DirectoryMonitor.c"
}


#line 183 "DirectoryMonitor.vala"
static char* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 3841 "DirectoryMonitor.c"
	char* result = NULL;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 183 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 183 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 183 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), NULL);
#line 185 "DirectoryMonitor.vala"
	if (info != NULL) {
#line 3859 "DirectoryMonitor.c"
		result = get_file_info_id (info);
#line 186 "DirectoryMonitor.vala"
		return result;
#line 3863 "DirectoryMonitor.c"
	}
	id = NULL;
	normalized = NULL;
#line 190 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 3869 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 191 "DirectoryMonitor.vala"
		return result;
#line 3875 "DirectoryMonitor.c"
	}
	result = id;
	_g_object_unref0 (normalized);
#line 193 "DirectoryMonitor.vala"
	return result;
#line 3881 "DirectoryMonitor.c"
}


#line 196 "DirectoryMonitor.vala"
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file) {
#line 3887 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
	GFileInfo* info;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 196 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 196 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 198 "DirectoryMonitor.vala"
	info = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
#line 199 "DirectoryMonitor.vala"
	if (info != NULL) {
#line 3906 "DirectoryMonitor.c"
		result = info;
#line 200 "DirectoryMonitor.vala"
		return result;
#line 3910 "DirectoryMonitor.c"
	}
	id = NULL;
	normalized = NULL;
#line 204 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 3916 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_object_unref0 (info);
#line 205 "DirectoryMonitor.vala"
		return result;
#line 3923 "DirectoryMonitor.c"
	}
	result = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), normalized);
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_object_unref0 (info);
#line 207 "DirectoryMonitor.vala"
	return result;
#line 3931 "DirectoryMonitor.c"
}


#line 210 "DirectoryMonitor.vala"
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable) {
#line 3937 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
	GFileInfo* info;
	char* id;
	GFile* normalized;
	GError * _inner_error_ = NULL;
#line 210 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 210 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 210 "DirectoryMonitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 211 "DirectoryMonitor.vala"
	info = directory_monitor_file_info_map_get_info (self, file);
#line 212 "DirectoryMonitor.vala"
	if (info != NULL) {
#line 3953 "DirectoryMonitor.c"
		result = info;
#line 213 "DirectoryMonitor.vala"
		return result;
#line 3957 "DirectoryMonitor.c"
	}
	{
		GFileInfo* _tmp0_;
		GFileInfo* _tmp1_;
#line 218 "DirectoryMonitor.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ID_FILE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 3964 "DirectoryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch279_g_error;
		}
#line 218 "DirectoryMonitor.vala"
		info = (_tmp1_ = _tmp0_, _g_object_unref0 (info), _tmp1_);
#line 3970 "DirectoryMonitor.c"
	}
	goto __finally279;
	__catch279_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp2_;
#line 221 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:221: Unable to query file ID of %s: %s", _tmp2_ = g_file_get_path (file), err->message);
#line 3982 "DirectoryMonitor.c"
			_g_free0 (_tmp2_);
			result = NULL;
			_g_error_free0 (err);
			_g_object_unref0 (info);
#line 223 "DirectoryMonitor.vala"
			return result;
#line 3989 "DirectoryMonitor.c"
		}
	}
	__finally279:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
#line 226 "DirectoryMonitor.vala"
	id = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE));
#line 227 "DirectoryMonitor.vala"
	if (id == NULL) {
#line 4003 "DirectoryMonitor.c"
		result = NULL;
		_g_free0 (id);
		_g_object_unref0 (info);
#line 228 "DirectoryMonitor.vala"
		return result;
#line 4009 "DirectoryMonitor.c"
	}
#line 230 "DirectoryMonitor.vala"
	normalized = (GFile*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), id);
#line 231 "DirectoryMonitor.vala"
	if (normalized == NULL) {
#line 4015 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_object_unref0 (info);
#line 232 "DirectoryMonitor.vala"
		return result;
#line 4022 "DirectoryMonitor.c"
	}
	result = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_object_unref0 (info);
#line 234 "DirectoryMonitor.vala"
	return result;
#line 4030 "DirectoryMonitor.c"
}


#line 237 "DirectoryMonitor.vala"
static GFile* directory_monitor_file_info_map_get_file (DirectoryMonitorFileInfoMap* self, const char* id) {
#line 4036 "DirectoryMonitor.c"
	GFile* result = NULL;
#line 237 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 237 "DirectoryMonitor.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 4042 "DirectoryMonitor.c"
	result = (GFile*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), id);
#line 238 "DirectoryMonitor.vala"
	return result;
#line 4046 "DirectoryMonitor.c"
}


#line 241 "DirectoryMonitor.vala"
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match) {
#line 4052 "DirectoryMonitor.c"
	GFile* result = NULL;
	char* match_id;
	gint64 match_size;
	GTimeVal match_time = {0};
#line 241 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 241 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (match), NULL);
#line 242 "DirectoryMonitor.vala"
	match_id = get_file_info_id (match);
#line 243 "DirectoryMonitor.vala"
	if (match_id == NULL) {
#line 4065 "DirectoryMonitor.c"
		result = NULL;
		_g_free0 (match_id);
#line 244 "DirectoryMonitor.vala"
		return result;
#line 4070 "DirectoryMonitor.c"
	}
#line 247 "DirectoryMonitor.vala"
	match_size = g_file_info_get_size (match);
#line 249 "DirectoryMonitor.vala"
	g_file_info_get_modification_time (match, &match_time);
#line 4076 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 251 "DirectoryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 251 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4085 "DirectoryMonitor.c"
			GFile* file;
			GFileInfo* info;
			char* _tmp2_;
			gboolean _tmp3_;
			GTimeVal time = {0};
#line 251 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 251 "DirectoryMonitor.vala"
				break;
#line 4095 "DirectoryMonitor.c"
			}
#line 251 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 252 "DirectoryMonitor.vala"
			info = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
#line 255 "DirectoryMonitor.vala"
			if ((_tmp3_ = _vala_strcmp0 (_tmp2_ = get_file_info_id (info), match_id) == 0, _g_free0 (_tmp2_), _tmp3_)) {
#line 4103 "DirectoryMonitor.c"
				result = file;
				_g_object_unref0 (info);
				_g_object_unref0 (_file_it);
				_g_free0 (match_id);
#line 256 "DirectoryMonitor.vala"
				return result;
#line 4110 "DirectoryMonitor.c"
			}
#line 259 "DirectoryMonitor.vala"
			if (match_size != g_file_info_get_size (info)) {
#line 4114 "DirectoryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 260 "DirectoryMonitor.vala"
				continue;
#line 4119 "DirectoryMonitor.c"
			}
#line 263 "DirectoryMonitor.vala"
			g_file_info_get_modification_time (info, &time);
#line 265 "DirectoryMonitor.vala"
			if (time.tv_sec != match_time.tv_sec) {
#line 4125 "DirectoryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 266 "DirectoryMonitor.vala"
				continue;
#line 4130 "DirectoryMonitor.c"
			}
			result = file;
			_g_object_unref0 (info);
			_g_object_unref0 (_file_it);
			_g_free0 (match_id);
#line 268 "DirectoryMonitor.vala"
			return result;
#line 4138 "DirectoryMonitor.c"
		}
		_g_object_unref0 (_file_it);
	}
	result = NULL;
	_g_free0 (match_id);
#line 271 "DirectoryMonitor.vala"
	return result;
#line 4146 "DirectoryMonitor.c"
}


#line 274 "DirectoryMonitor.vala"
static gint directory_monitor_file_info_map_get_count (DirectoryMonitorFileInfoMap* self) {
#line 4152 "DirectoryMonitor.c"
	gint result = 0;
#line 274 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), 0);
#line 4156 "DirectoryMonitor.c"
	result = gee_map_get_size (GEE_MAP (self->priv->map));
#line 275 "DirectoryMonitor.vala"
	return result;
#line 4160 "DirectoryMonitor.c"
}


#line 278 "DirectoryMonitor.vala"
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents) {
#line 4166 "DirectoryMonitor.c"
	GeeArrayList* pruned;
#line 278 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 278 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 278 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (descendents));
#line 279 "DirectoryMonitor.vala"
	pruned = NULL;
#line 4176 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 280 "DirectoryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 280 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4185 "DirectoryMonitor.c"
			GFile* file;
			GFile* parent;
#line 280 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 280 "DirectoryMonitor.vala"
				break;
#line 4192 "DirectoryMonitor.c"
			}
#line 280 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 281 "DirectoryMonitor.vala"
			parent = g_file_get_parent (file);
#line 282 "DirectoryMonitor.vala"
			while (TRUE) {
#line 4200 "DirectoryMonitor.c"
				GFile* _tmp4_;
#line 282 "DirectoryMonitor.vala"
				if (!(parent != NULL)) {
#line 282 "DirectoryMonitor.vala"
					break;
#line 4206 "DirectoryMonitor.c"
				}
#line 283 "DirectoryMonitor.vala"
				if (g_file_equal (parent, root)) {
#line 4210 "DirectoryMonitor.c"
					GFileInfo* _tmp3_;
#line 284 "DirectoryMonitor.vala"
					if (pruned == NULL) {
#line 4214 "DirectoryMonitor.c"
						GeeArrayList* _tmp2_;
#line 285 "DirectoryMonitor.vala"
						pruned = (_tmp2_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (pruned), _tmp2_);
#line 4218 "DirectoryMonitor.c"
					}
#line 287 "DirectoryMonitor.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (pruned), file);
#line 288 "DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (descendents, file, _tmp3_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file));
#line 4224 "DirectoryMonitor.c"
					_g_object_unref0 (_tmp3_);
#line 290 "DirectoryMonitor.vala"
					break;
#line 4228 "DirectoryMonitor.c"
				}
#line 293 "DirectoryMonitor.vala"
				parent = (_tmp4_ = g_file_get_parent (parent), _g_object_unref0 (parent), _tmp4_);
#line 4232 "DirectoryMonitor.c"
			}
			_g_object_unref0 (parent);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
#line 297 "DirectoryMonitor.vala"
	if (pruned != NULL) {
#line 298 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, GEE_COLLECTION (pruned));
#line 4243 "DirectoryMonitor.c"
	}
	_g_object_unref0 (pruned);
}


static void directory_monitor_value_file_info_map_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void directory_monitor_value_file_info_map_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
	}
}


static void directory_monitor_value_file_info_map_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer directory_monitor_value_file_info_map_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* directory_monitor_value_file_info_map_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DirectoryMonitorFileInfoMap* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* directory_monitor_value_file_info_map_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorFileInfoMap** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecFileInfoMap* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer directory_monitor_value_get_file_info_map (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
	return value->data[0].v_pointer;
}


static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_file_info_map_unref (old);
	}
}


static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_file_info_map_unref (old);
	}
}


static void directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass) {
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->finalize = directory_monitor_file_info_map_finalize;
	g_type_class_add_private (klass, sizeof (DirectoryMonitorFileInfoMapPrivate));
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->update = directory_monitor_file_info_map_real_update;
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->remove = directory_monitor_file_info_map_real_remove;
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->remove_all = directory_monitor_file_info_map_real_remove_all;
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->remove_map = directory_monitor_file_info_map_real_remove_map;
}


static void directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self) {
	self->priv = DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL);
	self->priv->id_map = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_str_hash, g_str_equal, g_file_equal);
	self->ref_count = 1;
}


static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj) {
	DirectoryMonitorFileInfoMap * self;
	self = DIRECTORY_MONITOR_FILE_INFO_MAP (obj);
	_g_object_unref0 (self->priv->map);
	_g_object_unref0 (self->priv->id_map);
}


static GType directory_monitor_file_info_map_get_type (void) {
	static volatile gsize directory_monitor_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_file_info_map_type_id__volatile, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__volatile;
}


static gpointer directory_monitor_file_info_map_ref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void directory_monitor_file_info_map_unref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 308 "DirectoryMonitor.vala"
static DirectoryMonitorTimedFileInfoMap* directory_monitor_timed_file_info_map_construct (GType object_type) {
#line 4420 "DirectoryMonitor.c"
	DirectoryMonitorTimedFileInfoMap* self;
#line 308 "DirectoryMonitor.vala"
	self = (DirectoryMonitorTimedFileInfoMap*) directory_monitor_file_info_map_construct (object_type);
#line 4424 "DirectoryMonitor.c"
	return self;
}


#line 308 "DirectoryMonitor.vala"
static DirectoryMonitorTimedFileInfoMap* directory_monitor_timed_file_info_map_new (void) {
#line 308 "DirectoryMonitor.vala"
	return directory_monitor_timed_file_info_map_construct (DIRECTORY_MONITOR_TYPE_TIMED_FILE_INFO_MAP);
#line 4433 "DirectoryMonitor.c"
}


#line 311 "DirectoryMonitor.vala"
static gboolean directory_monitor_timed_file_info_map_real_update (DirectoryMonitorFileInfoMap* base, GFile* file, GFileInfo* info) {
#line 4439 "DirectoryMonitor.c"
	DirectoryMonitorTimedFileInfoMap * self;
	gboolean result = FALSE;
	char* id;
	self = DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP (base);
#line 311 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 311 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 312 "DirectoryMonitor.vala"
	if (!DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (directory_monitor_timed_file_info_map_parent_class)->update (DIRECTORY_MONITOR_FILE_INFO_MAP (self), file, info)) {
#line 4450 "DirectoryMonitor.c"
		result = FALSE;
#line 313 "DirectoryMonitor.vala"
		return result;
#line 4454 "DirectoryMonitor.c"
	}
#line 315 "DirectoryMonitor.vala"
	id = directory_monitor_file_info_map_get_id (DIRECTORY_MONITOR_FILE_INFO_MAP (self), file, info);
#line 316 "DirectoryMonitor.vala"
	g_assert (id != NULL);
#line 318 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->time_added), id, GUINT_TO_POINTER (now_ms ()));
#line 4462 "DirectoryMonitor.c"
	result = TRUE;
	_g_free0 (id);
#line 320 "DirectoryMonitor.vala"
	return result;
#line 4467 "DirectoryMonitor.c"
}


#line 323 "DirectoryMonitor.vala"
static gboolean directory_monitor_timed_file_info_map_real_remove (DirectoryMonitorFileInfoMap* base, GFile* file, GFileInfo* info) {
#line 4473 "DirectoryMonitor.c"
	DirectoryMonitorTimedFileInfoMap * self;
	gboolean result = FALSE;
	char* id;
	self = DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP (base);
#line 323 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 323 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 324 "DirectoryMonitor.vala"
	if (!DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (directory_monitor_timed_file_info_map_parent_class)->remove (DIRECTORY_MONITOR_FILE_INFO_MAP (self), file, info)) {
#line 4484 "DirectoryMonitor.c"
		result = FALSE;
#line 325 "DirectoryMonitor.vala"
		return result;
#line 4488 "DirectoryMonitor.c"
	}
#line 327 "DirectoryMonitor.vala"
	id = directory_monitor_file_info_map_get_id (DIRECTORY_MONITOR_FILE_INFO_MAP (self), file, info);
#line 328 "DirectoryMonitor.vala"
	g_assert (id != NULL);
#line 330 "DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->time_added), id, NULL);
#line 4496 "DirectoryMonitor.c"
	result = TRUE;
	_g_free0 (id);
#line 332 "DirectoryMonitor.vala"
	return result;
#line 4501 "DirectoryMonitor.c"
}


#line 335 "DirectoryMonitor.vala"
static GeeMap* directory_monitor_timed_file_info_map_remove_older_than (DirectoryMonitorTimedFileInfoMap* self, gulong time) {
#line 4507 "DirectoryMonitor.c"
	GeeMap* result = NULL;
	GeeMap* retirees;
#line 335 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_TIMED_FILE_INFO_MAP (self), NULL);
#line 336 "DirectoryMonitor.vala"
	retirees = NULL;
#line 4514 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _id_it;
#line 337 "DirectoryMonitor.vala"
		_id_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->time_added)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 337 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4523 "DirectoryMonitor.c"
			char* id;
			gulong added;
#line 337 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_id_it)) {
#line 337 "DirectoryMonitor.vala"
				break;
#line 4530 "DirectoryMonitor.c"
			}
#line 337 "DirectoryMonitor.vala"
			id = (char*) gee_iterator_get (_id_it);
#line 338 "DirectoryMonitor.vala"
			added = GPOINTER_TO_UINT (gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->time_added), id));
#line 339 "DirectoryMonitor.vala"
			if (added <= time) {
#line 4538 "DirectoryMonitor.c"
				GFile* file;
				GFileInfo* info;
#line 340 "DirectoryMonitor.vala"
				if (retirees == NULL) {
#line 4543 "DirectoryMonitor.c"
					GeeMap* _tmp2_;
#line 341 "DirectoryMonitor.vala"
					retirees = (_tmp2_ = GEE_MAP (gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL)), _g_object_unref0 (retirees), _tmp2_);
#line 4547 "DirectoryMonitor.c"
				}
#line 343 "DirectoryMonitor.vala"
				file = directory_monitor_file_info_map_get_file (DIRECTORY_MONITOR_FILE_INFO_MAP (self), id);
#line 344 "DirectoryMonitor.vala"
				g_assert (file != NULL);
#line 346 "DirectoryMonitor.vala"
				info = directory_monitor_file_info_map_get_info (DIRECTORY_MONITOR_FILE_INFO_MAP (self), file);
#line 347 "DirectoryMonitor.vala"
				g_assert (info != NULL);
#line 349 "DirectoryMonitor.vala"
				gee_map_set (retirees, file, info);
#line 4559 "DirectoryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
			}
			_g_free0 (id);
		}
		_g_object_unref0 (_id_it);
	}
#line 353 "DirectoryMonitor.vala"
	if (retirees != NULL) {
#line 354 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_map (DIRECTORY_MONITOR_FILE_INFO_MAP (self), retirees);
#line 4571 "DirectoryMonitor.c"
	}
	result = retirees;
#line 356 "DirectoryMonitor.vala"
	return result;
#line 4576 "DirectoryMonitor.c"
}


static void directory_monitor_timed_file_info_map_class_init (DirectoryMonitorTimedFileInfoMapClass * klass) {
	directory_monitor_timed_file_info_map_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->finalize = directory_monitor_timed_file_info_map_finalize;
	g_type_class_add_private (klass, sizeof (DirectoryMonitorTimedFileInfoMapPrivate));
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->update = directory_monitor_timed_file_info_map_real_update;
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->remove = directory_monitor_timed_file_info_map_real_remove;
}


static void directory_monitor_timed_file_info_map_instance_init (DirectoryMonitorTimedFileInfoMap * self) {
	self->priv = DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP_GET_PRIVATE (self);
	self->priv->time_added = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_ULONG, NULL, NULL, g_str_hash, g_str_equal, NULL);
}


static void directory_monitor_timed_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj) {
	DirectoryMonitorTimedFileInfoMap * self;
	self = DIRECTORY_MONITOR_TIMED_FILE_INFO_MAP (obj);
	_g_object_unref0 (self->priv->time_added);
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (directory_monitor_timed_file_info_map_parent_class)->finalize (obj);
}


static GType directory_monitor_timed_file_info_map_get_type (void) {
	static volatile gsize directory_monitor_timed_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_timed_file_info_map_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorTimedFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_timed_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorTimedFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_timed_file_info_map_instance_init, NULL };
		GType directory_monitor_timed_file_info_map_type_id;
		directory_monitor_timed_file_info_map_type_id = g_type_register_static (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, "DirectoryMonitorTimedFileInfoMap", &g_define_type_info, 0);
		g_once_init_leave (&directory_monitor_timed_file_info_map_type_id__volatile, directory_monitor_timed_file_info_map_type_id);
	}
	return directory_monitor_timed_file_info_map_type_id__volatile;
}


static void directory_monitor_class_init (DirectoryMonitorClass * klass) {
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DirectoryMonitorPrivate));
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_deleted = directory_monitor_real_notify_root_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_moved = directory_monitor_real_notify_root_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_started = directory_monitor_real_notify_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_file_discovered = directory_monitor_real_internal_notify_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_discovered = directory_monitor_real_notify_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_directory_discovered = directory_monitor_real_internal_notify_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_discovered = directory_monitor_real_notify_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_failed = directory_monitor_real_notify_discovery_failed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_completed = directory_monitor_real_notify_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = directory_monitor_real_notify_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = directory_monitor_real_notify_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = directory_monitor_real_notify_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = directory_monitor_real_notify_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = directory_monitor_real_notify_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = directory_monitor_real_notify_file_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_created = directory_monitor_real_notify_directory_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_moved = directory_monitor_real_notify_directory_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_altered = directory_monitor_real_notify_directory_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_alteration_completed = directory_monitor_real_notify_directory_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_attributes_altered = directory_monitor_real_notify_directory_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_deleted = directory_monitor_real_notify_directory_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_closed = directory_monitor_real_notify_closed;
	DIRECTORY_MONITOR_CLASS (klass)->close = directory_monitor_real_close;
	DIRECTORY_MONITOR_CLASS (klass)->root_moved = directory_monitor_real_root_moved;
	DIRECTORY_MONITOR_CLASS (klass)->root_deleted = directory_monitor_real_root_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = directory_monitor_real_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = directory_monitor_real_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_discovered = directory_monitor_real_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_failed = directory_monitor_real_discovery_failed;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = directory_monitor_real_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->file_created = directory_monitor_real_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->file_moved = directory_monitor_real_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->file_altered = directory_monitor_real_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->file_deleted = directory_monitor_real_file_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->directory_created = directory_monitor_real_directory_created;
	DIRECTORY_MONITOR_CLASS (klass)->directory_moved = directory_monitor_real_directory_moved;
	DIRECTORY_MONITOR_CLASS (klass)->directory_altered = directory_monitor_real_directory_altered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_deleted = directory_monitor_real_directory_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->closed = directory_monitor_real_closed;
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
	g_signal_new ("root_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("root_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("discovery_started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("file_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("discovery_failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("discovery_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("file_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("file_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void directory_monitor_instance_init (DirectoryMonitor * self) {
	self->priv = DIRECTORY_MONITOR_GET_PRIVATE (self);
	self->priv->monitors = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	self->priv->query_info_queue = GEE_QUEUE (gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, directory_monitor_query_info_queue_element_unref, NULL));
	self->priv->files = directory_monitor_file_info_map_new ();
	self->priv->deleted = directory_monitor_timed_file_info_map_new ();
	self->priv->parent_moved = directory_monitor_file_info_map_new ();
	self->priv->cancellable = g_cancellable_new ();
	self->priv->outstanding_exploration_dirs = 0;
	self->priv->has_discovery_started = FALSE;
	self->priv->delete_timer_active = FALSE;
}


static void directory_monitor_finalize (GObject* obj) {
	DirectoryMonitor * self;
	self = DIRECTORY_MONITOR (obj);
	{
#line 455 "DirectoryMonitor.vala"
		directory_monitor_close (self);
#line 4705 "DirectoryMonitor.c"
	}
	_g_object_unref0 (self->priv->root);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->query_info_queue);
	_directory_monitor_file_info_map_unref0 (self->priv->files);
	_directory_monitor_file_info_map_unref0 (self->priv->deleted);
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
}


GType directory_monitor_get_type (void) {
	static volatile gsize directory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
		GType directory_monitor_type_id;
		directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&directory_monitor_type_id__volatile, directory_monitor_type_id);
	}
	return directory_monitor_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}



